/* Enum.c generated by valac 0.56.18, the Vala compiler
 * generated from Enum.vala, do not modify */

/*
 * Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Alain M. <alainmh23@gmail.com>
 */

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static gboolean _int_equal (const gint * s1,
                     const gint * s2);

static GType
color_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{COLOR_SCHEME_NO_PREFERENCE, "COLOR_SCHEME_NO_PREFERENCE", "no-preference"}, {COLOR_SCHEME_DARK, "COLOR_SCHEME_DARK", "dark"}, {COLOR_SCHEME_LIGHT, "COLOR_SCHEME_LIGHT", "light"}, {0, NULL, NULL}};
	GType color_scheme_type_id;
	color_scheme_type_id = g_enum_register_static ("ColorScheme", values);
	return color_scheme_type_id;
}

GType
color_scheme_get_type (void)
{
	static volatile gsize color_scheme_type_id__once = 0;
	if (g_once_init_enter (&color_scheme_type_id__once)) {
		GType color_scheme_type_id;
		color_scheme_type_id = color_scheme_get_type_once ();
		g_once_init_leave (&color_scheme_type_id__once, color_scheme_type_id);
	}
	return color_scheme_type_id__once;
}

static GType
notification_style_get_type_once (void)
{
	static const GEnumValue values[] = {{NOTIFICATION_STYLE_NORMAL, "NOTIFICATION_STYLE_NORMAL", "normal"}, {NOTIFICATION_STYLE_ERROR, "NOTIFICATION_STYLE_ERROR", "error"}, {0, NULL, NULL}};
	GType notification_style_type_id;
	notification_style_type_id = g_enum_register_static ("NotificationStyle", values);
	return notification_style_type_id;
}

GType
notification_style_get_type (void)
{
	static volatile gsize notification_style_type_id__once = 0;
	if (g_once_init_enter (&notification_style_type_id__once)) {
		GType notification_style_type_id;
		notification_style_type_id = notification_style_get_type_once ();
		g_once_init_leave (&notification_style_type_id__once, notification_style_type_id);
	}
	return notification_style_type_id__once;
}

gchar*
project_view_style_to_string (ProjectViewStyle self)
{
	gchar* result;
	switch (self) {
		case PROJECT_VIEW_STYLE_LIST:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("list");
			result = _tmp0_;
			return result;
		}
		case PROJECT_VIEW_STYLE_BOARD:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("board");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

ProjectViewStyle
project_view_style_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	ProjectViewStyle result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("list")))) {
		switch (0) {
			default:
			{
				result = PROJECT_VIEW_STYLE_LIST;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("board")))) {
		switch (0) {
			default:
			{
				result = PROJECT_VIEW_STYLE_BOARD;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

static GType
project_view_style_get_type_once (void)
{
	static const GEnumValue values[] = {{PROJECT_VIEW_STYLE_LIST, "PROJECT_VIEW_STYLE_LIST", "list"}, {PROJECT_VIEW_STYLE_BOARD, "PROJECT_VIEW_STYLE_BOARD", "board"}, {0, NULL, NULL}};
	GType project_view_style_type_id;
	project_view_style_type_id = g_enum_register_static ("ProjectViewStyle", values);
	return project_view_style_type_id;
}

GType
project_view_style_get_type (void)
{
	static volatile gsize project_view_style_type_id__once = 0;
	if (g_once_init_enter (&project_view_style_type_id__once)) {
		GType project_view_style_type_id;
		project_view_style_type_id = project_view_style_get_type_once ();
		g_once_init_leave (&project_view_style_type_id__once, project_view_style_type_id);
	}
	return project_view_style_type_id__once;
}

gchar*
project_icon_style_to_string (ProjectIconStyle self)
{
	gchar* result;
	switch (self) {
		case PROJECT_ICON_STYLE_PROGRESS:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("progress");
			result = _tmp0_;
			return result;
		}
		case PROJECT_ICON_STYLE_EMOJI:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("emoji");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

ProjectIconStyle
project_icon_style_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	ProjectIconStyle result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("progress")))) {
		switch (0) {
			default:
			{
				result = PROJECT_ICON_STYLE_PROGRESS;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("emoji")))) {
		switch (0) {
			default:
			{
				result = PROJECT_ICON_STYLE_EMOJI;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

static GType
project_icon_style_get_type_once (void)
{
	static const GEnumValue values[] = {{PROJECT_ICON_STYLE_PROGRESS, "PROJECT_ICON_STYLE_PROGRESS", "progress"}, {PROJECT_ICON_STYLE_EMOJI, "PROJECT_ICON_STYLE_EMOJI", "emoji"}, {0, NULL, NULL}};
	GType project_icon_style_type_id;
	project_icon_style_type_id = g_enum_register_static ("ProjectIconStyle", values);
	return project_icon_style_type_id;
}

GType
project_icon_style_get_type (void)
{
	static volatile gsize project_icon_style_type_id__once = 0;
	if (g_once_init_enter (&project_icon_style_type_id__once)) {
		GType project_icon_style_type_id;
		project_icon_style_type_id = project_icon_style_get_type_once ();
		g_once_init_leave (&project_icon_style_type_id__once, project_icon_style_type_id);
	}
	return project_icon_style_type_id__once;
}

gchar*
filter_type_to_string (FilterType self)
{
	gchar* result;
	switch (self) {
		case FILTER_TYPE_INBOX:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("inbox");
			result = _tmp0_;
			return result;
		}
		case FILTER_TYPE_TODAY:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("today");
			result = _tmp1_;
			return result;
		}
		case FILTER_TYPE_SCHEDULED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("scheduled");
			result = _tmp2_;
			return result;
		}
		case FILTER_TYPE_PINBOARD:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("pinboard");
			result = _tmp3_;
			return result;
		}
		case FILTER_TYPE_LABELS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("labels");
			result = _tmp4_;
			return result;
		}
		case FILTER_TYPE_COMPLETED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("completed");
			result = _tmp5_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
filter_type_get_name (FilterType self)
{
	gchar* result;
	switch (self) {
		case FILTER_TYPE_INBOX:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Inbox"));
			result = _tmp0_;
			return result;
		}
		case FILTER_TYPE_TODAY:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Today"));
			result = _tmp1_;
			return result;
		}
		case FILTER_TYPE_SCHEDULED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Scheduled"));
			result = _tmp2_;
			return result;
		}
		case FILTER_TYPE_PINBOARD:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Pinboard"));
			result = _tmp3_;
			return result;
		}
		case FILTER_TYPE_LABELS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Labels"));
			result = _tmp4_;
			return result;
		}
		case FILTER_TYPE_COMPLETED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Completed"));
			result = _tmp5_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
filter_type_get_icon (FilterType self)
{
	gchar* result;
	switch (self) {
		case FILTER_TYPE_INBOX:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("mailbox-symbolic");
			result = _tmp0_;
			return result;
		}
		case FILTER_TYPE_TODAY:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("star-outline-thick-symbolic");
			result = _tmp1_;
			return result;
		}
		case FILTER_TYPE_SCHEDULED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("month-symbolic");
			result = _tmp2_;
			return result;
		}
		case FILTER_TYPE_PINBOARD:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("pin-symbolic");
			result = _tmp3_;
			return result;
		}
		case FILTER_TYPE_LABELS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("tag-outline-symbolic");
			result = _tmp4_;
			return result;
		}
		case FILTER_TYPE_COMPLETED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("check-round-outline-symbolic");
			result = _tmp5_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
filter_type_get_color (FilterType self,
                       gboolean dark)
{
	gchar* result;
	switch (self) {
		case FILTER_TYPE_INBOX:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_;
			if (dark) {
				_tmp0_ = "#99c1f1";
			} else {
				_tmp0_ = "#3584e4";
			}
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case FILTER_TYPE_TODAY:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("#33d17a");
			result = _tmp2_;
			return result;
		}
		case FILTER_TYPE_SCHEDULED:
		{
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			if (dark) {
				_tmp3_ = "#dc8add";
			} else {
				_tmp3_ = "#9141ac";
			}
			_tmp4_ = g_strdup (_tmp3_);
			result = _tmp4_;
			return result;
		}
		case FILTER_TYPE_PINBOARD:
		{
			const gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			if (dark) {
				_tmp5_ = "#f66151";
			} else {
				_tmp5_ = "#ed333b";
			}
			_tmp6_ = g_strdup (_tmp5_);
			result = _tmp6_;
			return result;
		}
		case FILTER_TYPE_LABELS:
		{
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_;
			if (dark) {
				_tmp7_ = "#cdab8f";
			} else {
				_tmp7_ = "#986a44";
			}
			_tmp8_ = g_strdup (_tmp7_);
			result = _tmp8_;
			return result;
		}
		case FILTER_TYPE_COMPLETED:
		{
			const gchar* _tmp9_ = NULL;
			gchar* _tmp10_;
			if (dark) {
				_tmp9_ = "#ffbe6f";
			} else {
				_tmp9_ = "#ff7800";
			}
			_tmp10_ = g_strdup (_tmp9_);
			result = _tmp10_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
filter_type_get_type_once (void)
{
	static const GEnumValue values[] = {{FILTER_TYPE_INBOX, "FILTER_TYPE_INBOX", "inbox"}, {FILTER_TYPE_TODAY, "FILTER_TYPE_TODAY", "today"}, {FILTER_TYPE_SCHEDULED, "FILTER_TYPE_SCHEDULED", "scheduled"}, {FILTER_TYPE_PINBOARD, "FILTER_TYPE_PINBOARD", "pinboard"}, {FILTER_TYPE_LABELS, "FILTER_TYPE_LABELS", "labels"}, {FILTER_TYPE_COMPLETED, "FILTER_TYPE_COMPLETED", "completed"}, {0, NULL, NULL}};
	GType filter_type_type_id;
	filter_type_type_id = g_enum_register_static ("FilterType", values);
	return filter_type_type_id;
}

GType
filter_type_get_type (void)
{
	static volatile gsize filter_type_type_id__once = 0;
	if (g_once_init_enter (&filter_type_type_id__once)) {
		GType filter_type_type_id;
		filter_type_type_id = filter_type_get_type_once ();
		g_once_init_leave (&filter_type_type_id__once, filter_type_type_id);
	}
	return filter_type_type_id__once;
}

gchar*
source_type_to_string (SourceType self)
{
	gchar* result;
	switch (self) {
		case SOURCE_TYPE_NONE:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("none");
			result = _tmp0_;
			return result;
		}
		case SOURCE_TYPE_LOCAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("local");
			result = _tmp1_;
			return result;
		}
		case SOURCE_TYPE_TODOIST:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("todoist");
			result = _tmp2_;
			return result;
		}
		case SOURCE_TYPE_GOOGLE_TASKS:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("google-tasks");
			result = _tmp3_;
			return result;
		}
		case SOURCE_TYPE_CALDAV:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("caldav");
			result = _tmp4_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

SourceType
source_type_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	SourceType result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("local")))) {
		switch (0) {
			default:
			{
				result = SOURCE_TYPE_LOCAL;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("todoist")))) {
		switch (0) {
			default:
			{
				result = SOURCE_TYPE_TODOIST;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("google-tasks")))) {
		switch (0) {
			default:
			{
				result = SOURCE_TYPE_GOOGLE_TASKS;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("caldav")))) {
		switch (0) {
			default:
			{
				result = SOURCE_TYPE_CALDAV;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = SOURCE_TYPE_NONE;
				return result;
			}
		}
	}
}

static GType
source_type_get_type_once (void)
{
	static const GEnumValue values[] = {{SOURCE_TYPE_NONE, "SOURCE_TYPE_NONE", "none"}, {SOURCE_TYPE_LOCAL, "SOURCE_TYPE_LOCAL", "local"}, {SOURCE_TYPE_TODOIST, "SOURCE_TYPE_TODOIST", "todoist"}, {SOURCE_TYPE_GOOGLE_TASKS, "SOURCE_TYPE_GOOGLE_TASKS", "google-tasks"}, {SOURCE_TYPE_CALDAV, "SOURCE_TYPE_CALDAV", "caldav"}, {0, NULL, NULL}};
	GType source_type_type_id;
	source_type_type_id = g_enum_register_static ("SourceType", values);
	return source_type_type_id;
}

GType
source_type_get_type (void)
{
	static volatile gsize source_type_type_id__once = 0;
	if (g_once_init_enter (&source_type_type_id__once)) {
		GType source_type_type_id;
		source_type_type_id = source_type_get_type_once ();
		g_once_init_leave (&source_type_type_id__once, source_type_type_id);
	}
	return source_type_type_id__once;
}

static GType
pane_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PANE_TYPE_FILTER, "PANE_TYPE_FILTER", "filter"}, {PANE_TYPE_FAVORITE, "PANE_TYPE_FAVORITE", "favorite"}, {PANE_TYPE_PROJECT, "PANE_TYPE_PROJECT", "project"}, {PANE_TYPE_LABEL, "PANE_TYPE_LABEL", "label"}, {PANE_TYPE_TASKLIST, "PANE_TYPE_TASKLIST", "tasklist"}, {0, NULL, NULL}};
	GType pane_type_type_id;
	pane_type_type_id = g_enum_register_static ("PaneType", values);
	return pane_type_type_id;
}

GType
pane_type_get_type (void)
{
	static volatile gsize pane_type_type_id__once = 0;
	if (g_once_init_enter (&pane_type_type_id__once)) {
		GType pane_type_type_id;
		pane_type_type_id = pane_type_get_type_once ();
		g_once_init_leave (&pane_type_type_id__once, pane_type_type_id);
	}
	return pane_type_type_id__once;
}

static GType
loading_button_type_get_type_once (void)
{
	static const GEnumValue values[] = {{LOADING_BUTTON_TYPE_LABEL, "LOADING_BUTTON_TYPE_LABEL", "label"}, {LOADING_BUTTON_TYPE_ICON, "LOADING_BUTTON_TYPE_ICON", "icon"}, {0, NULL, NULL}};
	GType loading_button_type_type_id;
	loading_button_type_type_id = g_enum_register_static ("LoadingButtonType", values);
	return loading_button_type_type_id;
}

GType
loading_button_type_get_type (void)
{
	static volatile gsize loading_button_type_type_id__once = 0;
	if (g_once_init_enter (&loading_button_type_type_id__once)) {
		GType loading_button_type_type_id;
		loading_button_type_type_id = loading_button_type_get_type_once ();
		g_once_init_leave (&loading_button_type_type_id__once, loading_button_type_type_id);
	}
	return loading_button_type_type_id__once;
}

gchar*
object_type_get_header (ObjectType self)
{
	gchar* result;
	switch (self) {
		case OBJECT_TYPE_PROJECT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Projects"));
			result = _tmp0_;
			return result;
		}
		case OBJECT_TYPE_SECTION:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Sections"));
			result = _tmp1_;
			return result;
		}
		case OBJECT_TYPE_ITEM:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Tasks"));
			result = _tmp2_;
			return result;
		}
		case OBJECT_TYPE_LABEL:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Labels"));
			result = _tmp3_;
			return result;
		}
		case OBJECT_TYPE_FILTER:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Filters"));
			result = _tmp4_;
			return result;
		}
		case OBJECT_TYPE_TASK:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Tasks"));
			result = _tmp5_;
			return result;
		}
		case OBJECT_TYPE_TASK_LIST:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Lists"));
			result = _tmp6_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
object_type_get_type_once (void)
{
	static const GEnumValue values[] = {{OBJECT_TYPE_PROJECT, "OBJECT_TYPE_PROJECT", "project"}, {OBJECT_TYPE_SECTION, "OBJECT_TYPE_SECTION", "section"}, {OBJECT_TYPE_ITEM, "OBJECT_TYPE_ITEM", "item"}, {OBJECT_TYPE_LABEL, "OBJECT_TYPE_LABEL", "label"}, {OBJECT_TYPE_TASK, "OBJECT_TYPE_TASK", "task"}, {OBJECT_TYPE_TASK_LIST, "OBJECT_TYPE_TASK_LIST", "task-list"}, {OBJECT_TYPE_FILTER, "OBJECT_TYPE_FILTER", "filter"}, {0, NULL, NULL}};
	GType object_type_type_id;
	object_type_type_id = g_enum_register_static ("ObjectType", values);
	return object_type_type_id;
}

GType
object_type_get_type (void)
{
	static volatile gsize object_type_type_id__once = 0;
	if (g_once_init_enter (&object_type_type_id__once)) {
		GType object_type_type_id;
		object_type_type_id = object_type_get_type_once ();
		g_once_init_leave (&object_type_type_id__once, object_type_type_id);
	}
	return object_type_type_id__once;
}

static GType
recurrency_end_type_get_type_once (void)
{
	static const GEnumValue values[] = {{RECURRENCY_END_TYPE_NEVER, "RECURRENCY_END_TYPE_NEVER", "never"}, {RECURRENCY_END_TYPE_ON_DATE, "RECURRENCY_END_TYPE_ON_DATE", "on-date"}, {RECURRENCY_END_TYPE_AFTER, "RECURRENCY_END_TYPE_AFTER", "after"}, {0, NULL, NULL}};
	GType recurrency_end_type_type_id;
	recurrency_end_type_type_id = g_enum_register_static ("RecurrencyEndType", values);
	return recurrency_end_type_type_id;
}

GType
recurrency_end_type_get_type (void)
{
	static volatile gsize recurrency_end_type_type_id__once = 0;
	if (g_once_init_enter (&recurrency_end_type_type_id__once)) {
		GType recurrency_end_type_type_id;
		recurrency_end_type_type_id = recurrency_end_type_get_type_once ();
		g_once_init_leave (&recurrency_end_type_type_id__once, recurrency_end_type_type_id);
	}
	return recurrency_end_type_type_id__once;
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

gchar*
recurrency_type_to_friendly_string (RecurrencyType self,
                                    gint* interval)
{
	gchar* result;
	switch (self) {
		case RECURRENCY_TYPE_NONE:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Don't Repeat"));
			result = _tmp0_;
			return result;
		}
		case RECURRENCY_TYPE_MINUTELY:
		{
			gboolean _tmp1_ = FALSE;
			if (interval == NULL) {
				_tmp1_ = TRUE;
			} else {
				gint _tmp2_;
				_tmp2_ = 0;
				_tmp1_ = _int_equal (interval, &_tmp2_) == TRUE;
			}
			if (_tmp1_) {
				gchar* _tmp3_;
				_tmp3_ = g_strdup (_ ("Every minute"));
				result = _tmp3_;
				return result;
			} else {
				gchar* _tmp4_;
				_tmp4_ = g_strdup_printf (ngettext (_ ("Every minute"), _ ("Every %d minutes"), *interval), *interval);
				result = _tmp4_;
				return result;
			}
		}
		case RECURRENCY_TYPE_HOURLY:
		{
			gboolean _tmp5_ = FALSE;
			if (interval == NULL) {
				_tmp5_ = TRUE;
			} else {
				gint _tmp6_;
				_tmp6_ = 0;
				_tmp5_ = _int_equal (interval, &_tmp6_) == TRUE;
			}
			if (_tmp5_) {
				gchar* _tmp7_;
				_tmp7_ = g_strdup (_ ("Every hour"));
				result = _tmp7_;
				return result;
			} else {
				gchar* _tmp8_;
				_tmp8_ = g_strdup_printf (ngettext (_ ("Every hour"), _ ("Every %d hours"), *interval), *interval);
				result = _tmp8_;
				return result;
			}
		}
		case RECURRENCY_TYPE_EVERY_DAY:
		{
			gboolean _tmp9_ = FALSE;
			if (interval == NULL) {
				_tmp9_ = TRUE;
			} else {
				gint _tmp10_;
				_tmp10_ = 0;
				_tmp9_ = _int_equal (interval, &_tmp10_) == TRUE;
			}
			if (_tmp9_) {
				gchar* _tmp11_;
				_tmp11_ = g_strdup (_ ("Every day"));
				result = _tmp11_;
				return result;
			} else {
				gchar* _tmp12_;
				_tmp12_ = g_strdup_printf (ngettext (_ ("Every day"), _ ("Every %d days"), *interval), *interval);
				result = _tmp12_;
				return result;
			}
		}
		case RECURRENCY_TYPE_EVERY_WEEK:
		{
			gboolean _tmp13_ = FALSE;
			if (interval == NULL) {
				_tmp13_ = TRUE;
			} else {
				gint _tmp14_;
				_tmp14_ = 0;
				_tmp13_ = _int_equal (interval, &_tmp14_) == TRUE;
			}
			if (_tmp13_) {
				gchar* _tmp15_;
				_tmp15_ = g_strdup (_ ("Every week"));
				result = _tmp15_;
				return result;
			} else {
				gchar* _tmp16_;
				_tmp16_ = g_strdup_printf (ngettext (_ ("Every week"), _ ("Every %d weeks"), *interval), *interval);
				result = _tmp16_;
				return result;
			}
		}
		case RECURRENCY_TYPE_EVERY_MONTH:
		{
			gboolean _tmp17_ = FALSE;
			if (interval == NULL) {
				_tmp17_ = TRUE;
			} else {
				gint _tmp18_;
				_tmp18_ = 0;
				_tmp17_ = _int_equal (interval, &_tmp18_) == TRUE;
			}
			if (_tmp17_) {
				gchar* _tmp19_;
				_tmp19_ = g_strdup (_ ("Every month"));
				result = _tmp19_;
				return result;
			} else {
				gchar* _tmp20_;
				_tmp20_ = g_strdup_printf (ngettext (_ ("Every month"), _ ("Every %d months"), *interval), *interval);
				result = _tmp20_;
				return result;
			}
		}
		case RECURRENCY_TYPE_EVERY_YEAR:
		{
			gboolean _tmp21_ = FALSE;
			if (interval == NULL) {
				_tmp21_ = TRUE;
			} else {
				gint _tmp22_;
				_tmp22_ = 0;
				_tmp21_ = _int_equal (interval, &_tmp22_) == TRUE;
			}
			if (_tmp21_) {
				gchar* _tmp23_;
				_tmp23_ = g_strdup (_ ("Every year"));
				result = _tmp23_;
				return result;
			} else {
				gchar* _tmp24_;
				_tmp24_ = g_strdup_printf (ngettext (_ ("Every year"), _ ("Every %d years"), *interval), *interval);
				result = _tmp24_;
				return result;
			}
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
recurrency_type_get_type_once (void)
{
	static const GEnumValue values[] = {{RECURRENCY_TYPE_MINUTELY, "RECURRENCY_TYPE_MINUTELY", "minutely"}, {RECURRENCY_TYPE_HOURLY, "RECURRENCY_TYPE_HOURLY", "hourly"}, {RECURRENCY_TYPE_EVERY_DAY, "RECURRENCY_TYPE_EVERY_DAY", "every-day"}, {RECURRENCY_TYPE_EVERY_WEEK, "RECURRENCY_TYPE_EVERY_WEEK", "every-week"}, {RECURRENCY_TYPE_EVERY_MONTH, "RECURRENCY_TYPE_EVERY_MONTH", "every-month"}, {RECURRENCY_TYPE_EVERY_YEAR, "RECURRENCY_TYPE_EVERY_YEAR", "every-year"}, {RECURRENCY_TYPE_NONE, "RECURRENCY_TYPE_NONE", "none"}, {0, NULL, NULL}};
	GType recurrency_type_type_id;
	recurrency_type_type_id = g_enum_register_static ("RecurrencyType", values);
	return recurrency_type_type_id;
}

GType
recurrency_type_get_type (void)
{
	static volatile gsize recurrency_type_type_id__once = 0;
	if (g_once_init_enter (&recurrency_type_type_id__once)) {
		GType recurrency_type_type_id;
		recurrency_type_type_id = recurrency_type_get_type_once ();
		g_once_init_leave (&recurrency_type_type_id__once, recurrency_type_type_id);
	}
	return recurrency_type_type_id__once;
}

gchar*
picker_type_to_string (PickerType self)
{
	gchar* result;
	switch (self) {
		case PICKER_TYPE_PROJECTS:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("projects");
			result = _tmp0_;
			return result;
		}
		case PICKER_TYPE_SECTIONS:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("sections");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
picker_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PICKER_TYPE_PROJECTS, "PICKER_TYPE_PROJECTS", "projects"}, {PICKER_TYPE_SECTIONS, "PICKER_TYPE_SECTIONS", "sections"}, {0, NULL, NULL}};
	GType picker_type_type_id;
	picker_type_type_id = g_enum_register_static ("PickerType", values);
	return picker_type_type_id;
}

GType
picker_type_get_type (void)
{
	static volatile gsize picker_type_type_id__once = 0;
	if (g_once_init_enter (&picker_type_type_id__once)) {
		GType picker_type_type_id;
		picker_type_type_id = picker_type_get_type_once ();
		g_once_init_leave (&picker_type_type_id__once, picker_type_type_id);
	}
	return picker_type_type_id__once;
}

static GType
new_task_position_get_type_once (void)
{
	static const GEnumValue values[] = {{NEW_TASK_POSITION_TOP, "NEW_TASK_POSITION_TOP", "top"}, {NEW_TASK_POSITION_BOTTOM, "NEW_TASK_POSITION_BOTTOM", "bottom"}, {0, NULL, NULL}};
	GType new_task_position_type_id;
	new_task_position_type_id = g_enum_register_static ("NewTaskPosition", values);
	return new_task_position_type_id;
}

GType
new_task_position_get_type (void)
{
	static volatile gsize new_task_position_type_id__once = 0;
	if (g_once_init_enter (&new_task_position_type_id__once)) {
		GType new_task_position_type_id;
		new_task_position_type_id = new_task_position_get_type_once ();
		g_once_init_leave (&new_task_position_type_id__once, new_task_position_type_id);
	}
	return new_task_position_type_id__once;
}

gchar*
cal_dav_type_to_string (CalDAVType self)
{
	gchar* result;
	switch (self) {
		case CAL_DAV_TYPE_NEXTCLOUD:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("nextcloud");
			result = _tmp0_;
			return result;
		}
		case CAL_DAV_TYPE_RADICALE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("radicale");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
cal_dav_type_title (CalDAVType self)
{
	gchar* result;
	switch (self) {
		case CAL_DAV_TYPE_NEXTCLOUD:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Nextcloud"));
			result = _tmp0_;
			return result;
		}
		case CAL_DAV_TYPE_RADICALE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Radicale"));
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

CalDAVType
cal_dav_type_parse_index (guint value)
{
	CalDAVType result;
	switch (value) {
		case 0:
		{
			result = CAL_DAV_TYPE_NEXTCLOUD;
			return result;
		}
		case 1:
		{
			result = CAL_DAV_TYPE_RADICALE;
			return result;
		}
		default:
		{
			result = CAL_DAV_TYPE_NEXTCLOUD;
			return result;
		}
	}
}

CalDAVType
cal_dav_type_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	CalDAVType result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("nextcloud")))) {
		switch (0) {
			default:
			{
				result = CAL_DAV_TYPE_NEXTCLOUD;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("radicale")))) {
		switch (0) {
			default:
			{
				result = CAL_DAV_TYPE_RADICALE;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = CAL_DAV_TYPE_NEXTCLOUD;
				return result;
			}
		}
	}
}

static GType
cal_dav_type_get_type_once (void)
{
	static const GEnumValue values[] = {{CAL_DAV_TYPE_NEXTCLOUD, "CAL_DAV_TYPE_NEXTCLOUD", "nextcloud"}, {CAL_DAV_TYPE_RADICALE, "CAL_DAV_TYPE_RADICALE", "radicale"}, {0, NULL, NULL}};
	GType cal_dav_type_type_id;
	cal_dav_type_type_id = g_enum_register_static ("CalDAVType", values);
	return cal_dav_type_type_id;
}

GType
cal_dav_type_get_type (void)
{
	static volatile gsize cal_dav_type_type_id__once = 0;
	if (g_once_init_enter (&cal_dav_type_type_id__once)) {
		GType cal_dav_type_type_id;
		cal_dav_type_type_id = cal_dav_type_get_type_once ();
		g_once_init_leave (&cal_dav_type_type_id__once, cal_dav_type_type_id);
	}
	return cal_dav_type_type_id__once;
}

gchar*
filter_item_type_to_string (FilterItemType self)
{
	gchar* result;
	switch (self) {
		case FILTER_ITEM_TYPE_PRIORITY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("priority");
			result = _tmp0_;
			return result;
		}
		case FILTER_ITEM_TYPE_LABEL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("label");
			result = _tmp1_;
			return result;
		}
		case FILTER_ITEM_TYPE_DUE_DATE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("due-date");
			result = _tmp2_;
			return result;
		}
		case FILTER_ITEM_TYPE_SECTION:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("section");
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
filter_item_type_get_title (FilterItemType self)
{
	gchar* result;
	switch (self) {
		case FILTER_ITEM_TYPE_PRIORITY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Priority"));
			result = _tmp0_;
			return result;
		}
		case FILTER_ITEM_TYPE_LABEL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Label"));
			result = _tmp1_;
			return result;
		}
		case FILTER_ITEM_TYPE_DUE_DATE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Due Date"));
			result = _tmp2_;
			return result;
		}
		case FILTER_ITEM_TYPE_SECTION:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Section"));
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
filter_item_type_get_icon (FilterItemType self)
{
	gchar* result;
	switch (self) {
		case FILTER_ITEM_TYPE_PRIORITY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("flag-outline-thick-symbolic");
			result = _tmp0_;
			return result;
		}
		case FILTER_ITEM_TYPE_LABEL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("tag-outline-symbolic");
			result = _tmp1_;
			return result;
		}
		case FILTER_ITEM_TYPE_DUE_DATE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("month-symbolic");
			result = _tmp2_;
			return result;
		}
		case FILTER_ITEM_TYPE_SECTION:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("arrow3-right-symbolic");
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
filter_item_type_get_type_once (void)
{
	static const GEnumValue values[] = {{FILTER_ITEM_TYPE_PRIORITY, "FILTER_ITEM_TYPE_PRIORITY", "priority"}, {FILTER_ITEM_TYPE_LABEL, "FILTER_ITEM_TYPE_LABEL", "label"}, {FILTER_ITEM_TYPE_DUE_DATE, "FILTER_ITEM_TYPE_DUE_DATE", "due-date"}, {FILTER_ITEM_TYPE_SECTION, "FILTER_ITEM_TYPE_SECTION", "section"}, {0, NULL, NULL}};
	GType filter_item_type_type_id;
	filter_item_type_type_id = g_enum_register_static ("FilterItemType", values);
	return filter_item_type_type_id;
}

GType
filter_item_type_get_type (void)
{
	static volatile gsize filter_item_type_type_id__once = 0;
	if (g_once_init_enter (&filter_item_type_type_id__once)) {
		GType filter_item_type_type_id;
		filter_item_type_type_id = filter_item_type_get_type_once ();
		g_once_init_leave (&filter_item_type_type_id__once, filter_item_type_type_id);
	}
	return filter_item_type_type_id__once;
}

gchar*
reminder_type_to_string (ReminderType self)
{
	gchar* result;
	switch (self) {
		case REMINDER_TYPE_ABSOLUTE:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("absolute");
			result = _tmp0_;
			return result;
		}
		case REMINDER_TYPE_RELATIVE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("relative");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
reminder_type_get_type_once (void)
{
	static const GEnumValue values[] = {{REMINDER_TYPE_ABSOLUTE, "REMINDER_TYPE_ABSOLUTE", "absolute"}, {REMINDER_TYPE_RELATIVE, "REMINDER_TYPE_RELATIVE", "relative"}, {0, NULL, NULL}};
	GType reminder_type_type_id;
	reminder_type_type_id = g_enum_register_static ("ReminderType", values);
	return reminder_type_type_id;
}

GType
reminder_type_get_type (void)
{
	static volatile gsize reminder_type_type_id__once = 0;
	if (g_once_init_enter (&reminder_type_type_id__once)) {
		GType reminder_type_type_id;
		reminder_type_type_id = reminder_type_get_type_once ();
		g_once_init_leave (&reminder_type_type_id__once, reminder_type_type_id);
	}
	return reminder_type_type_id__once;
}

gchar*
item_type_to_string (ItemType self)
{
	gchar* result;
	switch (self) {
		case ITEM_TYPE_TASK:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("task");
			result = _tmp0_;
			return result;
		}
		case ITEM_TYPE_NOTE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("note");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

ItemType
item_type_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	ItemType result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("task")))) {
		switch (0) {
			default:
			{
				result = ITEM_TYPE_TASK;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("note")))) {
		switch (0) {
			default:
			{
				result = ITEM_TYPE_NOTE;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

static GType
item_type_get_type_once (void)
{
	static const GEnumValue values[] = {{ITEM_TYPE_TASK, "ITEM_TYPE_TASK", "task"}, {ITEM_TYPE_NOTE, "ITEM_TYPE_NOTE", "note"}, {0, NULL, NULL}};
	GType item_type_type_id;
	item_type_type_id = g_enum_register_static ("ItemType", values);
	return item_type_type_id;
}

GType
item_type_get_type (void)
{
	static volatile gsize item_type_type_id__once = 0;
	if (g_once_init_enter (&item_type_type_id__once)) {
		GType item_type_type_id;
		item_type_type_id = item_type_get_type_once ();
		g_once_init_leave (&item_type_type_id__once, item_type_type_id);
	}
	return item_type_type_id__once;
}

ObjectEventType
object_event_type_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	ObjectEventType result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("insert")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_TYPE_INSERT;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("update")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_TYPE_UPDATE;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

gchar*
object_event_type_to_string (ObjectEventType self)
{
	gchar* result;
	switch (self) {
		case OBJECT_EVENT_TYPE_INSERT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("insert");
			result = _tmp0_;
			return result;
		}
		case OBJECT_EVENT_TYPE_UPDATE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("update");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
object_event_type_get_label (ObjectEventType self)
{
	gchar* result;
	switch (self) {
		case OBJECT_EVENT_TYPE_INSERT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Task Created"));
			result = _tmp0_;
			return result;
		}
		case OBJECT_EVENT_TYPE_UPDATE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Task Updated"));
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
object_event_type_get_type_once (void)
{
	static const GEnumValue values[] = {{OBJECT_EVENT_TYPE_INSERT, "OBJECT_EVENT_TYPE_INSERT", "insert"}, {OBJECT_EVENT_TYPE_UPDATE, "OBJECT_EVENT_TYPE_UPDATE", "update"}, {0, NULL, NULL}};
	GType object_event_type_type_id;
	object_event_type_type_id = g_enum_register_static ("ObjectEventType", values);
	return object_event_type_type_id;
}

GType
object_event_type_get_type (void)
{
	static volatile gsize object_event_type_type_id__once = 0;
	if (g_once_init_enter (&object_event_type_type_id__once)) {
		GType object_event_type_type_id;
		object_event_type_type_id = object_event_type_get_type_once ();
		g_once_init_leave (&object_event_type_type_id__once, object_event_type_type_id);
	}
	return object_event_type_type_id__once;
}

ObjectEventKeyType
object_event_key_type_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	static GQuark _tmp1_label6 = 0;
	static GQuark _tmp1_label7 = 0;
	static GQuark _tmp1_label8 = 0;
	ObjectEventKeyType result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("content")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_CONTENT;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("description")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_DESCRIPTION;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("due")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_DUE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("priority")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_PRIORITY;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("labels")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_LABELS;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("pinned")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_PINNED;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("checked")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_CHECKED;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("project")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_PROJECT;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("section")))) {
		switch (0) {
			default:
			{
				result = OBJECT_EVENT_KEY_TYPE_SECTION;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

gchar*
object_event_key_type_get_label (ObjectEventKeyType self)
{
	gchar* result;
	switch (self) {
		case OBJECT_EVENT_KEY_TYPE_CONTENT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Content"));
			result = _tmp0_;
			return result;
		}
		case OBJECT_EVENT_KEY_TYPE_DESCRIPTION:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Description"));
			result = _tmp1_;
			return result;
		}
		case OBJECT_EVENT_KEY_TYPE_DUE:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Scheduled"));
			result = _tmp2_;
			return result;
		}
		case OBJECT_EVENT_KEY_TYPE_PRIORITY:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Priority"));
			result = _tmp3_;
			return result;
		}
		case OBJECT_EVENT_KEY_TYPE_LABELS:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Labels"));
			result = _tmp4_;
			return result;
		}
		case OBJECT_EVENT_KEY_TYPE_PINNED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Pin"));
			result = _tmp5_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
object_event_key_type_get_type_once (void)
{
	static const GEnumValue values[] = {{OBJECT_EVENT_KEY_TYPE_CONTENT, "OBJECT_EVENT_KEY_TYPE_CONTENT", "content"}, {OBJECT_EVENT_KEY_TYPE_DESCRIPTION, "OBJECT_EVENT_KEY_TYPE_DESCRIPTION", "description"}, {OBJECT_EVENT_KEY_TYPE_DUE, "OBJECT_EVENT_KEY_TYPE_DUE", "due"}, {OBJECT_EVENT_KEY_TYPE_PRIORITY, "OBJECT_EVENT_KEY_TYPE_PRIORITY", "priority"}, {OBJECT_EVENT_KEY_TYPE_LABELS, "OBJECT_EVENT_KEY_TYPE_LABELS", "labels"}, {OBJECT_EVENT_KEY_TYPE_PINNED, "OBJECT_EVENT_KEY_TYPE_PINNED", "pinned"}, {OBJECT_EVENT_KEY_TYPE_CHECKED, "OBJECT_EVENT_KEY_TYPE_CHECKED", "checked"}, {OBJECT_EVENT_KEY_TYPE_PROJECT, "OBJECT_EVENT_KEY_TYPE_PROJECT", "project"}, {OBJECT_EVENT_KEY_TYPE_SECTION, "OBJECT_EVENT_KEY_TYPE_SECTION", "section"}, {0, NULL, NULL}};
	GType object_event_key_type_type_id;
	object_event_key_type_type_id = g_enum_register_static ("ObjectEventKeyType", values);
	return object_event_key_type_type_id;
}

GType
object_event_key_type_get_type (void)
{
	static volatile gsize object_event_key_type_type_id__once = 0;
	if (g_once_init_enter (&object_event_key_type_type_id__once)) {
		GType object_event_key_type_type_id;
		object_event_key_type_type_id = object_event_key_type_get_type_once ();
		g_once_init_leave (&object_event_key_type_type_id__once, object_event_key_type_type_id);
	}
	return object_event_key_type_type_id__once;
}

static GType
label_picker_type_get_type_once (void)
{
	static const GEnumValue values[] = {{LABEL_PICKER_TYPE_FILTER_AND_CREATE, "LABEL_PICKER_TYPE_FILTER_AND_CREATE", "filter-and-create"}, {LABEL_PICKER_TYPE_FILTER_ONLY, "LABEL_PICKER_TYPE_FILTER_ONLY", "filter-only"}, {0, NULL, NULL}};
	GType label_picker_type_type_id;
	label_picker_type_type_id = g_enum_register_static ("LabelPickerType", values);
	return label_picker_type_type_id;
}

GType
label_picker_type_get_type (void)
{
	static volatile gsize label_picker_type_type_id__once = 0;
	if (g_once_init_enter (&label_picker_type_type_id__once)) {
		GType label_picker_type_type_id;
		label_picker_type_type_id = label_picker_type_get_type_once ();
		g_once_init_leave (&label_picker_type_type_id__once, label_picker_type_type_id);
	}
	return label_picker_type_type_id__once;
}

ItemPriority
item_priority_parse (const gchar* value)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	ItemPriority result;
	g_return_val_if_fail (value != NULL, 0);
	_tmp0_ = value;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("p1")))) {
		switch (0) {
			default:
			{
				result = ITEM_PRIORITY_HIGHT;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("p2")))) {
		switch (0) {
			default:
			{
				result = ITEM_PRIORITY_MEDIUM;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("p3")))) {
		switch (0) {
			default:
			{
				result = ITEM_PRIORITY_LOW;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("p4")))) {
		switch (0) {
			default:
			{
				result = ITEM_PRIORITY_NONE;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = ITEM_PRIORITY_NONE;
				return result;
			}
		}
	}
}

static GType
item_priority_get_type_once (void)
{
	static const GEnumValue values[] = {{ITEM_PRIORITY_HIGHT, "ITEM_PRIORITY_HIGHT", "hight"}, {ITEM_PRIORITY_MEDIUM, "ITEM_PRIORITY_MEDIUM", "medium"}, {ITEM_PRIORITY_LOW, "ITEM_PRIORITY_LOW", "low"}, {ITEM_PRIORITY_NONE, "ITEM_PRIORITY_NONE", "none"}, {0, NULL, NULL}};
	GType item_priority_type_id;
	item_priority_type_id = g_enum_register_static ("ItemPriority", values);
	return item_priority_type_id;
}

GType
item_priority_get_type (void)
{
	static volatile gsize item_priority_type_id__once = 0;
	if (g_once_init_enter (&item_priority_type_id__once)) {
		GType item_priority_type_id;
		item_priority_type_id = item_priority_get_type_once ();
		g_once_init_leave (&item_priority_type_id__once, item_priority_type_id);
	}
	return item_priority_type_id__once;
}

