/* Radicale.c generated by valac 0.56.18, the Vala compiler
 * generated from Radicale.vala, do not modify */

/*
* Copyright © 2024 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gxml/gxml.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer services_cal_dav_providers_radicale_parent_class = NULL;

static gchar* services_cal_dav_providers_radicale_real_get_server_url (ServicesCalDAVProvidersBase* base,
                                                                const gchar* url,
                                                                const gchar* username,
                                                                const gchar* password);
static gchar* services_cal_dav_providers_radicale_real_get_account_url (ServicesCalDAVProvidersBase* base,
                                                                 const gchar* server_url,
                                                                 const gchar* username);
static void services_cal_dav_providers_radicale_real_set_user_data (ServicesCalDAVProvidersBase* base,
                                                             GXmlDomDocument* doc,
                                                             ObjectsSource* source);
static gchar* services_cal_dav_providers_radicale_real_get_all_taskslist_url (ServicesCalDAVProvidersBase* base,
                                                                       const gchar* server_url,
                                                                       const gchar* username);
static GeeArrayList* services_cal_dav_providers_radicale_real_get_projects_by_doc (ServicesCalDAVProvidersBase* base,
                                                                            GXmlDomDocument* doc,
                                                                            ObjectsSource* source);
static gboolean services_cal_dav_providers_radicale_real_is_vtodo_calendar (ServicesCalDAVProvidersBase* base,
                                                                     GXmlDomElement* element);
static GType services_cal_dav_providers_radicale_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

ServicesCalDAVProvidersRadicale*
services_cal_dav_providers_radicale_construct (GType object_type)
{
	ServicesCalDAVProvidersRadicale* self = NULL;
	self = (ServicesCalDAVProvidersRadicale*) services_cal_dav_providers_base_construct (object_type);
	services_cal_dav_providers_base_set_LOGIN_REQUEST ((ServicesCalDAVProvidersBase*) self, "\n" \
"            <d:propfind xmlns:d=\"DAV:\">\n" \
"                <d:prop>\n" \
"                    <d:current-user-principal />\n" \
"                </d:prop>\n" \
"            </d:propfind>\n" \
"        ");
	services_cal_dav_providers_base_set_USER_DATA_REQUEST ((ServicesCalDAVProvidersBase*) self, "\n" \
"            <x0:propfind xmlns:x0=\"DAV:\">\n" \
"                <x0:prop>\n" \
"                    <x0:displayname/>\n" \
"                    <x2:email-address xmlns:x2=\"http://sabredav.org/n" \
"s\"/>\n" \
"                </x0:prop>\n" \
"            </x0:propfind>\n" \
"        ");
	services_cal_dav_providers_base_set_TASKLIST_REQUEST ((ServicesCalDAVProvidersBase*) self, "\n" \
"            <?xml version=\"1.0\" encoding=\"utf-8\" ?>\n" \
"            <propfind\n" \
"                xmlns=\"DAV:\"\n" \
"                xmlns:C=\"urn:ietf:params:xml:ns:caldav\"\n" \
"                xmlns:CR=\"urn:ietf:params:xml:ns:carddav\"\n" \
"                xmlns:CS=\"http://calendarserver.org/ns/\"\n" \
"                xmlns:I=\"http://apple.com/ns/ical/\"\n" \
"                xmlns:INF=\"http://inf-it.com/ns/ab/\"\n" \
"                xmlns:RADICALE=\"http://radicale.org/ns/\">\n" \
"                <prop>\n" \
"                    <resourcetype />\n" \
"                    <RADICALE:displayname />\n" \
"                    <I:calendar-color />\n" \
"                    <INF:addressbook-color />\n" \
"                    <C:calendar-description />\n" \
"                    <C:supported-calendar-component-set />\n" \
"                    <CR:addressbook-description />\n" \
"                    <CS:source />\n" \
"                    <sync-token />\n" \
"                    <RADICALE:getcontentcount />\n" \
"                    <getcontentlength />\n" \
"                </prop>\n" \
"            </propfind>\n" \
"        ");
	return self;
}

ServicesCalDAVProvidersRadicale*
services_cal_dav_providers_radicale_new (void)
{
	return services_cal_dav_providers_radicale_construct (SERVICES_CAL_DAV_PROVIDERS_TYPE_RADICALE);
}

static gchar*
services_cal_dav_providers_radicale_real_get_server_url (ServicesCalDAVProvidersBase* base,
                                                         const gchar* url,
                                                         const gchar* username,
                                                         const gchar* password)
{
	ServicesCalDAVProvidersRadicale * self;
	gchar* server_url = NULL;
	gchar* _tmp0_;
	gchar* scheme = NULL;
	gchar* _tmp1_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	self = (ServicesCalDAVProvidersRadicale*) base;
	g_return_val_if_fail (url != NULL, NULL);
	g_return_val_if_fail (username != NULL, NULL);
	g_return_val_if_fail (password != NULL, NULL);
	_tmp0_ = g_strdup ("");
	server_url = _tmp0_;
	_tmp1_ = g_strdup ("");
	scheme = _tmp1_;
	{
		GUri* _uri = NULL;
		GUri* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp2_ = g_uri_parse (url, G_URI_FLAGS_NONE, &_inner_error0_);
		_uri = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = g_uri_get_host (_uri);
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (server_url);
		server_url = _tmp4_;
		_tmp5_ = g_uri_get_scheme (_uri);
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (scheme);
		scheme = _tmp6_;
		_g_uri_unref0 (_uri);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_debug ("Radicale.vala:76: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (scheme);
		_g_free0 (server_url);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp9_ = scheme;
	_tmp10_ = g_uri_escape_string (password, NULL, TRUE);
	_tmp11_ = _tmp10_;
	_tmp12_ = server_url;
	_tmp13_ = g_strdup_printf ("%s://%s:%s@%s", _tmp9_, username, _tmp11_, _tmp12_);
	_tmp14_ = _tmp13_;
	_g_free0 (_tmp11_);
	result = _tmp14_;
	_g_free0 (scheme);
	_g_free0 (server_url);
	return result;
}

static gchar*
services_cal_dav_providers_radicale_real_get_account_url (ServicesCalDAVProvidersBase* base,
                                                          const gchar* server_url,
                                                          const gchar* username)
{
	ServicesCalDAVProvidersRadicale * self;
	gchar* _tmp0_;
	gchar* result;
	self = (ServicesCalDAVProvidersRadicale*) base;
	g_return_val_if_fail (server_url != NULL, NULL);
	g_return_val_if_fail (username != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%s/%s/", server_url, username);
	result = _tmp0_;
	return result;
}

static void
services_cal_dav_providers_radicale_real_set_user_data (ServicesCalDAVProvidersBase* base,
                                                        GXmlDomDocument* doc,
                                                        ObjectsSource* source)
{
	ServicesCalDAVProvidersRadicale * self;
	ObjectsSourceCalDAVData* _tmp0_;
	ObjectsSourceCalDAVData* _tmp1_;
	ObjectsSourceCalDAVData* _tmp2_;
	ObjectsSourceCalDAVData* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ObjectsSourceCalDAVData* _tmp6_;
	ObjectsSourceCalDAVData* _tmp7_;
	self = (ServicesCalDAVProvidersRadicale*) base;
	g_return_if_fail (doc != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = objects_source_get_caldav_data (source);
	_tmp1_ = _tmp0_;
	_tmp2_ = objects_source_get_caldav_data (source);
	_tmp3_ = _tmp2_;
	_tmp4_ = objects_source_cal_dav_data_get_username (_tmp3_);
	_tmp5_ = _tmp4_;
	objects_source_cal_dav_data_set_user_displayname (_tmp1_, _tmp5_);
	_tmp6_ = objects_source_get_caldav_data (source);
	_tmp7_ = _tmp6_;
	objects_source_cal_dav_data_set_user_email (_tmp7_, "");
}

static gchar*
services_cal_dav_providers_radicale_real_get_all_taskslist_url (ServicesCalDAVProvidersBase* base,
                                                                const gchar* server_url,
                                                                const gchar* username)
{
	ServicesCalDAVProvidersRadicale * self;
	gchar* _tmp0_;
	gchar* result;
	self = (ServicesCalDAVProvidersRadicale*) base;
	g_return_val_if_fail (server_url != NULL, NULL);
	g_return_val_if_fail (username != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%s/%s/", server_url, username);
	result = _tmp0_;
	return result;
}

static GeeArrayList*
services_cal_dav_providers_radicale_real_get_projects_by_doc (ServicesCalDAVProvidersBase* base,
                                                              GXmlDomDocument* doc,
                                                              ObjectsSource* source)
{
	ServicesCalDAVProvidersRadicale * self;
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GXmlDomHTMLCollection* response = NULL;
	GXmlDomHTMLCollection* _tmp1_;
	GeeArrayList* result;
	self = (ServicesCalDAVProvidersRadicale*) base;
	g_return_val_if_fail (doc != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	_tmp1_ = gxml_dom_document_get_elements_by_tag_name (doc, "response");
	response = _tmp1_;
	{
		GXmlDomHTMLCollection* _element_list = NULL;
		GXmlDomHTMLCollection* _tmp2_;
		gint _element_size = 0;
		GXmlDomHTMLCollection* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _element_index = 0;
		_tmp2_ = response;
		_element_list = _tmp2_;
		_tmp3_ = _element_list;
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_element_size = _tmp5_;
		_element_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			GXmlDomElement* element = NULL;
			GXmlDomHTMLCollection* _tmp8_;
			gpointer _tmp9_;
			GXmlDomElement* _tmp10_;
			_element_index = _element_index + 1;
			_tmp6_ = _element_index;
			_tmp7_ = _element_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _element_list;
			_tmp9_ = gee_list_get ((GeeList*) _tmp8_, _element_index);
			element = (GXmlDomElement*) _tmp9_;
			_tmp10_ = element;
			if (services_cal_dav_providers_base_is_vtodo_calendar ((ServicesCalDAVProvidersBase*) self, _tmp10_)) {
				ObjectsProject* project = NULL;
				ObjectsProject* _tmp11_;
				ObjectsProject* _tmp12_;
				GXmlDomElement* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				ObjectsProject* _tmp16_;
				GXmlDomElement* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				ObjectsProject* _tmp20_;
				GXmlDomElement* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				ObjectsProject* _tmp24_;
				GXmlDomElement* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GeeArrayList* _tmp28_;
				ObjectsProject* _tmp29_;
				_tmp11_ = objects_project_new ();
				project = _tmp11_;
				_tmp12_ = project;
				_tmp13_ = element;
				_tmp14_ = services_cal_dav_providers_radicale_get_id_from_url (self, _tmp13_);
				_tmp15_ = _tmp14_;
				objects_base_object_set_id ((ObjectsBaseObject*) _tmp12_, _tmp15_);
				_g_free0 (_tmp15_);
				_tmp16_ = project;
				_tmp17_ = element;
				_tmp18_ = services_cal_dav_providers_radicale_get_prop_value (self, _tmp17_, "RADICALE:displayname");
				_tmp19_ = _tmp18_;
				objects_base_object_set_name ((ObjectsBaseObject*) _tmp16_, _tmp19_);
				_g_free0 (_tmp19_);
				_tmp20_ = project;
				_tmp21_ = element;
				_tmp22_ = services_cal_dav_providers_radicale_get_prop_value (self, _tmp21_, "ICAL:calendar-color");
				_tmp23_ = _tmp22_;
				objects_project_set_color (_tmp20_, _tmp23_);
				_g_free0 (_tmp23_);
				_tmp24_ = project;
				_tmp25_ = element;
				_tmp26_ = services_cal_dav_providers_radicale_get_prop_value (self, _tmp25_, "sync-token");
				_tmp27_ = _tmp26_;
				objects_project_set_sync_id (_tmp24_, _tmp27_);
				_g_free0 (_tmp27_);
				_tmp28_ = return_value;
				_tmp29_ = project;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
				_g_object_unref0 (project);
			}
			_g_object_unref0 (element);
		}
	}
	result = return_value;
	_g_object_unref0 (response);
	return result;
}

gchar*
services_cal_dav_providers_radicale_get_id_from_url (ServicesCalDAVProvidersRadicale* self,
                                                     GXmlDomElement* element)
{
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	GXmlDomElement* href = NULL;
	GXmlDomHTMLCollection* _tmp6_;
	GXmlDomHTMLCollection* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomElement* _tmp9_;
	gchar** parts = NULL;
	GXmlDomElement* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (element != NULL, NULL);
	_tmp0_ = gxml_dom_element_get_elements_by_tag_name (element, "href");
	_tmp1_ = _tmp0_;
	_tmp2_ = gxml_dom_html_collection_get_length (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ <= 0;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		result = _tmp5_;
		return result;
	}
	_tmp6_ = gxml_dom_element_get_elements_by_tag_name (element, "href");
	_tmp7_ = _tmp6_;
	_tmp8_ = gxml_dom_html_collection_get_element (_tmp7_, 0);
	_tmp9_ = _tmp8_;
	_g_object_unref0 (_tmp7_);
	href = _tmp9_;
	_tmp10_ = href;
	_tmp11_ = gxml_dom_node_get_text_content ((GXmlDomNode*) _tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "/", 0);
	_tmp16_ = _tmp15_;
	_tmp16__length1 = _vala_array_length (_tmp14_);
	_g_free0 (_tmp13_);
	parts = _tmp16_;
	parts_length1 = _tmp16__length1;
	_parts_size_ = parts_length1;
	_tmp17_ = parts;
	_tmp17__length1 = parts_length1;
	_tmp18_ = parts;
	_tmp18__length1 = parts_length1;
	_tmp19_ = _tmp17_[_tmp18__length1 - 2];
	_tmp20_ = g_strdup (_tmp19_);
	result = _tmp20_;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (href);
	return result;
}

gchar*
services_cal_dav_providers_radicale_get_prop_value (ServicesCalDAVProvidersRadicale* self,
                                                    GXmlDomElement* element,
                                                    const gchar* key)
{
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	GXmlDomElement* propstat = NULL;
	GXmlDomHTMLCollection* _tmp6_;
	GXmlDomHTMLCollection* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomElement* _tmp9_;
	GXmlDomElement* _tmp10_;
	GXmlDomHTMLCollection* _tmp11_;
	GXmlDomHTMLCollection* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gboolean _tmp15_;
	GXmlDomElement* prop = NULL;
	GXmlDomElement* _tmp17_;
	GXmlDomHTMLCollection* _tmp18_;
	GXmlDomHTMLCollection* _tmp19_;
	GXmlDomElement* _tmp20_;
	GXmlDomElement* _tmp21_;
	GXmlDomElement* _tmp22_;
	GXmlDomHTMLCollection* _tmp23_;
	GXmlDomHTMLCollection* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gboolean _tmp27_;
	GXmlDomElement* _tmp29_;
	GXmlDomHTMLCollection* _tmp30_;
	GXmlDomHTMLCollection* _tmp31_;
	GXmlDomElement* _tmp32_;
	GXmlDomElement* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (element != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = gxml_dom_element_get_elements_by_tag_name (element, "propstat");
	_tmp1_ = _tmp0_;
	_tmp2_ = gxml_dom_html_collection_get_length (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ <= 0;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		result = _tmp5_;
		return result;
	}
	_tmp6_ = gxml_dom_element_get_elements_by_tag_name (element, "propstat");
	_tmp7_ = _tmp6_;
	_tmp8_ = gxml_dom_html_collection_get_element (_tmp7_, 0);
	_tmp9_ = _tmp8_;
	_g_object_unref0 (_tmp7_);
	propstat = _tmp9_;
	_tmp10_ = propstat;
	_tmp11_ = gxml_dom_element_get_elements_by_tag_name (_tmp10_, "prop");
	_tmp12_ = _tmp11_;
	_tmp13_ = gxml_dom_html_collection_get_length (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = _tmp14_ <= 0;
	_g_object_unref0 (_tmp12_);
	if (_tmp15_) {
		gchar* _tmp16_;
		_tmp16_ = g_strdup ("");
		result = _tmp16_;
		_g_object_unref0 (propstat);
		return result;
	}
	_tmp17_ = propstat;
	_tmp18_ = gxml_dom_element_get_elements_by_tag_name (_tmp17_, "prop");
	_tmp19_ = _tmp18_;
	_tmp20_ = gxml_dom_html_collection_get_element (_tmp19_, 0);
	_tmp21_ = _tmp20_;
	_g_object_unref0 (_tmp19_);
	prop = _tmp21_;
	_tmp22_ = prop;
	_tmp23_ = gxml_dom_element_get_elements_by_tag_name (_tmp22_, key);
	_tmp24_ = _tmp23_;
	_tmp25_ = gxml_dom_html_collection_get_length (_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = _tmp26_ <= 0;
	_g_object_unref0 (_tmp24_);
	if (_tmp27_) {
		gchar* _tmp28_;
		_tmp28_ = g_strdup ("");
		result = _tmp28_;
		_g_object_unref0 (prop);
		_g_object_unref0 (propstat);
		return result;
	}
	_tmp29_ = prop;
	_tmp30_ = gxml_dom_element_get_elements_by_tag_name (_tmp29_, key);
	_tmp31_ = _tmp30_;
	_tmp32_ = gxml_dom_html_collection_get_element (_tmp31_, 0);
	_tmp33_ = _tmp32_;
	_tmp34_ = gxml_dom_node_get_text_content ((GXmlDomNode*) _tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = _tmp35_;
	_g_object_unref0 (_tmp33_);
	_g_object_unref0 (_tmp31_);
	result = _tmp36_;
	_g_object_unref0 (prop);
	_g_object_unref0 (propstat);
	return result;
}

static gboolean
services_cal_dav_providers_radicale_real_is_vtodo_calendar (ServicesCalDAVProvidersBase* base,
                                                            GXmlDomElement* element)
{
	ServicesCalDAVProvidersRadicale * self;
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	GXmlDomElement* propstat = NULL;
	GXmlDomHTMLCollection* _tmp5_;
	GXmlDomHTMLCollection* _tmp6_;
	GXmlDomElement* _tmp7_;
	GXmlDomElement* _tmp8_;
	GXmlDomElement* _tmp9_;
	GXmlDomHTMLCollection* _tmp10_;
	GXmlDomHTMLCollection* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	GXmlDomElement* prop = NULL;
	GXmlDomElement* _tmp15_;
	GXmlDomHTMLCollection* _tmp16_;
	GXmlDomHTMLCollection* _tmp17_;
	GXmlDomElement* _tmp18_;
	GXmlDomElement* _tmp19_;
	GXmlDomElement* _tmp20_;
	GXmlDomHTMLCollection* _tmp21_;
	GXmlDomHTMLCollection* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gboolean _tmp25_;
	GXmlDomElement* resourcetype = NULL;
	GXmlDomElement* _tmp26_;
	GXmlDomHTMLCollection* _tmp27_;
	GXmlDomHTMLCollection* _tmp28_;
	GXmlDomElement* _tmp29_;
	GXmlDomElement* _tmp30_;
	gboolean is_calendar = FALSE;
	GXmlDomElement* _tmp31_;
	GXmlDomHTMLCollection* _tmp32_;
	GXmlDomHTMLCollection* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gboolean _tmp36_;
	gboolean is_vtodo = FALSE;
	gboolean result;
	self = (ServicesCalDAVProvidersRadicale*) base;
	g_return_val_if_fail (element != NULL, FALSE);
	_tmp0_ = gxml_dom_element_get_elements_by_tag_name (element, "propstat");
	_tmp1_ = _tmp0_;
	_tmp2_ = gxml_dom_html_collection_get_length (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ <= 0;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = gxml_dom_element_get_elements_by_tag_name (element, "propstat");
	_tmp6_ = _tmp5_;
	_tmp7_ = gxml_dom_html_collection_get_element (_tmp6_, 0);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp6_);
	propstat = _tmp8_;
	_tmp9_ = propstat;
	_tmp10_ = gxml_dom_element_get_elements_by_tag_name (_tmp9_, "prop");
	_tmp11_ = _tmp10_;
	_tmp12_ = gxml_dom_html_collection_get_length (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = _tmp13_ <= 0;
	_g_object_unref0 (_tmp11_);
	if (_tmp14_) {
		result = FALSE;
		_g_object_unref0 (propstat);
		return result;
	}
	_tmp15_ = propstat;
	_tmp16_ = gxml_dom_element_get_elements_by_tag_name (_tmp15_, "prop");
	_tmp17_ = _tmp16_;
	_tmp18_ = gxml_dom_html_collection_get_element (_tmp17_, 0);
	_tmp19_ = _tmp18_;
	_g_object_unref0 (_tmp17_);
	prop = _tmp19_;
	_tmp20_ = prop;
	_tmp21_ = gxml_dom_element_get_elements_by_tag_name (_tmp20_, "resourcetype");
	_tmp22_ = _tmp21_;
	_tmp23_ = gxml_dom_html_collection_get_length (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = _tmp24_ <= 0;
	_g_object_unref0 (_tmp22_);
	if (_tmp25_) {
		result = FALSE;
		_g_object_unref0 (prop);
		_g_object_unref0 (propstat);
		return result;
	}
	_tmp26_ = prop;
	_tmp27_ = gxml_dom_element_get_elements_by_tag_name (_tmp26_, "resourcetype");
	_tmp28_ = _tmp27_;
	_tmp29_ = gxml_dom_html_collection_get_element (_tmp28_, 0);
	_tmp30_ = _tmp29_;
	_g_object_unref0 (_tmp28_);
	resourcetype = _tmp30_;
	_tmp31_ = resourcetype;
	_tmp32_ = gxml_dom_element_get_elements_by_tag_name (_tmp31_, "C:calendar");
	_tmp33_ = _tmp32_;
	_tmp34_ = gxml_dom_html_collection_get_length (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = _tmp35_ > 0;
	_g_object_unref0 (_tmp33_);
	is_calendar = _tmp36_;
	is_vtodo = FALSE;
	if (is_calendar) {
		GXmlDomElement* _tmp37_;
		GXmlDomHTMLCollection* _tmp38_;
		GXmlDomHTMLCollection* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gboolean _tmp42_;
		GXmlDomElement* supported_calendar = NULL;
		GXmlDomElement* _tmp43_;
		GXmlDomHTMLCollection* _tmp44_;
		GXmlDomHTMLCollection* _tmp45_;
		GXmlDomElement* _tmp46_;
		GXmlDomElement* _tmp47_;
		GXmlDomHTMLCollection* calendar_comps = NULL;
		GXmlDomElement* _tmp48_;
		GXmlDomHTMLCollection* _tmp49_;
		_tmp37_ = prop;
		_tmp38_ = gxml_dom_element_get_elements_by_tag_name (_tmp37_, "C:supported-calendar-component-set");
		_tmp39_ = _tmp38_;
		_tmp40_ = gxml_dom_html_collection_get_length (_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp42_ = _tmp41_ <= 0;
		_g_object_unref0 (_tmp39_);
		if (_tmp42_) {
			result = FALSE;
			_g_object_unref0 (resourcetype);
			_g_object_unref0 (prop);
			_g_object_unref0 (propstat);
			return result;
		}
		_tmp43_ = prop;
		_tmp44_ = gxml_dom_element_get_elements_by_tag_name (_tmp43_, "C:supported-calendar-component-set");
		_tmp45_ = _tmp44_;
		_tmp46_ = gxml_dom_html_collection_get_element (_tmp45_, 0);
		_tmp47_ = _tmp46_;
		_g_object_unref0 (_tmp45_);
		supported_calendar = _tmp47_;
		_tmp48_ = supported_calendar;
		_tmp49_ = gxml_dom_element_get_elements_by_tag_name (_tmp48_, "C:comp");
		calendar_comps = _tmp49_;
		{
			GXmlDomHTMLCollection* _calendar_comp_list = NULL;
			GXmlDomHTMLCollection* _tmp50_;
			gint _calendar_comp_size = 0;
			GXmlDomHTMLCollection* _tmp51_;
			gint _tmp52_;
			gint _tmp53_;
			gint _calendar_comp_index = 0;
			_tmp50_ = calendar_comps;
			_calendar_comp_list = _tmp50_;
			_tmp51_ = _calendar_comp_list;
			_tmp52_ = gee_collection_get_size ((GeeCollection*) _tmp51_);
			_tmp53_ = _tmp52_;
			_calendar_comp_size = _tmp53_;
			_calendar_comp_index = -1;
			while (TRUE) {
				gint _tmp54_;
				gint _tmp55_;
				GXmlDomElement* calendar_comp = NULL;
				GXmlDomHTMLCollection* _tmp56_;
				gpointer _tmp57_;
				GXmlDomElement* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gboolean _tmp61_;
				_calendar_comp_index = _calendar_comp_index + 1;
				_tmp54_ = _calendar_comp_index;
				_tmp55_ = _calendar_comp_size;
				if (!(_tmp54_ < _tmp55_)) {
					break;
				}
				_tmp56_ = _calendar_comp_list;
				_tmp57_ = gee_list_get ((GeeList*) _tmp56_, _calendar_comp_index);
				calendar_comp = (GXmlDomElement*) _tmp57_;
				_tmp58_ = calendar_comp;
				_tmp59_ = gxml_dom_element_get_attribute (_tmp58_, "name");
				_tmp60_ = _tmp59_;
				_tmp61_ = g_strcmp0 (_tmp60_, "VTODO") == 0;
				_g_free0 (_tmp60_);
				if (_tmp61_) {
					is_vtodo = TRUE;
				}
				_g_object_unref0 (calendar_comp);
			}
		}
		_g_object_unref0 (calendar_comps);
		_g_object_unref0 (supported_calendar);
	}
	result = is_vtodo;
	_g_object_unref0 (resourcetype);
	_g_object_unref0 (prop);
	_g_object_unref0 (propstat);
	return result;
}

static void
services_cal_dav_providers_radicale_class_init (ServicesCalDAVProvidersRadicaleClass * klass,
                                                gpointer klass_data)
{
	services_cal_dav_providers_radicale_parent_class = g_type_class_peek_parent (klass);
	((ServicesCalDAVProvidersBaseClass *) klass)->get_server_url = (gchar* (*) (ServicesCalDAVProvidersBase*, const gchar*, const gchar*, const gchar*)) services_cal_dav_providers_radicale_real_get_server_url;
	((ServicesCalDAVProvidersBaseClass *) klass)->get_account_url = (gchar* (*) (ServicesCalDAVProvidersBase*, const gchar*, const gchar*)) services_cal_dav_providers_radicale_real_get_account_url;
	((ServicesCalDAVProvidersBaseClass *) klass)->set_user_data = (void (*) (ServicesCalDAVProvidersBase*, GXmlDomDocument*, ObjectsSource*)) services_cal_dav_providers_radicale_real_set_user_data;
	((ServicesCalDAVProvidersBaseClass *) klass)->get_all_taskslist_url = (gchar* (*) (ServicesCalDAVProvidersBase*, const gchar*, const gchar*)) services_cal_dav_providers_radicale_real_get_all_taskslist_url;
	((ServicesCalDAVProvidersBaseClass *) klass)->get_projects_by_doc = (GeeArrayList* (*) (ServicesCalDAVProvidersBase*, GXmlDomDocument*, ObjectsSource*)) services_cal_dav_providers_radicale_real_get_projects_by_doc;
	((ServicesCalDAVProvidersBaseClass *) klass)->is_vtodo_calendar = (gboolean (*) (ServicesCalDAVProvidersBase*, GXmlDomElement*)) services_cal_dav_providers_radicale_real_is_vtodo_calendar;
}

static void
services_cal_dav_providers_radicale_instance_init (ServicesCalDAVProvidersRadicale * self,
                                                   gpointer klass)
{
}

static GType
services_cal_dav_providers_radicale_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesCalDAVProvidersRadicaleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_cal_dav_providers_radicale_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesCalDAVProvidersRadicale), 0, (GInstanceInitFunc) services_cal_dav_providers_radicale_instance_init, NULL };
	GType services_cal_dav_providers_radicale_type_id;
	services_cal_dav_providers_radicale_type_id = g_type_register_static (SERVICES_CAL_DAV_PROVIDERS_TYPE_BASE, "ServicesCalDAVProvidersRadicale", &g_define_type_info, 0);
	return services_cal_dav_providers_radicale_type_id;
}

GType
services_cal_dav_providers_radicale_get_type (void)
{
	static volatile gsize services_cal_dav_providers_radicale_type_id__once = 0;
	if (g_once_init_enter (&services_cal_dav_providers_radicale_type_id__once)) {
		GType services_cal_dav_providers_radicale_type_id;
		services_cal_dav_providers_radicale_type_id = services_cal_dav_providers_radicale_get_type_once ();
		g_once_init_leave (&services_cal_dav_providers_radicale_type_id__once, services_cal_dav_providers_radicale_type_id);
	}
	return services_cal_dav_providers_radicale_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

