/* Chrono.c generated by valac 0.56.18, the Vala compiler
 * generated from Chrono.vala, do not modify */

/*
* Copyright © 2024 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CHRONO_PARSE_0_PROPERTY,
	CHRONO_PARSE_LANG_PROPERTY,
	CHRONO_PARSE_NUM_PROPERTIES
};
static GParamSpec* chrono_parse_properties[CHRONO_PARSE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ChronoParsePrivate {
	gchar* _lang;
	GeeHashMap* configurations;
	ChronoConfiguration* configuration;
};

static gint ChronoParse_private_offset;
static gpointer chrono_parse_parent_class = NULL;

static GObject * chrono_parse_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void chrono_parse_finalize (GObject * obj);
static GType chrono_parse_get_type_once (void);
static void _vala_chrono_parse_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_chrono_parse_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
chrono_parse_get_instance_private (ChronoParse* self)
{
	return G_STRUCT_MEMBER_P (self, ChronoParse_private_offset);
}

ChronoParse*
chrono_parse_construct (GType object_type,
                        const gchar* lang)
{
	ChronoParse * self = NULL;
	g_return_val_if_fail (lang != NULL, NULL);
	self = (ChronoParse*) g_object_new (object_type, "lang", lang, NULL);
	return self;
}

ChronoParse*
chrono_parse_new (const gchar* lang)
{
	return chrono_parse_construct (CHRONO_TYPE_PARSE, lang);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

void
chrono_parse_parse (ChronoParse* self,
                    const gchar* text)
{
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp0_;
	GMatchInfo* match = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = gee_array_list_new (CHRONO_TYPE_PARSING_RESULT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	results = _tmp0_;
	{
		GeeArrayList* _parser_list = NULL;
		ChronoConfiguration* _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _parser_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _parser_index = 0;
		_tmp1_ = self->priv->configuration;
		_tmp2_ = chrono_configuration_get_parsers (_tmp1_);
		_tmp3_ = _tmp2_;
		_parser_list = _tmp3_;
		_tmp4_ = _parser_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_parser_size = _tmp6_;
		_parser_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			ChronoAbstractParser* parser = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			ChronoAbstractParser* _tmp11_;
			GRegex* _tmp12_;
			GRegex* _tmp13_;
			GMatchInfo* _tmp14_ = NULL;
			gboolean _tmp15_;
			gboolean _tmp16_;
			_parser_index = _parser_index + 1;
			_tmp7_ = _parser_index;
			_tmp8_ = _parser_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _parser_list;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _parser_index);
			parser = (ChronoAbstractParser*) _tmp10_;
			_tmp11_ = parser;
			_tmp12_ = chrono_abstract_parser_inner_pattern (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp15_ = g_regex_match_all (_tmp13_, text, 0, &_tmp14_);
			_g_match_info_unref0 (match);
			match = _tmp14_;
			_tmp16_ = _tmp15_;
			_g_regex_unref0 (_tmp13_);
			if (_tmp16_) {
				ChronoParsingResult* _result_ = NULL;
				ChronoAbstractParser* _tmp17_;
				GMatchInfo* _tmp18_;
				ChronoParsingResult* _tmp19_;
				GeeArrayList* _tmp20_;
				ChronoParsingResult* _tmp21_;
				_tmp17_ = parser;
				_tmp18_ = match;
				_tmp19_ = chrono_abstract_parser_inner_extract (_tmp17_, _tmp18_);
				_result_ = _tmp19_;
				_tmp20_ = results;
				_tmp21_ = _result_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
				_g_object_unref0 (_result_);
			}
			_g_object_unref0 (parser);
		}
	}
	{
		GeeArrayList* _result_list = NULL;
		GeeArrayList* _tmp22_;
		gint _result_size = 0;
		GeeArrayList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _result_index = 0;
		_tmp22_ = results;
		_result_list = _tmp22_;
		_tmp23_ = _result_list;
		_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
		_tmp25_ = _tmp24_;
		_result_size = _tmp25_;
		_result_index = -1;
		while (TRUE) {
			gint _tmp26_;
			gint _tmp27_;
			ChronoParsingResult* _result_ = NULL;
			GeeArrayList* _tmp28_;
			gpointer _tmp29_;
			ChronoParsingResult* _tmp30_;
			GDateTime* _tmp31_;
			GDateTime* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			_result_index = _result_index + 1;
			_tmp26_ = _result_index;
			_tmp27_ = _result_size;
			if (!(_tmp26_ < _tmp27_)) {
				break;
			}
			_tmp28_ = _result_list;
			_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _result_index);
			_result_ = (ChronoParsingResult*) _tmp29_;
			_tmp30_ = _result_;
			_tmp31_ = chrono_parsing_result_get_datetime (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = g_date_time_to_string (_tmp32_);
			_tmp34_ = _tmp33_;
			g_print ("Date: %s\n", _tmp34_);
			_g_free0 (_tmp34_);
			_g_object_unref0 (_result_);
		}
	}
	_g_match_info_unref0 (match);
	_g_object_unref0 (results);
}

const gchar*
chrono_parse_get_lang (ChronoParse* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lang;
	result = _tmp0_;
	return result;
}

static void
chrono_parse_set_lang (ChronoParse* self,
                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = chrono_parse_get_lang (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_lang);
		self->priv->_lang = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, chrono_parse_properties[CHRONO_PARSE_LANG_PROPERTY]);
	}
}

static GObject *
chrono_parse_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ChronoParse * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	ChronoEnParse* _tmp2_;
	ChronoEnParse* _tmp3_;
	GeeHashMap* _tmp4_;
	const gchar* _tmp5_;
	parent_class = G_OBJECT_CLASS (chrono_parse_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CHRONO_TYPE_PARSE, ChronoParse);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, CHRONO_TYPE_CONFIGURATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->configurations);
	self->priv->configurations = _tmp0_;
	_tmp1_ = self->priv->configurations;
	_tmp2_ = chrono_en_parse_new ();
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, "en", (ChronoConfiguration*) _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->configurations;
	_tmp5_ = self->priv->_lang;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, _tmp5_)) {
		GeeHashMap* _tmp6_;
		const gchar* _tmp7_;
		gpointer _tmp8_;
		_tmp6_ = self->priv->configurations;
		_tmp7_ = self->priv->_lang;
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
		_g_object_unref0 (self->priv->configuration);
		self->priv->configuration = (ChronoConfiguration*) _tmp8_;
	} else {
		ChronoEnParse* _tmp9_;
		_tmp9_ = chrono_en_parse_new ();
		_g_object_unref0 (self->priv->configuration);
		self->priv->configuration = (ChronoConfiguration*) _tmp9_;
	}
	return obj;
}

static void
chrono_parse_class_init (ChronoParseClass * klass,
                         gpointer klass_data)
{
	chrono_parse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ChronoParse_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_chrono_parse_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_chrono_parse_set_property;
	G_OBJECT_CLASS (klass)->constructor = chrono_parse_constructor;
	G_OBJECT_CLASS (klass)->finalize = chrono_parse_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHRONO_PARSE_LANG_PROPERTY, chrono_parse_properties[CHRONO_PARSE_LANG_PROPERTY] = g_param_spec_string ("lang", "lang", "lang", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
chrono_parse_instance_init (ChronoParse * self,
                            gpointer klass)
{
	self->priv = chrono_parse_get_instance_private (self);
}

static void
chrono_parse_finalize (GObject * obj)
{
	ChronoParse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CHRONO_TYPE_PARSE, ChronoParse);
	_g_free0 (self->priv->_lang);
	_g_object_unref0 (self->priv->configurations);
	_g_object_unref0 (self->priv->configuration);
	G_OBJECT_CLASS (chrono_parse_parent_class)->finalize (obj);
}

static GType
chrono_parse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChronoParseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chrono_parse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChronoParse), 0, (GInstanceInitFunc) chrono_parse_instance_init, NULL };
	GType chrono_parse_type_id;
	chrono_parse_type_id = g_type_register_static (G_TYPE_OBJECT, "ChronoParse", &g_define_type_info, 0);
	ChronoParse_private_offset = g_type_add_instance_private (chrono_parse_type_id, sizeof (ChronoParsePrivate));
	return chrono_parse_type_id;
}

GType
chrono_parse_get_type (void)
{
	static volatile gsize chrono_parse_type_id__once = 0;
	if (g_once_init_enter (&chrono_parse_type_id__once)) {
		GType chrono_parse_type_id;
		chrono_parse_type_id = chrono_parse_get_type_once ();
		g_once_init_leave (&chrono_parse_type_id__once, chrono_parse_type_id);
	}
	return chrono_parse_type_id__once;
}

static void
_vala_chrono_parse_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ChronoParse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CHRONO_TYPE_PARSE, ChronoParse);
	switch (property_id) {
		case CHRONO_PARSE_LANG_PROPERTY:
		g_value_set_string (value, chrono_parse_get_lang (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_chrono_parse_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ChronoParse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CHRONO_TYPE_PARSE, ChronoParse);
	switch (property_id) {
		case CHRONO_PARSE_LANG_PROPERTY:
		chrono_parse_set_lang (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

