/* Datetime.c generated by valac 0.56.18, the Vala compiler
 * generated from Datetime.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite-7.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>
#include <libical-glib/libical-glib.h>
#include <libecal/libecal.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _UtilsParamSpecDatetime UtilsParamSpecDatetime;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UtilsParamSpecDatetime {
	GParamSpec parent_instance;
};

static gpointer utils_datetime_parent_class = NULL;

static gboolean utils_datetime_check_by_day (const gchar* day,
                                      GArray* day_array);
static void utils_datetime_finalize (UtilsDatetime * obj);
static GType utils_datetime_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GDateTime*
utils_datetime_get_todoist_datetime (const gchar* date)
{
	GDateTime* datetime = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GDateTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	if (g_strcmp0 (date, "") == 0) {
		result = NULL;
		return result;
	}
	datetime = NULL;
	_tmp0_ = strlen (date);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 10) {
		gchar** _date = NULL;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _date_length1;
		gint __date_size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		GDateTime* _tmp10_;
		_tmp3_ = _tmp2_ = g_strsplit (date, "-", 0);
		_date = _tmp3_;
		_date_length1 = _vala_array_length (_tmp2_);
		__date_size_ = _date_length1;
		_tmp4_ = _date;
		_tmp4__length1 = _date_length1;
		_tmp5_ = _tmp4_[0];
		_tmp6_ = _date;
		_tmp6__length1 = _date_length1;
		_tmp7_ = _tmp6_[1];
		_tmp8_ = _date;
		_tmp8__length1 = _date_length1;
		_tmp9_ = _tmp8_[2];
		_tmp10_ = g_date_time_new_local (atoi (_tmp5_), atoi (_tmp7_), atoi (_tmp9_), 0, 0, (gdouble) 0);
		_g_date_time_unref0 (datetime);
		datetime = _tmp10_;
		_date = (_vala_array_free (_date, _date_length1, (GDestroyNotify) g_free), NULL);
	} else {
		gchar** _date = NULL;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		gchar** _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		gint _date_length1;
		gint __date_size_;
		gchar** _time = NULL;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		gchar** _tmp22_;
		gchar** _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		gint _time_length1;
		gint __time_size_;
		gchar** _tmp25_;
		gint _tmp25__length1;
		const gchar* _tmp26_;
		gchar** _tmp27_;
		gint _tmp27__length1;
		const gchar* _tmp28_;
		gchar** _tmp29_;
		gint _tmp29__length1;
		const gchar* _tmp30_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		const gchar* _tmp32_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		const gchar* _tmp34_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		const gchar* _tmp36_;
		GDateTime* _tmp37_;
		_tmp12_ = _tmp11_ = g_strsplit (date, "T", 0);
		_tmp13_ = _tmp12_;
		_tmp13__length1 = _vala_array_length (_tmp11_);
		_tmp14_ = _tmp13_[0];
		_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, "-", 0);
		_tmp17_ = _tmp16_;
		_tmp17__length1 = _vala_array_length (_tmp15_);
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
		_date = _tmp17_;
		_date_length1 = _tmp17__length1;
		__date_size_ = _date_length1;
		_tmp19_ = _tmp18_ = g_strsplit (date, "T", 0);
		_tmp20_ = _tmp19_;
		_tmp20__length1 = _vala_array_length (_tmp18_);
		_tmp21_ = _tmp20_[1];
		_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, ":", 0);
		_tmp24_ = _tmp23_;
		_tmp24__length1 = _vala_array_length (_tmp22_);
		_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
		_time = _tmp24_;
		_time_length1 = _tmp24__length1;
		__time_size_ = _time_length1;
		_tmp25_ = _date;
		_tmp25__length1 = _date_length1;
		_tmp26_ = _tmp25_[0];
		_tmp27_ = _date;
		_tmp27__length1 = _date_length1;
		_tmp28_ = _tmp27_[1];
		_tmp29_ = _date;
		_tmp29__length1 = _date_length1;
		_tmp30_ = _tmp29_[2];
		_tmp31_ = _time;
		_tmp31__length1 = _time_length1;
		_tmp32_ = _tmp31_[0];
		_tmp33_ = _time;
		_tmp33__length1 = _time_length1;
		_tmp34_ = _tmp33_[1];
		_tmp35_ = _time;
		_tmp35__length1 = _time_length1;
		_tmp36_ = _tmp35_[2];
		_tmp37_ = g_date_time_new_local (atoi (_tmp26_), atoi (_tmp28_), atoi (_tmp30_), atoi (_tmp32_), atoi (_tmp34_), (gdouble) atoi (_tmp36_));
		_g_date_time_unref0 (datetime);
		datetime = _tmp37_;
		_time = (_vala_array_free (_time, _time_length1, (GDestroyNotify) g_free), NULL);
		_date = (_vala_array_free (_date, _date_length1, (GDestroyNotify) g_free), NULL);
	}
	result = datetime;
	return result;
}

gchar*
utils_datetime_get_relative_date_from_date (GDateTime* datetime)
{
	gchar* returned = NULL;
	gchar* _tmp1_;
	gchar* result;
	if (datetime == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("");
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_strdup ("");
	returned = _tmp1_;
	if (utils_datetime_is_today (datetime)) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("Today"));
		_g_free0 (returned);
		returned = _tmp2_;
	} else {
		if (utils_datetime_is_tomorrow (datetime)) {
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Tomorrow"));
			_g_free0 (returned);
			returned = _tmp3_;
		} else {
			if (utils_datetime_is_yesterday (datetime)) {
				gchar* _tmp4_;
				_tmp4_ = g_strdup (_ ("Yesterday"));
				_g_free0 (returned);
				returned = _tmp4_;
			} else {
				gchar* _tmp5_;
				_tmp5_ = utils_datetime_get_default_date_format_from_date (datetime);
				_g_free0 (returned);
				returned = _tmp5_;
			}
		}
	}
	if (utils_datetime_has_time (datetime)) {
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp6_ = returned;
		_tmp7_ = utils_datetime_get_default_time_format ();
		_tmp8_ = _tmp7_;
		_tmp9_ = g_date_time_format (datetime, _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf ("%s %s", _tmp6_, _tmp10_);
		_g_free0 (returned);
		returned = _tmp11_;
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
	}
	result = returned;
	return result;
}

gchar*
utils_datetime_get_relative_datetime (GDateTime* datetime)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = granite_date_time_get_relative_datetime (datetime);
	result = _tmp0_;
	return result;
}

gchar*
utils_datetime_days_left (GDateTime* datetime,
                          gboolean show_today)
{
	gchar* return_value = NULL;
	gchar* _tmp0_;
	GTimeSpan days = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GTimeSpan _tmp3_;
	gchar* result;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = g_strdup ("");
	return_value = _tmp0_;
	_tmp1_ = g_date_time_new_now_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_difference (datetime, _tmp2_) / G_TIME_SPAN_DAY;
	_g_date_time_unref0 (_tmp2_);
	days = _tmp3_;
	if (utils_datetime_is_today (datetime)) {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		if (show_today) {
			_tmp4_ = _ ("Today");
		} else {
			_tmp4_ = "";
		}
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (return_value);
		return_value = _tmp5_;
	} else {
		if (utils_datetime_is_overdue (datetime)) {
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			if (days > ((GTimeSpan) 1)) {
				_tmp6_ = _ ("days");
			} else {
				_tmp6_ = _ ("day");
			}
			_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, (gint64) (days * -1));
			_tmp8_ = _tmp7_;
			_tmp9_ = g_strdup_printf ("%s %s ago", _tmp8_, _tmp6_);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_strdup (_ (_tmp10_));
			_g_free0 (return_value);
			return_value = _tmp11_;
			_g_free0 (_tmp10_);
			_g_free0 (_tmp8_);
		} else {
			const gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			if (days > ((GTimeSpan) 1)) {
				_tmp12_ = _ ("days");
			} else {
				_tmp12_ = _ ("day");
			}
			_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, (gint64) (days + 1));
			_tmp14_ = _tmp13_;
			_tmp15_ = g_strdup_printf ("%s %s left", _tmp14_, _tmp12_);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strdup (_ (_tmp16_));
			_g_free0 (return_value);
			return_value = _tmp17_;
			_g_free0 (_tmp16_);
			_g_free0 (_tmp14_);
		}
	}
	result = return_value;
	return result;
}

gchar*
utils_datetime_get_default_time_format (void)
{
	gchar* _tmp0_;
	gchar* result;
	_tmp0_ = granite_date_time_get_default_time_format (utils_datetime_is_clock_format_12h (), FALSE);
	result = _tmp0_;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gboolean
utils_datetime_is_clock_format_12h (void)
{
	ServicesSettings* _tmp0_;
	ServicesSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
	_tmp0_ = services_settings_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->settings;
	_tmp3_ = g_settings_get_string (_tmp2_, "clock-format");
	_tmp4_ = _tmp3_;
	_tmp5_ = string_contains (_tmp4_, "12h");
	_g_free0 (_tmp4_);
	_g_object_unref0 (_tmp1_);
	result = _tmp5_;
	return result;
}

gboolean
utils_datetime_is_yesterday (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_add_days (_tmp1_, -1);
	_tmp3_ = _tmp2_;
	_tmp4_ = utils_datetime_is_same_day (date, _tmp3_);
	_g_date_time_unref0 (_tmp3_);
	_g_date_time_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

gboolean
utils_datetime_is_same_day (GDateTime* day1,
                            GDateTime* day2)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (day1 != NULL, FALSE);
	g_return_val_if_fail (day2 != NULL, FALSE);
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gboolean
utils_datetime_is_overdue (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean _tmp6_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = utils_datetime_get_date_only (date);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_new_now_local ();
	_tmp3_ = _tmp2_;
	_tmp4_ = utils_datetime_get_date_only (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_date_time_compare (_tmp1_, _tmp5_) == -1;
	_g_date_time_unref0 (_tmp5_);
	_g_date_time_unref0 (_tmp3_);
	_g_date_time_unref0 (_tmp1_);
	if (_tmp6_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

gchar*
utils_datetime_get_calendar_icon (GDateTime* date)
{
	gchar* result;
	g_return_val_if_fail (date != NULL, NULL);
	if (utils_datetime_is_today (date)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("planner-today");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("planner-scheduled");
		result = _tmp1_;
		return result;
	}
}

void
utils_datetime_parse_todoist_recurrency (ObjectsDueDate* duedate,
                                         JsonObject* object)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (duedate != NULL);
	g_return_if_fail (object != NULL);
	if (json_object_has_member (object, "lang")) {
		const gchar* _tmp1_;
		_tmp1_ = json_object_get_string_member (object, "lang");
		_tmp0_ = g_strcmp0 (_tmp1_, "en") != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		objects_due_date_set_recurrence_supported (duedate, FALSE);
		return;
	}
}

gboolean
utils_datetime_has_time (GDateTime* datetime)
{
	gboolean returned = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	g_return_val_if_fail (datetime != NULL, FALSE);
	if (datetime == NULL) {
		result = FALSE;
		return result;
	}
	returned = TRUE;
	if (g_date_time_get_hour (datetime) == 0) {
		_tmp1_ = g_date_time_get_minute (datetime) == 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = g_date_time_get_second (datetime) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		returned = FALSE;
	}
	result = returned;
	return result;
}

gboolean
utils_datetime_is_today (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	if (date == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = utils_datetime_is_same_day (date, _tmp1_);
	_g_date_time_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

gboolean
utils_datetime_is_tomorrow (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	if (date == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_add_days (_tmp1_, 1);
	_tmp3_ = _tmp2_;
	_tmp4_ = utils_datetime_is_same_day (date, _tmp3_);
	_g_date_time_unref0 (_tmp3_);
	_g_date_time_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

gboolean
utils_datetime_is_next_week (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	if (date == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_add_days (_tmp1_, 7);
	_tmp3_ = _tmp2_;
	_tmp4_ = utils_datetime_is_same_day (date, _tmp3_);
	_g_date_time_unref0 (_tmp3_);
	_g_date_time_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

GDateTime*
utils_datetime_get_date_from_string (const gchar* date)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = g_time_zone_new_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_new_from_iso8601 (date, _tmp1_);
	_tmp3_ = _tmp2_;
	_g_time_zone_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

void
utils_datetime_recurrence_to_due (ICalRecurrence* recurrence,
                                  ObjectsDueDate* due)
{
	ICalRecurrenceFrequency freq = 0;
	gshort interval = 0;
	gint count = 0;
	ICalTime* until = NULL;
	ICalTime* _tmp0_;
	ICalTime* _tmp1_;
	RecurrencyType _tmp7_;
	RecurrencyType _tmp8_;
	g_return_if_fail (recurrence != NULL);
	g_return_if_fail (due != NULL);
	objects_due_date_set_is_recurring (due, TRUE);
	freq = i_cal_recurrence_get_freq (recurrence);
	if (freq == I_CAL_MINUTELY_RECURRENCE) {
		objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_MINUTELY);
	} else {
		if (freq == I_CAL_HOURLY_RECURRENCE) {
			objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_HOURLY);
		} else {
			if (freq == I_CAL_DAILY_RECURRENCE) {
				objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_DAY);
			} else {
				if (freq == I_CAL_WEEKLY_RECURRENCE) {
					objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_WEEK);
				} else {
					if (freq == I_CAL_MONTHLY_RECURRENCE) {
						objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_MONTH);
					} else {
						if (freq == I_CAL_YEARLY_RECURRENCE) {
							objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_YEAR);
						}
					}
				}
			}
		}
	}
	interval = i_cal_recurrence_get_interval (recurrence);
	objects_due_date_set_recurrency_interval (due, (gint) interval);
	count = i_cal_recurrence_get_count (recurrence);
	objects_due_date_set_recurrency_count (due, count);
	_tmp0_ = i_cal_recurrence_get_until (recurrence);
	until = _tmp0_;
	_tmp1_ = until;
	if (!i_cal_time_is_null_time (_tmp1_)) {
		ICalTime* _tmp2_;
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp2_ = until;
		_tmp3_ = utils_datetime_ical_to_date_time_local (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_date_time_to_string (_tmp4_);
		_tmp6_ = _tmp5_;
		objects_due_date_set_recurrency_end (due, _tmp6_);
		_g_free0 (_tmp6_);
		_g_date_time_unref0 (_tmp4_);
	}
	_tmp7_ = objects_due_date_get_recurrency_type (due);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == RECURRENCY_TYPE_EVERY_WEEK) {
		gchar* recurrency_weeks = NULL;
		gchar* _tmp9_;
		GArray* day_array = NULL;
		GArray* _tmp10_;
		GArray* _tmp11_;
		GArray* _tmp14_;
		GArray* _tmp17_;
		GArray* _tmp20_;
		GArray* _tmp23_;
		GArray* _tmp26_;
		GArray* _tmp29_;
		const gchar* _tmp32_;
		gchar** _tmp33_;
		gchar** _tmp34_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		gboolean _tmp36_;
		const gchar* _tmp40_;
		_tmp9_ = g_strdup ("");
		recurrency_weeks = _tmp9_;
		_tmp10_ = i_cal_recurrence_get_by_day_array (recurrence);
		day_array = _tmp10_;
		_tmp11_ = day_array;
		if (utils_datetime_check_by_day ("1", _tmp11_)) {
			const gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp12_ = recurrency_weeks;
			_tmp13_ = g_strconcat (_tmp12_, "7,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp13_;
		}
		_tmp14_ = day_array;
		if (utils_datetime_check_by_day ("2", _tmp14_)) {
			const gchar* _tmp15_;
			gchar* _tmp16_;
			_tmp15_ = recurrency_weeks;
			_tmp16_ = g_strconcat (_tmp15_, "1,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp16_;
		}
		_tmp17_ = day_array;
		if (utils_datetime_check_by_day ("3", _tmp17_)) {
			const gchar* _tmp18_;
			gchar* _tmp19_;
			_tmp18_ = recurrency_weeks;
			_tmp19_ = g_strconcat (_tmp18_, "2,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp19_;
		}
		_tmp20_ = day_array;
		if (utils_datetime_check_by_day ("4", _tmp20_)) {
			const gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp21_ = recurrency_weeks;
			_tmp22_ = g_strconcat (_tmp21_, "3,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp22_;
		}
		_tmp23_ = day_array;
		if (utils_datetime_check_by_day ("5", _tmp23_)) {
			const gchar* _tmp24_;
			gchar* _tmp25_;
			_tmp24_ = recurrency_weeks;
			_tmp25_ = g_strconcat (_tmp24_, "4,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp25_;
		}
		_tmp26_ = day_array;
		if (utils_datetime_check_by_day ("6", _tmp26_)) {
			const gchar* _tmp27_;
			gchar* _tmp28_;
			_tmp27_ = recurrency_weeks;
			_tmp28_ = g_strconcat (_tmp27_, "5,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp28_;
		}
		_tmp29_ = day_array;
		if (utils_datetime_check_by_day ("7", _tmp29_)) {
			const gchar* _tmp30_;
			gchar* _tmp31_;
			_tmp30_ = recurrency_weeks;
			_tmp31_ = g_strconcat (_tmp30_, "6,", NULL);
			_g_free0 (recurrency_weeks);
			recurrency_weeks = _tmp31_;
		}
		_tmp32_ = recurrency_weeks;
		_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, ",", 0);
		_tmp35_ = _tmp34_;
		_tmp35__length1 = _vala_array_length (_tmp33_);
		_tmp36_ = _vala_array_length (_tmp33_) > 0;
		_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
		if (_tmp36_) {
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			_tmp37_ = recurrency_weeks;
			_tmp38_ = string_slice (_tmp37_, (glong) 0, (glong) -1);
			_tmp39_ = _tmp38_;
			_g_free0 (_tmp39_);
		}
		_tmp40_ = recurrency_weeks;
		objects_due_date_set_recurrency_weeks (due, _tmp40_);
		_g_array_unref0 (day_array);
		_g_free0 (recurrency_weeks);
	}
	_g_object_unref0 (until);
}

static gboolean
utils_datetime_check_by_day (const gchar* day,
                             GArray* day_array)
{
	gboolean result;
	g_return_val_if_fail (day != NULL, FALSE);
	g_return_val_if_fail (day_array != NULL, FALSE);
	{
		GArray* _day_collection = NULL;
		guint _day_index = 0U;
		_day_collection = day_array;
		for (_day_index = 0; _day_index < _day_collection->len; _day_index = _day_index + 1) {
			gshort _day = 0;
			_day = g_array_index (_day_collection, gshort, _day_index);
			{
				gchar* _tmp0_;
				gchar* _tmp1_;
				gboolean _tmp2_;
				_tmp0_ = g_strdup_printf ("%hi", _day);
				_tmp1_ = _tmp0_;
				_tmp2_ = g_strcmp0 (_tmp1_, day) == 0;
				_g_free0 (_tmp1_);
				if (_tmp2_) {
					result = TRUE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

GDateTime*
utils_datetime_format_date (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), g_date_time_get_day_of_month (date), 0, 0, (gdouble) 0);
	result = _tmp0_;
	return result;
}

gboolean
utils_datetime_is_this_week (GDateTime* date)
{
	GDateTime* current_date = NULL;
	GDateTime* _tmp0_;
	GDateTime* start_of_week = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* end_of_week = NULL;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	gboolean _tmp10_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	current_date = _tmp0_;
	_tmp1_ = current_date;
	_tmp2_ = current_date;
	_tmp3_ = g_date_time_add_days (_tmp1_, (g_date_time_get_day_of_week (_tmp2_) - 1) * -1);
	start_of_week = _tmp3_;
	_tmp4_ = current_date;
	_tmp5_ = g_date_time_add_days (_tmp4_, 6);
	end_of_week = _tmp5_;
	_tmp7_ = start_of_week;
	_tmp8_ = utils_datetime_format_date (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_date_time_compare (date, _tmp9_) >= 0;
	_g_date_time_unref0 (_tmp9_);
	if (_tmp10_) {
		GDateTime* _tmp11_;
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		_tmp11_ = end_of_week;
		_tmp12_ = utils_datetime_format_date (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp6_ = g_date_time_compare (date, _tmp13_) <= 0;
		_g_date_time_unref0 (_tmp13_);
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		result = TRUE;
		_g_date_time_unref0 (end_of_week);
		_g_date_time_unref0 (start_of_week);
		_g_date_time_unref0 (current_date);
		return result;
	}
	result = FALSE;
	_g_date_time_unref0 (end_of_week);
	_g_date_time_unref0 (start_of_week);
	_g_date_time_unref0 (current_date);
	return result;
}

gboolean
utils_datetime_is_next_x_week (GDateTime* date,
                               gint days)
{
	GDateTime* current_date = NULL;
	GDateTime* _tmp0_;
	GDateTime* end_date = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gboolean _tmp7_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	current_date = _tmp0_;
	_tmp1_ = current_date;
	_tmp2_ = g_date_time_add_days (_tmp1_, days);
	end_date = _tmp2_;
	_tmp4_ = current_date;
	_tmp5_ = utils_datetime_format_date (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_date_time_compare (date, _tmp6_) >= 0;
	_g_date_time_unref0 (_tmp6_);
	if (_tmp7_) {
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		_tmp8_ = end_date;
		_tmp9_ = utils_datetime_format_date (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp3_ = g_date_time_compare (date, _tmp10_) <= 0;
		_g_date_time_unref0 (_tmp10_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = TRUE;
		_g_date_time_unref0 (end_date);
		_g_date_time_unref0 (current_date);
		return result;
	}
	result = FALSE;
	_g_date_time_unref0 (end_date);
	_g_date_time_unref0 (current_date);
	return result;
}

gboolean
utils_datetime_is_this_month (GDateTime* date)
{
	GDateTime* current_date = NULL;
	GDateTime* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GDateTime* _tmp2_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	current_date = _tmp0_;
	_tmp2_ = current_date;
	if (g_date_time_get_month (_tmp2_) == g_date_time_get_month (date)) {
		GDateTime* _tmp3_;
		_tmp3_ = current_date;
		_tmp1_ = g_date_time_get_year (_tmp3_) == g_date_time_get_year (date);
	} else {
		_tmp1_ = FALSE;
	}
	result = _tmp1_;
	_g_date_time_unref0 (current_date);
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

GDateTime*
utils_datetime_next_recurrency (GDateTime* datetime,
                                ObjectsDueDate* duedate)
{
	GDateTime* returned = NULL;
	GDateTime* _tmp0_;
	RecurrencyType _tmp1_;
	RecurrencyType _tmp2_;
	GDateTime* result;
	g_return_val_if_fail (datetime != NULL, NULL);
	g_return_val_if_fail (duedate != NULL, NULL);
	_tmp0_ = _g_date_time_ref0 (datetime);
	returned = _tmp0_;
	_tmp1_ = objects_due_date_get_recurrency_type (duedate);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == RECURRENCY_TYPE_MINUTELY) {
		GDateTime* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		GDateTime* _tmp6_;
		_tmp3_ = returned;
		_tmp4_ = objects_due_date_get_recurrency_interval (duedate);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_date_time_add_minutes (_tmp3_, _tmp5_);
		_g_date_time_unref0 (returned);
		returned = _tmp6_;
	} else {
		RecurrencyType _tmp7_;
		RecurrencyType _tmp8_;
		_tmp7_ = objects_due_date_get_recurrency_type (duedate);
		_tmp8_ = _tmp7_;
		if (_tmp8_ == RECURRENCY_TYPE_HOURLY) {
			GDateTime* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			GDateTime* _tmp12_;
			_tmp9_ = returned;
			_tmp10_ = objects_due_date_get_recurrency_interval (duedate);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_date_time_add_hours (_tmp9_, _tmp11_);
			_g_date_time_unref0 (returned);
			returned = _tmp12_;
		} else {
			RecurrencyType _tmp13_;
			RecurrencyType _tmp14_;
			_tmp13_ = objects_due_date_get_recurrency_type (duedate);
			_tmp14_ = _tmp13_;
			if (_tmp14_ == RECURRENCY_TYPE_EVERY_DAY) {
				GDateTime* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				GDateTime* _tmp18_;
				_tmp15_ = returned;
				_tmp16_ = objects_due_date_get_recurrency_interval (duedate);
				_tmp17_ = _tmp16_;
				_tmp18_ = g_date_time_add_days (_tmp15_, _tmp17_);
				_g_date_time_unref0 (returned);
				returned = _tmp18_;
			} else {
				RecurrencyType _tmp19_;
				RecurrencyType _tmp20_;
				_tmp19_ = objects_due_date_get_recurrency_type (duedate);
				_tmp20_ = _tmp19_;
				if (_tmp20_ == RECURRENCY_TYPE_EVERY_WEEK) {
					const gchar* _tmp21_;
					const gchar* _tmp22_;
					_tmp21_ = objects_due_date_get_recurrency_weeks (duedate);
					_tmp22_ = _tmp21_;
					if (g_strcmp0 (_tmp22_, "") == 0) {
						GDateTime* _tmp23_;
						gint _tmp24_;
						gint _tmp25_;
						GDateTime* _tmp26_;
						_tmp23_ = returned;
						_tmp24_ = objects_due_date_get_recurrency_interval (duedate);
						_tmp25_ = _tmp24_;
						_tmp26_ = g_date_time_add_days (_tmp23_, _tmp25_ * 7);
						_g_date_time_unref0 (returned);
						returned = _tmp26_;
					} else {
						GDateTime* _tmp27_;
						_tmp27_ = utils_datetime_next_recurrency_week (datetime, duedate, TRUE);
						_g_date_time_unref0 (returned);
						returned = _tmp27_;
					}
				} else {
					RecurrencyType _tmp28_;
					RecurrencyType _tmp29_;
					_tmp28_ = objects_due_date_get_recurrency_type (duedate);
					_tmp29_ = _tmp28_;
					if (_tmp29_ == RECURRENCY_TYPE_EVERY_MONTH) {
						GDateTime* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						GDateTime* _tmp33_;
						_tmp30_ = returned;
						_tmp31_ = objects_due_date_get_recurrency_interval (duedate);
						_tmp32_ = _tmp31_;
						_tmp33_ = g_date_time_add_months (_tmp30_, _tmp32_);
						_g_date_time_unref0 (returned);
						returned = _tmp33_;
					} else {
						RecurrencyType _tmp34_;
						RecurrencyType _tmp35_;
						_tmp34_ = objects_due_date_get_recurrency_type (duedate);
						_tmp35_ = _tmp34_;
						if (_tmp35_ == RECURRENCY_TYPE_EVERY_YEAR) {
							GDateTime* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GDateTime* _tmp39_;
							_tmp36_ = returned;
							_tmp37_ = objects_due_date_get_recurrency_interval (duedate);
							_tmp38_ = _tmp37_;
							_tmp39_ = g_date_time_add_years (_tmp36_, _tmp38_);
							_g_date_time_unref0 (returned);
							returned = _tmp39_;
						}
					}
				}
			}
		}
	}
	result = returned;
	return result;
}

gint
utils_datetime_get_next_day_of_week_from_recurrency_week (GDateTime* datetime,
                                                          ObjectsDueDate* duedate)
{
	gchar** weeks = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint weeks_length1;
	gint _weeks_size_;
	gint day_of_week = 0;
	gint index = 0;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gint result;
	g_return_val_if_fail (datetime != NULL, 0);
	g_return_val_if_fail (duedate != NULL, 0);
	_tmp0_ = objects_due_date_get_recurrency_weeks (duedate);
	_tmp1_ = _tmp0_;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ",", 0);
	weeks = _tmp3_;
	weeks_length1 = _vala_array_length (_tmp2_);
	_weeks_size_ = weeks_length1;
	day_of_week = g_date_time_get_day_of_week (datetime);
	index = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = weeks;
				_tmp6__length1 = weeks_length1;
				if (!(i < _tmp6__length1)) {
					break;
				}
				_tmp7_ = weeks;
				_tmp7__length1 = weeks_length1;
				_tmp8_ = _tmp7_[i];
				if (day_of_week <= atoi (_tmp8_)) {
					index = i;
					break;
				}
			}
		}
	}
	_tmp9_ = weeks;
	_tmp9__length1 = weeks_length1;
	if (index > (_tmp9__length1 - 1)) {
		index = 0;
	}
	_tmp10_ = weeks;
	_tmp10__length1 = weeks_length1;
	_tmp11_ = _tmp10_[index];
	result = atoi (_tmp11_);
	weeks = (_vala_array_free (weeks, weeks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

GDateTime*
utils_datetime_next_recurrency_week (GDateTime* datetime,
                                     ObjectsDueDate* duedate,
                                     gboolean user)
{
	gchar** weeks = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint weeks_length1;
	gint _weeks_size_;
	gint day_of_week = 0;
	gint days = 0;
	gint next_day = 0;
	gint index = 0;
	gint recurrency_interval = 0;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	GDateTime* result;
	g_return_val_if_fail (datetime != NULL, NULL);
	g_return_val_if_fail (duedate != NULL, NULL);
	_tmp0_ = objects_due_date_get_recurrency_weeks (duedate);
	_tmp1_ = _tmp0_;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ",", 0);
	weeks = _tmp3_;
	weeks_length1 = _vala_array_length (_tmp2_);
	_weeks_size_ = weeks_length1;
	day_of_week = g_date_time_get_day_of_week (datetime);
	days = 0;
	next_day = 0;
	index = 0;
	recurrency_interval = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = weeks;
				_tmp6__length1 = weeks_length1;
				if (!(i < _tmp6__length1)) {
					break;
				}
				_tmp7_ = weeks;
				_tmp7__length1 = weeks_length1;
				_tmp8_ = _tmp7_[i];
				if (day_of_week < atoi (_tmp8_)) {
					index = i;
					break;
				}
			}
		}
	}
	_tmp9_ = weeks;
	_tmp9__length1 = weeks_length1;
	_tmp10_ = _tmp9_[index];
	next_day = atoi (_tmp10_);
	if (day_of_week < next_day) {
		days = next_day - day_of_week;
	} else {
		days = 7 - (day_of_week - next_day);
	}
	if (user) {
		_tmp11_ = index == 0;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		gint _tmp12_;
		gint _tmp13_;
		_tmp12_ = objects_due_date_get_recurrency_interval (duedate);
		_tmp13_ = _tmp12_;
		recurrency_interval = (_tmp13_ - 1) * 7;
	}
	_tmp14_ = g_date_time_add_days (datetime, days);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_date_time_add_days (_tmp15_, recurrency_interval);
	_tmp17_ = _tmp16_;
	_g_date_time_unref0 (_tmp15_);
	result = _tmp17_;
	weeks = (_vala_array_free (weeks, weeks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gchar*
utils_datetime_get_recurrency_weeks (RecurrencyType recurrency_type,
                                     gint recurrency_interval,
                                     const gchar* recurrency_weeks,
                                     const gchar* end)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* result;
	g_return_val_if_fail (recurrency_weeks != NULL, NULL);
	g_return_val_if_fail (end != NULL, NULL);
	_tmp0_ = recurrency_type_to_friendly_string (recurrency_type, &recurrency_interval);
	returned = _tmp0_;
	if (recurrency_type == RECURRENCY_TYPE_EVERY_WEEK) {
		gchar** _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		_tmp3_ = _tmp2_ = g_strsplit (recurrency_weeks, ",", 0);
		_tmp4_ = _tmp3_;
		_tmp4__length1 = _vala_array_length (_tmp2_);
		_tmp1_ = _vala_array_length (_tmp2_) > 0;
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gchar* weeks = NULL;
		gchar* _tmp5_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		_tmp5_ = g_strdup ("");
		weeks = _tmp5_;
		if (string_contains (recurrency_weeks, "1")) {
			const gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp6_ = weeks;
			_tmp7_ = g_strconcat (_tmp6_, _ ("Mo,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp7_;
		}
		if (string_contains (recurrency_weeks, "2")) {
			const gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp8_ = weeks;
			_tmp9_ = g_strconcat (_tmp8_, _ ("Tu,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp9_;
		}
		if (string_contains (recurrency_weeks, "3")) {
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp10_ = weeks;
			_tmp11_ = g_strconcat (_tmp10_, _ ("We,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp11_;
		}
		if (string_contains (recurrency_weeks, "4")) {
			const gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp12_ = weeks;
			_tmp13_ = g_strconcat (_tmp12_, _ ("Th,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp13_;
		}
		if (string_contains (recurrency_weeks, "5")) {
			const gchar* _tmp14_;
			gchar* _tmp15_;
			_tmp14_ = weeks;
			_tmp15_ = g_strconcat (_tmp14_, _ ("Fr,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp15_;
		}
		if (string_contains (recurrency_weeks, "6")) {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp16_ = weeks;
			_tmp17_ = g_strconcat (_tmp16_, _ ("Sa,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp17_;
		}
		if (string_contains (recurrency_weeks, "7")) {
			const gchar* _tmp18_;
			gchar* _tmp19_;
			_tmp18_ = weeks;
			_tmp19_ = g_strconcat (_tmp18_, _ ("Su,"), NULL);
			_g_free0 (weeks);
			weeks = _tmp19_;
		}
		_tmp20_ = weeks;
		_tmp21_ = string_slice (_tmp20_, (glong) 0, (glong) -1);
		_g_free0 (weeks);
		weeks = _tmp21_;
		_tmp22_ = returned;
		_tmp23_ = weeks;
		_tmp24_ = g_strdup_printf ("%s (%s)", _tmp22_, _tmp23_);
		_g_free0 (returned);
		returned = _tmp24_;
		_g_free0 (weeks);
	}
	_tmp25_ = returned;
	_tmp26_ = g_strconcat (_tmp25_, " ", NULL);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_strconcat (_tmp27_, end, NULL);
	_tmp29_ = _tmp28_;
	_g_free0 (_tmp27_);
	result = _tmp29_;
	_g_free0 (returned);
	return result;
}

GDateTime*
utils_datetime_get_today_format_date (void)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* result;
	_tmp0_ = g_date_time_new_now_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = utils_datetime_get_date_only (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_date_time_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}

GDateTime*
utils_datetime_get_date_only (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), g_date_time_get_day_of_month (date), 0, 0, (gdouble) 0);
	result = _tmp0_;
	return result;
}

gchar*
utils_datetime_get_default_date_format_from_date (GDateTime* date)
{
	gchar* format = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
	if (date == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("");
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_date_time_new_now_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = granite_date_time_get_default_date_format (FALSE, TRUE, g_date_time_get_year (date) != g_date_time_get_year (_tmp2_));
	_tmp4_ = _tmp3_;
	_tmp5_ = g_date_time_format (date, _tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_date_time_unref0 (_tmp2_);
	format = _tmp6_;
	result = format;
	return result;
}

gchar*
utils_datetime_get_todoist_datetime_format (GDateTime* date)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = g_strdup ("");
	returned = _tmp0_;
	if (utils_datetime_has_time (date)) {
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp1_ = g_date_time_format (date, "%F");
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strconcat (_tmp2_, "T", NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_date_time_format (date, "%T");
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
		_g_free0 (returned);
		returned = _tmp7_;
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
	} else {
		gchar* _tmp8_;
		_tmp8_ = g_date_time_format (date, "%F");
		_g_free0 (returned);
		returned = _tmp8_;
	}
	result = returned;
	return result;
}

gboolean
utils_datetime_has_time_from_string (const gchar* date)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = g_time_zone_new_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_new_from_iso8601 (date, _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = utils_datetime_has_time (_tmp3_);
	_g_date_time_unref0 (_tmp3_);
	_g_time_zone_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

gint
utils_datetime_get_days_of_month (gint index,
                                  gint year_nav)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint result;
	if (index == 1) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = index == 3;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		_tmp4_ = index == 5;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = index == 7;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = index == 8;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = index == 10;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = index == 12;
	}
	if (_tmp0_) {
		result = 31;
		return result;
	} else {
		if (index == 2) {
			if ((year_nav % 4) == 0) {
				result = 29;
				return result;
			} else {
				result = 28;
				return result;
			}
		} else {
			result = 30;
			return result;
		}
	}
}

GDateTime*
utils_datetime_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result;
	if (date == NULL) {
		GDateTime* _tmp0_;
		_tmp0_ = g_date_time_new_now_local ();
		_g_date_time_unref0 (date);
		date = _tmp0_;
	}
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
	result = _tmp1_;
	_g_date_time_unref0 (date);
	return result;
}

gboolean
utils_datetime_is_current_month (GDateTime* date)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean result;
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = now;
	if (g_date_time_get_year (date) == g_date_time_get_year (_tmp1_)) {
		GDateTime* _tmp2_;
		_tmp2_ = now;
		if (g_date_time_get_month (date) == g_date_time_get_month (_tmp2_)) {
			result = TRUE;
			_g_date_time_unref0 (now);
			return result;
		} else {
			result = FALSE;
			_g_date_time_unref0 (now);
			return result;
		}
	} else {
		result = FALSE;
		_g_date_time_unref0 (now);
		return result;
	}
}

/**
     * Converts the given ICal.Time to a GLib.DateTime, represented in the
     * system timezone.
     *
     * All timezone information in the original @date is lost. However, the
     * {@link GLib.TimeZone} contained in the resulting DateTime is correct,
     * since there is a well-defined local timezone between both libical and
     * GLib.
     */
GDateTime*
utils_datetime_ical_to_date_time_local (ICalTime* date)
{
	ICalTime* converted = NULL;
	ICalTime* _tmp0_;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GDateTime* _tmp7_;
	GDateTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	_vala_assert (!i_cal_time_is_null_time (date), "!date.is_null_time ()");
	_tmp0_ = utils_datetime_ical_convert_to_local (date);
	converted = _tmp0_;
	i_cal_time_get_date (converted, &_tmp1_, &_tmp2_, &_tmp3_);
	year = _tmp1_;
	month = _tmp2_;
	day = _tmp3_;
	i_cal_time_get_time (converted, &_tmp4_, &_tmp5_, &_tmp6_);
	hour = _tmp4_;
	minute = _tmp5_;
	second = _tmp6_;
	_tmp7_ = g_date_time_new_local (year, month, day, hour, minute, (gdouble) second);
	result = _tmp7_;
	_g_object_unref0 (converted);
	return result;
}

/** Converts the given ICal.Time to the local (or system) timezone */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ICalTime*
utils_datetime_ical_convert_to_local (ICalTime* time)
{
	ICalTimezone* system_tz = NULL;
	ICalTimezone* _tmp0_;
	ICalTimezone* _tmp1_;
	ICalTime* _tmp2_;
	ICalTime* result;
	g_return_val_if_fail (time != NULL, NULL);
	_tmp0_ = e_cal_util_get_system_timezone ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	system_tz = _tmp1_;
	_tmp2_ = i_cal_time_convert_to_zone (time, system_tz);
	result = _tmp2_;
	_g_object_unref0 (system_tz);
	return result;
}

/**
     * Converts two DateTimes representing a date and a time to one TimeType.
     *
     * The first contains the date; its time settings are ignored. The second
     * one contains the time itself; its date settings are ignored. If the time
     * is `null`, the resulting TimeType is of `DATE` type; if it is given, the
     * TimeType is of `DATE-TIME` type.
     *
     * This also accepts an optional `timezone` argument. If it is given a
     * timezone, the resulting TimeType will be relative to the given timezone.
     * If it is `null`, the resulting TimeType will be "floating" with no
     * timezone. If the argument is not given, it will default to the system
     * timezone.
     */
ICalTime*
utils_datetime_datetimes_to_icaltime (GDateTime* date,
                                      GDateTime* time_local,
                                      ICalTimezone* timezone)
{
	ICalTime* _result_ = NULL;
	ICalTime* _tmp0_;
	ICalTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = i_cal_time_new_from_day_of_year (g_date_time_get_day_of_year (date), g_date_time_get_year (date));
	_result_ = _tmp0_;
	if (time_local == NULL) {
		ICalTime* _tmp1_;
		_tmp1_ = _result_;
		i_cal_time_set_is_date (_tmp1_, TRUE);
	} else {
		ICalTime* _tmp2_;
		ICalTime* _tmp3_;
		ICalTime* _tmp4_;
		_tmp2_ = _result_;
		i_cal_time_set_is_date (_tmp2_, FALSE);
		_tmp3_ = _result_;
		i_cal_time_set_timezone (_tmp3_, timezone);
		_tmp4_ = _result_;
		i_cal_time_set_time (_tmp4_, g_date_time_get_hour (time_local), g_date_time_get_minute (time_local), g_date_time_get_second (time_local));
	}
	result = _result_;
	return result;
}

gchar*
utils_datetime_get_markdown_format_date (ObjectsItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	ObjectsDueDate* _tmp3_;
	ObjectsDueDate* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
	g_return_val_if_fail (item != NULL, NULL);
	_tmp0_ = objects_item_get_has_due (item);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (" ");
		result = _tmp2_;
		return result;
	}
	_tmp3_ = objects_item_get_due (item);
	_tmp4_ = _tmp3_;
	_tmp5_ = objects_due_date_get_datetime (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = utils_datetime_get_relative_date_from_date (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat (_tmp10_, ") ", NULL);
	_tmp12_ = _tmp11_;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	result = _tmp12_;
	return result;
}

GDateTime*
utils_datetime_get_datetime_no_seconds (GDateTime* date,
                                        GDateTime* time)
{
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GDateTime* _tmp2_;
	GDateTime* result;
	g_return_val_if_fail (date != NULL, NULL);
	if (time == NULL) {
		_tmp0_ = g_date_time_get_hour (date);
	} else {
		_tmp0_ = g_date_time_get_hour (time);
	}
	if (time == NULL) {
		_tmp1_ = g_date_time_get_minute (date);
	} else {
		_tmp1_ = g_date_time_get_minute (time);
	}
	_tmp2_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), g_date_time_get_day_of_month (date), _tmp0_, _tmp1_, (gdouble) 0);
	result = _tmp2_;
	return result;
}

UtilsDatetime*
utils_datetime_construct (GType object_type)
{
	UtilsDatetime* self = NULL;
	self = (UtilsDatetime*) g_type_create_instance (object_type);
	return self;
}

UtilsDatetime*
utils_datetime_new (void)
{
	return utils_datetime_construct (UTILS_TYPE_DATETIME);
}

static void
utils_value_datetime_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
utils_value_datetime_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		utils_datetime_unref (value->data[0].v_pointer);
	}
}

static void
utils_value_datetime_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = utils_datetime_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
utils_value_datetime_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
utils_value_datetime_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		UtilsDatetime * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = utils_datetime_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
utils_value_datetime_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	UtilsDatetime ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = utils_datetime_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
utils_param_spec_datetime (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	UtilsParamSpecDatetime* spec;
	g_return_val_if_fail (g_type_is_a (object_type, UTILS_TYPE_DATETIME), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
utils_value_get_datetime (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME), NULL);
	return value->data[0].v_pointer;
}

void
utils_value_set_datetime (GValue* value,
                          gpointer v_object)
{
	UtilsDatetime * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTILS_TYPE_DATETIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		utils_datetime_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		utils_datetime_unref (old);
	}
}

void
utils_value_take_datetime (GValue* value,
                           gpointer v_object)
{
	UtilsDatetime * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTILS_TYPE_DATETIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		utils_datetime_unref (old);
	}
}

static void
utils_datetime_class_init (UtilsDatetimeClass * klass,
                           gpointer klass_data)
{
	utils_datetime_parent_class = g_type_class_peek_parent (klass);
	((UtilsDatetimeClass *) klass)->finalize = utils_datetime_finalize;
}

static void
utils_datetime_instance_init (UtilsDatetime * self,
                              gpointer klass)
{
	self->ref_count = 1;
}

static void
utils_datetime_finalize (UtilsDatetime * obj)
{
	UtilsDatetime * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTILS_TYPE_DATETIME, UtilsDatetime);
	g_signal_handlers_destroy (self);
}

static GType
utils_datetime_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { utils_value_datetime_init, utils_value_datetime_free_value, utils_value_datetime_copy_value, utils_value_datetime_peek_pointer, "p", utils_value_datetime_collect_value, "p", utils_value_datetime_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UtilsDatetimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_datetime_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilsDatetime), 0, (GInstanceInitFunc) utils_datetime_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType utils_datetime_type_id;
	utils_datetime_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UtilsDatetime", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return utils_datetime_type_id;
}

GType
utils_datetime_get_type (void)
{
	static volatile gsize utils_datetime_type_id__once = 0;
	if (g_once_init_enter (&utils_datetime_type_id__once)) {
		GType utils_datetime_type_id;
		utils_datetime_type_id = utils_datetime_get_type_once ();
		g_once_init_leave (&utils_datetime_type_id__once, utils_datetime_type_id);
	}
	return utils_datetime_type_id__once;
}

gpointer
utils_datetime_ref (gpointer instance)
{
	UtilsDatetime * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
utils_datetime_unref (gpointer instance)
{
	UtilsDatetime * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UTILS_DATETIME_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

