/* ItemLabels.c generated by valac 0.56.18, the Vala compiler
 * generated from ItemLabels.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <adwaita.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_ITEM_LABELS_0_PROPERTY,
	WIDGETS_ITEM_LABELS_ITEM_PROPERTY,
	WIDGETS_ITEM_LABELS_TOP_MARGIN_PROPERTY,
	WIDGETS_ITEM_LABELS_NUM_PROPERTIES
};
static GParamSpec* widgets_item_labels_properties[WIDGETS_ITEM_LABELS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WidgetsItemLabelsPrivate {
	ObjectsItem* _item;
	GtkFlowBox* flowbox;
	GtkRevealer* main_revealer;
	GeeHashMap* item_labels_map;
};

static gint WidgetsItemLabels_private_offset;
static gpointer widgets_item_labels_parent_class = NULL;

static gboolean widgets_item_labels_get_has_items (WidgetsItemLabels* self);
static GObject * widgets_item_labels_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _widgets_item_labels___lambda95_ (WidgetsItemLabels* self,
                                       ObjectsLabel* label);
static void __widgets_item_labels___lambda95__objects_item_item_label_deleted (ObjectsItem* _sender,
                                                                        ObjectsLabel* label,
                                                                        gpointer self);
static void _widgets_item_labels___lambda96_ (WidgetsItemLabels* self,
                                       ObjectsLabel* label);
static void __widgets_item_labels___lambda96__objects_item_item_label_added (ObjectsItem* _sender,
                                                                      ObjectsLabel* label,
                                                                      gpointer self);
static void widgets_item_labels_finalize (GObject * obj);
static GType widgets_item_labels_get_type_once (void);
static void _vala_widgets_item_labels_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_widgets_item_labels_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
widgets_item_labels_get_instance_private (WidgetsItemLabels* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsItemLabels_private_offset);
}

WidgetsItemLabels*
widgets_item_labels_construct (GType object_type,
                               ObjectsItem* item)
{
	WidgetsItemLabels * self = NULL;
	g_return_val_if_fail (item != NULL, NULL);
	self = (WidgetsItemLabels*) g_object_new (object_type, "item", item, NULL);
	return self;
}

WidgetsItemLabels*
widgets_item_labels_new (ObjectsItem* item)
{
	return widgets_item_labels_construct (WIDGETS_TYPE_ITEM_LABELS, item);
}

void
widgets_item_labels_add_labels (WidgetsItemLabels* self)
{
	GtkRevealer* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	{
		GeeArrayList* _label_list = NULL;
		ObjectsItem* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _label_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _label_index = 0;
		_tmp0_ = self->priv->_item;
		_tmp1_ = _objects_item_get_labels (_tmp0_);
		_label_list = _tmp1_;
		_tmp2_ = _label_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_label_size = _tmp4_;
		_label_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			ObjectsLabel* label = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			ObjectsLabel* _tmp9_;
			_label_index = _label_index + 1;
			_tmp5_ = _label_index;
			_tmp6_ = _label_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _label_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _label_index);
			label = (ObjectsLabel*) _tmp8_;
			_tmp9_ = label;
			widgets_item_labels_add_item_label (self, _tmp9_);
			_g_object_unref0 (label);
		}
		_g_object_unref0 (_label_list);
	}
	_tmp10_ = self->priv->main_revealer;
	_tmp11_ = widgets_item_labels_get_has_items (self);
	_tmp12_ = _tmp11_;
	gtk_revealer_set_reveal_child (_tmp10_, _tmp12_);
}

void
widgets_item_labels_add_item_label (WidgetsItemLabels* self,
                                    ObjectsLabel* label)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkRevealer* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = self->priv->item_labels_map;
	_tmp1_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
	_tmp2_ = _tmp1_;
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		WidgetsItemLabelChild* _tmp6_;
		WidgetsItemLabelChild* _tmp7_;
		GtkFlowBox* _tmp8_;
		GeeHashMap* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gpointer _tmp12_;
		WidgetsItemLabelChild* _tmp13_;
		_tmp3_ = self->priv->item_labels_map;
		_tmp4_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
		_tmp5_ = _tmp4_;
		_tmp6_ = widgets_item_label_child_new (label);
		g_object_ref_sink (_tmp6_);
		_tmp7_ = _tmp6_;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, _tmp5_, _tmp7_);
		_g_object_unref0 (_tmp7_);
		_tmp8_ = self->priv->flowbox;
		_tmp9_ = self->priv->item_labels_map;
		_tmp10_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
		_tmp11_ = _tmp10_;
		_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, _tmp11_);
		_tmp13_ = (WidgetsItemLabelChild*) _tmp12_;
		gtk_flow_box_append (_tmp8_, (GtkWidget*) _tmp13_);
		_g_object_unref0 (_tmp13_);
	}
	_tmp14_ = self->priv->main_revealer;
	_tmp15_ = widgets_item_labels_get_has_items (self);
	_tmp16_ = _tmp15_;
	gtk_revealer_set_reveal_child (_tmp14_, _tmp16_);
}

void
widgets_item_labels_remove_item_label (WidgetsItemLabels* self,
                                       ObjectsLabel* label)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkRevealer* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = self->priv->item_labels_map;
	_tmp1_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
	_tmp2_ = _tmp1_;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gpointer _tmp6_;
		WidgetsItemLabelChild* _tmp7_;
		GeeHashMap* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp3_ = self->priv->item_labels_map;
		_tmp4_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
		_tmp5_ = _tmp4_;
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp5_);
		_tmp7_ = (WidgetsItemLabelChild*) _tmp6_;
		widgets_item_label_child_hide_destroy (_tmp7_);
		_g_object_unref0 (_tmp7_);
		_tmp8_ = self->priv->item_labels_map;
		_tmp9_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
		_tmp10_ = _tmp9_;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp8_, _tmp10_, NULL);
	}
	_tmp11_ = self->priv->main_revealer;
	_tmp12_ = widgets_item_labels_get_has_items (self);
	_tmp13_ = _tmp12_;
	gtk_revealer_set_reveal_child (_tmp11_, _tmp13_);
}

void
widgets_item_labels_update_labels (WidgetsItemLabels* self)
{
	g_return_if_fail (self != NULL);
	widgets_item_labels_reset (self);
	widgets_item_labels_add_labels (self);
}

void
widgets_item_labels_reset (WidgetsItemLabels* self)
{
	GeeHashMap* _tmp11_;
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _item_label_row_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->item_labels_map;
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_item_label_row_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			WidgetsItemLabelChild* item_label_row = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GtkFlowBox* _tmp9_;
			WidgetsItemLabelChild* _tmp10_;
			_tmp6_ = _item_label_row_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _item_label_row_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			item_label_row = (WidgetsItemLabelChild*) _tmp8_;
			_tmp9_ = self->priv->flowbox;
			_tmp10_ = item_label_row;
			gtk_flow_box_remove (_tmp9_, (GtkWidget*) _tmp10_);
			_g_object_unref0 (item_label_row);
		}
		_g_object_unref0 (_item_label_row_it);
	}
	_tmp11_ = self->priv->item_labels_map;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp11_);
}

ObjectsItem*
widgets_item_labels_get_item (WidgetsItemLabels* self)
{
	ObjectsItem* result;
	ObjectsItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_item;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
widgets_item_labels_set_item (WidgetsItemLabels* self,
                              ObjectsItem* value)
{
	ObjectsItem* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_item_labels_get_item (self);
	if (old_value != value) {
		ObjectsItem* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_item);
		self->priv->_item = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_item_labels_properties[WIDGETS_ITEM_LABELS_ITEM_PROPERTY]);
	}
}

static gboolean
widgets_item_labels_get_has_items (WidgetsItemLabels* self)
{
	gboolean result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->item_labels_map;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_ > 0;
	return result;
}

void
widgets_item_labels_set_top_margin (WidgetsItemLabels* self,
                                    gint value)
{
	GtkFlowBox* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->flowbox;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, widgets_item_labels_properties[WIDGETS_ITEM_LABELS_TOP_MARGIN_PROPERTY]);
}

static void
_widgets_item_labels___lambda95_ (WidgetsItemLabels* self,
                                  ObjectsLabel* label)
{
	g_return_if_fail (label != NULL);
	widgets_item_labels_remove_item_label (self, label);
}

static void
__widgets_item_labels___lambda95__objects_item_item_label_deleted (ObjectsItem* _sender,
                                                                   ObjectsLabel* label,
                                                                   gpointer self)
{
	_widgets_item_labels___lambda95_ ((WidgetsItemLabels*) self, label);
}

static void
_widgets_item_labels___lambda96_ (WidgetsItemLabels* self,
                                  ObjectsLabel* label)
{
	g_return_if_fail (label != NULL);
	widgets_item_labels_add_item_label (self, label);
}

static void
__widgets_item_labels___lambda96__objects_item_item_label_added (ObjectsItem* _sender,
                                                                 ObjectsLabel* label,
                                                                 gpointer self)
{
	_widgets_item_labels___lambda96_ ((WidgetsItemLabels*) self, label);
}

static GObject *
widgets_item_labels_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsItemLabels * self;
	GtkFlowBox* _tmp0_ = NULL;
	GtkFlowBox* _tmp1_;
	GtkWidget* _tmp2_;
	GtkRevealer* _tmp3_ = NULL;
	GtkRevealer* _tmp4_;
	ObjectsItem* _tmp5_;
	ObjectsItem* _tmp6_;
	parent_class = G_OBJECT_CLASS (widgets_item_labels_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_ITEM_LABELS, WidgetsItemLabels);
	_tmp0_ = (GtkFlowBox*) gtk_flow_box_new ();
	gtk_flow_box_set_column_spacing (_tmp0_, (guint) 6);
	gtk_flow_box_set_row_spacing (_tmp0_, (guint) 6);
	gtk_flow_box_set_homogeneous (_tmp0_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
	gtk_flow_box_set_min_children_per_line (_tmp0_, (guint) 3);
	gtk_flow_box_set_max_children_per_line (_tmp0_, (guint) 20);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->flowbox);
	self->priv->flowbox = _tmp0_;
	_tmp1_ = self->priv->flowbox;
	_tmp2_ = _g_object_ref0 ((GtkWidget*) _tmp1_);
	_tmp3_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_transition_type (_tmp3_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	gtk_revealer_set_child (_tmp3_, _tmp2_);
	_g_object_unref0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->main_revealer);
	self->priv->main_revealer = _tmp3_;
	_tmp4_ = self->priv->main_revealer;
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp4_);
	widgets_item_labels_add_labels (self);
	_tmp5_ = self->priv->_item;
	g_signal_connect_object (_tmp5_, "item-label-deleted", (GCallback) __widgets_item_labels___lambda95__objects_item_item_label_deleted, self, 0);
	_tmp6_ = self->priv->_item;
	g_signal_connect_object (_tmp6_, "item-label-added", (GCallback) __widgets_item_labels___lambda96__objects_item_item_label_added, self, 0);
	return obj;
}

static void
widgets_item_labels_class_init (WidgetsItemLabelsClass * klass,
                                gpointer klass_data)
{
	widgets_item_labels_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsItemLabels_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_item_labels_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_item_labels_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_item_labels_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_item_labels_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_ITEM_LABELS_ITEM_PROPERTY, widgets_item_labels_properties[WIDGETS_ITEM_LABELS_ITEM_PROPERTY] = g_param_spec_object ("item", "item", "item", OBJECTS_TYPE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_ITEM_LABELS_TOP_MARGIN_PROPERTY, widgets_item_labels_properties[WIDGETS_ITEM_LABELS_TOP_MARGIN_PROPERTY] = g_param_spec_int ("top-margin", "top-margin", "top-margin", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
widgets_item_labels_instance_init (WidgetsItemLabels * self,
                                   gpointer klass)
{
	GeeHashMap* _tmp0_;
	self->priv = widgets_item_labels_get_instance_private (self);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WIDGETS_TYPE_ITEM_LABEL_CHILD, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->item_labels_map = _tmp0_;
}

static void
widgets_item_labels_finalize (GObject * obj)
{
	WidgetsItemLabels * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_ITEM_LABELS, WidgetsItemLabels);
	_g_object_unref0 (self->priv->_item);
	_g_object_unref0 (self->priv->flowbox);
	_g_object_unref0 (self->priv->main_revealer);
	_g_object_unref0 (self->priv->item_labels_map);
	G_OBJECT_CLASS (widgets_item_labels_parent_class)->finalize (obj);
}

static GType
widgets_item_labels_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsItemLabelsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_item_labels_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsItemLabels), 0, (GInstanceInitFunc) widgets_item_labels_instance_init, NULL };
	GType widgets_item_labels_type_id;
	widgets_item_labels_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsItemLabels", &g_define_type_info, 0);
	WidgetsItemLabels_private_offset = g_type_add_instance_private (widgets_item_labels_type_id, sizeof (WidgetsItemLabelsPrivate));
	return widgets_item_labels_type_id;
}

GType
widgets_item_labels_get_type (void)
{
	static volatile gsize widgets_item_labels_type_id__once = 0;
	if (g_once_init_enter (&widgets_item_labels_type_id__once)) {
		GType widgets_item_labels_type_id;
		widgets_item_labels_type_id = widgets_item_labels_get_type_once ();
		g_once_init_leave (&widgets_item_labels_type_id__once, widgets_item_labels_type_id);
	}
	return widgets_item_labels_type_id__once;
}

static void
_vala_widgets_item_labels_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	WidgetsItemLabels * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_ITEM_LABELS, WidgetsItemLabels);
	switch (property_id) {
		case WIDGETS_ITEM_LABELS_ITEM_PROPERTY:
		g_value_set_object (value, widgets_item_labels_get_item (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_item_labels_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	WidgetsItemLabels * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_ITEM_LABELS, WidgetsItemLabels);
	switch (property_id) {
		case WIDGETS_ITEM_LABELS_ITEM_PROPERTY:
		widgets_item_labels_set_item (self, g_value_get_object (value));
		break;
		case WIDGETS_ITEM_LABELS_TOP_MARGIN_PROPERTY:
		widgets_item_labels_set_top_margin (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

