/* Color.c generated by valac 0.56.18, the Vala compiler
 * generated from Color.vala, do not modify */

/*
 *
 * Based on Folio
 * https://github.com/toolstack/Folio
 */

#include "planify.h"
#include <glib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

ColorHSL*
color_hsl_dup (const ColorHSL* self)
{
	ColorHSL* dup;
	dup = g_new0 (ColorHSL, 1);
	memcpy (dup, self, sizeof (ColorHSL));
	return dup;
}

void
color_hsl_free (ColorHSL* self)
{
	g_free (self);
}

static GType
color_hsl_get_type_once (void)
{
	GType color_hsl_type_id;
	color_hsl_type_id = g_boxed_type_register_static ("ColorHSL", (GBoxedCopyFunc) color_hsl_dup, (GBoxedFreeFunc) color_hsl_free);
	return color_hsl_type_id;
}

GType
color_hsl_get_type (void)
{
	static volatile gsize color_hsl_type_id__once = 0;
	if (g_once_init_enter (&color_hsl_type_id__once)) {
		GType color_hsl_type_id;
		color_hsl_type_id = color_hsl_get_type_once ();
		g_once_init_leave (&color_hsl_type_id__once, color_hsl_type_id);
	}
	return color_hsl_type_id__once;
}

void
color_rgb_init (ColorRGB *self,
                gfloat r,
                gfloat g,
                gfloat b)
{
	memset (self, 0, sizeof (ColorRGB));
	(*self).r = r;
	(*self).g = g;
	(*self).b = b;
}

inline void
color_rgb_times (ColorRGB *self,
                 ColorRGB* rgb,
                 ColorRGB* result)
{
	ColorRGB _tmp0_;
	ColorRGB _tmp1_;
	ColorRGB _tmp2_;
	ColorRGB _tmp3_ = {0};
	g_return_if_fail (rgb != NULL);
	_tmp0_ = *rgb;
	_tmp1_ = *rgb;
	_tmp2_ = *rgb;
	color_rgb_init (&_tmp3_, (*self).r * _tmp0_.r, (*self).g * _tmp1_.g, (*self).b * _tmp2_.b);
	*result = _tmp3_;
	return;
}

inline void
color_rgb_multiply (ColorRGB *self,
                    gfloat x,
                    ColorRGB* result)
{
	ColorRGB _tmp0_ = {0};
	color_rgb_init (&_tmp0_, (*self).r * x, (*self).g * x, (*self).b * x);
	*result = _tmp0_;
	return;
}

inline void
color_rgb_plus (ColorRGB *self,
                ColorRGB* rgb,
                ColorRGB* result)
{
	ColorRGB _tmp0_;
	ColorRGB _tmp1_;
	ColorRGB _tmp2_;
	ColorRGB _tmp3_ = {0};
	g_return_if_fail (rgb != NULL);
	_tmp0_ = *rgb;
	_tmp1_ = *rgb;
	_tmp2_ = *rgb;
	color_rgb_init (&_tmp3_, (*self).r + _tmp0_.r, (*self).g + _tmp1_.g, (*self).b + _tmp2_.b);
	*result = _tmp3_;
	return;
}

ColorRGB*
color_rgb_dup (const ColorRGB* self)
{
	ColorRGB* dup;
	dup = g_new0 (ColorRGB, 1);
	memcpy (dup, self, sizeof (ColorRGB));
	return dup;
}

void
color_rgb_free (ColorRGB* self)
{
	g_free (self);
}

static GType
color_rgb_get_type_once (void)
{
	GType color_rgb_type_id;
	color_rgb_type_id = g_boxed_type_register_static ("ColorRGB", (GBoxedCopyFunc) color_rgb_dup, (GBoxedFreeFunc) color_rgb_free);
	return color_rgb_type_id;
}

GType
color_rgb_get_type (void)
{
	static volatile gsize color_rgb_type_id__once = 0;
	if (g_once_init_enter (&color_rgb_type_id__once)) {
		GType color_rgb_type_id;
		color_rgb_type_id = color_rgb_get_type_once ();
		g_once_init_leave (&color_rgb_type_id__once, color_rgb_type_id);
	}
	return color_rgb_type_id__once;
}

inline void
color_rgb_to_hsl (ColorRGB* rgb,
                  ColorHSL* hsl,
                  ColorHSL* result)
{
	ColorHSL _vala_hsl = {0};
	gfloat s = 0.0F;
	gfloat v = 0.0F;
	ColorRGB _tmp0_;
	ColorRGB _tmp1_;
	ColorRGB _tmp2_;
	gfloat _tmp3_ = 0.0F;
	gfloat _tmp4_ = 0.0F;
	gfloat _tmp5_ = 0.0F;
	gfloat m = 0.0F;
	ColorHSL _tmp6_;
	ColorHSL _tmp7_;
	gfloat _tmp8_ = 0.0F;
	ColorHSL _tmp10_;
	g_return_if_fail (rgb != NULL);
	memset (&_vala_hsl, 0, sizeof (ColorHSL));
	_tmp0_ = *rgb;
	_tmp1_ = *rgb;
	_tmp2_ = *rgb;
	gtk_rgb_to_hsv (_tmp0_.r, _tmp1_.g, _tmp2_.b, &_tmp3_, &_tmp4_, &_tmp5_);
	_vala_hsl.h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_vala_hsl.l = v - ((v * s) / 2);
	_tmp6_ = _vala_hsl;
	_tmp7_ = _vala_hsl;
	m = MIN (_tmp6_.l, 1 - _tmp7_.l);
	if (m != ((gfloat) 0)) {
		ColorHSL _tmp9_;
		_tmp9_ = _vala_hsl;
		_tmp8_ = (v - _tmp9_.l) / m;
	} else {
		_tmp8_ = (gfloat) 0;
	}
	_vala_hsl.s = _tmp8_;
	_tmp10_ = _vala_hsl;
	*result = _tmp10_;
	if (hsl) {
		*hsl = _vala_hsl;
	}
	return;
}

inline void
color_hsl_to_rgb (ColorHSL* hsl,
                  ColorRGB* rgb,
                  ColorRGB* result)
{
	ColorRGB _vala_rgb = {0};
	gfloat v = 0.0F;
	ColorHSL _tmp0_;
	ColorHSL _tmp1_;
	ColorHSL _tmp2_;
	ColorHSL _tmp3_;
	gfloat _tmp4_ = 0.0F;
	gfloat s = 0.0F;
	ColorHSL _tmp6_;
	gfloat _tmp7_ = 0.0F;
	gfloat _tmp8_ = 0.0F;
	gfloat _tmp9_ = 0.0F;
	ColorRGB _tmp10_;
	g_return_if_fail (hsl != NULL);
	color_rgb_init (&_vala_rgb, (gfloat) 0, (gfloat) 0, (gfloat) 0);
	_tmp0_ = *hsl;
	_tmp1_ = *hsl;
	_tmp2_ = *hsl;
	_tmp3_ = *hsl;
	v = (_tmp0_.s * MIN (_tmp1_.l, 1 - _tmp2_.l)) + _tmp3_.l;
	if (v != ((gfloat) 0)) {
		ColorHSL _tmp5_;
		_tmp5_ = *hsl;
		_tmp4_ = 2 - ((2 * _tmp5_.l) / v);
	} else {
		_tmp4_ = (gfloat) 0;
	}
	s = _tmp4_;
	_tmp6_ = *hsl;
	gtk_hsv_to_rgb (_tmp6_.h, s, v, &_tmp7_, &_tmp8_, &_tmp9_);
	_vala_rgb.r = _tmp7_;
	_vala_rgb.g = _tmp8_;
	_vala_rgb.b = _tmp9_;
	_tmp10_ = _vala_rgb;
	*result = _tmp10_;
	if (rgb) {
		*rgb = _vala_rgb;
	}
	return;
}

inline void
color_RGBA_to_rgb (GdkRGBA* rgba,
                   ColorRGB* rgb,
                   ColorRGB* result)
{
	ColorRGB _vala_rgb = {0};
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	ColorRGB _tmp3_;
	g_return_if_fail (rgba != NULL);
	color_rgb_init (&_vala_rgb, (gfloat) 0, (gfloat) 0, (gfloat) 0);
	_tmp0_ = *rgba;
	_vala_rgb.r = _tmp0_.red;
	_tmp1_ = *rgba;
	_vala_rgb.g = _tmp1_.green;
	_tmp2_ = *rgba;
	_vala_rgb.b = _tmp2_.blue;
	_tmp3_ = _vala_rgb;
	*result = _tmp3_;
	if (rgb) {
		*rgb = _vala_rgb;
	}
	return;
}

inline void
color_rgb_to_RGBA (ColorRGB* rgb,
                   GdkRGBA* rgba,
                   GdkRGBA* result)
{
	GdkRGBA _vala_rgba = {0};
	ColorRGB _tmp0_;
	ColorRGB _tmp1_;
	ColorRGB _tmp2_;
	GdkRGBA _tmp3_;
	g_return_if_fail (rgb != NULL);
	memset (&_vala_rgba, 0, sizeof (GdkRGBA));
	_tmp0_ = *rgb;
	_vala_rgba.red = _tmp0_.r;
	_tmp1_ = *rgb;
	_vala_rgba.green = _tmp1_.g;
	_tmp2_ = *rgb;
	_vala_rgba.blue = _tmp2_.b;
	_vala_rgba.alpha = (gfloat) 1;
	_tmp3_ = _vala_rgba;
	*result = _tmp3_;
	if (rgba) {
		*rgba = _vala_rgba;
	}
	return;
}

inline gfloat
color_get_luminance (gfloat r,
                     gfloat g,
                     gfloat b)
{
	gfloat result;
	result = sqrtf ((((0.299f * r) * r) + ((0.587f * g) * g)) + ((0.114f * b) * b));
	return result;
}

inline gfloat
color_get_luminance_photometric (gfloat r,
                                 gfloat g,
                                 gfloat b)
{
	gfloat result;
	result = ((0.2126f * r) + (0.7152f * g)) + 0.0722f;
	return result;
}

inline gfloat
color_get_luminance_digital (gfloat r,
                             gfloat g,
                             gfloat b)
{
	gfloat result;
	result = ((0.299f * r) + (0.587f * g)) + 0.114f;
	return result;
}

