/* Project.c generated by valac 0.56.18, the Vala compiler
 * generated from Project.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <adwaita.h>
#include <glib-object.h>
#include "planify.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DIALOGS_TYPE_PROJECT (dialogs_project_get_type ())
#define DIALOGS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_TYPE_PROJECT, DialogsProject))
#define DIALOGS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_TYPE_PROJECT, DialogsProjectClass))
#define DIALOGS_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_TYPE_PROJECT))
#define DIALOGS_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_TYPE_PROJECT))
#define DIALOGS_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_TYPE_PROJECT, DialogsProjectClass))

typedef struct _DialogsProject DialogsProject;
typedef struct _DialogsProjectClass DialogsProjectClass;
typedef struct _DialogsProjectPrivate DialogsProjectPrivate;

#define WIDGETS_TYPE_COLOR_PICKER_ROW (widgets_color_picker_row_get_type ())
#define WIDGETS_COLOR_PICKER_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_COLOR_PICKER_ROW, WidgetsColorPickerRow))
#define WIDGETS_COLOR_PICKER_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_COLOR_PICKER_ROW, WidgetsColorPickerRowClass))
#define WIDGETS_IS_COLOR_PICKER_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_COLOR_PICKER_ROW))
#define WIDGETS_IS_COLOR_PICKER_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_COLOR_PICKER_ROW))
#define WIDGETS_COLOR_PICKER_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_COLOR_PICKER_ROW, WidgetsColorPickerRowClass))

typedef struct _WidgetsColorPickerRow WidgetsColorPickerRow;
typedef struct _WidgetsColorPickerRowClass WidgetsColorPickerRowClass;
enum  {
	DIALOGS_PROJECT_0_PROPERTY,
	DIALOGS_PROJECT_PROJECT_PROPERTY,
	DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY,
	DIALOGS_PROJECT_HEADER_TITLE_PROPERTY,
	DIALOGS_PROJECT_IS_CREATING_PROPERTY,
	DIALOGS_PROJECT_NUM_PROPERTIES
};
static GParamSpec* dialogs_project_properties[DIALOGS_PROJECT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block61Data Block61Data;
typedef struct _Block62Data Block62Data;
#define _http_response_unref0(var) ((var == NULL) ? NULL : (var = (http_response_unref (var), NULL)))
typedef struct _DialogsProjectUpdateProjectData DialogsProjectUpdateProjectData;
typedef struct _Block63Data Block63Data;

struct _DialogsProject {
	AdwDialog parent_instance;
	DialogsProjectPrivate * priv;
};

struct _DialogsProjectClass {
	AdwDialogClass parent_class;
};

struct _DialogsProjectPrivate {
	ObjectsProject* _project;
	gboolean _backend_picker;
	gchar* _header_title;
	GtkStack* emoji_color_stack;
	WidgetsCircularProgressBar* progress_bar;
	AdwEntryRow* name_entry;
	WidgetsColorPickerRow* color_picker_row;
	WidgetsLoadingButton* submit_button;
	GtkSwitch* emoji_switch;
	GtkLabel* emoji_label;
	GtkLabel* source_selected_label;
	AdwNavigationView* navigation_view;
	AdwNavigationPage* sources_page;
	GeeHashMap* signal_map;
};

struct _Block61Data {
	int _ref_count_;
	DialogsProject* self;
	GtkEmojiChooser* emoji_chooser;
	GtkRevealer* color_box_revealer;
};

struct _Block62Data {
	int _ref_count_;
	DialogsProject* self;
	ObjectsSource* source;
};

struct _DialogsProjectUpdateProjectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DialogsProject* self;
	ObjectsProject* _tmp0_;
	SourceType _tmp1_;
	SourceType _tmp2_;
	ServicesStore* _tmp3_;
	ObjectsProject* _tmp4_;
	HttpResponse* response;
	ObjectsProject* _tmp5_;
	SourceType _tmp6_;
	SourceType _tmp7_;
	ServicesTodoist* _tmp8_;
	ServicesTodoist* _tmp9_;
	ObjectsProject* _tmp10_;
	HttpResponse* _tmp11_;
	ServicesCalDAVCore* _tmp12_;
	ServicesCalDAVCore* _tmp13_;
	ObjectsProject* _tmp14_;
	HttpResponse* _tmp15_;
	HttpResponse* _tmp16_;
	HttpResponse* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	ServicesStore* _tmp20_;
	ObjectsProject* _tmp21_;
	ServicesEventBus* _tmp22_;
	ServicesEventBus* _tmp23_;
	HttpResponse* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	HttpResponse* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
};

struct _Block63Data {
	int _ref_count_;
	DialogsProject* self;
	gchar* id;
};

static gint DialogsProject_private_offset;
static gpointer dialogs_project_parent_class = NULL;

VALA_EXTERN GType dialogs_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsProject, g_object_unref)
VALA_EXTERN GType widgets_color_picker_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsColorPickerRow, g_object_unref)
VALA_EXTERN DialogsProject* dialogs_project_new_new (const gchar* source_id,
                                         gboolean backend_picker,
                                         const gchar* parent_id);
VALA_EXTERN DialogsProject* dialogs_project_construct_new (GType object_type,
                                               const gchar* source_id,
                                               gboolean backend_picker,
                                               const gchar* parent_id);
VALA_EXTERN DialogsProject* dialogs_project_new (ObjectsProject* project);
VALA_EXTERN DialogsProject* dialogs_project_construct (GType object_type,
                                           ObjectsProject* project);
static AdwNavigationPage* dialogs_project_get_main_page (DialogsProject* self);
static Block61Data* block61_data_ref (Block61Data* _data61_);
static void block61_data_unref (void * _userdata_);
VALA_EXTERN ObjectsProject* dialogs_project_get_project (DialogsProject* self);
VALA_EXTERN gboolean dialogs_project_get_backend_picker (DialogsProject* self);
VALA_EXTERN WidgetsColorPickerRow* widgets_color_picker_row_new (void);
VALA_EXTERN WidgetsColorPickerRow* widgets_color_picker_row_construct (GType object_type);
VALA_EXTERN gboolean dialogs_project_get_is_creating (DialogsProject* self);
VALA_EXTERN const gchar* dialogs_project_get_header_title (DialogsProject* self);
static gboolean __lambda30_ (DialogsProject* self);
VALA_EXTERN void widgets_color_picker_row_set_color (WidgetsColorPickerRow* self,
                                         const gchar* value);
static gboolean ___lambda30__gsource_func (gpointer self);
static void dialogs_project_add_update_project (DialogsProject* self);
static void _dialogs_project_add_update_project_adw_entry_row_entry_activated (AdwEntryRow* _sender,
                                                                        gpointer self);
static void _dialogs_project_add_update_project_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void __lambda34_ (DialogsProject* self,
                  const gchar* emoji);
static void ___lambda34__gtk_emoji_chooser_emoji_picked (GtkEmojiChooser* _sender,
                                                  const gchar* text,
                                                  gpointer self);
static void __lambda35_ (Block61Data* _data61_);
static void ___lambda35__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda36_ (DialogsProject* self);
VALA_EXTERN const gchar* widgets_color_picker_row_get_color (WidgetsColorPickerRow* self);
static void ___lambda36__widgets_color_picker_row_color_changed (WidgetsColorPickerRow* _sender,
                                                          const gchar* color,
                                                          gpointer self);
static void __lambda37_ (Block61Data* _data61_);
static void ___lambda37__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda38_ (DialogsProject* self);
static void ___lambda38__adw_action_row_activated (AdwActionRow* _sender,
                                            gpointer self);
static AdwNavigationPage* dialogs_project_get_sources_page (DialogsProject* self);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static void ____lambda39_ (Block62Data* _data62_);
static void _____lambda39__adw_action_row_activated (AdwActionRow* _sender,
                                              gpointer self);
static void ____lambda40_ (Block62Data* _data62_);
static void _____lambda40__gtk_check_button_toggled (GtkCheckButton* _sender,
                                              gpointer self);
VALA_EXTERN void dialogs_project_hide_destroy (DialogsProject* self);
static void dialogs_project_update_project (DialogsProject* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void dialogs_project_update_project_finish (DialogsProject* self,
                                            GAsyncResult* _res_);
static void dialogs_project_add_project (DialogsProject* self);
static void dialogs_project_update_project_data_free (gpointer _data);
static gboolean dialogs_project_update_project_co (DialogsProjectUpdateProjectData* _data_);
static void dialogs_project_update_project_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN void dialogs_project_go_project (DialogsProject* self,
                                 const gchar* id);
static void ____lambda32_ (DialogsProject* self,
                    GObject* obj,
                    GAsyncResult* res);
static void _____lambda32__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void _____lambda33_ (DialogsProject* self,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda33__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static Block63Data* block63_data_ref (Block63Data* _data63_);
static void block63_data_unref (void * _userdata_);
static gboolean __lambda31_ (Block63Data* _data63_);
static gboolean ___lambda31__gsource_func (gpointer self);
static void dialogs_project_set_project (DialogsProject* self,
                                  ObjectsProject* value);
static void dialogs_project_set_backend_picker (DialogsProject* self,
                                         gboolean value);
static void dialogs_project_set_header_title (DialogsProject* self,
                                       const gchar* value);
static GObject * dialogs_project_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _dialogs_project___lambda41_ (DialogsProject* self);
static void __dialogs_project___lambda41__adw_dialog_closed (AdwDialog* _sender,
                                                      gpointer self);
static void dialogs_project_finalize (GObject * obj);
static GType dialogs_project_get_type_once (void);
static void _vala_dialogs_project_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_dialogs_project_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
dialogs_project_get_instance_private (DialogsProject* self)
{
	return G_STRUCT_MEMBER_P (self, DialogsProject_private_offset);
}

DialogsProject*
dialogs_project_construct_new (GType object_type,
                               const gchar* source_id,
                               gboolean backend_picker,
                               const gchar* parent_id)
{
	DialogsProject * self = NULL;
	ObjectsProject* project = NULL;
	ObjectsProject* _tmp0_;
	ObjectsProject* _tmp1_;
	ObjectsProject* _tmp2_;
	ObjectsProject* _tmp3_;
	ObjectsProject* _tmp4_;
	ObjectsProject* _tmp5_;
	gchar* _tmp6_ = NULL;
	ObjectsProject* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	ObjectsProject* _tmp19_;
	g_return_val_if_fail (source_id != NULL, NULL);
	g_return_val_if_fail (parent_id != NULL, NULL);
	_tmp0_ = objects_project_new ();
	project = _tmp0_;
	_tmp1_ = project;
	objects_project_set_color (_tmp1_, "blue");
	_tmp2_ = project;
	objects_project_set_emoji (_tmp2_, "🚀️");
	_tmp3_ = project;
	objects_base_object_set_id ((ObjectsBaseObject*) _tmp3_, "");
	_tmp4_ = project;
	objects_project_set_parent_id (_tmp4_, parent_id);
	_tmp5_ = project;
	objects_project_set_source_id (_tmp5_, source_id);
	_tmp7_ = project;
	_tmp8_ = objects_project_get_parent_id (_tmp7_);
	_tmp9_ = _tmp8_;
	if (g_strcmp0 (_tmp9_, "") == 0) {
		gchar* _tmp10_;
		_tmp10_ = g_strdup (_ ("New Project"));
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp10_;
	} else {
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
		ObjectsProject* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp11_ = project;
		_tmp12_ = objects_project_get_parent (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat (_tmp15_, " → ", NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat (_tmp17_, _ ("New Project"), NULL);
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp18_;
		_g_free0 (_tmp17_);
	}
	_tmp19_ = project;
	self = (DialogsProject*) g_object_new (object_type, "project", _tmp19_, "backend-picker", backend_picker, "header-title", _tmp6_, NULL);
	_g_free0 (_tmp6_);
	_g_object_unref0 (project);
	return self;
}

DialogsProject*
dialogs_project_new_new (const gchar* source_id,
                         gboolean backend_picker,
                         const gchar* parent_id)
{
	return dialogs_project_construct_new (DIALOGS_TYPE_PROJECT, source_id, backend_picker, parent_id);
}

DialogsProject*
dialogs_project_construct (GType object_type,
                           ObjectsProject* project)
{
	DialogsProject * self = NULL;
	g_return_val_if_fail (project != NULL, NULL);
	self = (DialogsProject*) g_object_new (object_type, "project", project, "backend-picker", FALSE, "header-title", _ ("Edit Project"), NULL);
	return self;
}

DialogsProject*
dialogs_project_new (ObjectsProject* project)
{
	return dialogs_project_construct (DIALOGS_TYPE_PROJECT, project);
}

static Block61Data*
block61_data_ref (Block61Data* _data61_)
{
	g_atomic_int_inc (&_data61_->_ref_count_);
	return _data61_;
}

static void
block61_data_unref (void * _userdata_)
{
	Block61Data* _data61_;
	_data61_ = (Block61Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data61_->_ref_count_)) {
		DialogsProject* self;
		self = _data61_->self;
		_g_object_unref0 (_data61_->color_box_revealer);
		_g_object_unref0 (_data61_->emoji_chooser);
		_g_object_unref0 (self);
		g_slice_free (Block61Data, _data61_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda30_ (DialogsProject* self)
{
	WidgetsCircularProgressBar* _tmp0_;
	ObjectsProject* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	WidgetsColorPickerRow* _tmp4_;
	ObjectsProject* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean result;
	_tmp0_ = self->priv->progress_bar;
	_tmp1_ = self->priv->_project;
	_tmp2_ = objects_project_get_color (_tmp1_);
	_tmp3_ = _tmp2_;
	widgets_circular_progress_bar_set_color (_tmp0_, _tmp3_);
	_tmp4_ = self->priv->color_picker_row;
	_tmp5_ = self->priv->_project;
	_tmp6_ = objects_project_get_color (_tmp5_);
	_tmp7_ = _tmp6_;
	widgets_color_picker_row_set_color (_tmp4_, _tmp7_);
	_tmp8_ = dialogs_project_get_is_creating (self);
	_tmp9_ = _tmp8_;
	if (_tmp9_) {
		AdwEntryRow* _tmp10_;
		_tmp10_ = self->priv->name_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda30__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda30_ ((DialogsProject*) self);
	return result;
}

static void
_dialogs_project_add_update_project_adw_entry_row_entry_activated (AdwEntryRow* _sender,
                                                                   gpointer self)
{
	dialogs_project_add_update_project ((DialogsProject*) self);
}

static void
_dialogs_project_add_update_project_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
	dialogs_project_add_update_project ((DialogsProject*) self);
}

static void
__lambda34_ (DialogsProject* self,
             const gchar* emoji)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (emoji != NULL);
	_tmp0_ = self->priv->emoji_label;
	gtk_label_set_label (_tmp0_, emoji);
}

static void
___lambda34__gtk_emoji_chooser_emoji_picked (GtkEmojiChooser* _sender,
                                             const gchar* text,
                                             gpointer self)
{
	__lambda34_ ((DialogsProject*) self, text);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
__lambda35_ (Block61Data* _data61_)
{
	DialogsProject* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data61_->self;
	_tmp0_ = self->priv->emoji_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkRevealer* _tmp3_;
		GtkStack* _tmp4_;
		GtkLabel* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean _tmp10_;
		GtkEmojiChooser* _tmp12_;
		_tmp3_ = _data61_->color_box_revealer;
		gtk_revealer_set_reveal_child (_tmp3_, FALSE);
		_tmp4_ = self->priv->emoji_color_stack;
		gtk_stack_set_visible_child_name (_tmp4_, "emoji");
		_tmp5_ = self->priv->emoji_label;
		_tmp6_ = gtk_label_get_label (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = string_strip (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strcmp0 (_tmp9_, "") == 0;
		_g_free0 (_tmp9_);
		if (_tmp10_) {
			GtkLabel* _tmp11_;
			_tmp11_ = self->priv->emoji_label;
			gtk_label_set_label (_tmp11_, "🚀️");
		}
		_tmp12_ = _data61_->emoji_chooser;
		gtk_popover_popup ((GtkPopover*) _tmp12_);
	} else {
		GtkRevealer* _tmp13_;
		GtkStack* _tmp14_;
		_tmp13_ = _data61_->color_box_revealer;
		gtk_revealer_set_reveal_child (_tmp13_, TRUE);
		_tmp14_ = self->priv->emoji_color_stack;
		gtk_stack_set_visible_child_name (_tmp14_, "color");
	}
}

static void
___lambda35__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda35_ (self);
}

static void
__lambda36_ (DialogsProject* self)
{
	WidgetsCircularProgressBar* _tmp0_;
	WidgetsColorPickerRow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	_tmp0_ = self->priv->progress_bar;
	_tmp1_ = self->priv->color_picker_row;
	_tmp2_ = widgets_color_picker_row_get_color (_tmp1_);
	_tmp3_ = _tmp2_;
	widgets_circular_progress_bar_set_color (_tmp0_, _tmp3_);
}

static void
___lambda36__widgets_color_picker_row_color_changed (WidgetsColorPickerRow* _sender,
                                                     const gchar* color,
                                                     gpointer self)
{
	__lambda36_ ((DialogsProject*) self);
}

static void
__lambda37_ (Block61Data* _data61_)
{
	DialogsProject* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data61_->self;
	_tmp0_ = self->priv->emoji_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkEmojiChooser* _tmp3_;
		_tmp3_ = _data61_->emoji_chooser;
		gtk_popover_popup ((GtkPopover*) _tmp3_);
	}
}

static void
___lambda37__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda37_ (self);
}

static void
__lambda38_ (DialogsProject* self)
{
	AdwNavigationView* _tmp0_;
	AdwNavigationPage* _tmp1_;
	_tmp0_ = self->priv->navigation_view;
	_tmp1_ = self->priv->sources_page;
	adw_navigation_view_push (_tmp0_, _tmp1_);
}

static void
___lambda38__adw_action_row_activated (AdwActionRow* _sender,
                                       gpointer self)
{
	__lambda38_ ((DialogsProject*) self);
}

static AdwNavigationPage*
dialogs_project_get_main_page (DialogsProject* self)
{
	Block61Data* _data61_;
	AdwHeaderBar* headerbar = NULL;
	AdwHeaderBar* _tmp0_;
	AdwHeaderBar* _tmp1_;
	ObjectsProject* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	WidgetsCircularProgressBar* _tmp6_;
	WidgetsCircularProgressBar* _tmp7_;
	GtkStack* _tmp8_ = NULL;
	GtkStack* _tmp9_;
	WidgetsCircularProgressBar* _tmp10_;
	GtkStack* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_ = NULL;
	ObjectsProject* _tmp14_;
	ProjectIconStyle _tmp15_;
	ProjectIconStyle _tmp16_;
	GtkStack* _tmp17_;
	GtkButton* emoji_picker_button = NULL;
	GtkStack* _tmp18_;
	GtkWidget* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	GtkButton* _tmp23_ = NULL;
	GtkEmojiChooser* _tmp24_ = NULL;
	GtkEmojiChooser* _tmp25_;
	GtkButton* _tmp26_;
	AdwEntryRow* _tmp27_;
	AdwEntryRow* _tmp28_;
	AdwEntryRow* _tmp29_;
	ObjectsProject* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	GtkImage* emoji_icon = NULL;
	GtkImage* _tmp33_;
	ObjectsProject* _tmp34_;
	ProjectIconStyle _tmp35_;
	ProjectIconStyle _tmp36_;
	GtkSwitch* _tmp37_ = NULL;
	AdwActionRow* emoji_switch_row = NULL;
	AdwActionRow* _tmp38_;
	AdwActionRow* _tmp39_;
	AdwActionRow* _tmp40_;
	GtkSwitch* _tmp41_;
	AdwActionRow* _tmp42_;
	GtkImage* _tmp43_;
	AdwActionRow* _tmp44_;
	GtkSwitch* _tmp45_;
	AdwPreferencesGroup* name_group = NULL;
	AdwPreferencesGroup* _tmp46_ = NULL;
	AdwPreferencesGroup* _tmp47_;
	AdwEntryRow* _tmp48_;
	AdwPreferencesGroup* _tmp49_;
	AdwActionRow* _tmp50_;
	ObjectsProject* _tmp51_;
	ObjectsSource* _tmp52_;
	ObjectsSource* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	ObjectsProject* _tmp58_;
	ObjectsSource* _tmp59_;
	ObjectsSource* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	GtkLabel* _tmp64_ = NULL;
	GtkImage* pan_icon = NULL;
	GtkImage* _tmp65_ = NULL;
	GtkBox* source_selected_box = NULL;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	GtkLabel* _tmp68_;
	GtkBox* _tmp69_;
	GtkImage* _tmp70_;
	AdwActionRow* source_row = NULL;
	gchar* _tmp71_;
	AdwActionRow* _tmp72_ = NULL;
	AdwActionRow* _tmp73_;
	GtkBox* _tmp74_;
	AdwPreferencesGroup* source_group = NULL;
	AdwPreferencesGroup* _tmp75_ = NULL;
	AdwPreferencesGroup* _tmp76_;
	AdwActionRow* _tmp77_;
	GtkRevealer* source_revealer = NULL;
	gboolean _tmp78_;
	AdwPreferencesGroup* _tmp79_;
	GtkWidget* _tmp80_;
	GtkRevealer* _tmp81_ = NULL;
	WidgetsColorPickerRow* _tmp82_;
	AdwBin* color_group = NULL;
	gchar* _tmp83_;
	gchar** _tmp84_;
	WidgetsColorPickerRow* _tmp85_;
	GtkWidget* _tmp86_;
	AdwBin* _tmp87_ = NULL;
	ObjectsProject* _tmp88_;
	ProjectIconStyle _tmp89_;
	ProjectIconStyle _tmp90_;
	GtkRevealer* _tmp91_ = NULL;
	GtkRevealer* _tmp92_;
	AdwBin* _tmp93_;
	const gchar* _tmp94_ = NULL;
	gboolean _tmp95_;
	gboolean _tmp96_;
	WidgetsLoadingButton* _tmp97_ = NULL;
	WidgetsLoadingButton* _tmp98_;
	GtkBox* content_box = NULL;
	GtkBox* _tmp99_;
	GtkButton* _tmp100_;
	AdwPreferencesGroup* _tmp101_;
	GtkRevealer* _tmp102_;
	GtkRevealer* _tmp103_;
	WidgetsLoadingButton* _tmp104_;
	AdwClamp* content_clamp = NULL;
	AdwClamp* _tmp105_ = NULL;
	AdwToolbarView* toolbar_view = NULL;
	AdwToolbarView* _tmp106_;
	AdwHeaderBar* _tmp107_;
	AdwNavigationPage* navigation_page = NULL;
	const gchar* _tmp108_;
	AdwNavigationPage* _tmp109_;
	GtkStack* _tmp110_;
	guint _tmp111_;
	guint _tmp112_;
	GeeHashMap* _tmp113_;
	AdwEntryRow* _tmp114_;
	gulong _tmp115_;
	AdwEntryRow* _tmp116_;
	GeeHashMap* _tmp117_;
	WidgetsLoadingButton* _tmp118_;
	gulong _tmp119_;
	WidgetsLoadingButton* _tmp120_;
	GeeHashMap* _tmp121_;
	GtkEmojiChooser* _tmp122_;
	gulong _tmp123_;
	GtkEmojiChooser* _tmp124_;
	GeeHashMap* _tmp125_;
	GtkSwitch* _tmp126_;
	gulong _tmp127_;
	GtkSwitch* _tmp128_;
	GeeHashMap* _tmp129_;
	WidgetsColorPickerRow* _tmp130_;
	gulong _tmp131_;
	WidgetsColorPickerRow* _tmp132_;
	GeeHashMap* _tmp133_;
	GtkButton* _tmp134_;
	gulong _tmp135_;
	GtkButton* _tmp136_;
	GeeHashMap* _tmp137_;
	AdwActionRow* _tmp138_;
	gulong _tmp139_;
	AdwActionRow* _tmp140_;
	AdwNavigationPage* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data61_ = g_slice_new0 (Block61Data);
	_data61_->_ref_count_ = 1;
	_data61_->self = g_object_ref (self);
	_tmp0_ = (AdwHeaderBar*) adw_header_bar_new ();
	g_object_ref_sink (_tmp0_);
	headerbar = _tmp0_;
	_tmp1_ = headerbar;
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "flat");
	_tmp2_ = self->priv->_project;
	_tmp3_ = objects_project_get_emoji (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->emoji_label);
	self->priv->emoji_label = _tmp5_;
	_tmp6_ = widgets_circular_progress_bar_new (32);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->progress_bar);
	self->priv->progress_bar = _tmp6_;
	_tmp7_ = self->priv->progress_bar;
	widgets_circular_progress_bar_set_percentage (_tmp7_, 0.64);
	_tmp8_ = (GtkStack*) gtk_stack_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
	gtk_stack_set_transition_type (_tmp8_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->emoji_color_stack);
	self->priv->emoji_color_stack = _tmp8_;
	_tmp9_ = self->priv->emoji_color_stack;
	_tmp10_ = self->priv->progress_bar;
	gtk_stack_add_named (_tmp9_, (GtkWidget*) _tmp10_, "color");
	_tmp11_ = self->priv->emoji_color_stack;
	_tmp12_ = self->priv->emoji_label;
	gtk_stack_add_named (_tmp11_, (GtkWidget*) _tmp12_, "emoji");
	_tmp14_ = self->priv->_project;
	_tmp15_ = objects_project_get_icon_style (_tmp14_);
	_tmp16_ = _tmp15_;
	if (_tmp16_ == PROJECT_ICON_STYLE_PROGRESS) {
		_tmp13_ = "color";
	} else {
		_tmp13_ = "emoji";
	}
	_tmp17_ = self->priv->emoji_color_stack;
	gtk_stack_set_visible_child_name (_tmp17_, _tmp13_);
	_tmp18_ = self->priv->emoji_color_stack;
	_tmp19_ = _g_object_ref0 ((GtkWidget*) _tmp18_);
	_tmp20_ = g_strdup ("title-2");
	_tmp21_ = g_strdup ("button-emoji-picker");
	_tmp22_ = g_new0 (gchar*, 2 + 1);
	_tmp22_[0] = _tmp20_;
	_tmp22_[1] = _tmp21_;
	_tmp23_ = (GtkButton*) gtk_button_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp23_, TRUE);
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
	g_object_set ((GtkWidget*) _tmp23_, "height-request", 64, NULL);
	g_object_set ((GtkWidget*) _tmp23_, "width-request", 64, NULL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp23_, 6);
	gtk_button_set_child (_tmp23_, _tmp19_);
	_g_object_unref0 (_tmp19_);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp23_, _tmp22_);
	_tmp22_ = (_vala_array_free (_tmp22_, 2, (GDestroyNotify) g_free), NULL);
	g_object_ref_sink (_tmp23_);
	emoji_picker_button = _tmp23_;
	_tmp24_ = (GtkEmojiChooser*) gtk_emoji_chooser_new ();
	gtk_popover_set_has_arrow ((GtkPopover*) _tmp24_, FALSE);
	g_object_ref_sink (_tmp24_);
	_data61_->emoji_chooser = _tmp24_;
	_tmp25_ = _data61_->emoji_chooser;
	_tmp26_ = emoji_picker_button;
	gtk_widget_set_parent ((GtkWidget*) _tmp25_, (GtkWidget*) _tmp26_);
	_tmp27_ = (AdwEntryRow*) adw_entry_row_new ();
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->name_entry);
	self->priv->name_entry = _tmp27_;
	_tmp28_ = self->priv->name_entry;
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp28_, _ ("Give your project a name"));
	_tmp29_ = self->priv->name_entry;
	_tmp30_ = self->priv->_project;
	_tmp31_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp30_);
	_tmp32_ = _tmp31_;
	gtk_editable_set_text ((GtkEditable*) _tmp29_, _tmp32_);
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name ("reaction-add2-symbolic");
	g_object_ref_sink (_tmp33_);
	emoji_icon = _tmp33_;
	_tmp34_ = self->priv->_project;
	_tmp35_ = objects_project_get_icon_style (_tmp34_);
	_tmp36_ = _tmp35_;
	_tmp37_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
	gtk_switch_set_active (_tmp37_, _tmp36_ == PROJECT_ICON_STYLE_EMOJI);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->emoji_switch);
	self->priv->emoji_switch = _tmp37_;
	_tmp38_ = (AdwActionRow*) adw_action_row_new ();
	g_object_ref_sink (_tmp38_);
	emoji_switch_row = _tmp38_;
	_tmp39_ = emoji_switch_row;
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp39_, _ ("Use Emoji"));
	_tmp40_ = emoji_switch_row;
	_tmp41_ = self->priv->emoji_switch;
	adw_action_row_set_activatable_widget (_tmp40_, (GtkWidget*) _tmp41_);
	_tmp42_ = emoji_switch_row;
	_tmp43_ = emoji_icon;
	adw_action_row_add_prefix (_tmp42_, (GtkWidget*) _tmp43_);
	_tmp44_ = emoji_switch_row;
	_tmp45_ = self->priv->emoji_switch;
	adw_action_row_add_suffix (_tmp44_, (GtkWidget*) _tmp45_);
	_tmp46_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
	gtk_widget_set_margin_end ((GtkWidget*) _tmp46_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp46_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp46_, 24);
	g_object_ref_sink (_tmp46_);
	name_group = _tmp46_;
	_tmp47_ = name_group;
	_tmp48_ = self->priv->name_entry;
	adw_preferences_group_add (_tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = name_group;
	_tmp50_ = emoji_switch_row;
	adw_preferences_group_add (_tmp49_, (GtkWidget*) _tmp50_);
	_tmp51_ = self->priv->_project;
	_tmp52_ = objects_project_get_source (_tmp51_);
	_tmp53_ = _tmp52_;
	_tmp54_ = objects_source_get_display_name (_tmp53_);
	_tmp55_ = _tmp54_;
	_tmp56_ = g_strdup ("dim-label");
	_tmp57_ = g_new0 (gchar*, 1 + 1);
	_tmp57_[0] = _tmp56_;
	_tmp58_ = self->priv->_project;
	_tmp59_ = objects_project_get_source (_tmp58_);
	_tmp60_ = _tmp59_;
	_tmp61_ = objects_source_get_subheader_text (_tmp60_);
	_tmp62_ = _tmp61_;
	_tmp63_ = g_strdup (_tmp62_);
	_tmp64_ = (GtkLabel*) gtk_label_new (_tmp55_);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp64_, _tmp57_);
	_tmp57_ = (_vala_array_free (_tmp57_, 1, (GDestroyNotify) g_free), NULL);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp64_, _tmp63_);
	_g_free0 (_tmp63_);
	g_object_ref_sink (_tmp64_);
	_g_object_unref0 (self->priv->source_selected_label);
	self->priv->source_selected_label = _tmp64_;
	_tmp65_ = (GtkImage*) gtk_image_new_from_icon_name ("go-next-symbolic");
	gtk_image_set_pixel_size (_tmp65_, 16);
	g_object_ref_sink (_tmp65_);
	pan_icon = _tmp65_;
	_tmp66_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	g_object_ref_sink (_tmp66_);
	source_selected_box = _tmp66_;
	_tmp67_ = source_selected_box;
	_tmp68_ = self->priv->source_selected_label;
	gtk_box_append (_tmp67_, (GtkWidget*) _tmp68_);
	_tmp69_ = source_selected_box;
	_tmp70_ = pan_icon;
	gtk_box_append (_tmp69_, (GtkWidget*) _tmp70_);
	_tmp71_ = g_strdup (_ ("Source"));
	_tmp72_ = (AdwActionRow*) adw_action_row_new ();
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) _tmp72_, TRUE);
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp72_, _tmp71_);
	_g_free0 (_tmp71_);
	g_object_ref_sink (_tmp72_);
	source_row = _tmp72_;
	_tmp73_ = source_row;
	_tmp74_ = source_selected_box;
	adw_action_row_add_suffix (_tmp73_, (GtkWidget*) _tmp74_);
	_tmp75_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
	gtk_widget_set_margin_end ((GtkWidget*) _tmp75_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp75_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp75_, 24);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp75_, 1);
	g_object_ref_sink (_tmp75_);
	source_group = _tmp75_;
	_tmp76_ = source_group;
	_tmp77_ = source_row;
	adw_preferences_group_add (_tmp76_, (GtkWidget*) _tmp77_);
	_tmp78_ = self->priv->_backend_picker;
	_tmp79_ = source_group;
	_tmp80_ = _g_object_ref0 ((GtkWidget*) _tmp79_);
	_tmp81_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_transition_type (_tmp81_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	gtk_revealer_set_reveal_child (_tmp81_, _tmp78_);
	gtk_revealer_set_child (_tmp81_, _tmp80_);
	_g_object_unref0 (_tmp80_);
	g_object_ref_sink (_tmp81_);
	source_revealer = _tmp81_;
	_tmp82_ = widgets_color_picker_row_new ();
	g_object_ref_sink (_tmp82_);
	_g_object_unref0 (self->priv->color_picker_row);
	self->priv->color_picker_row = _tmp82_;
	_tmp83_ = g_strdup ("card");
	_tmp84_ = g_new0 (gchar*, 1 + 1);
	_tmp84_[0] = _tmp83_;
	_tmp85_ = self->priv->color_picker_row;
	_tmp86_ = _g_object_ref0 ((GtkWidget*) _tmp85_);
	_tmp87_ = (AdwBin*) adw_bin_new ();
	gtk_widget_set_margin_end ((GtkWidget*) _tmp87_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp87_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp87_, 24);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp87_, 1);
	gtk_widget_set_valign ((GtkWidget*) _tmp87_, GTK_ALIGN_START);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp87_, _tmp84_);
	_tmp84_ = (_vala_array_free (_tmp84_, 1, (GDestroyNotify) g_free), NULL);
	adw_bin_set_child (_tmp87_, _tmp86_);
	_g_object_unref0 (_tmp86_);
	g_object_ref_sink (_tmp87_);
	color_group = _tmp87_;
	_tmp88_ = self->priv->_project;
	_tmp89_ = objects_project_get_icon_style (_tmp88_);
	_tmp90_ = _tmp89_;
	_tmp91_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_transition_type (_tmp91_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
	gtk_revealer_set_reveal_child (_tmp91_, _tmp90_ == PROJECT_ICON_STYLE_PROGRESS);
	g_object_ref_sink (_tmp91_);
	_data61_->color_box_revealer = _tmp91_;
	_tmp92_ = _data61_->color_box_revealer;
	_tmp93_ = color_group;
	gtk_revealer_set_child (_tmp92_, (GtkWidget*) _tmp93_);
	_tmp95_ = dialogs_project_get_is_creating (self);
	_tmp96_ = _tmp95_;
	if (_tmp96_) {
		_tmp94_ = _ ("Add Project");
	} else {
		_tmp94_ = _ ("Update Project");
	}
	_tmp97_ = widgets_loading_button_new_with_label (_tmp94_);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp97_, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp97_, TRUE);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp97_, 12);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp97_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp97_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp97_, 24);
	gtk_widget_set_valign ((GtkWidget*) _tmp97_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp97_);
	_g_object_unref0 (self->priv->submit_button);
	self->priv->submit_button = _tmp97_;
	_tmp98_ = self->priv->submit_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp98_, "suggested-action");
	_tmp99_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp99_);
	content_box = _tmp99_;
	_tmp100_ = emoji_picker_button;
	gtk_box_append (content_box, (GtkWidget*) _tmp100_);
	_tmp101_ = name_group;
	gtk_box_append (content_box, (GtkWidget*) _tmp101_);
	_tmp102_ = source_revealer;
	gtk_box_append (content_box, (GtkWidget*) _tmp102_);
	_tmp103_ = _data61_->color_box_revealer;
	gtk_box_append (content_box, (GtkWidget*) _tmp103_);
	_tmp104_ = self->priv->submit_button;
	gtk_box_append (content_box, (GtkWidget*) _tmp104_);
	_tmp105_ = (AdwClamp*) adw_clamp_new ();
	adw_clamp_set_maximum_size (_tmp105_, 600);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp105_, 12);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp105_, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp105_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp105_, 6);
	g_object_ref_sink (_tmp105_);
	content_clamp = _tmp105_;
	adw_clamp_set_child (content_clamp, (GtkWidget*) content_box);
	_tmp106_ = (AdwToolbarView*) adw_toolbar_view_new ();
	g_object_ref_sink (_tmp106_);
	toolbar_view = _tmp106_;
	_tmp107_ = headerbar;
	adw_toolbar_view_add_top_bar (toolbar_view, (GtkWidget*) _tmp107_);
	adw_toolbar_view_set_content (toolbar_view, (GtkWidget*) content_clamp);
	_tmp108_ = self->priv->_header_title;
	_tmp109_ = adw_navigation_page_new ((GtkWidget*) toolbar_view, _tmp108_);
	g_object_ref_sink (_tmp109_);
	navigation_page = _tmp109_;
	_tmp110_ = self->priv->emoji_color_stack;
	_tmp111_ = gtk_stack_get_transition_duration (_tmp110_);
	_tmp112_ = _tmp111_;
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp112_, ___lambda30__gsource_func, g_object_ref (self), g_object_unref);
	_tmp113_ = self->priv->signal_map;
	_tmp114_ = self->priv->name_entry;
	_tmp115_ = g_signal_connect_object (_tmp114_, "entry-activated", (GCallback) _dialogs_project_add_update_project_adw_entry_row_entry_activated, self, 0);
	_tmp116_ = self->priv->name_entry;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp113_, (gpointer) ((guintptr) _tmp115_), (GObject*) _tmp116_);
	_tmp117_ = self->priv->signal_map;
	_tmp118_ = self->priv->submit_button;
	_tmp119_ = g_signal_connect_object ((GtkButton*) _tmp118_, "clicked", (GCallback) _dialogs_project_add_update_project_gtk_button_clicked, self, 0);
	_tmp120_ = self->priv->submit_button;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp117_, (gpointer) ((guintptr) _tmp119_), (GObject*) _tmp120_);
	_tmp121_ = self->priv->signal_map;
	_tmp122_ = _data61_->emoji_chooser;
	_tmp123_ = g_signal_connect_object (_tmp122_, "emoji-picked", (GCallback) ___lambda34__gtk_emoji_chooser_emoji_picked, self, 0);
	_tmp124_ = _data61_->emoji_chooser;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp121_, (gpointer) ((guintptr) _tmp123_), (GObject*) _tmp124_);
	_tmp125_ = self->priv->signal_map;
	_tmp126_ = self->priv->emoji_switch;
	_tmp127_ = g_signal_connect_data ((GObject*) _tmp126_, "notify::active", (GCallback) ___lambda35__g_object_notify, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
	_tmp128_ = self->priv->emoji_switch;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp125_, (gpointer) ((guintptr) _tmp127_), (GObject*) _tmp128_);
	_tmp129_ = self->priv->signal_map;
	_tmp130_ = self->priv->color_picker_row;
	_tmp131_ = g_signal_connect_object (_tmp130_, "color-changed", (GCallback) ___lambda36__widgets_color_picker_row_color_changed, self, 0);
	_tmp132_ = self->priv->color_picker_row;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp129_, (gpointer) ((guintptr) _tmp131_), (GObject*) _tmp132_);
	_tmp133_ = self->priv->signal_map;
	_tmp134_ = emoji_picker_button;
	_tmp135_ = g_signal_connect_data (_tmp134_, "clicked", (GCallback) ___lambda37__gtk_button_clicked, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
	_tmp136_ = emoji_picker_button;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp133_, (gpointer) ((guintptr) _tmp135_), (GObject*) _tmp136_);
	_tmp137_ = self->priv->signal_map;
	_tmp138_ = source_row;
	_tmp139_ = g_signal_connect_object (_tmp138_, "activated", (GCallback) ___lambda38__adw_action_row_activated, self, 0);
	_tmp140_ = source_row;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp137_, (gpointer) ((guintptr) _tmp139_), (GObject*) _tmp140_);
	result = navigation_page;
	_g_object_unref0 (toolbar_view);
	_g_object_unref0 (content_clamp);
	_g_object_unref0 (content_box);
	_g_object_unref0 (color_group);
	_g_object_unref0 (source_revealer);
	_g_object_unref0 (source_group);
	_g_object_unref0 (source_row);
	_g_object_unref0 (source_selected_box);
	_g_object_unref0 (pan_icon);
	_g_object_unref0 (name_group);
	_g_object_unref0 (emoji_switch_row);
	_g_object_unref0 (emoji_icon);
	_g_object_unref0 (emoji_picker_button);
	_g_object_unref0 (headerbar);
	block61_data_unref (_data61_);
	_data61_ = NULL;
	return result;
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
	g_atomic_int_inc (&_data62_->_ref_count_);
	return _data62_;
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
		DialogsProject* self;
		self = _data62_->self;
		_g_object_unref0 (_data62_->source);
		_g_object_unref0 (self);
		g_slice_free (Block62Data, _data62_);
	}
}

static void
____lambda39_ (Block62Data* _data62_)
{
	DialogsProject* self;
	ObjectsProject* _tmp0_;
	ObjectsSource* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	ObjectsSource* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkLabel* _tmp8_;
	ObjectsSource* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	AdwNavigationView* _tmp12_;
	self = _data62_->self;
	_tmp0_ = self->priv->_project;
	_tmp1_ = _data62_->source;
	_tmp2_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp1_);
	_tmp3_ = _tmp2_;
	objects_project_set_source_id (_tmp0_, _tmp3_);
	_tmp4_ = self->priv->source_selected_label;
	_tmp5_ = _data62_->source;
	_tmp6_ = objects_source_get_display_name (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_label_set_label (_tmp4_, _tmp7_);
	_tmp8_ = self->priv->source_selected_label;
	_tmp9_ = _data62_->source;
	_tmp10_ = objects_source_get_subheader_text (_tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp11_);
	_tmp12_ = self->priv->navigation_view;
	adw_navigation_view_pop (_tmp12_);
}

static void
_____lambda39__adw_action_row_activated (AdwActionRow* _sender,
                                         gpointer self)
{
	____lambda39_ (self);
}

static void
____lambda40_ (Block62Data* _data62_)
{
	DialogsProject* self;
	ObjectsProject* _tmp0_;
	ObjectsSource* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	ObjectsSource* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkLabel* _tmp8_;
	ObjectsSource* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	AdwNavigationView* _tmp12_;
	self = _data62_->self;
	_tmp0_ = self->priv->_project;
	_tmp1_ = _data62_->source;
	_tmp2_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp1_);
	_tmp3_ = _tmp2_;
	objects_project_set_source_id (_tmp0_, _tmp3_);
	_tmp4_ = self->priv->source_selected_label;
	_tmp5_ = _data62_->source;
	_tmp6_ = objects_source_get_display_name (_tmp5_);
	_tmp7_ = _tmp6_;
	gtk_label_set_label (_tmp4_, _tmp7_);
	_tmp8_ = self->priv->source_selected_label;
	_tmp9_ = _data62_->source;
	_tmp10_ = objects_source_get_subheader_text (_tmp9_);
	_tmp11_ = _tmp10_;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp11_);
	_tmp12_ = self->priv->navigation_view;
	adw_navigation_view_pop (_tmp12_);
}

static void
_____lambda40__gtk_check_button_toggled (GtkCheckButton* _sender,
                                         gpointer self)
{
	____lambda40_ (self);
}

static AdwNavigationPage*
dialogs_project_get_sources_page (DialogsProject* self)
{
	AdwHeaderBar* headerbar = NULL;
	AdwHeaderBar* _tmp0_;
	AdwHeaderBar* _tmp1_;
	AdwPreferencesGroup* sources_group = NULL;
	AdwPreferencesGroup* _tmp2_ = NULL;
	GtkCheckButton* none_radio = NULL;
	GtkCheckButton* _tmp3_;
	AdwClamp* content_clamp = NULL;
	AdwPreferencesGroup* _tmp46_;
	GtkWidget* _tmp47_;
	AdwClamp* _tmp48_ = NULL;
	AdwToolbarView* toolbar_view = NULL;
	AdwToolbarView* _tmp49_;
	AdwHeaderBar* _tmp50_;
	AdwNavigationPage* navigation_page = NULL;
	AdwNavigationPage* _tmp51_;
	AdwNavigationPage* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (AdwHeaderBar*) adw_header_bar_new ();
	g_object_ref_sink (_tmp0_);
	headerbar = _tmp0_;
	_tmp1_ = headerbar;
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "flat");
	_tmp2_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
	gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 6);
	g_object_ref_sink (_tmp2_);
	sources_group = _tmp2_;
	_tmp3_ = (GtkCheckButton*) gtk_check_button_new ();
	g_object_ref_sink (_tmp3_);
	none_radio = _tmp3_;
	{
		GeeArrayList* _source_list = NULL;
		ServicesStore* _tmp4_;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gint _source_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _source_index = 0;
		_tmp4_ = services_store_instance ();
		_tmp5_ = services_store_get_sources (_tmp4_);
		_tmp6_ = _tmp5_;
		_source_list = _tmp6_;
		_tmp7_ = _source_list;
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_source_size = _tmp9_;
		_source_index = -1;
		while (TRUE) {
			Block62Data* _data62_;
			gint _tmp10_;
			gint _tmp11_;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			GtkCheckButton* radio_button = NULL;
			GtkCheckButton* _tmp14_;
			GtkCheckButton* _tmp15_;
			ObjectsProject* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			ObjectsSource* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			GtkCheckButton* _tmp22_ = NULL;
			AdwActionRow* source_row = NULL;
			ObjectsSource* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			ObjectsSource* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			AdwActionRow* _tmp31_ = NULL;
			AdwActionRow* _tmp32_;
			GtkCheckButton* _tmp33_;
			AdwActionRow* _tmp34_;
			GtkCheckButton* _tmp35_;
			GeeHashMap* _tmp36_;
			AdwActionRow* _tmp37_;
			gulong _tmp38_;
			AdwActionRow* _tmp39_;
			GeeHashMap* _tmp40_;
			GtkCheckButton* _tmp41_;
			gulong _tmp42_;
			GtkCheckButton* _tmp43_;
			AdwPreferencesGroup* _tmp44_;
			AdwActionRow* _tmp45_;
			_data62_ = g_slice_new0 (Block62Data);
			_data62_->_ref_count_ = 1;
			_data62_->self = g_object_ref (self);
			_source_index = _source_index + 1;
			_tmp10_ = _source_index;
			_tmp11_ = _source_size;
			if (!(_tmp10_ < _tmp11_)) {
				block62_data_unref (_data62_);
				_data62_ = NULL;
				break;
			}
			_tmp12_ = _source_list;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _source_index);
			_data62_->source = (ObjectsSource*) _tmp13_;
			_tmp14_ = none_radio;
			_tmp15_ = _g_object_ref0 (_tmp14_);
			_tmp16_ = self->priv->_project;
			_tmp17_ = objects_project_get_source_id (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = _data62_->source;
			_tmp20_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = (GtkCheckButton*) gtk_check_button_new ();
			gtk_check_button_set_group (_tmp22_, _tmp15_);
			_g_object_unref0 (_tmp15_);
			gtk_check_button_set_active (_tmp22_, g_strcmp0 (_tmp18_, _tmp21_) == 0);
			g_object_ref_sink (_tmp22_);
			radio_button = _tmp22_;
			_tmp23_ = _data62_->source;
			_tmp24_ = objects_source_get_display_name (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = _data62_->source;
			_tmp28_ = objects_source_get_subheader_text (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = g_strdup (_tmp29_);
			_tmp31_ = (AdwActionRow*) adw_action_row_new ();
			gtk_list_box_row_set_activatable ((GtkListBoxRow*) _tmp31_, TRUE);
			adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp31_, _tmp26_);
			_g_free0 (_tmp26_);
			adw_action_row_set_subtitle (_tmp31_, _tmp30_);
			_g_free0 (_tmp30_);
			g_object_ref_sink (_tmp31_);
			source_row = _tmp31_;
			_tmp32_ = source_row;
			_tmp33_ = radio_button;
			adw_action_row_add_suffix (_tmp32_, (GtkWidget*) _tmp33_);
			_tmp34_ = source_row;
			_tmp35_ = radio_button;
			adw_action_row_set_activatable_widget (_tmp34_, (GtkWidget*) _tmp35_);
			_tmp36_ = self->priv->signal_map;
			_tmp37_ = source_row;
			_tmp38_ = g_signal_connect_data (_tmp37_, "activated", (GCallback) _____lambda39__adw_action_row_activated, block62_data_ref (_data62_), (GClosureNotify) block62_data_unref, 0);
			_tmp39_ = source_row;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, (gpointer) ((guintptr) _tmp38_), (GObject*) _tmp39_);
			_tmp40_ = self->priv->signal_map;
			_tmp41_ = radio_button;
			_tmp42_ = g_signal_connect_data (_tmp41_, "toggled", (GCallback) _____lambda40__gtk_check_button_toggled, block62_data_ref (_data62_), (GClosureNotify) block62_data_unref, 0);
			_tmp43_ = radio_button;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp40_, (gpointer) ((guintptr) _tmp42_), (GObject*) _tmp43_);
			_tmp44_ = sources_group;
			_tmp45_ = source_row;
			adw_preferences_group_add (_tmp44_, (GtkWidget*) _tmp45_);
			_g_object_unref0 (source_row);
			_g_object_unref0 (radio_button);
			block62_data_unref (_data62_);
			_data62_ = NULL;
		}
	}
	_tmp46_ = sources_group;
	_tmp47_ = _g_object_ref0 ((GtkWidget*) _tmp46_);
	_tmp48_ = (AdwClamp*) adw_clamp_new ();
	adw_clamp_set_maximum_size (_tmp48_, 600);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp48_, 12);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp48_, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp48_, 12);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp48_, 6);
	adw_clamp_set_child (_tmp48_, _tmp47_);
	_g_object_unref0 (_tmp47_);
	g_object_ref_sink (_tmp48_);
	content_clamp = _tmp48_;
	_tmp49_ = (AdwToolbarView*) adw_toolbar_view_new ();
	g_object_ref_sink (_tmp49_);
	toolbar_view = _tmp49_;
	_tmp50_ = headerbar;
	adw_toolbar_view_add_top_bar (toolbar_view, (GtkWidget*) _tmp50_);
	adw_toolbar_view_set_content (toolbar_view, (GtkWidget*) content_clamp);
	_tmp51_ = adw_navigation_page_new ((GtkWidget*) toolbar_view, _ ("Sources"));
	g_object_ref_sink (_tmp51_);
	navigation_page = _tmp51_;
	result = navigation_page;
	_g_object_unref0 (toolbar_view);
	_g_object_unref0 (content_clamp);
	_g_object_unref0 (none_radio);
	_g_object_unref0 (sources_group);
	_g_object_unref0 (headerbar);
	return result;
}

static void
dialogs_project_add_update_project (DialogsProject* self)
{
	AdwEntryRow* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ObjectsProject* _tmp5_;
	AdwEntryRow* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ObjectsProject* _tmp9_;
	WidgetsColorPickerRow* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	ProjectIconStyle _tmp13_ = 0;
	GtkSwitch* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	ObjectsProject* _tmp17_;
	ObjectsProject* _tmp18_;
	GtkLabel* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	WidgetsLoadingButton* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->name_entry;
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = strlen (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ <= 0) {
		dialogs_project_hide_destroy (self);
		return;
	}
	_tmp5_ = self->priv->_project;
	_tmp6_ = self->priv->name_entry;
	_tmp7_ = gtk_editable_get_text ((GtkEditable*) _tmp6_);
	_tmp8_ = _tmp7_;
	objects_base_object_set_name ((ObjectsBaseObject*) _tmp5_, _tmp8_);
	_tmp9_ = self->priv->_project;
	_tmp10_ = self->priv->color_picker_row;
	_tmp11_ = widgets_color_picker_row_get_color (_tmp10_);
	_tmp12_ = _tmp11_;
	objects_project_set_color (_tmp9_, _tmp12_);
	_tmp14_ = self->priv->emoji_switch;
	_tmp15_ = gtk_switch_get_active (_tmp14_);
	_tmp16_ = _tmp15_;
	if (_tmp16_) {
		_tmp13_ = PROJECT_ICON_STYLE_EMOJI;
	} else {
		_tmp13_ = PROJECT_ICON_STYLE_PROGRESS;
	}
	_tmp17_ = self->priv->_project;
	objects_project_set_icon_style (_tmp17_, _tmp13_);
	_tmp18_ = self->priv->_project;
	_tmp19_ = self->priv->emoji_label;
	_tmp20_ = gtk_label_get_label (_tmp19_);
	_tmp21_ = _tmp20_;
	objects_project_set_emoji (_tmp18_, _tmp21_);
	_tmp22_ = self->priv->submit_button;
	widgets_loading_button_set_is_loading (_tmp22_, TRUE);
	_tmp23_ = dialogs_project_get_is_creating (self);
	_tmp24_ = _tmp23_;
	if (!_tmp24_) {
		dialogs_project_update_project (self, NULL, NULL);
	} else {
		dialogs_project_add_project (self);
	}
}

static void
dialogs_project_update_project_data_free (gpointer _data)
{
	DialogsProjectUpdateProjectData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (DialogsProjectUpdateProjectData, _data_);
}

static void
dialogs_project_update_project (DialogsProject* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	DialogsProjectUpdateProjectData* _data_;
	DialogsProject* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (DialogsProjectUpdateProjectData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, dialogs_project_update_project_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	dialogs_project_update_project_co (_data_);
}

static void
dialogs_project_update_project_finish (DialogsProject* self,
                                       GAsyncResult* _res_)
{
	DialogsProjectUpdateProjectData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
dialogs_project_update_project_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	DialogsProjectUpdateProjectData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	dialogs_project_update_project_co (_data_);
}

static gboolean
dialogs_project_update_project_co (DialogsProjectUpdateProjectData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_project;
	_data_->_tmp1_ = objects_project_get_source_type (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	if (_data_->_tmp2_ == SOURCE_TYPE_LOCAL) {
		_data_->_tmp3_ = services_store_instance ();
		_data_->_tmp4_ = _data_->self->priv->_project;
		services_store_update_project (_data_->_tmp3_, _data_->_tmp4_);
		dialogs_project_hide_destroy (_data_->self);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp5_ = _data_->self->priv->_project;
	_data_->_tmp6_ = objects_project_get_source_type (_data_->_tmp5_);
	_data_->_tmp7_ = _data_->_tmp6_;
	if (_data_->_tmp7_ == SOURCE_TYPE_TODOIST) {
		_data_->_tmp8_ = services_todoist_get_default ();
		_data_->_tmp9_ = _data_->_tmp8_;
		_data_->_tmp10_ = _data_->self->priv->_project;
		_data_->_state_ = 1;
		services_todoist_update (_data_->_tmp9_, (ObjectsBaseObject*) _data_->_tmp10_, dialogs_project_update_project_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp11_ = services_todoist_update_finish (_data_->_tmp9_, _data_->_res_);
		_http_response_unref0 (_data_->response);
		_data_->response = _data_->_tmp11_;
		_g_object_unref0 (_data_->_tmp9_);
	} else {
		_data_->_tmp12_ = services_cal_dav_core_get_default ();
		_data_->_tmp13_ = _data_->_tmp12_;
		_data_->_tmp14_ = _data_->self->priv->_project;
		_data_->_state_ = 2;
		services_cal_dav_core_update_tasklist (_data_->_tmp13_, _data_->_tmp14_, dialogs_project_update_project_ready, _data_);
		return FALSE;
		_state_2:
		_data_->_tmp15_ = services_cal_dav_core_update_tasklist_finish (_data_->_tmp13_, _data_->_res_);
		_http_response_unref0 (_data_->response);
		_data_->response = _data_->_tmp15_;
		_g_object_unref0 (_data_->_tmp13_);
	}
	_data_->_tmp16_ = _data_->response;
	if (_data_->_tmp16_ == NULL) {
		dialogs_project_hide_destroy (_data_->self);
		_http_response_unref0 (_data_->response);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp17_ = _data_->response;
	_data_->_tmp18_ = http_response_get_status (_data_->_tmp17_);
	_data_->_tmp19_ = _data_->_tmp18_;
	if (_data_->_tmp19_) {
		_data_->_tmp20_ = services_store_instance ();
		_data_->_tmp21_ = _data_->self->priv->_project;
		services_store_update_project (_data_->_tmp20_, _data_->_tmp21_);
		dialogs_project_hide_destroy (_data_->self);
	} else {
		_data_->_tmp22_ = services_event_bus_get_default ();
		_data_->_tmp23_ = _data_->_tmp22_;
		_data_->_tmp24_ = _data_->response;
		_data_->_tmp25_ = http_response_get_error_code (_data_->_tmp24_);
		_data_->_tmp26_ = _data_->_tmp25_;
		_data_->_tmp27_ = _data_->response;
		_data_->_tmp28_ = http_response_get_error (_data_->_tmp27_);
		_data_->_tmp29_ = _data_->_tmp28_;
		g_signal_emit_by_name (_data_->_tmp23_, "send-error-toast", _data_->_tmp26_, _data_->_tmp29_);
		_g_object_unref0 (_data_->_tmp23_);
		dialogs_project_hide_destroy (_data_->self);
	}
	_http_response_unref0 (_data_->response);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
____lambda32_ (DialogsProject* self,
               GObject* obj,
               GAsyncResult* res)
{
	HttpResponse* response = NULL;
	ServicesTodoist* _tmp0_;
	ServicesTodoist* _tmp1_;
	HttpResponse* _tmp2_;
	HttpResponse* _tmp3_;
	HttpResponse* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (res != NULL);
	_tmp0_ = services_todoist_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_todoist_add_finish (_tmp1_, res);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	response = _tmp3_;
	_tmp4_ = response;
	_tmp5_ = http_response_get_status (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		ObjectsProject* _tmp7_;
		HttpResponse* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		ServicesStore* _tmp11_;
		ObjectsProject* _tmp12_;
		ObjectsProject* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		_tmp7_ = self->priv->_project;
		_tmp8_ = response;
		_tmp9_ = http_response_get_data (_tmp8_);
		_tmp10_ = _tmp9_;
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp7_, _tmp10_);
		_tmp11_ = services_store_instance ();
		_tmp12_ = self->priv->_project;
		services_store_insert_project (_tmp11_, _tmp12_);
		_tmp13_ = self->priv->_project;
		_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp13_);
		_tmp15_ = _tmp14_;
		dialogs_project_go_project (self, _tmp15_);
	} else {
		ServicesEventBus* _tmp16_;
		ServicesEventBus* _tmp17_;
		HttpResponse* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		HttpResponse* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		_tmp16_ = services_event_bus_get_default ();
		_tmp17_ = _tmp16_;
		_tmp18_ = response;
		_tmp19_ = http_response_get_error_code (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = response;
		_tmp22_ = http_response_get_error (_tmp21_);
		_tmp23_ = _tmp22_;
		g_signal_emit_by_name (_tmp17_, "send-error-toast", _tmp20_, _tmp23_);
		_g_object_unref0 (_tmp17_);
		dialogs_project_hide_destroy (self);
	}
	_http_response_unref0 (response);
}

static void
_____lambda32__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	____lambda32_ ((DialogsProject*) self, source_object, res);
	g_object_unref (self);
}

static void
_____lambda33_ (DialogsProject* self,
                GObject* obj,
                GAsyncResult* res)
{
	HttpResponse* response = NULL;
	ServicesCalDAVCore* _tmp0_;
	ServicesCalDAVCore* _tmp1_;
	HttpResponse* _tmp2_;
	HttpResponse* _tmp3_;
	HttpResponse* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (res != NULL);
	_tmp0_ = services_cal_dav_core_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_cal_dav_core_add_tasklist_finish (_tmp1_, res);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	response = _tmp3_;
	_tmp4_ = response;
	_tmp5_ = http_response_get_status (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		ServicesStore* _tmp7_;
		ObjectsProject* _tmp8_;
		ServicesCalDAVCore* _tmp9_;
		ServicesCalDAVCore* _tmp10_;
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp7_ = services_store_instance ();
		_tmp8_ = self->priv->_project;
		services_store_insert_project (_tmp7_, _tmp8_);
		_tmp9_ = services_cal_dav_core_get_default ();
		_tmp10_ = _tmp9_;
		_tmp11_ = self->priv->_project;
		services_cal_dav_core_update_sync_token (_tmp10_, _tmp11_, NULL, NULL);
		_g_object_unref0 (_tmp10_);
		_tmp12_ = self->priv->_project;
		_tmp13_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp12_);
		_tmp14_ = _tmp13_;
		dialogs_project_go_project (self, _tmp14_);
	} else {
		ServicesEventBus* _tmp15_;
		ServicesEventBus* _tmp16_;
		HttpResponse* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		HttpResponse* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp15_ = services_event_bus_get_default ();
		_tmp16_ = _tmp15_;
		_tmp17_ = response;
		_tmp18_ = http_response_get_error_code (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = response;
		_tmp21_ = http_response_get_error (_tmp20_);
		_tmp22_ = _tmp21_;
		g_signal_emit_by_name (_tmp16_, "send-error-toast", _tmp19_, _tmp22_);
		_g_object_unref0 (_tmp16_);
		dialogs_project_hide_destroy (self);
	}
	_http_response_unref0 (response);
}

static void
______lambda33__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
	_____lambda33_ ((DialogsProject*) self, source_object, res);
	g_object_unref (self);
}

static void
dialogs_project_add_project (DialogsProject* self)
{
	ObjectsProject* _tmp0_;
	ServicesStore* _tmp1_;
	ObjectsProject* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	ObjectsProject* _tmp10_;
	SourceType _tmp11_;
	SourceType _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_project;
	_tmp1_ = services_store_instance ();
	_tmp2_ = self->priv->_project;
	_tmp3_ = objects_project_get_source_id (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = services_store_get_projects_by_source (_tmp1_, _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
	_tmp8_ = _tmp7_;
	objects_project_set_child_order (_tmp0_, _tmp8_);
	_g_object_unref0 (_tmp6_);
	_tmp10_ = self->priv->_project;
	_tmp11_ = objects_project_get_source_type (_tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_ == SOURCE_TYPE_LOCAL) {
		_tmp9_ = TRUE;
	} else {
		ObjectsProject* _tmp13_;
		SourceType _tmp14_;
		SourceType _tmp15_;
		_tmp13_ = self->priv->_project;
		_tmp14_ = objects_project_get_source_type (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp9_ = _tmp15_ == SOURCE_TYPE_NONE;
	}
	if (_tmp9_) {
		ObjectsProject* _tmp16_;
		Util* _tmp17_;
		Util* _tmp18_;
		ObjectsProject* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		ServicesStore* _tmp22_;
		ObjectsProject* _tmp23_;
		ObjectsProject* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		_tmp16_ = self->priv->_project;
		_tmp17_ = util_get_default ();
		_tmp18_ = _tmp17_;
		_tmp19_ = self->priv->_project;
		_tmp20_ = util_generate_id (_tmp18_, (ObjectsBaseObject*) _tmp19_);
		_tmp21_ = _tmp20_;
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp16_, _tmp21_);
		_g_free0 (_tmp21_);
		_g_object_unref0 (_tmp18_);
		_tmp22_ = services_store_instance ();
		_tmp23_ = self->priv->_project;
		services_store_insert_project (_tmp22_, _tmp23_);
		_tmp24_ = self->priv->_project;
		_tmp25_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp24_);
		_tmp26_ = _tmp25_;
		dialogs_project_go_project (self, _tmp26_);
	} else {
		ObjectsProject* _tmp27_;
		SourceType _tmp28_;
		SourceType _tmp29_;
		_tmp27_ = self->priv->_project;
		_tmp28_ = objects_project_get_source_type (_tmp27_);
		_tmp29_ = _tmp28_;
		if (_tmp29_ == SOURCE_TYPE_TODOIST) {
			ServicesTodoist* _tmp30_;
			ServicesTodoist* _tmp31_;
			ObjectsProject* _tmp32_;
			_tmp30_ = services_todoist_get_default ();
			_tmp31_ = _tmp30_;
			_tmp32_ = self->priv->_project;
			services_todoist_add (_tmp31_, (ObjectsBaseObject*) _tmp32_, _____lambda32__gasync_ready_callback, g_object_ref (self));
			_g_object_unref0 (_tmp31_);
		} else {
			ObjectsProject* _tmp33_;
			SourceType _tmp34_;
			SourceType _tmp35_;
			_tmp33_ = self->priv->_project;
			_tmp34_ = objects_project_get_source_type (_tmp33_);
			_tmp35_ = _tmp34_;
			if (_tmp35_ == SOURCE_TYPE_CALDAV) {
				ObjectsProject* _tmp36_;
				Util* _tmp37_;
				Util* _tmp38_;
				ObjectsProject* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				ServicesCalDAVCore* _tmp42_;
				ServicesCalDAVCore* _tmp43_;
				ObjectsProject* _tmp44_;
				_tmp36_ = self->priv->_project;
				_tmp37_ = util_get_default ();
				_tmp38_ = _tmp37_;
				_tmp39_ = self->priv->_project;
				_tmp40_ = util_generate_id (_tmp38_, (ObjectsBaseObject*) _tmp39_);
				_tmp41_ = _tmp40_;
				objects_base_object_set_id ((ObjectsBaseObject*) _tmp36_, _tmp41_);
				_g_free0 (_tmp41_);
				_g_object_unref0 (_tmp38_);
				_tmp42_ = services_cal_dav_core_get_default ();
				_tmp43_ = _tmp42_;
				_tmp44_ = self->priv->_project;
				services_cal_dav_core_add_tasklist (_tmp43_, _tmp44_, ______lambda33__gasync_ready_callback, g_object_ref (self));
				_g_object_unref0 (_tmp43_);
			}
		}
	}
}

static Block63Data*
block63_data_ref (Block63Data* _data63_)
{
	g_atomic_int_inc (&_data63_->_ref_count_);
	return _data63_;
}

static void
block63_data_unref (void * _userdata_)
{
	Block63Data* _data63_;
	_data63_ = (Block63Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data63_->_ref_count_)) {
		DialogsProject* self;
		self = _data63_->self;
		_g_free0 (_data63_->id);
		_g_object_unref0 (self);
		g_slice_free (Block63Data, _data63_);
	}
}

static gboolean
__lambda31_ (Block63Data* _data63_)
{
	DialogsProject* self;
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	Util* _tmp2_;
	Util* _tmp3_;
	AdwToast* _tmp4_;
	AdwToast* _tmp5_;
	ServicesEventBus* _tmp6_;
	ServicesEventBus* _tmp7_;
	gboolean result;
	self = _data63_->self;
	_tmp0_ = services_event_bus_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = util_get_default ();
	_tmp3_ = _tmp2_;
	_tmp4_ = util_create_toast (_tmp3_, _ ("Project added successfully!"), (guint) 2, ADW_TOAST_PRIORITY_NORMAL);
	_tmp5_ = _tmp4_;
	g_signal_emit_by_name (_tmp1_, "send-toast", _tmp5_);
	_g_object_unref0 (_tmp5_);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	_tmp6_ = services_event_bus_get_default ();
	_tmp7_ = _tmp6_;
	g_signal_emit_by_name (_tmp7_, "pane-selected", PANE_TYPE_PROJECT, _data63_->id);
	_g_object_unref0 (_tmp7_);
	dialogs_project_hide_destroy (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
	return result;
}

void
dialogs_project_go_project (DialogsProject* self,
                            const gchar* id)
{
	Block63Data* _data63_;
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	_data63_ = g_slice_new0 (Block63Data);
	_data63_->_ref_count_ = 1;
	_data63_->self = g_object_ref (self);
	_tmp0_ = g_strdup (id);
	_g_free0 (_data63_->id);
	_data63_->id = _tmp0_;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ___lambda31__gsource_func, block63_data_ref (_data63_), block63_data_unref);
	block63_data_unref (_data63_);
	_data63_ = NULL;
}

void
dialogs_project_hide_destroy (DialogsProject* self)
{
	g_return_if_fail (self != NULL);
	adw_dialog_close ((AdwDialog*) self);
}

ObjectsProject*
dialogs_project_get_project (DialogsProject* self)
{
	ObjectsProject* result;
	ObjectsProject* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_project;
	result = _tmp0_;
	return result;
}

static void
dialogs_project_set_project (DialogsProject* self,
                             ObjectsProject* value)
{
	ObjectsProject* old_value;
	g_return_if_fail (self != NULL);
	old_value = dialogs_project_get_project (self);
	if (old_value != value) {
		ObjectsProject* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_project);
		self->priv->_project = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dialogs_project_properties[DIALOGS_PROJECT_PROJECT_PROPERTY]);
	}
}

gboolean
dialogs_project_get_backend_picker (DialogsProject* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_backend_picker;
	return result;
}

static void
dialogs_project_set_backend_picker (DialogsProject* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = dialogs_project_get_backend_picker (self);
	if (old_value != value) {
		self->priv->_backend_picker = value;
		g_object_notify_by_pspec ((GObject *) self, dialogs_project_properties[DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY]);
	}
}

const gchar*
dialogs_project_get_header_title (DialogsProject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_header_title;
	result = _tmp0_;
	return result;
}

static void
dialogs_project_set_header_title (DialogsProject* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dialogs_project_get_header_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_header_title);
		self->priv->_header_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dialogs_project_properties[DIALOGS_PROJECT_HEADER_TITLE_PROPERTY]);
	}
}

gboolean
dialogs_project_get_is_creating (DialogsProject* self)
{
	gboolean result;
	ObjectsProject* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_project;
	_tmp1_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = g_strcmp0 (_tmp2_, "") == 0;
	return result;
}

static void
_dialogs_project___lambda41_ (DialogsProject* self)
{
	GeeHashMap* _tmp15_;
	ServicesEventBus* _tmp16_;
	ServicesEventBus* _tmp17_;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->signal_map;
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_entry_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			GeeMapEntry* _tmp12_;
			gconstpointer _tmp13_;
			gconstpointer _tmp14_;
			_tmp6_ = _entry_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _entry_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			entry = (GeeMapEntry*) _tmp8_;
			_tmp9_ = entry;
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = entry;
			_tmp13_ = gee_map_entry_get_key (_tmp12_);
			_tmp14_ = _tmp13_;
			g_signal_handler_disconnect ((GObject*) _tmp11_, (gulong) ((guintptr) _tmp14_));
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp15_ = self->priv->signal_map;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp15_);
	_tmp16_ = services_event_bus_get_default ();
	_tmp17_ = _tmp16_;
	g_signal_emit_by_name (_tmp17_, "connect-typing-accel");
	_g_object_unref0 (_tmp17_);
}

static void
__dialogs_project___lambda41__adw_dialog_closed (AdwDialog* _sender,
                                                 gpointer self)
{
	_dialogs_project___lambda41_ ((DialogsProject*) self);
}

static GObject *
dialogs_project_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DialogsProject * self;
	AdwNavigationPage* main_page = NULL;
	AdwNavigationPage* _tmp0_;
	AdwNavigationPage* _tmp1_;
	AdwNavigationView* _tmp2_;
	AdwNavigationView* _tmp3_;
	AdwNavigationPage* _tmp4_;
	AdwNavigationView* _tmp5_;
	ServicesEventBus* _tmp6_;
	ServicesEventBus* _tmp7_;
	parent_class = G_OBJECT_CLASS (dialogs_project_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIALOGS_TYPE_PROJECT, DialogsProject);
	_tmp0_ = dialogs_project_get_main_page (self);
	main_page = _tmp0_;
	_tmp1_ = dialogs_project_get_sources_page (self);
	_g_object_unref0 (self->priv->sources_page);
	self->priv->sources_page = _tmp1_;
	_tmp2_ = (AdwNavigationView*) adw_navigation_view_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->navigation_view);
	self->priv->navigation_view = _tmp2_;
	_tmp3_ = self->priv->navigation_view;
	_tmp4_ = main_page;
	adw_navigation_view_add (_tmp3_, _tmp4_);
	_tmp5_ = self->priv->navigation_view;
	adw_dialog_set_child ((AdwDialog*) self, (GtkWidget*) _tmp5_);
	_tmp6_ = services_event_bus_get_default ();
	_tmp7_ = _tmp6_;
	g_signal_emit_by_name (_tmp7_, "disconnect-typing-accel");
	_g_object_unref0 (_tmp7_);
	g_signal_connect_object ((AdwDialog*) self, "closed", (GCallback) __dialogs_project___lambda41__adw_dialog_closed, self, 0);
	_g_object_unref0 (main_page);
	return obj;
}

static void
dialogs_project_class_init (DialogsProjectClass * klass,
                            gpointer klass_data)
{
	dialogs_project_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DialogsProject_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dialogs_project_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dialogs_project_set_property;
	G_OBJECT_CLASS (klass)->constructor = dialogs_project_constructor;
	G_OBJECT_CLASS (klass)->finalize = dialogs_project_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_PROJECT_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_PROJECT_PROPERTY] = g_param_spec_object ("project", "project", "project", OBJECTS_TYPE_PROJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY] = g_param_spec_boolean ("backend-picker", "backend-picker", "backend-picker", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_HEADER_TITLE_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_HEADER_TITLE_PROPERTY] = g_param_spec_string ("header-title", "header-title", "header-title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_IS_CREATING_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_IS_CREATING_PROPERTY] = g_param_spec_boolean ("is-creating", "is-creating", "is-creating", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
dialogs_project_instance_init (DialogsProject * self,
                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	self->priv = dialogs_project_get_instance_private (self);
	_tmp0_ = gee_hash_map_new (G_TYPE_ULONG, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->signal_map = _tmp0_;
}

static void
dialogs_project_finalize (GObject * obj)
{
	DialogsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIALOGS_TYPE_PROJECT, DialogsProject);
	g_print ("Destroying Dialogs.Project\n");
	_g_object_unref0 (self->priv->_project);
	_g_free0 (self->priv->_header_title);
	_g_object_unref0 (self->priv->emoji_color_stack);
	_g_object_unref0 (self->priv->progress_bar);
	_g_object_unref0 (self->priv->name_entry);
	_g_object_unref0 (self->priv->color_picker_row);
	_g_object_unref0 (self->priv->submit_button);
	_g_object_unref0 (self->priv->emoji_switch);
	_g_object_unref0 (self->priv->emoji_label);
	_g_object_unref0 (self->priv->source_selected_label);
	_g_object_unref0 (self->priv->navigation_view);
	_g_object_unref0 (self->priv->sources_page);
	_g_object_unref0 (self->priv->signal_map);
	G_OBJECT_CLASS (dialogs_project_parent_class)->finalize (obj);
}

static GType
dialogs_project_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DialogsProjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dialogs_project_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DialogsProject), 0, (GInstanceInitFunc) dialogs_project_instance_init, NULL };
	GType dialogs_project_type_id;
	dialogs_project_type_id = g_type_register_static (adw_dialog_get_type (), "DialogsProject", &g_define_type_info, 0);
	DialogsProject_private_offset = g_type_add_instance_private (dialogs_project_type_id, sizeof (DialogsProjectPrivate));
	return dialogs_project_type_id;
}

GType
dialogs_project_get_type (void)
{
	static volatile gsize dialogs_project_type_id__once = 0;
	if (g_once_init_enter (&dialogs_project_type_id__once)) {
		GType dialogs_project_type_id;
		dialogs_project_type_id = dialogs_project_get_type_once ();
		g_once_init_leave (&dialogs_project_type_id__once, dialogs_project_type_id);
	}
	return dialogs_project_type_id__once;
}

static void
_vala_dialogs_project_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	DialogsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIALOGS_TYPE_PROJECT, DialogsProject);
	switch (property_id) {
		case DIALOGS_PROJECT_PROJECT_PROPERTY:
		g_value_set_object (value, dialogs_project_get_project (self));
		break;
		case DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY:
		g_value_set_boolean (value, dialogs_project_get_backend_picker (self));
		break;
		case DIALOGS_PROJECT_HEADER_TITLE_PROPERTY:
		g_value_set_string (value, dialogs_project_get_header_title (self));
		break;
		case DIALOGS_PROJECT_IS_CREATING_PROPERTY:
		g_value_set_boolean (value, dialogs_project_get_is_creating (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dialogs_project_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	DialogsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIALOGS_TYPE_PROJECT, DialogsProject);
	switch (property_id) {
		case DIALOGS_PROJECT_PROJECT_PROPERTY:
		dialogs_project_set_project (self, g_value_get_object (value));
		break;
		case DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY:
		dialogs_project_set_backend_picker (self, g_value_get_boolean (value));
		break;
		case DIALOGS_PROJECT_HEADER_TITLE_PROPERTY:
		dialogs_project_set_header_title (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

