/* Backup.c generated by valac 0.56.18, the Vala compiler
 * generated from Backup.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include "planify.h"
#include <gio/gio.h>
#include <json-glib/json-glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define OBJECTS_TYPE_BACKUP (objects_backup_get_type ())
#define OBJECTS_BACKUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OBJECTS_TYPE_BACKUP, ObjectsBackup))
#define OBJECTS_BACKUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OBJECTS_TYPE_BACKUP, ObjectsBackupClass))
#define OBJECTS_IS_BACKUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OBJECTS_TYPE_BACKUP))
#define OBJECTS_IS_BACKUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OBJECTS_TYPE_BACKUP))
#define OBJECTS_BACKUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OBJECTS_TYPE_BACKUP, ObjectsBackupClass))

typedef struct _ObjectsBackup ObjectsBackup;
typedef struct _ObjectsBackupClass ObjectsBackupClass;
typedef struct _ObjectsBackupPrivate ObjectsBackupPrivate;
enum  {
	OBJECTS_BACKUP_0_PROPERTY,
	OBJECTS_BACKUP_VERSION_PROPERTY,
	OBJECTS_BACKUP_DATE_PROPERTY,
	OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY,
	OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY,
	OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY,
	OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY,
	OBJECTS_BACKUP_PROJECTS_PROPERTY,
	OBJECTS_BACKUP_SECTIONS_PROPERTY,
	OBJECTS_BACKUP_ITEMS_PROPERTY,
	OBJECTS_BACKUP_LABELS_PROPERTY,
	OBJECTS_BACKUP_SOURCES_PROPERTY,
	OBJECTS_BACKUP_PATH_PROPERTY,
	OBJECTS_BACKUP_ERROR_PROPERTY,
	OBJECTS_BACKUP_DATETIME_PROPERTY,
	OBJECTS_BACKUP_TITLE_PROPERTY,
	OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY,
	OBJECTS_BACKUP_NUM_PROPERTIES
};
static GParamSpec* objects_backup_properties[OBJECTS_BACKUP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
enum  {
	OBJECTS_BACKUP_DELETED_SIGNAL,
	OBJECTS_BACKUP_NUM_SIGNALS
};
static guint objects_backup_signals[OBJECTS_BACKUP_NUM_SIGNALS] = {0};

struct _ObjectsBackup {
	GObject parent_instance;
	ObjectsBackupPrivate * priv;
};

struct _ObjectsBackupClass {
	GObjectClass parent_class;
};

struct _ObjectsBackupPrivate {
	gchar* _version;
	gchar* _date;
	gint _default_inbox;
	gchar* _local_inbox_project_id;
	gchar* _todoist_access_token;
	gchar* _todoist_sync_token;
	gchar* _todoist_user_name;
	gchar* _todoist_user_email;
	gchar* _todoist_user_image_id;
	gchar* _todoist_user_avatar;
	gboolean _todoist_user_is_premium;
	GeeArrayList* _projects;
	GeeArrayList* _sections;
	GeeArrayList* _items;
	GeeArrayList* _labels;
	GeeArrayList* _sources;
	gchar* _path;
	gchar* _error;
	GDateTime* _datetime;
	gchar* _title;
	gboolean _todoist_backend;
};

static gint ObjectsBackup_private_offset;
static gpointer objects_backup_parent_class = NULL;

VALA_EXTERN GType objects_backup_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ObjectsBackup, g_object_unref)
VALA_EXTERN ObjectsBackup* objects_backup_new_from_file (GFile* file);
VALA_EXTERN ObjectsBackup* objects_backup_construct_from_file (GType object_type,
                                                   GFile* file);
VALA_EXTERN void objects_backup_set_path (ObjectsBackup* self,
                              const gchar* value);
VALA_EXTERN void objects_backup_set_version (ObjectsBackup* self,
                                 const gchar* value);
VALA_EXTERN void objects_backup_set_date (ObjectsBackup* self,
                              const gchar* value);
VALA_EXTERN void objects_backup_set_local_inbox_project_id (ObjectsBackup* self,
                                                const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_access_token (ObjectsBackup* self,
                                              const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_sync_token (ObjectsBackup* self,
                                            const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_name (ObjectsBackup* self,
                                           const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_email (ObjectsBackup* self,
                                            const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_image_id (ObjectsBackup* self,
                                               const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_avatar (ObjectsBackup* self,
                                             const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_is_premium (ObjectsBackup* self,
                                                 gboolean value);
VALA_EXTERN GeeArrayList* objects_backup_get_sources (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_version (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_access_token (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_email (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_sync_token (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_avatar (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_image_id (ObjectsBackup* self);
VALA_EXTERN gboolean objects_backup_get_todoist_user_is_premium (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_labels (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_projects (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_sections (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_items (ObjectsBackup* self);
VALA_EXTERN void objects_backup_set_error (ObjectsBackup* self,
                               const gchar* value);
VALA_EXTERN gboolean objects_backup_valid (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_error (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_date (ObjectsBackup* self);
VALA_EXTERN ObjectsBackup* objects_backup_new (void);
VALA_EXTERN ObjectsBackup* objects_backup_construct (GType object_type);
VALA_EXTERN gint objects_backup_get_default_inbox (ObjectsBackup* self);
VALA_EXTERN void objects_backup_set_default_inbox (ObjectsBackup* self,
                                       gint value);
VALA_EXTERN const gchar* objects_backup_get_local_inbox_project_id (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_name (ObjectsBackup* self);
VALA_EXTERN void objects_backup_set_projects (ObjectsBackup* self,
                                  GeeArrayList* value);
VALA_EXTERN void objects_backup_set_sections (ObjectsBackup* self,
                                  GeeArrayList* value);
VALA_EXTERN void objects_backup_set_items (ObjectsBackup* self,
                               GeeArrayList* value);
VALA_EXTERN void objects_backup_set_labels (ObjectsBackup* self,
                                GeeArrayList* value);
VALA_EXTERN void objects_backup_set_sources (ObjectsBackup* self,
                                 GeeArrayList* value);
VALA_EXTERN const gchar* objects_backup_get_path (ObjectsBackup* self);
VALA_EXTERN GDateTime* objects_backup_get_datetime (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_title (ObjectsBackup* self);
VALA_EXTERN gboolean objects_backup_get_todoist_backend (ObjectsBackup* self);
static void objects_backup_finalize (GObject * obj);
static GType objects_backup_get_type_once (void);
static void _vala_objects_backup_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_objects_backup_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
objects_backup_get_instance_private (ObjectsBackup* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsBackup_private_offset);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

ObjectsBackup*
objects_backup_construct_from_file (GType object_type,
                                    GFile* file)
{
	ObjectsBackup * self = NULL;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (ObjectsBackup*) g_object_new (object_type, NULL);
	_tmp0_ = json_parser_new ();
	parser = _tmp0_;
	{
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		JsonObject* node = NULL;
		JsonNode* _tmp5_;
		JsonObject* _tmp6_;
		JsonObject* _tmp7_;
		JsonObject* _tmp8_;
		const gchar* _tmp9_;
		JsonObject* _tmp10_;
		const gchar* _tmp11_;
		JsonObject* settings = NULL;
		JsonObject* _tmp12_;
		JsonObject* _tmp13_;
		JsonObject* _tmp14_;
		JsonObject* _tmp15_;
		const gchar* _tmp16_;
		JsonObject* _tmp17_;
		JsonObject* _tmp20_;
		JsonObject* _tmp23_;
		JsonObject* _tmp26_;
		JsonObject* _tmp29_;
		JsonObject* _tmp32_;
		JsonObject* _tmp35_;
		GeeArrayList* _tmp37_;
		JsonArray* _sources = NULL;
		JsonObject* _tmp38_;
		JsonArray* _tmp39_;
		JsonArray* _tmp40_;
		GList* _tmp41_;
		gboolean _tmp46_ = FALSE;
		const gchar* _tmp47_;
		GeeArrayList* _tmp77_;
		JsonArray* _labels = NULL;
		JsonObject* _tmp78_;
		JsonArray* _tmp79_;
		JsonArray* _tmp80_;
		GList* _tmp81_;
		GeeArrayList* _tmp86_;
		JsonArray* _projects = NULL;
		JsonObject* _tmp87_;
		JsonArray* _tmp88_;
		JsonArray* _tmp89_;
		GList* _tmp90_;
		GeeArrayList* _tmp104_;
		JsonArray* _sections = NULL;
		JsonObject* _tmp105_;
		JsonArray* _tmp106_;
		JsonArray* _tmp107_;
		GList* _tmp108_;
		GeeArrayList* _tmp113_;
		JsonArray* _items = NULL;
		JsonObject* _tmp114_;
		JsonArray* _tmp115_;
		JsonArray* _tmp116_;
		GList* _tmp117_;
		_tmp1_ = g_file_get_path (file);
		_tmp2_ = _tmp1_;
		json_parser_load_from_file (parser, _tmp2_, &_inner_error0_);
		_g_free0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = g_file_get_path (file);
		_tmp4_ = _tmp3_;
		objects_backup_set_path (self, _tmp4_);
		_g_free0 (_tmp4_);
		_tmp5_ = json_parser_get_root (parser);
		_tmp6_ = json_node_get_object (_tmp5_);
		_tmp7_ = _json_object_ref0 (_tmp6_);
		node = _tmp7_;
		_tmp8_ = node;
		_tmp9_ = json_object_get_string_member (_tmp8_, "version");
		objects_backup_set_version (self, _tmp9_);
		_tmp10_ = node;
		_tmp11_ = json_object_get_string_member (_tmp10_, "date");
		objects_backup_set_date (self, _tmp11_);
		_tmp12_ = node;
		_tmp13_ = json_object_get_object_member (_tmp12_, "settings");
		_tmp14_ = _json_object_ref0 (_tmp13_);
		settings = _tmp14_;
		_tmp15_ = settings;
		_tmp16_ = json_object_get_string_member (_tmp15_, "local-inbox-project-id");
		objects_backup_set_local_inbox_project_id (self, _tmp16_);
		_tmp17_ = settings;
		if (json_object_has_member (_tmp17_, "todoist-access-token")) {
			JsonObject* _tmp18_;
			const gchar* _tmp19_;
			_tmp18_ = settings;
			_tmp19_ = json_object_get_string_member (_tmp18_, "todoist-access-token");
			objects_backup_set_todoist_access_token (self, _tmp19_);
		}
		_tmp20_ = settings;
		if (json_object_has_member (_tmp20_, "todoist-sync-token")) {
			JsonObject* _tmp21_;
			const gchar* _tmp22_;
			_tmp21_ = settings;
			_tmp22_ = json_object_get_string_member (_tmp21_, "todoist-sync-token");
			objects_backup_set_todoist_sync_token (self, _tmp22_);
		}
		_tmp23_ = settings;
		if (json_object_has_member (_tmp23_, "todoist-user-name")) {
			JsonObject* _tmp24_;
			const gchar* _tmp25_;
			_tmp24_ = settings;
			_tmp25_ = json_object_get_string_member (_tmp24_, "todoist-user-name");
			objects_backup_set_todoist_user_name (self, _tmp25_);
		}
		_tmp26_ = settings;
		if (json_object_has_member (_tmp26_, "todoist-user-email")) {
			JsonObject* _tmp27_;
			const gchar* _tmp28_;
			_tmp27_ = settings;
			_tmp28_ = json_object_get_string_member (_tmp27_, "todoist-user-name");
			objects_backup_set_todoist_user_email (self, _tmp28_);
		}
		_tmp29_ = settings;
		if (json_object_has_member (_tmp29_, "todoist-user-image-id")) {
			JsonObject* _tmp30_;
			const gchar* _tmp31_;
			_tmp30_ = settings;
			_tmp31_ = json_object_get_string_member (_tmp30_, "todoist-user-image-id");
			objects_backup_set_todoist_user_image_id (self, _tmp31_);
		}
		_tmp32_ = settings;
		if (json_object_has_member (_tmp32_, "todoist-user-avatar")) {
			JsonObject* _tmp33_;
			const gchar* _tmp34_;
			_tmp33_ = settings;
			_tmp34_ = json_object_get_string_member (_tmp33_, "todoist-user-avatar");
			objects_backup_set_todoist_user_avatar (self, _tmp34_);
		}
		_tmp35_ = settings;
		if (json_object_has_member (_tmp35_, "todoist-user-is-premium")) {
			JsonObject* _tmp36_;
			_tmp36_ = settings;
			objects_backup_set_todoist_user_is_premium (self, json_object_get_boolean_member (_tmp36_, "todoist-user-is-premium"));
		}
		_tmp37_ = self->priv->_sources;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp37_);
		_tmp38_ = node;
		_tmp39_ = json_object_get_array_member (_tmp38_, "sources");
		_sources = _tmp39_;
		_tmp40_ = _sources;
		_tmp41_ = json_array_get_elements (_tmp40_);
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
			item_collection = _tmp41_;
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				JsonNode* item = NULL;
				item = (JsonNode*) item_it->data;
				{
					GeeArrayList* _tmp42_;
					JsonNode* _tmp43_;
					ObjectsSource* _tmp44_;
					ObjectsSource* _tmp45_;
					_tmp42_ = self->priv->_sources;
					_tmp43_ = item;
					_tmp44_ = objects_source_new_from_import_json (_tmp43_);
					_tmp45_ = _tmp44_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, _tmp45_);
					_g_object_unref0 (_tmp45_);
				}
			}
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
		}
		_tmp47_ = self->priv->_version;
		if (g_strcmp0 (_tmp47_, "1.0") == 0) {
			const gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			_tmp48_ = self->priv->_todoist_access_token;
			_tmp49_ = string_strip (_tmp48_);
			_tmp50_ = _tmp49_;
			_tmp46_ = g_strcmp0 (_tmp50_, "") != 0;
			_g_free0 (_tmp50_);
		} else {
			_tmp46_ = FALSE;
		}
		if (_tmp46_) {
			ObjectsSource* todoist_source = NULL;
			ObjectsSource* _tmp51_;
			ObjectsSource* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			ObjectsSource* _tmp55_;
			ObjectsSource* _tmp56_;
			const gchar* _tmp57_;
			ObjectsSourceTodoistData* todoist_data = NULL;
			ObjectsSourceTodoistData* _tmp58_;
			ObjectsSourceTodoistData* _tmp59_;
			const gchar* _tmp60_;
			ObjectsSourceTodoistData* _tmp61_;
			const gchar* _tmp62_;
			ObjectsSourceTodoistData* _tmp63_;
			const gchar* _tmp64_;
			ObjectsSourceTodoistData* _tmp65_;
			const gchar* _tmp66_;
			ObjectsSourceTodoistData* _tmp67_;
			const gchar* _tmp68_;
			ObjectsSourceTodoistData* _tmp69_;
			const gchar* _tmp70_;
			ObjectsSourceTodoistData* _tmp71_;
			gboolean _tmp72_;
			ObjectsSource* _tmp73_;
			ObjectsSourceTodoistData* _tmp74_;
			GeeArrayList* _tmp75_;
			ObjectsSource* _tmp76_;
			_tmp51_ = objects_source_new ();
			todoist_source = _tmp51_;
			_tmp52_ = todoist_source;
			_tmp53_ = source_type_to_string (SOURCE_TYPE_TODOIST);
			_tmp54_ = _tmp53_;
			objects_base_object_set_id ((ObjectsBaseObject*) _tmp52_, _tmp54_);
			_g_free0 (_tmp54_);
			_tmp55_ = todoist_source;
			objects_source_set_source_type (_tmp55_, SOURCE_TYPE_TODOIST);
			_tmp56_ = todoist_source;
			_tmp57_ = self->priv->_todoist_user_email;
			objects_source_set_display_name (_tmp56_, _tmp57_);
			_tmp58_ = objects_source_todoist_data_new ();
			todoist_data = _tmp58_;
			_tmp59_ = todoist_data;
			_tmp60_ = self->priv->_todoist_sync_token;
			objects_source_todoist_data_set_sync_token (_tmp59_, _tmp60_);
			_tmp61_ = todoist_data;
			_tmp62_ = self->priv->_todoist_access_token;
			objects_source_todoist_data_set_access_token (_tmp61_, _tmp62_);
			_tmp63_ = todoist_data;
			_tmp64_ = self->priv->_todoist_user_email;
			objects_source_todoist_data_set_user_email (_tmp63_, _tmp64_);
			_tmp65_ = todoist_data;
			_tmp66_ = self->priv->_todoist_user_email;
			objects_source_todoist_data_set_user_name (_tmp65_, _tmp66_);
			_tmp67_ = todoist_data;
			_tmp68_ = self->priv->_todoist_user_avatar;
			objects_source_todoist_data_set_user_avatar (_tmp67_, _tmp68_);
			_tmp69_ = todoist_data;
			_tmp70_ = self->priv->_todoist_user_image_id;
			objects_source_todoist_data_set_user_image_id (_tmp69_, _tmp70_);
			_tmp71_ = todoist_data;
			_tmp72_ = self->priv->_todoist_user_is_premium;
			objects_source_todoist_data_set_user_is_premium (_tmp71_, _tmp72_);
			_tmp73_ = todoist_source;
			_tmp74_ = todoist_data;
			objects_source_set_data (_tmp73_, (ObjectsSourceData*) _tmp74_);
			_tmp75_ = self->priv->_sources;
			_tmp76_ = todoist_source;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp75_, _tmp76_);
			_g_object_unref0 (todoist_data);
			_g_object_unref0 (todoist_source);
		}
		_tmp77_ = self->priv->_labels;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp77_);
		_tmp78_ = node;
		_tmp79_ = json_object_get_array_member (_tmp78_, "labels");
		_labels = _tmp79_;
		_tmp80_ = _labels;
		_tmp81_ = json_array_get_elements (_tmp80_);
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
			item_collection = _tmp81_;
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				JsonNode* item = NULL;
				item = (JsonNode*) item_it->data;
				{
					GeeArrayList* _tmp82_;
					JsonNode* _tmp83_;
					ObjectsLabel* _tmp84_;
					ObjectsLabel* _tmp85_;
					_tmp82_ = self->priv->_labels;
					_tmp83_ = item;
					_tmp84_ = objects_label_new_from_import_json (_tmp83_);
					_tmp85_ = _tmp84_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp82_, _tmp85_);
					_g_object_unref0 (_tmp85_);
				}
			}
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
		}
		_tmp86_ = self->priv->_projects;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp86_);
		_tmp87_ = node;
		_tmp88_ = json_object_get_array_member (_tmp87_, "projects");
		_projects = _tmp88_;
		_tmp89_ = _projects;
		_tmp90_ = json_array_get_elements (_tmp89_);
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
			item_collection = _tmp90_;
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				JsonNode* item = NULL;
				item = (JsonNode*) item_it->data;
				{
					ObjectsProject* _project = NULL;
					JsonNode* _tmp91_;
					ObjectsProject* _tmp92_;
					const gchar* _tmp93_;
					_tmp91_ = item;
					_tmp92_ = objects_project_new_from_import_json (_tmp91_);
					_project = _tmp92_;
					_tmp93_ = self->priv->_version;
					if (g_strcmp0 (_tmp93_, "1.0") == 0) {
						ObjectsProject* _tmp94_;
						const gchar* _tmp95_;
						const gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						gboolean _tmp99_;
						_tmp94_ = _project;
						_tmp95_ = objects_project_get_source_id (_tmp94_);
						_tmp96_ = _tmp95_;
						_tmp97_ = source_type_to_string (SOURCE_TYPE_CALDAV);
						_tmp98_ = _tmp97_;
						_tmp99_ = g_strcmp0 (_tmp96_, _tmp98_) != 0;
						_g_free0 (_tmp98_);
						if (_tmp99_) {
							GeeArrayList* _tmp100_;
							ObjectsProject* _tmp101_;
							_tmp100_ = self->priv->_projects;
							_tmp101_ = _project;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, _tmp101_);
						}
					} else {
						GeeArrayList* _tmp102_;
						ObjectsProject* _tmp103_;
						_tmp102_ = self->priv->_projects;
						_tmp103_ = _project;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp102_, _tmp103_);
					}
					_g_object_unref0 (_project);
				}
			}
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
		}
		_tmp104_ = self->priv->_sections;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp104_);
		_tmp105_ = node;
		_tmp106_ = json_object_get_array_member (_tmp105_, "sections");
		_sections = _tmp106_;
		_tmp107_ = _sections;
		_tmp108_ = json_array_get_elements (_tmp107_);
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
			item_collection = _tmp108_;
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				JsonNode* item = NULL;
				item = (JsonNode*) item_it->data;
				{
					GeeArrayList* _tmp109_;
					JsonNode* _tmp110_;
					ObjectsSection* _tmp111_;
					ObjectsSection* _tmp112_;
					_tmp109_ = self->priv->_sections;
					_tmp110_ = item;
					_tmp111_ = objects_section_new_from_import_json (_tmp110_);
					_tmp112_ = _tmp111_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp109_, _tmp112_);
					_g_object_unref0 (_tmp112_);
				}
			}
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
		}
		_tmp113_ = self->priv->_items;
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp113_);
		_tmp114_ = node;
		_tmp115_ = json_object_get_array_member (_tmp114_, "items");
		_items = _tmp115_;
		_tmp116_ = _items;
		_tmp117_ = json_array_get_elements (_tmp116_);
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
			item_collection = _tmp117_;
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				JsonNode* item = NULL;
				item = (JsonNode*) item_it->data;
				{
					GeeArrayList* _tmp118_;
					JsonNode* _tmp119_;
					GeeArrayList* _tmp120_;
					ObjectsItem* _tmp121_;
					ObjectsItem* _tmp122_;
					_tmp118_ = self->priv->_items;
					_tmp119_ = item;
					_tmp120_ = self->priv->_labels;
					_tmp121_ = objects_item_new_from_import_json (_tmp119_, _tmp120_);
					_tmp122_ = _tmp121_;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp118_, _tmp122_);
					_g_object_unref0 (_tmp122_);
				}
			}
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
		}
		_json_object_unref0 (settings);
		_json_object_unref0 (node);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp123_;
		const gchar* _tmp124_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp123_ = e;
		_tmp124_ = _tmp123_->message;
		objects_backup_set_error (self, _tmp124_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (parser);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_g_object_unref0 (parser);
	return self;
}

ObjectsBackup*
objects_backup_new_from_file (GFile* file)
{
	return objects_backup_construct_from_file (OBJECTS_TYPE_BACKUP, file);
}

gboolean
objects_backup_valid (ObjectsBackup* self)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GeeArrayList* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_error;
	if (g_strcmp0 (_tmp0_, "") != 0) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->_version;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->_version;
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
	}
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = self->priv->_date;
	if (_tmp5_ == NULL) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp6_;
		_tmp6_ = self->priv->_date;
		_tmp4_ = g_strcmp0 (_tmp6_, "") == 0;
	}
	if (_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp7_ = self->priv->_projects;
	_tmp8_ = gee_collection_get_is_empty ((GeeCollection*) _tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

ObjectsBackup*
objects_backup_construct (GType object_type)
{
	ObjectsBackup * self = NULL;
	self = (ObjectsBackup*) g_object_new (object_type, NULL);
	return self;
}

ObjectsBackup*
objects_backup_new (void)
{
	return objects_backup_construct (OBJECTS_TYPE_BACKUP);
}

const gchar*
objects_backup_get_version (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_version;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_version (ObjectsBackup* self,
                            const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_version (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_version);
		self->priv->_version = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_VERSION_PROPERTY]);
	}
}

const gchar*
objects_backup_get_date (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_date (ObjectsBackup* self,
                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_date (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_date);
		self->priv->_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_DATE_PROPERTY]);
	}
}

gint
objects_backup_get_default_inbox (ObjectsBackup* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_default_inbox;
	return result;
}

void
objects_backup_set_default_inbox (ObjectsBackup* self,
                                  gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_default_inbox (self);
	if (old_value != value) {
		self->priv->_default_inbox = value;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY]);
	}
}

const gchar*
objects_backup_get_local_inbox_project_id (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_local_inbox_project_id;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_local_inbox_project_id (ObjectsBackup* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_local_inbox_project_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_local_inbox_project_id);
		self->priv->_local_inbox_project_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY]);
	}
}

const gchar*
objects_backup_get_todoist_access_token (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_todoist_access_token;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_todoist_access_token (ObjectsBackup* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_access_token (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_todoist_access_token);
		self->priv->_todoist_access_token = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY]);
	}
}

const gchar*
objects_backup_get_todoist_sync_token (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_todoist_sync_token;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_todoist_sync_token (ObjectsBackup* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_sync_token (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_todoist_sync_token);
		self->priv->_todoist_sync_token = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY]);
	}
}

const gchar*
objects_backup_get_todoist_user_name (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_todoist_user_name;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_todoist_user_name (ObjectsBackup* self,
                                      const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_user_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_todoist_user_name);
		self->priv->_todoist_user_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY]);
	}
}

const gchar*
objects_backup_get_todoist_user_email (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_todoist_user_email;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_todoist_user_email (ObjectsBackup* self,
                                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_user_email (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_todoist_user_email);
		self->priv->_todoist_user_email = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY]);
	}
}

const gchar*
objects_backup_get_todoist_user_image_id (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_todoist_user_image_id;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_todoist_user_image_id (ObjectsBackup* self,
                                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_user_image_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_todoist_user_image_id);
		self->priv->_todoist_user_image_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY]);
	}
}

const gchar*
objects_backup_get_todoist_user_avatar (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_todoist_user_avatar;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_todoist_user_avatar (ObjectsBackup* self,
                                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_user_avatar (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_todoist_user_avatar);
		self->priv->_todoist_user_avatar = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY]);
	}
}

gboolean
objects_backup_get_todoist_user_is_premium (ObjectsBackup* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_todoist_user_is_premium;
	return result;
}

void
objects_backup_set_todoist_user_is_premium (ObjectsBackup* self,
                                            gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_todoist_user_is_premium (self);
	if (old_value != value) {
		self->priv->_todoist_user_is_premium = value;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY]);
	}
}

GeeArrayList*
objects_backup_get_projects (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_projects;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
objects_backup_set_projects (ObjectsBackup* self,
                             GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_projects (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_projects);
		self->priv->_projects = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_PROJECTS_PROPERTY]);
	}
}

GeeArrayList*
objects_backup_get_sections (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sections;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_sections (ObjectsBackup* self,
                             GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_sections (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_sections);
		self->priv->_sections = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_SECTIONS_PROPERTY]);
	}
}

GeeArrayList*
objects_backup_get_items (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_items;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_items (ObjectsBackup* self,
                          GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_items (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_items);
		self->priv->_items = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_ITEMS_PROPERTY]);
	}
}

GeeArrayList*
objects_backup_get_labels (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_labels;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_labels (ObjectsBackup* self,
                           GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_labels (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_labels);
		self->priv->_labels = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_LABELS_PROPERTY]);
	}
}

GeeArrayList*
objects_backup_get_sources (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sources;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_sources (ObjectsBackup* self,
                            GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_sources (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_sources);
		self->priv->_sources = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_SOURCES_PROPERTY]);
	}
}

const gchar*
objects_backup_get_path (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_path;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_path (ObjectsBackup* self,
                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_path);
		self->priv->_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_PATH_PROPERTY]);
	}
}

const gchar*
objects_backup_get_error (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_error;
	result = _tmp0_;
	return result;
}

void
objects_backup_set_error (ObjectsBackup* self,
                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = objects_backup_get_error (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_error);
		self->priv->_error = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_ERROR_PROPERTY]);
	}
}

GDateTime*
objects_backup_get_datetime (ObjectsBackup* self)
{
	GDateTime* result;
	const gchar* _tmp0_;
	GTimeZone* _tmp1_;
	GTimeZone* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	_tmp1_ = g_time_zone_new_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_new_from_iso8601 (_tmp0_, _tmp2_);
	_g_date_time_unref0 (self->priv->_datetime);
	self->priv->_datetime = _tmp3_;
	_g_time_zone_unref0 (_tmp2_);
	_tmp4_ = self->priv->_datetime;
	result = _tmp4_;
	return result;
}

const gchar*
objects_backup_get_title (ObjectsBackup* self)
{
	const gchar* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = objects_backup_get_datetime (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_format (_tmp1_, "%c");
	_g_free0 (self->priv->_title);
	self->priv->_title = _tmp2_;
	_tmp3_ = self->priv->_title;
	result = _tmp3_;
	return result;
}

gboolean
objects_backup_get_todoist_backend (ObjectsBackup* self)
{
	gboolean result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_todoist_access_token;
	_tmp1_ = string_strip (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->_todoist_backend = g_strcmp0 (_tmp2_, "") != 0;
	_g_free0 (_tmp2_);
	result = self->priv->_todoist_backend;
	return result;
}

static void
objects_backup_class_init (ObjectsBackupClass * klass,
                           gpointer klass_data)
{
	objects_backup_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ObjectsBackup_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_backup_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_backup_set_property;
	G_OBJECT_CLASS (klass)->finalize = objects_backup_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_VERSION_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_DATE_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_DATE_PROPERTY] = g_param_spec_string ("date", "date", "date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY] = g_param_spec_int ("default-inbox", "default-inbox", "default-inbox", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY] = g_param_spec_string ("local-inbox-project-id", "local-inbox-project-id", "local-inbox-project-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY] = g_param_spec_string ("todoist-access-token", "todoist-access-token", "todoist-access-token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY] = g_param_spec_string ("todoist-sync-token", "todoist-sync-token", "todoist-sync-token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY] = g_param_spec_string ("todoist-user-name", "todoist-user-name", "todoist-user-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY] = g_param_spec_string ("todoist-user-email", "todoist-user-email", "todoist-user-email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY] = g_param_spec_string ("todoist-user-image-id", "todoist-user-image-id", "todoist-user-image-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY] = g_param_spec_string ("todoist-user-avatar", "todoist-user-avatar", "todoist-user-avatar", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY] = g_param_spec_boolean ("todoist-user-is-premium", "todoist-user-is-premium", "todoist-user-is-premium", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_PROJECTS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_PROJECTS_PROPERTY] = g_param_spec_object ("projects", "projects", "projects", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_SECTIONS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_SECTIONS_PROPERTY] = g_param_spec_object ("sections", "sections", "sections", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_ITEMS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_ITEMS_PROPERTY] = g_param_spec_object ("items", "items", "items", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_LABELS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_LABELS_PROPERTY] = g_param_spec_object ("labels", "labels", "labels", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_SOURCES_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_SOURCES_PROPERTY] = g_param_spec_object ("sources", "sources", "sources", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_PATH_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_ERROR_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_ERROR_PROPERTY] = g_param_spec_string ("error", "error", "error", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_DATETIME_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_DATETIME_PROPERTY] = g_param_spec_boxed ("datetime", "datetime", "datetime", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TITLE_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY] = g_param_spec_boolean ("todoist-backend", "todoist-backend", "todoist-backend", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	objects_backup_signals[OBJECTS_BACKUP_DELETED_SIGNAL] = g_signal_new ("deleted", OBJECTS_TYPE_BACKUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
objects_backup_instance_init (ObjectsBackup * self,
                              gpointer klass)
{
	gchar* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gchar* _tmp16_;
	self->priv = objects_backup_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->_version = _tmp0_;
	_tmp1_ = g_date_time_new_now_local ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_to_string (_tmp2_);
	self->priv->_date = _tmp3_;
	_g_date_time_unref0 (_tmp2_);
	self->priv->_default_inbox = 0;
	_tmp4_ = g_strdup ("");
	self->priv->_local_inbox_project_id = _tmp4_;
	_tmp5_ = g_strdup ("");
	self->priv->_todoist_access_token = _tmp5_;
	_tmp6_ = g_strdup ("");
	self->priv->_todoist_sync_token = _tmp6_;
	_tmp7_ = g_strdup ("");
	self->priv->_todoist_user_name = _tmp7_;
	_tmp8_ = g_strdup ("");
	self->priv->_todoist_user_email = _tmp8_;
	_tmp9_ = g_strdup ("");
	self->priv->_todoist_user_image_id = _tmp9_;
	_tmp10_ = g_strdup ("");
	self->priv->_todoist_user_avatar = _tmp10_;
	self->priv->_todoist_user_is_premium = FALSE;
	_tmp11_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_projects = _tmp11_;
	_tmp12_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_sections = _tmp12_;
	_tmp13_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_items = _tmp13_;
	_tmp14_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_labels = _tmp14_;
	_tmp15_ = gee_array_list_new (OBJECTS_TYPE_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_sources = _tmp15_;
	_tmp16_ = g_strdup ("");
	self->priv->_error = _tmp16_;
}

static void
objects_backup_finalize (GObject * obj)
{
	ObjectsBackup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_BACKUP, ObjectsBackup);
	_g_free0 (self->priv->_version);
	_g_free0 (self->priv->_date);
	_g_free0 (self->priv->_local_inbox_project_id);
	_g_free0 (self->priv->_todoist_access_token);
	_g_free0 (self->priv->_todoist_sync_token);
	_g_free0 (self->priv->_todoist_user_name);
	_g_free0 (self->priv->_todoist_user_email);
	_g_free0 (self->priv->_todoist_user_image_id);
	_g_free0 (self->priv->_todoist_user_avatar);
	_g_object_unref0 (self->priv->_projects);
	_g_object_unref0 (self->priv->_sections);
	_g_object_unref0 (self->priv->_items);
	_g_object_unref0 (self->priv->_labels);
	_g_object_unref0 (self->priv->_sources);
	_g_free0 (self->priv->_path);
	_g_free0 (self->priv->_error);
	_g_date_time_unref0 (self->priv->_datetime);
	_g_free0 (self->priv->_title);
	G_OBJECT_CLASS (objects_backup_parent_class)->finalize (obj);
}

static GType
objects_backup_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsBackupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_backup_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsBackup), 0, (GInstanceInitFunc) objects_backup_instance_init, NULL };
	GType objects_backup_type_id;
	objects_backup_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsBackup", &g_define_type_info, 0);
	ObjectsBackup_private_offset = g_type_add_instance_private (objects_backup_type_id, sizeof (ObjectsBackupPrivate));
	return objects_backup_type_id;
}

GType
objects_backup_get_type (void)
{
	static volatile gsize objects_backup_type_id__once = 0;
	if (g_once_init_enter (&objects_backup_type_id__once)) {
		GType objects_backup_type_id;
		objects_backup_type_id = objects_backup_get_type_once ();
		g_once_init_leave (&objects_backup_type_id__once, objects_backup_type_id);
	}
	return objects_backup_type_id__once;
}

static void
_vala_objects_backup_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ObjectsBackup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BACKUP, ObjectsBackup);
	switch (property_id) {
		case OBJECTS_BACKUP_VERSION_PROPERTY:
		g_value_set_string (value, objects_backup_get_version (self));
		break;
		case OBJECTS_BACKUP_DATE_PROPERTY:
		g_value_set_string (value, objects_backup_get_date (self));
		break;
		case OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY:
		g_value_set_int (value, objects_backup_get_default_inbox (self));
		break;
		case OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY:
		g_value_set_string (value, objects_backup_get_local_inbox_project_id (self));
		break;
		case OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY:
		g_value_set_string (value, objects_backup_get_todoist_access_token (self));
		break;
		case OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY:
		g_value_set_string (value, objects_backup_get_todoist_sync_token (self));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY:
		g_value_set_string (value, objects_backup_get_todoist_user_name (self));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY:
		g_value_set_string (value, objects_backup_get_todoist_user_email (self));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY:
		g_value_set_string (value, objects_backup_get_todoist_user_image_id (self));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY:
		g_value_set_string (value, objects_backup_get_todoist_user_avatar (self));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY:
		g_value_set_boolean (value, objects_backup_get_todoist_user_is_premium (self));
		break;
		case OBJECTS_BACKUP_PROJECTS_PROPERTY:
		g_value_set_object (value, objects_backup_get_projects (self));
		break;
		case OBJECTS_BACKUP_SECTIONS_PROPERTY:
		g_value_set_object (value, objects_backup_get_sections (self));
		break;
		case OBJECTS_BACKUP_ITEMS_PROPERTY:
		g_value_set_object (value, objects_backup_get_items (self));
		break;
		case OBJECTS_BACKUP_LABELS_PROPERTY:
		g_value_set_object (value, objects_backup_get_labels (self));
		break;
		case OBJECTS_BACKUP_SOURCES_PROPERTY:
		g_value_set_object (value, objects_backup_get_sources (self));
		break;
		case OBJECTS_BACKUP_PATH_PROPERTY:
		g_value_set_string (value, objects_backup_get_path (self));
		break;
		case OBJECTS_BACKUP_ERROR_PROPERTY:
		g_value_set_string (value, objects_backup_get_error (self));
		break;
		case OBJECTS_BACKUP_DATETIME_PROPERTY:
		g_value_set_boxed (value, objects_backup_get_datetime (self));
		break;
		case OBJECTS_BACKUP_TITLE_PROPERTY:
		g_value_set_string (value, objects_backup_get_title (self));
		break;
		case OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY:
		g_value_set_boolean (value, objects_backup_get_todoist_backend (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_objects_backup_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ObjectsBackup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BACKUP, ObjectsBackup);
	switch (property_id) {
		case OBJECTS_BACKUP_VERSION_PROPERTY:
		objects_backup_set_version (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_DATE_PROPERTY:
		objects_backup_set_date (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY:
		objects_backup_set_default_inbox (self, g_value_get_int (value));
		break;
		case OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY:
		objects_backup_set_local_inbox_project_id (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY:
		objects_backup_set_todoist_access_token (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY:
		objects_backup_set_todoist_sync_token (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY:
		objects_backup_set_todoist_user_name (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY:
		objects_backup_set_todoist_user_email (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY:
		objects_backup_set_todoist_user_image_id (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY:
		objects_backup_set_todoist_user_avatar (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY:
		objects_backup_set_todoist_user_is_premium (self, g_value_get_boolean (value));
		break;
		case OBJECTS_BACKUP_PROJECTS_PROPERTY:
		objects_backup_set_projects (self, g_value_get_object (value));
		break;
		case OBJECTS_BACKUP_SECTIONS_PROPERTY:
		objects_backup_set_sections (self, g_value_get_object (value));
		break;
		case OBJECTS_BACKUP_ITEMS_PROPERTY:
		objects_backup_set_items (self, g_value_get_object (value));
		break;
		case OBJECTS_BACKUP_LABELS_PROPERTY:
		objects_backup_set_labels (self, g_value_get_object (value));
		break;
		case OBJECTS_BACKUP_SOURCES_PROPERTY:
		objects_backup_set_sources (self, g_value_get_object (value));
		break;
		case OBJECTS_BACKUP_PATH_PROPERTY:
		objects_backup_set_path (self, g_value_get_string (value));
		break;
		case OBJECTS_BACKUP_ERROR_PROPERTY:
		objects_backup_set_error (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

