/* EditableLabel.c generated by valac 0.56.18, the Vala compiler
 * generated from EditableLabel.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "planify.h"
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_EDITABLE_LABEL (widgets_editable_label_get_type ())
#define WIDGETS_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel))
#define WIDGETS_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabelClass))
#define WIDGETS_IS_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EDITABLE_LABEL))
#define WIDGETS_IS_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EDITABLE_LABEL))
#define WIDGETS_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabelClass))

typedef struct _WidgetsEditableLabel WidgetsEditableLabel;
typedef struct _WidgetsEditableLabelClass WidgetsEditableLabelClass;
typedef struct _WidgetsEditableLabelPrivate WidgetsEditableLabelPrivate;
enum  {
	WIDGETS_EDITABLE_LABEL_0_PROPERTY,
	WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY,
	WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY,
	WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY,
	WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY,
	WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY,
	WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY,
	WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY,
	WIDGETS_EDITABLE_LABEL_NUM_PROPERTIES
};
static GParamSpec* widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	WIDGETS_EDITABLE_LABEL_FOCUS_CHANGED_SIGNAL,
	WIDGETS_EDITABLE_LABEL_CHANGED_SIGNAL,
	WIDGETS_EDITABLE_LABEL_NUM_SIGNALS
};
static guint widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_NUM_SIGNALS] = {0};

struct _WidgetsEditableLabel {
	GtkGrid parent_instance;
	WidgetsEditableLabelPrivate * priv;
};

struct _WidgetsEditableLabelClass {
	GtkGridClass parent_class;
};

struct _WidgetsEditableLabelPrivate {
	gchar* _placeholder_text;
	gboolean _auto_focus;
	GtkLabel* title;
	WidgetsEntry* entry;
	GtkStack* stack;
	GtkBox* grid;
	GtkRevealer* edit_revealer;
	gchar* _text;
	gboolean _entry_menu_opened;
};

static gint WidgetsEditableLabel_private_offset;
static gpointer widgets_editable_label_parent_class = NULL;

VALA_EXTERN GType widgets_editable_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEditableLabel, g_object_unref)
VALA_EXTERN void widgets_editable_label_editing (WidgetsEditableLabel* self,
                                     gboolean value,
                                     gboolean grab_focus);
VALA_EXTERN const gchar* widgets_editable_label_get_text (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_set_text (WidgetsEditableLabel* self,
                                      const gchar* value);
VALA_EXTERN WidgetsEditableLabel* widgets_editable_label_new (const gchar* placeholder_text,
                                                  gboolean auto_focus);
VALA_EXTERN WidgetsEditableLabel* widgets_editable_label_construct (GType object_type,
                                                        const gchar* placeholder_text,
                                                        gboolean auto_focus);
VALA_EXTERN void widgets_editable_label_add_style (WidgetsEditableLabel* self,
                                       const gchar* style);
static void widgets_editable_label_handle_focus_in (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_update_on_leave (WidgetsEditableLabel* self);
VALA_EXTERN const gchar* widgets_editable_label_get_placeholder_text (WidgetsEditableLabel* self);
static void widgets_editable_label_set_placeholder_text (WidgetsEditableLabel* self,
                                                  const gchar* value);
VALA_EXTERN gboolean widgets_editable_label_get_auto_focus (WidgetsEditableLabel* self);
static void widgets_editable_label_set_auto_focus (WidgetsEditableLabel* self,
                                            gboolean value);
VALA_EXTERN gboolean widgets_editable_label_get_entry_menu_opened (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_set_entry_menu_opened (WidgetsEditableLabel* self,
                                                   gboolean value);
VALA_EXTERN gboolean widgets_editable_label_get_is_editing (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_set_show_edit (WidgetsEditableLabel* self,
                                           gboolean value);
VALA_EXTERN void widgets_editable_label_set_editable (WidgetsEditableLabel* self,
                                          gboolean value);
static GObject * widgets_editable_label_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _widgets_editable_label____lambda787_ (WidgetsEditableLabel* self);
static void __widgets_editable_label____lambda787__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self);
static void _widgets_editable_label___lambda788_ (WidgetsEditableLabel* self);
static void __widgets_editable_label___lambda788__gtk_entry_activate (GtkEntry* _sender,
                                                               gpointer self);
static void _widgets_editable_label_handle_focus_in_gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                                               gpointer self);
static void _widgets_editable_label_update_on_leave_gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                               gpointer self);
static void _widgets_editable_label___lambda789_ (WidgetsEditableLabel* self);
static void __widgets_editable_label___lambda789__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                             gpointer self);
static void widgets_editable_label_finalize (GObject * obj);
static GType widgets_editable_label_get_type_once (void);
static void _vala_widgets_editable_label_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_widgets_editable_label_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
widgets_editable_label_get_instance_private (WidgetsEditableLabel* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsEditableLabel_private_offset);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

void
widgets_editable_label_editing (WidgetsEditableLabel* self,
                                gboolean value,
                                gboolean grab_focus)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_FOCUS_CHANGED_SIGNAL], 0, value);
	if (value) {
		WidgetsEntry* _tmp0_;
		const gchar* _tmp1_;
		GtkStack* _tmp2_;
		WidgetsEntry* _tmp3_;
		_tmp0_ = self->priv->entry;
		_tmp1_ = self->priv->_text;
		gtk_editable_set_text ((GtkEditable*) _tmp0_, _tmp1_);
		_tmp2_ = self->priv->stack;
		_tmp3_ = self->priv->entry;
		gtk_stack_set_visible_child (_tmp2_, (GtkWidget*) _tmp3_);
		if (grab_focus) {
			WidgetsEntry* _tmp4_;
			_tmp4_ = self->priv->entry;
			gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
		} else {
			WidgetsEntry* _tmp5_;
			WidgetsEntry* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			WidgetsEntry* _tmp9_;
			guint _tmp10_;
			guint _tmp11_;
			_tmp5_ = self->priv->entry;
			gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp5_);
			_tmp6_ = self->priv->entry;
			g_object_get ((GtkEditable*) _tmp6_, "cursor-position", &_tmp7_, NULL);
			_tmp8_ = _tmp7_;
			_tmp9_ = self->priv->entry;
			_tmp10_ = gtk_entry_get_text_length ((GtkEntry*) _tmp9_);
			_tmp11_ = _tmp10_;
			if (((guint) _tmp8_) < _tmp11_) {
				WidgetsEntry* _tmp12_;
				WidgetsEntry* _tmp13_;
				guint _tmp14_;
				guint _tmp15_;
				_tmp12_ = self->priv->entry;
				_tmp13_ = self->priv->entry;
				_tmp14_ = gtk_entry_get_text_length ((GtkEntry*) _tmp13_);
				_tmp15_ = _tmp14_;
				gtk_editable_set_position ((GtkEditable*) _tmp12_, (gint) ((gint32) _tmp15_));
			}
		}
	} else {
		gboolean _tmp16_ = FALSE;
		WidgetsEntry* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gboolean _tmp22_;
		GtkStack* _tmp30_;
		GtkBox* _tmp31_;
		_tmp17_ = self->priv->entry;
		_tmp18_ = gtk_editable_get_text ((GtkEditable*) _tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = string_strip (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strcmp0 (_tmp21_, "") != 0;
		_g_free0 (_tmp21_);
		if (_tmp22_) {
			const gchar* _tmp23_;
			WidgetsEntry* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			_tmp23_ = self->priv->_text;
			_tmp24_ = self->priv->entry;
			_tmp25_ = gtk_editable_get_text ((GtkEditable*) _tmp24_);
			_tmp26_ = _tmp25_;
			_tmp16_ = g_strcmp0 (_tmp23_, _tmp26_) != 0;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			WidgetsEntry* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			_tmp27_ = self->priv->entry;
			_tmp28_ = gtk_editable_get_text ((GtkEditable*) _tmp27_);
			_tmp29_ = _tmp28_;
			widgets_editable_label_set_text (self, _tmp29_);
			g_signal_emit (self, widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_CHANGED_SIGNAL], 0);
		}
		_tmp30_ = self->priv->stack;
		_tmp31_ = self->priv->grid;
		gtk_stack_set_visible_child (_tmp30_, (GtkWidget*) _tmp31_);
	}
}

WidgetsEditableLabel*
widgets_editable_label_construct (GType object_type,
                                  const gchar* placeholder_text,
                                  gboolean auto_focus)
{
	WidgetsEditableLabel * self = NULL;
	g_return_val_if_fail (placeholder_text != NULL, NULL);
	self = (WidgetsEditableLabel*) g_object_new (object_type, "placeholder-text", placeholder_text, "auto-focus", auto_focus, NULL);
	return self;
}

WidgetsEditableLabel*
widgets_editable_label_new (const gchar* placeholder_text,
                            gboolean auto_focus)
{
	return widgets_editable_label_construct (WIDGETS_TYPE_EDITABLE_LABEL, placeholder_text, auto_focus);
}

void
widgets_editable_label_add_style (WidgetsEditableLabel* self,
                                  const gchar* style)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (style != NULL);
	_tmp0_ = self->priv->stack;
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, style);
}

static void
widgets_editable_label_handle_focus_in (WidgetsEditableLabel* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = services_event_bus_get_default ();
	_tmp1_ = _tmp0_;
	g_signal_emit_by_name (_tmp1_, "disconnect-typing-accel");
	_g_object_unref0 (_tmp1_);
}

void
widgets_editable_label_update_on_leave (WidgetsEditableLabel* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = services_event_bus_get_default ();
	_tmp1_ = _tmp0_;
	g_signal_emit_by_name (_tmp1_, "connect-typing-accel");
	_g_object_unref0 (_tmp1_);
}

const gchar*
widgets_editable_label_get_placeholder_text (WidgetsEditableLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_placeholder_text;
	result = _tmp0_;
	return result;
}

static void
widgets_editable_label_set_placeholder_text (WidgetsEditableLabel* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_editable_label_get_placeholder_text (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_placeholder_text);
		self->priv->_placeholder_text = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY]);
	}
}

gboolean
widgets_editable_label_get_auto_focus (WidgetsEditableLabel* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_auto_focus;
	return result;
}

static void
widgets_editable_label_set_auto_focus (WidgetsEditableLabel* self,
                                       gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_editable_label_get_auto_focus (self);
	if (old_value != value) {
		self->priv->_auto_focus = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY]);
	}
}

const gchar*
widgets_editable_label_get_text (WidgetsEditableLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_text;
	result = _tmp0_;
	return result;
}

void
widgets_editable_label_set_text (WidgetsEditableLabel* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_editable_label_get_text (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_text);
		self->priv->_text = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY]);
	}
}

gboolean
widgets_editable_label_get_entry_menu_opened (WidgetsEditableLabel* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_entry_menu_opened;
	return result;
}

void
widgets_editable_label_set_entry_menu_opened (WidgetsEditableLabel* self,
                                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_editable_label_get_entry_menu_opened (self);
	if (old_value != value) {
		self->priv->_entry_menu_opened = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY]);
	}
}

gboolean
widgets_editable_label_get_is_editing (WidgetsEditableLabel* self)
{
	gboolean result;
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	WidgetsEntry* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->entry;
	result = _tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget);
	return result;
}

void
widgets_editable_label_set_show_edit (WidgetsEditableLabel* self,
                                      gboolean value)
{
	GtkRevealer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->edit_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY]);
}

void
widgets_editable_label_set_editable (WidgetsEditableLabel* self,
                                     gboolean value)
{
	WidgetsEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->entry;
	gtk_editable_set_editable ((GtkEditable*) _tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY]);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_widgets_editable_label____lambda787_ (WidgetsEditableLabel* self)
{
	widgets_editable_label_editing (self, TRUE, FALSE);
}

static void
__widgets_editable_label____lambda787__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self)
{
	_widgets_editable_label____lambda787_ ((WidgetsEditableLabel*) self);
}

static void
_widgets_editable_label___lambda788_ (WidgetsEditableLabel* self)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	WidgetsEntry* _tmp3_;
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->entry;
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
		widgets_editable_label_editing (self, FALSE, FALSE);
	}
}

static void
__widgets_editable_label___lambda788__gtk_entry_activate (GtkEntry* _sender,
                                                          gpointer self)
{
	_widgets_editable_label___lambda788_ ((WidgetsEditableLabel*) self);
}

static void
_widgets_editable_label_handle_focus_in_gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                                          gpointer self)
{
	widgets_editable_label_handle_focus_in ((WidgetsEditableLabel*) self);
}

static void
_widgets_editable_label_update_on_leave_gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                          gpointer self)
{
	widgets_editable_label_update_on_leave ((WidgetsEditableLabel*) self);
}

static void
_widgets_editable_label___lambda789_ (WidgetsEditableLabel* self)
{
	gboolean _tmp0_ = FALSE;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	WidgetsEntry* _tmp4_;
	_tmp1_ = self->priv->stack;
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->entry;
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
		gboolean _tmp5_;
		_tmp5_ = self->priv->_entry_menu_opened;
		_tmp0_ = !_tmp5_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		widgets_editable_label_editing (self, FALSE, FALSE);
	}
}

static void
__widgets_editable_label___lambda789__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                        gpointer self)
{
	_widgets_editable_label___lambda789_ ((WidgetsEditableLabel*) self);
}

static GObject *
widgets_editable_label_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsEditableLabel * self;
	GtkLabel* _tmp0_ = NULL;
	GtkImage* edit_icon = NULL;
	gchar* _tmp1_;
	gchar** _tmp2_;
	GtkImage* _tmp3_ = NULL;
	GtkImage* _tmp4_;
	GtkWidget* _tmp5_;
	GtkRevealer* _tmp6_ = NULL;
	GtkBox* _tmp7_ = NULL;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkBox* _tmp10_;
	GtkRevealer* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	WidgetsEntry* _tmp16_ = NULL;
	GtkStack* _tmp17_ = NULL;
	GtkStack* _tmp18_;
	GtkBox* _tmp19_;
	GtkStack* _tmp20_;
	WidgetsEntry* _tmp21_;
	GtkStack* _tmp22_;
	GtkLabel* _tmp23_;
	gboolean _tmp24_;
	WidgetsEntry* _tmp29_;
	GtkEventControllerFocus* gesture = NULL;
	GtkEventControllerFocus* _tmp30_;
	WidgetsEntry* _tmp31_;
	GtkEventControllerFocus* _tmp32_;
	GtkEventController* _tmp33_;
	GtkEventControllerFocus* _tmp34_;
	GtkEventControllerFocus* _tmp35_;
	GtkEventControllerFocus* _tmp36_;
	parent_class = G_OBJECT_CLASS (widgets_editable_label_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_END);
	gtk_label_set_xalign (_tmp0_, (gfloat) 0);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->title);
	self->priv->title = _tmp0_;
	_tmp1_ = g_strdup ("dim-label");
	_tmp2_ = g_new0 (gchar*, 1 + 1);
	_tmp2_[0] = _tmp1_;
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-symbolic");
	gtk_widget_set_css_classes ((GtkWidget*) _tmp3_, _tmp2_);
	_tmp2_ = (_vala_array_free (_tmp2_, 1, (GDestroyNotify) g_free), NULL);
	gtk_image_set_pixel_size (_tmp3_, 16);
	g_object_ref_sink (_tmp3_);
	edit_icon = _tmp3_;
	_tmp4_ = edit_icon;
	_tmp5_ = _g_object_ref0 ((GtkWidget*) _tmp4_);
	_tmp6_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_transition_type (_tmp6_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	gtk_revealer_set_child (_tmp6_, _tmp5_);
	_g_object_unref0 (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->edit_revealer);
	self->priv->edit_revealer = _tmp6_;
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp7_;
	_tmp8_ = self->priv->grid;
	_tmp9_ = self->priv->title;
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->grid;
	_tmp11_ = self->priv->edit_revealer;
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->_placeholder_text;
	_tmp13_ = g_strdup (_tmp12_);
	_tmp14_ = g_strdup ("editable-label");
	_tmp15_ = g_new0 (gchar*, 1 + 1);
	_tmp15_[0] = _tmp14_;
	_tmp16_ = widgets_entry_new ();
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp16_, _tmp13_);
	_g_free0 (_tmp13_);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp16_, _tmp15_);
	_tmp15_ = (_vala_array_free (_tmp15_, 1, (GDestroyNotify) g_free), NULL);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->entry);
	self->priv->entry = _tmp16_;
	_tmp17_ = (GtkStack*) gtk_stack_new ();
	gtk_stack_set_transition_type (_tmp17_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	gtk_stack_set_transition_duration (_tmp17_, (guint) 115);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp17_;
	_tmp18_ = self->priv->stack;
	_tmp19_ = self->priv->grid;
	gtk_stack_add_child (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->stack;
	_tmp21_ = self->priv->entry;
	gtk_stack_add_child (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = self->priv->stack;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp22_, 0, 0, 1, 1);
	_tmp23_ = self->priv->title;
	g_object_bind_property_with_closures ((GObject*) self, "text", (GObject*) _tmp23_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp24_ = self->priv->_auto_focus;
	if (_tmp24_) {
		GtkGestureClick* gesture_click = NULL;
		GtkGestureClick* _tmp25_;
		GtkGestureClick* _tmp26_;
		GtkEventController* _tmp27_;
		GtkGestureClick* _tmp28_;
		_tmp25_ = (GtkGestureClick*) gtk_gesture_click_new ();
		gesture_click = _tmp25_;
		_tmp26_ = gesture_click;
		_tmp27_ = _g_object_ref0 ((GtkEventController*) _tmp26_);
		gtk_widget_add_controller ((GtkWidget*) self, _tmp27_);
		_tmp28_ = gesture_click;
		g_signal_connect_object (_tmp28_, "pressed", (GCallback) __widgets_editable_label____lambda787__gtk_gesture_click_pressed, self, 0);
		_g_object_unref0 (gesture_click);
	}
	_tmp29_ = self->priv->entry;
	g_signal_connect_object ((GtkEntry*) _tmp29_, "activate", (GCallback) __widgets_editable_label___lambda788__gtk_entry_activate, self, 0);
	_tmp30_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
	gesture = _tmp30_;
	_tmp31_ = self->priv->entry;
	_tmp32_ = gesture;
	_tmp33_ = _g_object_ref0 ((GtkEventController*) _tmp32_);
	gtk_widget_add_controller ((GtkWidget*) _tmp31_, _tmp33_);
	_tmp34_ = gesture;
	g_signal_connect_object (_tmp34_, "enter", (GCallback) _widgets_editable_label_handle_focus_in_gtk_event_controller_focus_enter, self, 0);
	_tmp35_ = gesture;
	g_signal_connect_object (_tmp35_, "leave", (GCallback) _widgets_editable_label_update_on_leave_gtk_event_controller_focus_leave, self, 0);
	_tmp36_ = gesture;
	g_signal_connect_object (_tmp36_, "leave", (GCallback) __widgets_editable_label___lambda789__gtk_event_controller_focus_leave, self, 0);
	_g_object_unref0 (gesture);
	_g_object_unref0 (edit_icon);
	return obj;
}

static void
widgets_editable_label_class_init (WidgetsEditableLabelClass * klass,
                                   gpointer klass_data)
{
	widgets_editable_label_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsEditableLabel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_editable_label_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_editable_label_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_editable_label_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_editable_label_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY] = g_param_spec_string ("placeholder-text", "placeholder-text", "placeholder-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY] = g_param_spec_boolean ("auto-focus", "auto-focus", "auto-focus", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY] = g_param_spec_boolean ("entry-menu-opened", "entry-menu-opened", "entry-menu-opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY] = g_param_spec_boolean ("is-editing", "is-editing", "is-editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY] = g_param_spec_boolean ("show-edit", "show-edit", "show-edit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY] = g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_FOCUS_CHANGED_SIGNAL] = g_signal_new ("focus-changed", WIDGETS_TYPE_EDITABLE_LABEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_CHANGED_SIGNAL] = g_signal_new ("changed", WIDGETS_TYPE_EDITABLE_LABEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
widgets_editable_label_instance_init (WidgetsEditableLabel * self,
                                      gpointer klass)
{
	self->priv = widgets_editable_label_get_instance_private (self);
	self->priv->_entry_menu_opened = FALSE;
}

static void
widgets_editable_label_finalize (GObject * obj)
{
	WidgetsEditableLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
	_g_free0 (self->priv->_placeholder_text);
	_g_object_unref0 (self->priv->title);
	_g_object_unref0 (self->priv->entry);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->edit_revealer);
	_g_free0 (self->priv->_text);
	G_OBJECT_CLASS (widgets_editable_label_parent_class)->finalize (obj);
}

static GType
widgets_editable_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsEditableLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_editable_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsEditableLabel), 0, (GInstanceInitFunc) widgets_editable_label_instance_init, NULL };
	GType widgets_editable_label_type_id;
	widgets_editable_label_type_id = g_type_register_static (gtk_grid_get_type (), "WidgetsEditableLabel", &g_define_type_info, 0);
	WidgetsEditableLabel_private_offset = g_type_add_instance_private (widgets_editable_label_type_id, sizeof (WidgetsEditableLabelPrivate));
	return widgets_editable_label_type_id;
}

GType
widgets_editable_label_get_type (void)
{
	static volatile gsize widgets_editable_label_type_id__once = 0;
	if (g_once_init_enter (&widgets_editable_label_type_id__once)) {
		GType widgets_editable_label_type_id;
		widgets_editable_label_type_id = widgets_editable_label_get_type_once ();
		g_once_init_leave (&widgets_editable_label_type_id__once, widgets_editable_label_type_id);
	}
	return widgets_editable_label_type_id__once;
}

static void
_vala_widgets_editable_label_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WidgetsEditableLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
	switch (property_id) {
		case WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY:
		g_value_set_string (value, widgets_editable_label_get_placeholder_text (self));
		break;
		case WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY:
		g_value_set_boolean (value, widgets_editable_label_get_auto_focus (self));
		break;
		case WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY:
		g_value_set_string (value, widgets_editable_label_get_text (self));
		break;
		case WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY:
		g_value_set_boolean (value, widgets_editable_label_get_entry_menu_opened (self));
		break;
		case WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY:
		g_value_set_boolean (value, widgets_editable_label_get_is_editing (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_editable_label_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WidgetsEditableLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
	switch (property_id) {
		case WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY:
		widgets_editable_label_set_placeholder_text (self, g_value_get_string (value));
		break;
		case WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY:
		widgets_editable_label_set_auto_focus (self, g_value_get_boolean (value));
		break;
		case WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY:
		widgets_editable_label_set_text (self, g_value_get_string (value));
		break;
		case WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY:
		widgets_editable_label_set_entry_menu_opened (self, g_value_get_boolean (value));
		break;
		case WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY:
		widgets_editable_label_set_show_edit (self, g_value_get_boolean (value));
		break;
		case WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY:
		widgets_editable_label_set_editable (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

