/* EventRow.c generated by valac 0.56.18, the Vala compiler
 * generated from EventRow.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <libical-glib/libical-glib.h>
#include <libedataserver/libedataserver.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "planify.h"
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_EVENT_ROW (widgets_event_row_get_type ())
#define WIDGETS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow))
#define WIDGETS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRowClass))
#define WIDGETS_IS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EVENT_ROW))
#define WIDGETS_IS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EVENT_ROW))
#define WIDGETS_EVENT_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRowClass))

typedef struct _WidgetsEventRow WidgetsEventRow;
typedef struct _WidgetsEventRowClass WidgetsEventRowClass;
typedef struct _WidgetsEventRowPrivate WidgetsEventRowPrivate;
enum  {
	WIDGETS_EVENT_ROW_0_PROPERTY,
	WIDGETS_EVENT_ROW_COMPONENT_PROPERTY,
	WIDGETS_EVENT_ROW_CAL_PROPERTY,
	WIDGETS_EVENT_ROW_SOURCE_PROPERTY,
	WIDGETS_EVENT_ROW_START_TIME_PROPERTY,
	WIDGETS_EVENT_ROW_END_TIME_PROPERTY,
	WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY,
	WIDGETS_EVENT_ROW_NUM_PROPERTIES
};
static GParamSpec* widgets_event_row_properties[WIDGETS_EVENT_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WidgetsEventRow {
	GtkListBoxRow parent_instance;
	WidgetsEventRowPrivate * priv;
};

struct _WidgetsEventRowClass {
	GtkListBoxRowClass parent_class;
};

struct _WidgetsEventRowPrivate {
	ICalComponent* _component;
	ESourceCalendar* _cal;
	ESource* _source;
	GDateTime* _start_time;
	GDateTime* _end_time;
	gboolean _is_allday;
	GtkGrid* color_grid;
	GtkLabel* time_label;
};

static gint WidgetsEventRow_private_offset;
static gpointer widgets_event_row_parent_class = NULL;

VALA_EXTERN GType widgets_event_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEventRow, g_object_unref)
VALA_EXTERN WidgetsEventRow* widgets_event_row_new (ICalComponent* component,
                                        ESource* source);
VALA_EXTERN WidgetsEventRow* widgets_event_row_construct (GType object_type,
                                              ICalComponent* component,
                                              ESource* source);
static void widgets_event_row_update_timelabel (WidgetsEventRow* self);
VALA_EXTERN GDateTime* widgets_event_row_get_start_time (WidgetsEventRow* self);
static void widgets_event_row_update_color (WidgetsEventRow* self);
VALA_EXTERN ESourceCalendar* widgets_event_row_get_cal (WidgetsEventRow* self);
VALA_EXTERN ICalComponent* widgets_event_row_get_component (WidgetsEventRow* self);
static void widgets_event_row_set_component (WidgetsEventRow* self,
                                      ICalComponent* value);
static void widgets_event_row_set_cal (WidgetsEventRow* self,
                                ESourceCalendar* value);
VALA_EXTERN ESource* widgets_event_row_get_source (WidgetsEventRow* self);
VALA_EXTERN void widgets_event_row_set_source (WidgetsEventRow* self,
                                   ESource* value);
static void widgets_event_row_set_start_time (WidgetsEventRow* self,
                                       GDateTime* value);
VALA_EXTERN GDateTime* widgets_event_row_get_end_time (WidgetsEventRow* self);
static void widgets_event_row_set_end_time (WidgetsEventRow* self,
                                     GDateTime* value);
VALA_EXTERN gboolean widgets_event_row_get_is_allday (WidgetsEventRow* self);
static void widgets_event_row_set_is_allday (WidgetsEventRow* self,
                                      gboolean value);
static GObject * widgets_event_row_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
VALA_EXTERN GDateTime* calendar_events_util_ical_to_date_time (ICalTime* date);
VALA_EXTERN gboolean calendar_events_util_is_the_all_day (GDateTime* dtstart,
                                              GDateTime* dtend);
static void _widgets_event_row_update_color_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void widgets_event_row_finalize (GObject * obj);
static GType widgets_event_row_get_type_once (void);
static void _vala_widgets_event_row_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_widgets_event_row_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
widgets_event_row_get_instance_private (WidgetsEventRow* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsEventRow_private_offset);
}

WidgetsEventRow*
widgets_event_row_construct (GType object_type,
                             ICalComponent* component,
                             ESource* source)
{
	WidgetsEventRow * self = NULL;
	ESourceExtension* _tmp0_;
	g_return_val_if_fail (component != NULL, NULL);
	g_return_val_if_fail (source != NULL, NULL);
	_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
	self = (WidgetsEventRow*) g_object_new (object_type, "component", component, "cal", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar), NULL);
	return self;
}

WidgetsEventRow*
widgets_event_row_new (ICalComponent* component,
                       ESource* source)
{
	return widgets_event_row_construct (WIDGETS_TYPE_EVENT_ROW, component, source);
}

static void
widgets_event_row_update_timelabel (WidgetsEventRow* self)
{
	GtkLabel* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->time_label;
	_tmp1_ = self->priv->_start_time;
	_tmp2_ = g_date_time_format (_tmp1_, "%I:%M %p");
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf ("%s", _tmp3_);
	_tmp5_ = _tmp4_;
	gtk_label_set_label (_tmp0_, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
}

static void
widgets_event_row_update_color (WidgetsEventRow* self)
{
	Util* _tmp0_;
	Util* _tmp1_;
	ESourceCalendar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkGrid* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = util_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_cal;
	_tmp3_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->color_grid;
	util_set_widget_color (_tmp1_, _tmp4_, (GtkWidget*) _tmp5_);
	_g_free0 (_tmp4_);
	_g_object_unref0 (_tmp1_);
}

ICalComponent*
widgets_event_row_get_component (WidgetsEventRow* self)
{
	ICalComponent* result;
	ICalComponent* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_component;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_component (WidgetsEventRow* self,
                                 ICalComponent* value)
{
	ICalComponent* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_component (self);
	if (old_value != value) {
		self->priv->_component = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_COMPONENT_PROPERTY]);
	}
}

ESourceCalendar*
widgets_event_row_get_cal (WidgetsEventRow* self)
{
	ESourceCalendar* result;
	ESourceCalendar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cal;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_cal (WidgetsEventRow* self,
                           ESourceCalendar* value)
{
	ESourceCalendar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_cal (self);
	if (old_value != value) {
		self->priv->_cal = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_CAL_PROPERTY]);
	}
}

ESource*
widgets_event_row_get_source (WidgetsEventRow* self)
{
	ESource* result;
	ESource* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_source;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
widgets_event_row_set_source (WidgetsEventRow* self,
                              ESource* value)
{
	ESource* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_source (self);
	if (old_value != value) {
		ESource* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_source);
		self->priv->_source = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_SOURCE_PROPERTY]);
	}
}

GDateTime*
widgets_event_row_get_start_time (WidgetsEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_start_time;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
widgets_event_row_set_start_time (WidgetsEventRow* self,
                                  GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_start_time (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_start_time);
		self->priv->_start_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_START_TIME_PROPERTY]);
	}
}

GDateTime*
widgets_event_row_get_end_time (WidgetsEventRow* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_end_time;
	result = _tmp0_;
	return result;
}

static void
widgets_event_row_set_end_time (WidgetsEventRow* self,
                                GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_end_time (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_end_time);
		self->priv->_end_time = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_END_TIME_PROPERTY]);
	}
}

gboolean
widgets_event_row_get_is_allday (WidgetsEventRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_allday;
	return result;
}

static void
widgets_event_row_set_is_allday (WidgetsEventRow* self,
                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_event_row_get_is_allday (self);
	if (old_value != value) {
		self->priv->_is_allday = value;
		g_object_notify_by_pspec ((GObject *) self, widgets_event_row_properties[WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY]);
	}
}

static void
_widgets_event_row_update_color_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
	widgets_event_row_update_color ((WidgetsEventRow*) self);
}

static GObject *
widgets_event_row_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsEventRow * self;
	ICalTime* dt_start = NULL;
	ICalComponent* _tmp0_;
	ICalTime* _tmp1_;
	ICalComponent* _tmp2_;
	ICalTime* _tmp3_;
	ICalTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	ICalTime* _tmp7_;
	ICalTime* dt_end = NULL;
	ICalComponent* _tmp16_;
	ICalTime* _tmp17_;
	ICalTime* _tmp18_;
	gboolean _tmp27_ = FALSE;
	GDateTime* _tmp28_;
	gchar* _tmp31_;
	gchar** _tmp32_;
	GtkGrid* _tmp33_ = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar** _tmp36_;
	GtkLabel* _tmp37_ = NULL;
	GtkLabel* name_label = NULL;
	ICalComponent* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	gchar** _tmp41_;
	GtkLabel* _tmp42_ = NULL;
	GtkBox* grid = NULL;
	GtkBox* _tmp43_ = NULL;
	gboolean _tmp44_;
	GtkBox* _tmp47_;
	GtkGrid* _tmp48_;
	GtkBox* _tmp49_;
	GtkLabel* _tmp50_;
	GtkBox* _tmp51_;
	ESourceCalendar* _tmp52_;
	parent_class = G_OBJECT_CLASS (widgets_event_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	gtk_widget_add_css_class ((GtkWidget*) self, "no-selectable");
	gtk_widget_add_css_class ((GtkWidget*) self, "transition");
	_tmp0_ = self->priv->_component;
	_tmp1_ = i_cal_component_get_dtstart (_tmp0_);
	dt_start = _tmp1_;
	_tmp2_ = self->priv->_component;
	_tmp3_ = i_cal_component_get_dtend (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = calendar_events_util_ical_to_date_time (_tmp4_);
	_tmp6_ = _tmp5_;
	widgets_event_row_set_end_time (self, _tmp6_);
	_g_date_time_unref0 (_tmp6_);
	_g_object_unref0 (_tmp4_);
	_tmp7_ = dt_start;
	if (i_cal_time_is_date (_tmp7_)) {
		ICalTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		_tmp8_ = dt_start;
		_tmp9_ = calendar_events_util_ical_to_date_time (_tmp8_);
		_tmp10_ = _tmp9_;
		widgets_event_row_set_start_time (self, _tmp10_);
		_g_date_time_unref0 (_tmp10_);
	} else {
		ICalTime* _tmp11_;
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		_tmp11_ = dt_start;
		_tmp12_ = calendar_events_util_ical_to_date_time (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_date_time_to_local (_tmp13_);
		_tmp15_ = _tmp14_;
		widgets_event_row_set_start_time (self, _tmp15_);
		_g_date_time_unref0 (_tmp15_);
		_g_date_time_unref0 (_tmp13_);
	}
	_tmp16_ = self->priv->_component;
	_tmp17_ = i_cal_component_get_dtend (_tmp16_);
	dt_end = _tmp17_;
	_tmp18_ = dt_end;
	if (i_cal_time_is_date (_tmp18_)) {
		ICalTime* _tmp19_;
		GDateTime* _tmp20_;
		GDateTime* _tmp21_;
		_tmp19_ = dt_end;
		_tmp20_ = calendar_events_util_ical_to_date_time (_tmp19_);
		_tmp21_ = _tmp20_;
		widgets_event_row_set_end_time (self, _tmp21_);
		_g_date_time_unref0 (_tmp21_);
	} else {
		ICalTime* _tmp22_;
		GDateTime* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp25_;
		GDateTime* _tmp26_;
		_tmp22_ = dt_end;
		_tmp23_ = calendar_events_util_ical_to_date_time (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_date_time_to_local (_tmp24_);
		_tmp26_ = _tmp25_;
		widgets_event_row_set_end_time (self, _tmp26_);
		_g_date_time_unref0 (_tmp26_);
		_g_date_time_unref0 (_tmp24_);
	}
	_tmp28_ = self->priv->_end_time;
	if (_tmp28_ != NULL) {
		GDateTime* _tmp29_;
		GDateTime* _tmp30_;
		_tmp29_ = self->priv->_start_time;
		_tmp30_ = self->priv->_end_time;
		_tmp27_ = calendar_events_util_is_the_all_day (_tmp29_, _tmp30_);
	} else {
		_tmp27_ = FALSE;
	}
	if (_tmp27_) {
		widgets_event_row_set_is_allday (self, TRUE);
	}
	_tmp31_ = g_strdup ("event-bar");
	_tmp32_ = g_new0 (gchar*, 1 + 1);
	_tmp32_[0] = _tmp31_;
	_tmp33_ = (GtkGrid*) gtk_grid_new ();
	g_object_set ((GtkWidget*) _tmp33_, "width-request", 3, NULL);
	g_object_set ((GtkWidget*) _tmp33_, "height-request", 12, NULL);
	gtk_widget_set_valign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp33_, _tmp32_);
	_tmp32_ = (_vala_array_free (_tmp32_, 1, (GDestroyNotify) g_free), NULL);
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (self->priv->color_grid);
	self->priv->color_grid = _tmp33_;
	_tmp34_ = g_strdup ("dim-label");
	_tmp35_ = g_strdup ("caption");
	_tmp36_ = g_new0 (gchar*, 2 + 1);
	_tmp36_[0] = _tmp34_;
	_tmp36_[1] = _tmp35_;
	_tmp37_ = (GtkLabel*) gtk_label_new (NULL);
	gtk_label_set_xalign (_tmp37_, (gfloat) 0);
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
	gtk_label_set_width_chars (_tmp37_, 7);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp37_, _tmp36_);
	_tmp36_ = (_vala_array_free (_tmp36_, 2, (GDestroyNotify) g_free), NULL);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->time_label);
	self->priv->time_label = _tmp37_;
	_tmp38_ = self->priv->_component;
	_tmp39_ = i_cal_component_get_summary (_tmp38_);
	_tmp40_ = g_strdup ("caption");
	_tmp41_ = g_new0 (gchar*, 1 + 1);
	_tmp41_[0] = _tmp40_;
	_tmp42_ = (GtkLabel*) gtk_label_new (_tmp39_);
	gtk_widget_set_valign ((GtkWidget*) _tmp42_, GTK_ALIGN_CENTER);
	gtk_label_set_ellipsize (_tmp42_, PANGO_ELLIPSIZE_END);
	gtk_label_set_wrap (_tmp42_, TRUE);
	gtk_label_set_use_markup (_tmp42_, TRUE);
	gtk_label_set_wrap_mode (_tmp42_, PANGO_WRAP_WORD_CHAR);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp42_, 3);
	gtk_widget_set_css_classes ((GtkWidget*) _tmp42_, _tmp41_);
	_tmp41_ = (_vala_array_free (_tmp41_, 1, (GDestroyNotify) g_free), NULL);
	g_object_ref_sink (_tmp42_);
	name_label = _tmp42_;
	_tmp43_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp43_, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp43_, 3);
	g_object_ref_sink (_tmp43_);
	grid = _tmp43_;
	_tmp44_ = self->priv->_is_allday;
	if (!_tmp44_) {
		GtkBox* _tmp45_;
		GtkLabel* _tmp46_;
		_tmp45_ = grid;
		_tmp46_ = self->priv->time_label;
		gtk_box_append (_tmp45_, (GtkWidget*) _tmp46_);
	}
	_tmp47_ = grid;
	_tmp48_ = self->priv->color_grid;
	gtk_box_append (_tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = grid;
	_tmp50_ = name_label;
	gtk_box_append (_tmp49_, (GtkWidget*) _tmp50_);
	_tmp51_ = grid;
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp51_);
	widgets_event_row_update_color (self);
	_tmp52_ = self->priv->_cal;
	g_signal_connect_object ((GObject*) _tmp52_, "notify::color", (GCallback) _widgets_event_row_update_color_g_object_notify, self, 0);
	widgets_event_row_update_timelabel (self);
	_g_object_unref0 (grid);
	_g_object_unref0 (name_label);
	_g_object_unref0 (dt_end);
	_g_object_unref0 (dt_start);
	return obj;
}

static void
widgets_event_row_class_init (WidgetsEventRowClass * klass,
                              gpointer klass_data)
{
	widgets_event_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsEventRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_event_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_event_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_event_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_event_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_COMPONENT_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_COMPONENT_PROPERTY] = g_param_spec_object ("component", "component", "component", i_cal_component_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_CAL_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_CAL_PROPERTY] = g_param_spec_object ("cal", "cal", "cal", e_source_calendar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_SOURCE_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", e_source_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_START_TIME_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_START_TIME_PROPERTY] = g_param_spec_boxed ("start-time", "start-time", "start-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_END_TIME_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_END_TIME_PROPERTY] = g_param_spec_boxed ("end-time", "end-time", "end-time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY, widgets_event_row_properties[WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY] = g_param_spec_boolean ("is-allday", "is-allday", "is-allday", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
widgets_event_row_instance_init (WidgetsEventRow * self,
                                 gpointer klass)
{
	self->priv = widgets_event_row_get_instance_private (self);
	self->priv->_is_allday = FALSE;
}

static void
widgets_event_row_finalize (GObject * obj)
{
	WidgetsEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	_g_object_unref0 (self->priv->_source);
	_g_date_time_unref0 (self->priv->_start_time);
	_g_date_time_unref0 (self->priv->_end_time);
	_g_object_unref0 (self->priv->color_grid);
	_g_object_unref0 (self->priv->time_label);
	G_OBJECT_CLASS (widgets_event_row_parent_class)->finalize (obj);
}

static GType
widgets_event_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsEventRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_event_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsEventRow), 0, (GInstanceInitFunc) widgets_event_row_instance_init, NULL };
	GType widgets_event_row_type_id;
	widgets_event_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "WidgetsEventRow", &g_define_type_info, 0);
	WidgetsEventRow_private_offset = g_type_add_instance_private (widgets_event_row_type_id, sizeof (WidgetsEventRowPrivate));
	return widgets_event_row_type_id;
}

GType
widgets_event_row_get_type (void)
{
	static volatile gsize widgets_event_row_type_id__once = 0;
	if (g_once_init_enter (&widgets_event_row_type_id__once)) {
		GType widgets_event_row_type_id;
		widgets_event_row_type_id = widgets_event_row_get_type_once ();
		g_once_init_leave (&widgets_event_row_type_id__once, widgets_event_row_type_id);
	}
	return widgets_event_row_type_id__once;
}

static void
_vala_widgets_event_row_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	switch (property_id) {
		case WIDGETS_EVENT_ROW_COMPONENT_PROPERTY:
		g_value_set_object (value, widgets_event_row_get_component (self));
		break;
		case WIDGETS_EVENT_ROW_CAL_PROPERTY:
		g_value_set_object (value, widgets_event_row_get_cal (self));
		break;
		case WIDGETS_EVENT_ROW_SOURCE_PROPERTY:
		g_value_set_object (value, widgets_event_row_get_source (self));
		break;
		case WIDGETS_EVENT_ROW_START_TIME_PROPERTY:
		g_value_set_boxed (value, widgets_event_row_get_start_time (self));
		break;
		case WIDGETS_EVENT_ROW_END_TIME_PROPERTY:
		g_value_set_boxed (value, widgets_event_row_get_end_time (self));
		break;
		case WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY:
		g_value_set_boolean (value, widgets_event_row_get_is_allday (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_event_row_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WidgetsEventRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow);
	switch (property_id) {
		case WIDGETS_EVENT_ROW_COMPONENT_PROPERTY:
		widgets_event_row_set_component (self, g_value_get_object (value));
		break;
		case WIDGETS_EVENT_ROW_CAL_PROPERTY:
		widgets_event_row_set_cal (self, g_value_get_object (value));
		break;
		case WIDGETS_EVENT_ROW_SOURCE_PROPERTY:
		widgets_event_row_set_source (self, g_value_get_object (value));
		break;
		case WIDGETS_EVENT_ROW_START_TIME_PROPERTY:
		widgets_event_row_set_start_time (self, g_value_get_boxed (value));
		break;
		case WIDGETS_EVENT_ROW_END_TIME_PROPERTY:
		widgets_event_row_set_end_time (self, g_value_get_boxed (value));
		break;
		case WIDGETS_EVENT_ROW_IS_ALLDAY_PROPERTY:
		widgets_event_row_set_is_allday (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

