/* Store.c generated by valac 0.56.18, the Vala compiler
 * generated from Store.vala, do not modify */

/*
 * Copyright © 2024 Alain M. (https://github.com/alainm23/planify)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Alain M. <alainmh23@gmail.com>
 */

#include "planify.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERVICES_STORE_0_PROPERTY,
	SERVICES_STORE_SOURCES_PROPERTY,
	SERVICES_STORE_PROJECTS_PROPERTY,
	SERVICES_STORE_SECTIONS_PROPERTY,
	SERVICES_STORE_ITEMS_PROPERTY,
	SERVICES_STORE_LABELS_PROPERTY,
	SERVICES_STORE_REMINDERS_PROPERTY,
	SERVICES_STORE_ATTACHMENTS_PROPERTY,
	SERVICES_STORE_NUM_PROPERTIES
};
static GParamSpec* services_store_properties[SERVICES_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SERVICES_STORE_SOURCE_ADDED_SIGNAL,
	SERVICES_STORE_SOURCE_DELETED_SIGNAL,
	SERVICES_STORE_SOURCE_UPDATED_SIGNAL,
	SERVICES_STORE_PROJECT_ADDED_SIGNAL,
	SERVICES_STORE_PROJECT_UPDATED_SIGNAL,
	SERVICES_STORE_PROJECT_DELETED_SIGNAL,
	SERVICES_STORE_PROJECT_ARCHIVED_SIGNAL,
	SERVICES_STORE_PROJECT_UNARCHIVED_SIGNAL,
	SERVICES_STORE_LABEL_ADDED_SIGNAL,
	SERVICES_STORE_LABEL_UPDATED_SIGNAL,
	SERVICES_STORE_LABEL_DELETED_SIGNAL,
	SERVICES_STORE_SECTION_DELETED_SIGNAL,
	SERVICES_STORE_SECTION_MOVED_SIGNAL,
	SERVICES_STORE_SECTION_ARCHIVED_SIGNAL,
	SERVICES_STORE_SECTION_UNARCHIVED_SIGNAL,
	SERVICES_STORE_ITEM_DELETED_SIGNAL,
	SERVICES_STORE_ITEM_ADDED_SIGNAL,
	SERVICES_STORE_ITEM_UPDATED_SIGNAL,
	SERVICES_STORE_ITEM_ARCHIVED_SIGNAL,
	SERVICES_STORE_ITEM_UNARCHIVED_SIGNAL,
	SERVICES_STORE_ITEM_PIN_CHANGE_SIGNAL,
	SERVICES_STORE_ITEM_LABEL_ADDED_SIGNAL,
	SERVICES_STORE_ITEM_LABEL_DELETED_SIGNAL,
	SERVICES_STORE_REMINDER_ADDED_SIGNAL,
	SERVICES_STORE_REMINDER_DELETED_SIGNAL,
	SERVICES_STORE_ATTACHMENT_DELETED_SIGNAL,
	SERVICES_STORE_NUM_SIGNALS
};
static guint services_store_signals[SERVICES_STORE_NUM_SIGNALS] = {0};

struct _ServicesStorePrivate {
	GeeArrayList* _sources;
	GRecMutex __lock__sources;
	GeeArrayList* _projects;
	GRecMutex __lock__projects;
	GeeArrayList* _sections;
	GRecMutex __lock__sections;
	GeeArrayList* _items;
	GRecMutex __lock__items;
	GeeArrayList* _labels;
	GRecMutex __lock__labels;
	GeeArrayList* _reminders;
	GRecMutex __lock__reminders;
	GeeArrayList* _attachments;
	GRecMutex __lock__attachments;
};

static gint ServicesStore_private_offset;
static gpointer services_store_parent_class = NULL;
static GOnce services_store__instance;
static GOnce services_store__instance = G_ONCE_INIT;

static ServicesStore* __lambda4_ (void);
static gpointer ___lambda4__gthread_func (gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void services_store_finalize (GObject * obj);
static GType services_store_get_type_once (void);
static void _vala_services_store_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
services_store_get_instance_private (ServicesStore* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesStore_private_offset);
}

static ServicesStore*
__lambda4_ (void)
{
	ServicesStore* _tmp0_;
	ServicesStore* result;
	_tmp0_ = services_store_new ();
	result = _tmp0_;
	return result;
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ ();
	return result;
}

ServicesStore*
services_store_instance (void)
{
	gconstpointer _tmp0_;
	ServicesStore* result;
	_tmp0_ = g_once (&services_store__instance, ___lambda4__gthread_func, NULL);
	result = (ServicesStore*) _tmp0_;
	return result;
}

gboolean
services_store_is_database_empty (ServicesStore* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = services_store_get_projects (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_ <= 0;
	return result;
}

gboolean
services_store_is_sources_empty (ServicesStore* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = services_store_get_sources (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_ <= 0;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GeeArrayList*
services_store_get_collection_by_type (ServicesStore* self,
                                       ObjectsBaseObject* base_object)
{
	GeeArrayList* _tmp12_;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (base_object != NULL, NULL);
	if (OBJECTS_IS_PROJECT (base_object)) {
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		_tmp0_ = services_store_get_projects (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		result = _tmp2_;
		return result;
	} else {
		if (OBJECTS_IS_SECTION (base_object)) {
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			GeeArrayList* _tmp5_;
			_tmp3_ = services_store_get_sections (self);
			_tmp4_ = _tmp3_;
			_tmp5_ = _g_object_ref0 (_tmp4_);
			result = _tmp5_;
			return result;
		} else {
			if (OBJECTS_IS_ITEM (base_object)) {
				GeeArrayList* _tmp6_;
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				_tmp6_ = services_store_get_items (self);
				_tmp7_ = _tmp6_;
				_tmp8_ = _g_object_ref0 (_tmp7_);
				result = _tmp8_;
				return result;
			} else {
				if (OBJECTS_IS_LABEL (base_object)) {
					GeeArrayList* _tmp9_;
					GeeArrayList* _tmp10_;
					GeeArrayList* _tmp11_;
					_tmp9_ = services_store_get_labels (self);
					_tmp10_ = _tmp9_;
					_tmp11_ = _g_object_ref0 (_tmp10_);
					result = _tmp11_;
					return result;
				}
			}
		}
	}
	_tmp12_ = gee_array_list_new (OBJECTS_TYPE_BASE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	result = _tmp12_;
	return result;
}

void
services_store_insert_source (ServicesStore* self,
                              ObjectsSource* source)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	ServicesDatabase* _tmp4_;
	ServicesDatabase* _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = services_store_get_sources (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	objects_source_set_child_order (source, _tmp3_ + 1);
	_tmp4_ = services_database_get_default ();
	_tmp5_ = _tmp4_;
	_tmp6_ = services_database_insert_source (_tmp5_, source);
	_g_object_unref0 (_tmp5_);
	if (_tmp6_) {
		GeeArrayList* _tmp7_;
		GeeArrayList* _tmp8_;
		_tmp7_ = services_store_get_sources (self);
		_tmp8_ = _tmp7_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, source);
		g_signal_emit (self, services_store_signals[SERVICES_STORE_SOURCE_ADDED_SIGNAL], 0, source);
	}
}

void
services_store_delete_source (ServicesStore* self,
                              ObjectsSource* source)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_source (_tmp1_, source);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp14_;
		{
			GeeArrayList* _project_list = NULL;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			GeeArrayList* _tmp5_;
			gint _project_size = 0;
			GeeArrayList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _project_index = 0;
			_tmp3_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
			_tmp4_ = _tmp3_;
			_tmp5_ = services_store_get_projects_by_source (self, _tmp4_);
			_project_list = _tmp5_;
			_tmp6_ = _project_list;
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
			_tmp8_ = _tmp7_;
			_project_size = _tmp8_;
			_project_index = -1;
			while (TRUE) {
				gint _tmp9_;
				gint _tmp10_;
				ObjectsProject* project = NULL;
				GeeArrayList* _tmp11_;
				gpointer _tmp12_;
				ObjectsProject* _tmp13_;
				_project_index = _project_index + 1;
				_tmp9_ = _project_index;
				_tmp10_ = _project_size;
				if (!(_tmp9_ < _tmp10_)) {
					break;
				}
				_tmp11_ = _project_list;
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _project_index);
				project = (ObjectsProject*) _tmp12_;
				_tmp13_ = project;
				services_store_delete_project (self, _tmp13_);
				_g_object_unref0 (project);
			}
			_g_object_unref0 (_project_list);
		}
		g_signal_emit_by_name ((ObjectsBaseObject*) source, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_SOURCE_DELETED_SIGNAL], 0, source);
		_tmp14_ = self->priv->_sources;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp14_, source);
	}
}

void
services_store_update_source (ServicesStore* self,
                              ObjectsSource* source)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_source (_tmp1_, source);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		g_signal_emit_by_name ((ObjectsBaseObject*) source, "updated", "");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_SOURCE_UPDATED_SIGNAL], 0, source);
	}
}

ObjectsSource*
services_store_get_source (ServicesStore* self,
                           const gchar* id)
{
	ObjectsSource* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsSource* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_sources;
		g_rec_mutex_lock (&self->priv->__lock__sources);
		{
			ObjectsSource* _tmp15_;
			ObjectsSource* _tmp16_;
			{
				GeeArrayList* _source_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _source_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _source_index = 0;
				_tmp1_ = services_store_get_sources (self);
				_tmp2_ = _tmp1_;
				_source_list = _tmp2_;
				_tmp3_ = _source_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_source_size = _tmp5_;
				_source_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsSource* source = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsSource* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_source_index = _source_index + 1;
					_tmp6_ = _source_index;
					_tmp7_ = _source_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _source_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _source_index);
					source = (ObjectsSource*) _tmp9_;
					_tmp10_ = source;
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, id) == 0) {
						ObjectsSource* _tmp13_;
						ObjectsSource* _tmp14_;
						_tmp13_ = source;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (source);
						break;
					}
					_g_object_unref0 (source);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_sources;
				g_rec_mutex_unlock (&self->priv->__lock__sources);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_sources;
			g_rec_mutex_unlock (&self->priv->__lock__sources);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

gboolean
services_store_source_todoist_exists (ServicesStore* self,
                                      const gchar* email)
{
	gboolean return_value = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (email != NULL, FALSE);
	return_value = FALSE;
	{
		GeeArrayList* _tmp0_;
		gboolean _tmp21_ = FALSE;
		_tmp0_ = self->priv->_sources;
		g_rec_mutex_lock (&self->priv->__lock__sources);
		{
			{
				GeeArrayList* _source_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _source_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _source_index = 0;
				_tmp1_ = services_store_get_sources (self);
				_tmp2_ = _tmp1_;
				_source_list = _tmp2_;
				_tmp3_ = _source_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_source_size = _tmp5_;
				_source_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsSource* source = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					ObjectsSource* _tmp11_;
					SourceType _tmp12_;
					SourceType _tmp13_;
					_source_index = _source_index + 1;
					_tmp6_ = _source_index;
					_tmp7_ = _source_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _source_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _source_index);
					source = (ObjectsSource*) _tmp9_;
					_tmp11_ = source;
					_tmp12_ = objects_source_get_source_type (_tmp11_);
					_tmp13_ = _tmp12_;
					if (_tmp13_ == SOURCE_TYPE_TODOIST) {
						ObjectsSource* _tmp14_;
						ObjectsSourceTodoistData* _tmp15_;
						ObjectsSourceTodoistData* _tmp16_;
						const gchar* _tmp17_;
						const gchar* _tmp18_;
						_tmp14_ = source;
						_tmp15_ = objects_source_get_todoist_data (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp17_ = objects_source_todoist_data_get_user_email (_tmp16_);
						_tmp18_ = _tmp17_;
						_tmp10_ = g_strcmp0 (_tmp18_, email) == 0;
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						return_value = TRUE;
						_g_object_unref0 (source);
						break;
					}
					_g_object_unref0 (source);
				}
			}
			result = return_value;
			{
				GeeArrayList* _tmp19_;
				_tmp19_ = self->priv->_sources;
				g_rec_mutex_unlock (&self->priv->__lock__sources);
			}
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp20_;
			_tmp20_ = self->priv->_sources;
			g_rec_mutex_unlock (&self->priv->__lock__sources);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp21_;
	}
}

gboolean
services_store_source_caldav_exists (ServicesStore* self,
                                     const gchar* server_url,
                                     const gchar* username)
{
	gboolean return_value = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (server_url != NULL, FALSE);
	g_return_val_if_fail (username != NULL, FALSE);
	return_value = FALSE;
	{
		GeeArrayList* _tmp0_;
		gboolean _tmp27_ = FALSE;
		_tmp0_ = self->priv->_sources;
		g_rec_mutex_lock (&self->priv->__lock__sources);
		{
			{
				GeeArrayList* _source_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _source_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _source_index = 0;
				_tmp1_ = services_store_get_sources (self);
				_tmp2_ = _tmp1_;
				_source_list = _tmp2_;
				_tmp3_ = _source_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_source_size = _tmp5_;
				_source_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsSource* source = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					gboolean _tmp11_ = FALSE;
					ObjectsSource* _tmp12_;
					SourceType _tmp13_;
					SourceType _tmp14_;
					_source_index = _source_index + 1;
					_tmp6_ = _source_index;
					_tmp7_ = _source_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _source_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _source_index);
					source = (ObjectsSource*) _tmp9_;
					_tmp12_ = source;
					_tmp13_ = objects_source_get_source_type (_tmp12_);
					_tmp14_ = _tmp13_;
					if (_tmp14_ == SOURCE_TYPE_CALDAV) {
						ObjectsSource* _tmp15_;
						ObjectsSourceCalDAVData* _tmp16_;
						ObjectsSourceCalDAVData* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						_tmp15_ = source;
						_tmp16_ = objects_source_get_caldav_data (_tmp15_);
						_tmp17_ = _tmp16_;
						_tmp18_ = objects_source_cal_dav_data_get_server_url (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp11_ = g_strcmp0 (_tmp19_, server_url) == 0;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						ObjectsSource* _tmp20_;
						ObjectsSourceCalDAVData* _tmp21_;
						ObjectsSourceCalDAVData* _tmp22_;
						const gchar* _tmp23_;
						const gchar* _tmp24_;
						_tmp20_ = source;
						_tmp21_ = objects_source_get_caldav_data (_tmp20_);
						_tmp22_ = _tmp21_;
						_tmp23_ = objects_source_cal_dav_data_get_username (_tmp22_);
						_tmp24_ = _tmp23_;
						_tmp10_ = g_strcmp0 (_tmp24_, username) == 0;
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						return_value = TRUE;
						_g_object_unref0 (source);
						break;
					}
					_g_object_unref0 (source);
				}
			}
			result = return_value;
			{
				GeeArrayList* _tmp25_;
				_tmp25_ = self->priv->_sources;
				g_rec_mutex_unlock (&self->priv->__lock__sources);
			}
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp26_;
			_tmp26_ = self->priv->_sources;
			g_rec_mutex_unlock (&self->priv->__lock__sources);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp27_;
	}
}

void
services_store_insert_project (ServicesStore* self,
                               ObjectsProject* project)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_insert_project (_tmp1_, project);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		ObjectsProject* _tmp5_;
		ObjectsProject* _tmp6_;
		_tmp3_ = services_store_get_projects (self);
		_tmp4_ = _tmp3_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, project);
		_tmp5_ = objects_project_get_parent (project);
		_tmp6_ = _tmp5_;
		if (_tmp6_ == NULL) {
			g_signal_emit (self, services_store_signals[SERVICES_STORE_PROJECT_ADDED_SIGNAL], 0, project);
		} else {
			ObjectsProject* _tmp7_;
			ObjectsProject* _tmp8_;
			_tmp7_ = objects_project_get_parent (project);
			_tmp8_ = _tmp7_;
			g_signal_emit_by_name (_tmp8_, "subproject-added", project);
		}
	}
}

GeeArrayList*
services_store_get_projects_by_source (ServicesStore* self,
                                       const gchar* source_id)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (source_id != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
				_tmp2_ = services_store_get_projects (self);
				_tmp3_ = _tmp2_;
				_project_list = _tmp3_;
				_tmp4_ = _project_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_project_size = _tmp6_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					_project_index = _project_index + 1;
					_tmp7_ = _project_index;
					_tmp8_ = _project_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _project_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
					project = (ObjectsProject*) _tmp10_;
					_tmp11_ = project;
					_tmp12_ = objects_project_get_source_id (_tmp11_);
					_tmp13_ = _tmp12_;
					if (g_strcmp0 (_tmp13_, source_id) == 0) {
						GeeArrayList* _tmp14_;
						ObjectsProject* _tmp15_;
						_tmp14_ = return_value;
						_tmp15_ = project;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
					}
					_g_object_unref0 (project);
				}
			}
			_tmp16_ = return_value;
			_tmp17_ = _g_object_ref0 (_tmp16_);
			result = _tmp17_;
			{
				GeeArrayList* _tmp18_;
				_tmp18_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
			_tmp19_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

void
services_store_delete_project (ServicesStore* self,
                               ObjectsProject* project)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_project (_tmp1_, project);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp30_;
		{
			GeeArrayList* _section_list = NULL;
			GeeArrayList* _tmp3_;
			gint _section_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _section_index = 0;
			_tmp3_ = services_store_get_sections_by_project (self, project);
			_section_list = _tmp3_;
			_tmp4_ = _section_list;
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
			_tmp6_ = _tmp5_;
			_section_size = _tmp6_;
			_section_index = -1;
			while (TRUE) {
				gint _tmp7_;
				gint _tmp8_;
				ObjectsSection* section = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				ObjectsSection* _tmp11_;
				_section_index = _section_index + 1;
				_tmp7_ = _section_index;
				_tmp8_ = _section_size;
				if (!(_tmp7_ < _tmp8_)) {
					break;
				}
				_tmp9_ = _section_list;
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _section_index);
				section = (ObjectsSection*) _tmp10_;
				_tmp11_ = section;
				services_store_delete_section (self, _tmp11_);
				_g_object_unref0 (section);
			}
			_g_object_unref0 (_section_list);
		}
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp12_;
			gint _item_size = 0;
			GeeArrayList* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _item_index = 0;
			_tmp12_ = services_store_get_items_by_project (self, project);
			_item_list = _tmp12_;
			_tmp13_ = _item_list;
			_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
			_tmp15_ = _tmp14_;
			_item_size = _tmp15_;
			_item_index = -1;
			while (TRUE) {
				gint _tmp16_;
				gint _tmp17_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp18_;
				gpointer _tmp19_;
				ObjectsItem* _tmp20_;
				_item_index = _item_index + 1;
				_tmp16_ = _item_index;
				_tmp17_ = _item_size;
				if (!(_tmp16_ < _tmp17_)) {
					break;
				}
				_tmp18_ = _item_list;
				_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _item_index);
				item = (ObjectsItem*) _tmp19_;
				_tmp20_ = item;
				services_store_delete_item (self, _tmp20_);
				_g_object_unref0 (item);
			}
			_g_object_unref0 (_item_list);
		}
		{
			GeeArrayList* _subproject_list = NULL;
			GeeArrayList* _tmp21_;
			gint _subproject_size = 0;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gint _subproject_index = 0;
			_tmp21_ = services_store_get_subprojects (self, project);
			_subproject_list = _tmp21_;
			_tmp22_ = _subproject_list;
			_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
			_tmp24_ = _tmp23_;
			_subproject_size = _tmp24_;
			_subproject_index = -1;
			while (TRUE) {
				gint _tmp25_;
				gint _tmp26_;
				ObjectsProject* subproject = NULL;
				GeeArrayList* _tmp27_;
				gpointer _tmp28_;
				ObjectsProject* _tmp29_;
				_subproject_index = _subproject_index + 1;
				_tmp25_ = _subproject_index;
				_tmp26_ = _subproject_size;
				if (!(_tmp25_ < _tmp26_)) {
					break;
				}
				_tmp27_ = _subproject_list;
				_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _subproject_index);
				subproject = (ObjectsProject*) _tmp28_;
				_tmp29_ = subproject;
				services_store_delete_project (self, _tmp29_);
				_g_object_unref0 (subproject);
			}
			_g_object_unref0 (_subproject_list);
		}
		g_signal_emit_by_name ((ObjectsBaseObject*) project, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_PROJECT_DELETED_SIGNAL], 0, project);
		_tmp30_ = self->priv->_projects;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp30_, project);
	}
}

void
services_store_archive_project (ServicesStore* self,
                                ObjectsProject* project)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_archive_project (_tmp1_, project);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		gboolean _tmp28_;
		gboolean _tmp29_;
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _item_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _item_index = 0;
			_tmp3_ = objects_project_get_items (project);
			_tmp4_ = _tmp3_;
			_item_list = _tmp4_;
			_tmp5_ = _item_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_item_size = _tmp7_;
			_item_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				ObjectsItem* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				_item_index = _item_index + 1;
				_tmp8_ = _item_index;
				_tmp9_ = _item_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _item_list;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
				item = (ObjectsItem*) _tmp11_;
				_tmp12_ = item;
				_tmp13_ = objects_project_get_is_archived (project);
				_tmp14_ = _tmp13_;
				services_store_archive_item (self, _tmp12_, _tmp14_);
				_g_object_unref0 (item);
			}
		}
		{
			GeeArrayList* _section_list = NULL;
			GeeArrayList* _tmp15_;
			GeeArrayList* _tmp16_;
			gint _section_size = 0;
			GeeArrayList* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _section_index = 0;
			_tmp15_ = objects_project_get_sections (project);
			_tmp16_ = _tmp15_;
			_section_list = _tmp16_;
			_tmp17_ = _section_list;
			_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
			_tmp19_ = _tmp18_;
			_section_size = _tmp19_;
			_section_index = -1;
			while (TRUE) {
				gint _tmp20_;
				gint _tmp21_;
				ObjectsSection* section = NULL;
				GeeArrayList* _tmp22_;
				gpointer _tmp23_;
				ObjectsSection* _tmp24_;
				gboolean _tmp25_;
				gboolean _tmp26_;
				ObjectsSection* _tmp27_;
				_section_index = _section_index + 1;
				_tmp20_ = _section_index;
				_tmp21_ = _section_size;
				if (!(_tmp20_ < _tmp21_)) {
					break;
				}
				_tmp22_ = _section_list;
				_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _section_index);
				section = (ObjectsSection*) _tmp23_;
				_tmp24_ = section;
				_tmp25_ = objects_project_get_is_archived (project);
				_tmp26_ = _tmp25_;
				objects_section_set_is_archived (_tmp24_, _tmp26_);
				_tmp27_ = section;
				services_store_archive_section (self, _tmp27_);
				_g_object_unref0 (section);
			}
		}
		_tmp28_ = objects_project_get_is_archived (project);
		_tmp29_ = _tmp28_;
		if (_tmp29_) {
			g_signal_emit_by_name ((ObjectsBaseObject*) project, "archived");
			g_signal_emit (self, services_store_signals[SERVICES_STORE_PROJECT_ARCHIVED_SIGNAL], 0, project);
		} else {
			g_signal_emit_by_name ((ObjectsBaseObject*) project, "unarchived");
			g_signal_emit (self, services_store_signals[SERVICES_STORE_PROJECT_UNARCHIVED_SIGNAL], 0, project);
		}
	}
}

void
services_store_update_project (ServicesStore* self,
                               ObjectsProject* project)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_project (_tmp1_, project);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		g_signal_emit_by_name ((ObjectsBaseObject*) project, "updated", "");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_PROJECT_UPDATED_SIGNAL], 0, project);
	}
}

void
services_store_update_project_id (ServicesStore* self,
                                  const gchar* current_id,
                                  const gchar* new_id)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_id != NULL);
	g_return_if_fail (new_id != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_project_id (_tmp1_, current_id, new_id);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		ObjectsProject* project = NULL;
		ObjectsProject* _tmp3_;
		ObjectsProject* _tmp4_;
		ServicesDatabase* _tmp6_;
		ServicesDatabase* _tmp7_;
		gboolean _tmp8_;
		_tmp3_ = services_store_get_project (self, current_id);
		project = _tmp3_;
		_tmp4_ = project;
		if (_tmp4_ != NULL) {
			ObjectsProject* _tmp5_;
			_tmp5_ = project;
			objects_base_object_set_id ((ObjectsBaseObject*) _tmp5_, new_id);
		}
		_tmp6_ = services_database_get_default ();
		_tmp7_ = _tmp6_;
		_tmp8_ = services_database_update_project_section_id (_tmp7_, current_id, new_id);
		_g_object_unref0 (_tmp7_);
		if (_tmp8_) {
			ServicesDatabase* _tmp22_;
			ServicesDatabase* _tmp23_;
			gboolean _tmp24_;
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp9_;
				GeeArrayList* _tmp10_;
				gint _section_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _section_index = 0;
				_tmp9_ = services_store_get_sections (self);
				_tmp10_ = _tmp9_;
				_section_list = _tmp10_;
				_tmp11_ = _section_list;
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
				_tmp13_ = _tmp12_;
				_section_size = _tmp13_;
				_section_index = -1;
				while (TRUE) {
					gint _tmp14_;
					gint _tmp15_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp16_;
					gpointer _tmp17_;
					ObjectsSection* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					_section_index = _section_index + 1;
					_tmp14_ = _section_index;
					_tmp15_ = _section_size;
					if (!(_tmp14_ < _tmp15_)) {
						break;
					}
					_tmp16_ = _section_list;
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _section_index);
					section = (ObjectsSection*) _tmp17_;
					_tmp18_ = section;
					_tmp19_ = objects_section_get_project_id (_tmp18_);
					_tmp20_ = _tmp19_;
					if (g_strcmp0 (_tmp20_, current_id) == 0) {
						ObjectsSection* _tmp21_;
						_tmp21_ = section;
						objects_section_set_project_id (_tmp21_, new_id);
					}
					_g_object_unref0 (section);
				}
			}
			_tmp22_ = services_database_get_default ();
			_tmp23_ = _tmp22_;
			_tmp24_ = services_database_update_project_item_id (_tmp23_, current_id, new_id);
			_g_object_unref0 (_tmp23_);
			if (_tmp24_) {
				{
					GeeArrayList* _item_list = NULL;
					GeeArrayList* _tmp25_;
					GeeArrayList* _tmp26_;
					gint _item_size = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _item_index = 0;
					_tmp25_ = services_store_get_items (self);
					_tmp26_ = _tmp25_;
					_item_list = _tmp26_;
					_tmp27_ = _item_list;
					_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
					_tmp29_ = _tmp28_;
					_item_size = _tmp29_;
					_item_index = -1;
					while (TRUE) {
						gint _tmp30_;
						gint _tmp31_;
						ObjectsItem* item = NULL;
						GeeArrayList* _tmp32_;
						gpointer _tmp33_;
						ObjectsItem* _tmp34_;
						const gchar* _tmp35_;
						const gchar* _tmp36_;
						_item_index = _item_index + 1;
						_tmp30_ = _item_index;
						_tmp31_ = _item_size;
						if (!(_tmp30_ < _tmp31_)) {
							break;
						}
						_tmp32_ = _item_list;
						_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _item_index);
						item = (ObjectsItem*) _tmp33_;
						_tmp34_ = item;
						_tmp35_ = objects_item_get_project_id (_tmp34_);
						_tmp36_ = _tmp35_;
						if (g_strcmp0 (_tmp36_, current_id) == 0) {
							ObjectsItem* _tmp37_;
							_tmp37_ = item;
							objects_item_set_project_id (_tmp37_, new_id);
						}
						_g_object_unref0 (item);
					}
				}
			}
		}
		_g_object_unref0 (project);
	}
}

ObjectsProject*
services_store_get_inbox_project (ServicesStore* self)
{
	ObjectsProject* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsProject* result;
	g_return_val_if_fail (self != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			ObjectsProject* _tmp15_;
			ObjectsProject* _tmp16_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _project_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _project_index = 0;
				_tmp1_ = services_store_get_projects (self);
				_tmp2_ = _tmp1_;
				_project_list = _tmp2_;
				_tmp3_ = _project_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_project_size = _tmp5_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsProject* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_project_index = _project_index + 1;
					_tmp6_ = _project_index;
					_tmp7_ = _project_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _project_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _project_index);
					project = (ObjectsProject*) _tmp9_;
					_tmp10_ = project;
					_tmp11_ = objects_project_get_is_inbox_project (_tmp10_);
					_tmp12_ = _tmp11_;
					if (_tmp12_) {
						ObjectsProject* _tmp13_;
						ObjectsProject* _tmp14_;
						_tmp13_ = project;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (project);
						break;
					}
					_g_object_unref0 (project);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

ObjectsProject*
services_store_get_project (ServicesStore* self,
                            const gchar* id)
{
	ObjectsProject* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsProject* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			ObjectsProject* _tmp15_;
			ObjectsProject* _tmp16_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _project_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _project_index = 0;
				_tmp1_ = services_store_get_projects (self);
				_tmp2_ = _tmp1_;
				_project_list = _tmp2_;
				_tmp3_ = _project_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_project_size = _tmp5_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsProject* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_project_index = _project_index + 1;
					_tmp6_ = _project_index;
					_tmp7_ = _project_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _project_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _project_index);
					project = (ObjectsProject*) _tmp9_;
					_tmp10_ = project;
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, id) == 0) {
						ObjectsProject* _tmp13_;
						ObjectsProject* _tmp14_;
						_tmp13_ = project;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (project);
						break;
					}
					_g_object_unref0 (project);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_subprojects (ServicesStore* self,
                                ObjectsProject* _project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (_project != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
				_tmp2_ = services_store_get_projects (self);
				_tmp3_ = _tmp2_;
				_project_list = _tmp3_;
				_tmp4_ = _project_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_project_size = _tmp6_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_project_index = _project_index + 1;
					_tmp7_ = _project_index;
					_tmp8_ = _project_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _project_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
					project = (ObjectsProject*) _tmp10_;
					_tmp11_ = project;
					_tmp12_ = objects_project_get_parent_id (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) _project);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
						GeeArrayList* _tmp16_;
						ObjectsProject* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = project;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (project);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (return_value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = return_value;
	return result;
}

gint
services_store_next_project_child_order (ServicesStore* self,
                                         ObjectsSource* source)
{
	gint child_order = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (source != NULL, 0);
	child_order = 0;
	{
		GeeArrayList* _tmp0_;
		gint _tmp22_ = -1;
		_tmp0_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _project_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _project_index = 0;
				_tmp1_ = services_store_get_projects (self);
				_tmp2_ = _tmp1_;
				_project_list = _tmp2_;
				_tmp3_ = _project_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_project_size = _tmp5_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					ObjectsProject* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_project_index = _project_index + 1;
					_tmp6_ = _project_index;
					_tmp7_ = _project_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _project_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _project_index);
					project = (ObjectsProject*) _tmp9_;
					_tmp11_ = project;
					_tmp12_ = objects_project_get_source_id (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) source);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
						ObjectsProject* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
						_tmp16_ = project;
						_tmp17_ = objects_project_get_is_deleted (_tmp16_);
						_tmp18_ = _tmp17_;
						_tmp10_ = !_tmp18_;
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						gint _tmp19_;
						_tmp19_ = child_order;
						child_order = _tmp19_ + 1;
					}
					_g_object_unref0 (project);
				}
			}
			result = child_order;
			{
				GeeArrayList* _tmp20_;
				_tmp20_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
			_tmp21_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp22_;
	}
}

void
services_store_insert_section (ServicesStore* self,
                               ObjectsSection* section)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_insert_section (_tmp1_, section);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		ObjectsProject* _tmp5_;
		ObjectsProject* _tmp6_;
		_tmp3_ = services_store_get_sections (self);
		_tmp4_ = _tmp3_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, section);
		_tmp5_ = objects_section_get_project (section);
		_tmp6_ = _tmp5_;
		g_signal_emit_by_name (_tmp6_, "section-added", section);
	}
}

void
services_store_update_section (ServicesStore* self,
                               ObjectsSection* section)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_section (_tmp1_, section);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		g_signal_emit_by_name ((ObjectsBaseObject*) section, "updated", "");
	}
}

void
services_store_delete_section (ServicesStore* self,
                               ObjectsSection* section)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_section (_tmp1_, section);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp13_;
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _item_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _item_index = 0;
			_tmp3_ = objects_section_get_items (section);
			_tmp4_ = _tmp3_;
			_item_list = _tmp4_;
			_tmp5_ = _item_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_item_size = _tmp7_;
			_item_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				ObjectsItem* _tmp12_;
				_item_index = _item_index + 1;
				_tmp8_ = _item_index;
				_tmp9_ = _item_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _item_list;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
				item = (ObjectsItem*) _tmp11_;
				_tmp12_ = item;
				services_store_delete_item (self, _tmp12_);
				_g_object_unref0 (item);
			}
		}
		g_signal_emit_by_name ((ObjectsBaseObject*) section, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_SECTION_DELETED_SIGNAL], 0, section);
		_tmp13_ = self->priv->_sections;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp13_, section);
	}
}

void
services_store_move_section (ServicesStore* self,
                             ObjectsSection* section,
                             const gchar* old_project_id)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	g_return_if_fail (old_project_id != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_move_section (_tmp1_, section, old_project_id);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		ServicesDatabase* _tmp3_;
		ServicesDatabase* _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = services_database_get_default ();
		_tmp4_ = _tmp3_;
		_tmp5_ = services_database_move_section_items (_tmp4_, section);
		_g_object_unref0 (_tmp4_);
		if (_tmp5_) {
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp6_;
				GeeArrayList* _tmp7_;
				gint _item_size = 0;
				GeeArrayList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gint _item_index = 0;
				_tmp6_ = objects_section_get_items (section);
				_tmp7_ = _tmp6_;
				_item_list = _tmp7_;
				_tmp8_ = _item_list;
				_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
				_tmp10_ = _tmp9_;
				_item_size = _tmp10_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp11_;
					gint _tmp12_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp13_;
					gpointer _tmp14_;
					ObjectsItem* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					_item_index = _item_index + 1;
					_tmp11_ = _item_index;
					_tmp12_ = _item_size;
					if (!(_tmp11_ < _tmp12_)) {
						break;
					}
					_tmp13_ = _item_list;
					_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _item_index);
					item = (ObjectsItem*) _tmp14_;
					_tmp15_ = item;
					_tmp16_ = objects_section_get_project_id (section);
					_tmp17_ = _tmp16_;
					objects_item_set_project_id (_tmp15_, _tmp17_);
					_g_object_unref0 (item);
				}
			}
			g_signal_emit (self, services_store_signals[SERVICES_STORE_SECTION_MOVED_SIGNAL], 0, section, old_project_id);
		}
	}
}

void
services_store_update_section_id (ServicesStore* self,
                                  const gchar* current_id,
                                  const gchar* new_id)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_id != NULL);
	g_return_if_fail (new_id != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_section_id (_tmp1_, current_id, new_id);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		ServicesDatabase* _tmp16_;
		ServicesDatabase* _tmp17_;
		gboolean _tmp18_;
		{
			GeeArrayList* _section_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _section_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _section_index = 0;
			_tmp3_ = services_store_get_sections (self);
			_tmp4_ = _tmp3_;
			_section_list = _tmp4_;
			_tmp5_ = _section_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_section_size = _tmp7_;
			_section_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				ObjectsSection* section = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				ObjectsSection* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				_section_index = _section_index + 1;
				_tmp8_ = _section_index;
				_tmp9_ = _section_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _section_list;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _section_index);
				section = (ObjectsSection*) _tmp11_;
				_tmp12_ = section;
				_tmp13_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp12_);
				_tmp14_ = _tmp13_;
				if (g_strcmp0 (_tmp14_, current_id) == 0) {
					ObjectsSection* _tmp15_;
					_tmp15_ = section;
					objects_base_object_set_id ((ObjectsBaseObject*) _tmp15_, new_id);
				}
				_g_object_unref0 (section);
			}
		}
		_tmp16_ = services_database_get_default ();
		_tmp17_ = _tmp16_;
		_tmp18_ = services_database_update_section_item_id (_tmp17_, current_id, new_id);
		_g_object_unref0 (_tmp17_);
		if (_tmp18_) {
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp19_;
				GeeArrayList* _tmp20_;
				gint _item_size = 0;
				GeeArrayList* _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				gint _item_index = 0;
				_tmp19_ = services_store_get_items (self);
				_tmp20_ = _tmp19_;
				_item_list = _tmp20_;
				_tmp21_ = _item_list;
				_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
				_tmp23_ = _tmp22_;
				_item_size = _tmp23_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp24_;
					gint _tmp25_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp26_;
					gpointer _tmp27_;
					ObjectsItem* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					_item_index = _item_index + 1;
					_tmp24_ = _item_index;
					_tmp25_ = _item_size;
					if (!(_tmp24_ < _tmp25_)) {
						break;
					}
					_tmp26_ = _item_list;
					_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _item_index);
					item = (ObjectsItem*) _tmp27_;
					_tmp28_ = item;
					_tmp29_ = objects_item_get_section_id (_tmp28_);
					_tmp30_ = _tmp29_;
					if (g_strcmp0 (_tmp30_, current_id) == 0) {
						ObjectsItem* _tmp31_;
						_tmp31_ = item;
						objects_item_set_section_id (_tmp31_, new_id);
					}
					_g_object_unref0 (item);
				}
			}
		}
	}
}

void
services_store_archive_section (ServicesStore* self,
                                ObjectsSection* section)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (section != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_archive_section (_tmp1_, section);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		gboolean _tmp15_;
		gboolean _tmp16_;
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _item_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _item_index = 0;
			_tmp3_ = objects_section_get_items (section);
			_tmp4_ = _tmp3_;
			_item_list = _tmp4_;
			_tmp5_ = _item_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_item_size = _tmp7_;
			_item_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				ObjectsItem* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				_item_index = _item_index + 1;
				_tmp8_ = _item_index;
				_tmp9_ = _item_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _item_list;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
				item = (ObjectsItem*) _tmp11_;
				_tmp12_ = item;
				_tmp13_ = objects_section_get_is_archived (section);
				_tmp14_ = _tmp13_;
				services_store_archive_item (self, _tmp12_, _tmp14_);
				_g_object_unref0 (item);
			}
		}
		_tmp15_ = objects_section_get_is_archived (section);
		_tmp16_ = _tmp15_;
		if (_tmp16_) {
			g_signal_emit_by_name ((ObjectsBaseObject*) section, "archived");
			g_signal_emit (self, services_store_signals[SERVICES_STORE_SECTION_ARCHIVED_SIGNAL], 0, section);
		} else {
			g_signal_emit_by_name ((ObjectsBaseObject*) section, "unarchived");
			g_signal_emit (self, services_store_signals[SERVICES_STORE_SECTION_UNARCHIVED_SIGNAL], 0, section);
		}
	}
}

GeeArrayList*
services_store_get_sections_by_project (ServicesStore* self,
                                        ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_sections;
		g_rec_mutex_lock (&self->priv->__lock__sections);
		{
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _section_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _section_index = 0;
				_tmp2_ = services_store_get_sections (self);
				_tmp3_ = _tmp2_;
				_section_list = _tmp3_;
				_tmp4_ = _section_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_section_size = _tmp6_;
				_section_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsSection* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_section_index = _section_index + 1;
					_tmp7_ = _section_index;
					_tmp8_ = _section_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _section_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _section_index);
					section = (ObjectsSection*) _tmp10_;
					_tmp11_ = section;
					_tmp12_ = objects_section_get_project_id (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
						GeeArrayList* _tmp16_;
						ObjectsSection* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = section;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (section);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_sections;
			g_rec_mutex_unlock (&self->priv->__lock__sections);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (return_value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = return_value;
	return result;
}

GeeArrayList*
services_store_get_sections_archived_by_project (ServicesStore* self,
                                                 ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_sections;
		g_rec_mutex_lock (&self->priv->__lock__sections);
		{
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _section_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _section_index = 0;
				_tmp2_ = services_store_get_sections (self);
				_tmp3_ = _tmp2_;
				_section_list = _tmp3_;
				_tmp4_ = _section_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_section_size = _tmp6_;
				_section_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsSection* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					_section_index = _section_index + 1;
					_tmp7_ = _section_index;
					_tmp8_ = _section_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _section_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _section_index);
					section = (ObjectsSection*) _tmp10_;
					_tmp12_ = section;
					_tmp13_ = objects_section_get_project_id (_tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
					_tmp16_ = _tmp15_;
					if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
						ObjectsSection* _tmp17_;
						_tmp17_ = section;
						_tmp11_ = objects_section_was_archived (_tmp17_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp18_;
						ObjectsSection* _tmp19_;
						_tmp18_ = return_value;
						_tmp19_ = section;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
					}
					_g_object_unref0 (section);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp20_;
			_tmp20_ = self->priv->_sections;
			g_rec_mutex_unlock (&self->priv->__lock__sections);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (return_value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = return_value;
	return result;
}

ObjectsSection*
services_store_get_section (ServicesStore* self,
                            const gchar* id)
{
	ObjectsSection* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsSection* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_sections;
		g_rec_mutex_lock (&self->priv->__lock__sections);
		{
			ObjectsSection* _tmp15_;
			ObjectsSection* _tmp16_;
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _section_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _section_index = 0;
				_tmp1_ = services_store_get_sections (self);
				_tmp2_ = _tmp1_;
				_section_list = _tmp2_;
				_tmp3_ = _section_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_section_size = _tmp5_;
				_section_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsSection* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_section_index = _section_index + 1;
					_tmp6_ = _section_index;
					_tmp7_ = _section_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _section_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _section_index);
					section = (ObjectsSection*) _tmp9_;
					_tmp10_ = section;
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, id) == 0) {
						ObjectsSection* _tmp13_;
						ObjectsSection* _tmp14_;
						_tmp13_ = section;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (section);
						break;
					}
					_g_object_unref0 (section);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_sections;
				g_rec_mutex_unlock (&self->priv->__lock__sections);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_sections;
			g_rec_mutex_unlock (&self->priv->__lock__sections);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

void
services_store_insert_item (ServicesStore* self,
                            ObjectsItem* item,
                            gboolean insert)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_insert_item (_tmp1_, item, insert);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		services_store_add_item (self, item, insert);
	}
}

void
services_store_add_item (ServicesStore* self,
                         ObjectsItem* item,
                         gboolean insert)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	ServicesEventBus* _tmp12_;
	ServicesEventBus* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = services_store_get_items (self);
	_tmp1_ = _tmp0_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, item);
	g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_ADDED_SIGNAL], 0, item, insert);
	if (insert) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = objects_item_get_parent_id (item);
		_tmp3_ = _tmp2_;
		if (g_strcmp0 (_tmp3_, "") != 0) {
			ObjectsItem* _tmp4_;
			ObjectsItem* _tmp5_;
			_tmp4_ = objects_item_get_parent (item);
			_tmp5_ = _tmp4_;
			g_signal_emit_by_name (_tmp5_, "item-added", item);
		} else {
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			_tmp6_ = objects_item_get_section_id (item);
			_tmp7_ = _tmp6_;
			if (g_strcmp0 (_tmp7_, "") == 0) {
				ObjectsProject* _tmp8_;
				ObjectsProject* _tmp9_;
				_tmp8_ = objects_item_get_project (item);
				_tmp9_ = _tmp8_;
				g_signal_emit_by_name (_tmp9_, "item-added", item);
			} else {
				ObjectsSection* _tmp10_;
				ObjectsSection* _tmp11_;
				_tmp10_ = objects_item_get_section (item);
				_tmp11_ = _tmp10_;
				g_signal_emit_by_name (_tmp11_, "item-added", item);
			}
		}
	}
	_tmp12_ = services_event_bus_get_default ();
	_tmp13_ = _tmp12_;
	_tmp14_ = objects_item_get_project_id (item);
	_tmp15_ = _tmp14_;
	_tmp16_ = objects_item_get_section_id (item);
	_tmp17_ = _tmp16_;
	g_signal_emit_by_name (_tmp13_, "update-items-position", _tmp15_, _tmp17_);
	_g_object_unref0 (_tmp13_);
}

void
services_store_update_item (ServicesStore* self,
                            ObjectsItem* item,
                            const gchar* update_id)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	g_return_if_fail (update_id != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_item (_tmp1_, item, update_id);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "updated", update_id);
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_UPDATED_SIGNAL], 0, item, update_id);
	}
}

void
services_store_update_item_pin (ServicesStore* self,
                                ObjectsItem* item)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_item (_tmp1_, item, "");
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_PIN_CHANGE_SIGNAL], 0, item);
		g_signal_emit_by_name (item, "pin-updated");
	}
}

void
services_store_delete_item (ServicesStore* self,
                            ObjectsItem* item)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_item (_tmp1_, item);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp12_;
		ObjectsProject* _tmp13_;
		ObjectsProject* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		{
			GeeArrayList* _subitem_list = NULL;
			GeeArrayList* _tmp3_;
			gint _subitem_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _subitem_index = 0;
			_tmp3_ = services_store_get_subitems (self, item);
			_subitem_list = _tmp3_;
			_tmp4_ = _subitem_list;
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
			_tmp6_ = _tmp5_;
			_subitem_size = _tmp6_;
			_subitem_index = -1;
			while (TRUE) {
				gint _tmp7_;
				gint _tmp8_;
				ObjectsItem* subitem = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				ObjectsItem* _tmp11_;
				_subitem_index = _subitem_index + 1;
				_tmp7_ = _subitem_index;
				_tmp8_ = _subitem_size;
				if (!(_tmp7_ < _tmp8_)) {
					break;
				}
				_tmp9_ = _subitem_list;
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _subitem_index);
				subitem = (ObjectsItem*) _tmp10_;
				_tmp11_ = subitem;
				services_store_delete_item (self, _tmp11_);
				_g_object_unref0 (subitem);
			}
			_g_object_unref0 (_subitem_list);
		}
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_DELETED_SIGNAL], 0, item);
		_tmp12_ = self->priv->_items;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp12_, item);
		_tmp13_ = objects_item_get_project (item);
		_tmp14_ = _tmp13_;
		g_signal_emit_by_name (_tmp14_, "item-deleted", item);
		_tmp15_ = objects_item_get_has_section (item);
		_tmp16_ = _tmp15_;
		if (_tmp16_) {
			ObjectsSection* _tmp17_;
			ObjectsSection* _tmp18_;
			_tmp17_ = objects_item_get_section (item);
			_tmp18_ = _tmp17_;
			g_signal_emit_by_name (_tmp18_, "item-deleted", item);
		}
	}
}

void
services_store_move_item (ServicesStore* self,
                          ObjectsItem* item,
                          const gchar* old_section_id,
                          const gchar* old_parent_id)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	g_return_if_fail (old_section_id != NULL);
	g_return_if_fail (old_parent_id != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_move_item (_tmp1_, item);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		ObjectsSection* _tmp17_;
		ObjectsSection* _tmp18_;
		ObjectsSection* _tmp19_;
		ObjectsSection* _tmp20_;
		{
			GeeArrayList* _subitem_list = NULL;
			GeeArrayList* _tmp3_;
			gint _subitem_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _subitem_index = 0;
			_tmp3_ = services_store_get_subitems (self, item);
			_subitem_list = _tmp3_;
			_tmp4_ = _subitem_list;
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
			_tmp6_ = _tmp5_;
			_subitem_size = _tmp6_;
			_subitem_index = -1;
			while (TRUE) {
				gint _tmp7_;
				gint _tmp8_;
				ObjectsItem* subitem = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				ObjectsItem* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				ObjectsItem* _tmp14_;
				_subitem_index = _subitem_index + 1;
				_tmp7_ = _subitem_index;
				_tmp8_ = _subitem_size;
				if (!(_tmp7_ < _tmp8_)) {
					break;
				}
				_tmp9_ = _subitem_list;
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _subitem_index);
				subitem = (ObjectsItem*) _tmp10_;
				_tmp11_ = subitem;
				_tmp12_ = objects_item_get_project_id (item);
				_tmp13_ = _tmp12_;
				objects_item_set_project_id (_tmp11_, _tmp13_);
				_tmp14_ = subitem;
				services_store_move_item (self, _tmp14_, "", "");
				_g_object_unref0 (subitem);
			}
			_g_object_unref0 (_subitem_list);
		}
		_tmp15_ = objects_item_get_section_id (item);
		_tmp16_ = _tmp15_;
		_tmp17_ = services_store_get_section (self, _tmp16_);
		_tmp18_ = _tmp17_;
		objects_section_update_count (_tmp18_);
		_g_object_unref0 (_tmp18_);
		_tmp19_ = services_store_get_section (self, old_section_id);
		_tmp20_ = _tmp19_;
		objects_section_update_count (_tmp20_);
		_g_object_unref0 (_tmp20_);
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "updated", "");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_UPDATED_SIGNAL], 0, item, "");
	}
}

void
services_store_complete_item (ServicesStore* self,
                              ObjectsItem* item,
                              gboolean old_checked,
                              gboolean complete_subitems)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_complete_item (_tmp1_, item, old_checked);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		ServicesEventBus* _tmp18_;
		ServicesEventBus* _tmp19_;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_;
		gboolean _tmp22_;
		if (complete_subitems) {
			{
				GeeArrayList* _subitem_list = NULL;
				GeeArrayList* _tmp3_;
				gint _subitem_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _subitem_index = 0;
				_tmp3_ = services_store_get_subitems (self, item);
				_subitem_list = _tmp3_;
				_tmp4_ = _subitem_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_subitem_size = _tmp6_;
				_subitem_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* subitem = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
					ObjectsItem* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					ObjectsItem* _tmp17_;
					_subitem_index = _subitem_index + 1;
					_tmp7_ = _subitem_index;
					_tmp8_ = _subitem_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _subitem_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _subitem_index);
					subitem = (ObjectsItem*) _tmp10_;
					_tmp11_ = subitem;
					_tmp12_ = objects_item_get_checked (item);
					_tmp13_ = _tmp12_;
					objects_item_set_checked (_tmp11_, _tmp13_);
					_tmp14_ = subitem;
					_tmp15_ = objects_item_get_completed_at (item);
					_tmp16_ = _tmp15_;
					objects_item_set_completed_at (_tmp14_, _tmp16_);
					_tmp17_ = subitem;
					services_store_complete_item (self, _tmp17_, old_checked, TRUE);
					_g_object_unref0 (subitem);
				}
				_g_object_unref0 (_subitem_list);
			}
		}
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "updated", "");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_UPDATED_SIGNAL], 0, item, "");
		_tmp18_ = services_event_bus_get_default ();
		_tmp19_ = _tmp18_;
		g_signal_emit_by_name (_tmp19_, "checked-toggled", item, old_checked);
		_g_object_unref0 (_tmp19_);
		_tmp21_ = objects_item_get_has_parent (item);
		_tmp22_ = _tmp21_;
		if (_tmp22_) {
			gboolean _tmp23_;
			gboolean _tmp24_;
			_tmp23_ = objects_item_get_checked (item);
			_tmp24_ = _tmp23_;
			_tmp20_ = !_tmp24_;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			ObjectsItem* _tmp25_;
			ObjectsItem* _tmp26_;
			gboolean _tmp27_;
			gboolean _tmp28_;
			ObjectsItem* _tmp29_;
			ObjectsItem* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			ObjectsItem* _tmp33_;
			ObjectsItem* _tmp34_;
			_tmp25_ = objects_item_get_parent (item);
			_tmp26_ = _tmp25_;
			_tmp27_ = objects_item_get_checked (item);
			_tmp28_ = _tmp27_;
			objects_item_set_checked (_tmp26_, _tmp28_);
			_tmp29_ = objects_item_get_parent (item);
			_tmp30_ = _tmp29_;
			_tmp31_ = objects_item_get_completed_at (item);
			_tmp32_ = _tmp31_;
			objects_item_set_completed_at (_tmp30_, _tmp32_);
			_tmp33_ = objects_item_get_parent (item);
			_tmp34_ = _tmp33_;
			services_store_complete_item (self, _tmp34_, old_checked, FALSE);
		}
	}
}

void
services_store_archive_item (ServicesStore* self,
                             ObjectsItem* item,
                             gboolean is_archived)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	if (is_archived) {
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "archived");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_ARCHIVED_SIGNAL], 0, item);
	} else {
		g_signal_emit_by_name ((ObjectsBaseObject*) item, "unarchived");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ITEM_UNARCHIVED_SIGNAL], 0, item);
	}
	{
		GeeArrayList* _subitem_list = NULL;
		GeeArrayList* _tmp0_;
		gint _subitem_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _subitem_index = 0;
		_tmp0_ = services_store_get_subitems (self, item);
		_subitem_list = _tmp0_;
		_tmp1_ = _subitem_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_subitem_size = _tmp3_;
		_subitem_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ObjectsItem* subitem = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			ObjectsItem* _tmp8_;
			_subitem_index = _subitem_index + 1;
			_tmp4_ = _subitem_index;
			_tmp5_ = _subitem_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _subitem_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _subitem_index);
			subitem = (ObjectsItem*) _tmp7_;
			_tmp8_ = subitem;
			services_store_archive_item (self, _tmp8_, is_archived);
			_g_object_unref0 (subitem);
		}
		_g_object_unref0 (_subitem_list);
	}
}

void
services_store_update_item_id (ServicesStore* self,
                               const gchar* current_id,
                               const gchar* new_id)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_id != NULL);
	g_return_if_fail (new_id != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_item_id (_tmp1_, current_id, new_id);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		ServicesDatabase* _tmp16_;
		ServicesDatabase* _tmp17_;
		gboolean _tmp18_;
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _item_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _item_index = 0;
			_tmp3_ = services_store_get_items (self);
			_tmp4_ = _tmp3_;
			_item_list = _tmp4_;
			_tmp5_ = _item_list;
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_item_size = _tmp7_;
			_item_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				ObjectsItem* item = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				ObjectsItem* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				_item_index = _item_index + 1;
				_tmp8_ = _item_index;
				_tmp9_ = _item_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _item_list;
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
				item = (ObjectsItem*) _tmp11_;
				_tmp12_ = item;
				_tmp13_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp12_);
				_tmp14_ = _tmp13_;
				if (g_strcmp0 (_tmp14_, current_id) == 0) {
					ObjectsItem* _tmp15_;
					_tmp15_ = item;
					objects_base_object_set_id ((ObjectsBaseObject*) _tmp15_, new_id);
				}
				_g_object_unref0 (item);
			}
		}
		_tmp16_ = services_database_get_default ();
		_tmp17_ = _tmp16_;
		_tmp18_ = services_database_update_item_child_id (_tmp17_, current_id, new_id);
		_g_object_unref0 (_tmp17_);
		if (_tmp18_) {
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp19_;
				GeeArrayList* _tmp20_;
				gint _item_size = 0;
				GeeArrayList* _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				gint _item_index = 0;
				_tmp19_ = services_store_get_items (self);
				_tmp20_ = _tmp19_;
				_item_list = _tmp20_;
				_tmp21_ = _item_list;
				_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
				_tmp23_ = _tmp22_;
				_item_size = _tmp23_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp24_;
					gint _tmp25_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp26_;
					gpointer _tmp27_;
					ObjectsItem* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					_item_index = _item_index + 1;
					_tmp24_ = _item_index;
					_tmp25_ = _item_size;
					if (!(_tmp24_ < _tmp25_)) {
						break;
					}
					_tmp26_ = _item_list;
					_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _item_index);
					item = (ObjectsItem*) _tmp27_;
					_tmp28_ = item;
					_tmp29_ = objects_item_get_parent_id (_tmp28_);
					_tmp30_ = _tmp29_;
					if (g_strcmp0 (_tmp30_, current_id) == 0) {
						ObjectsItem* _tmp31_;
						_tmp31_ = item;
						objects_item_set_parent_id (_tmp31_, new_id);
					}
					_g_object_unref0 (item);
				}
			}
		}
	}
}

gint
services_store_next_item_child_order (ServicesStore* self,
                                      const gchar* project_id,
                                      const gchar* section_id)
{
	gint child_order = 0;
	GError* _inner_error0_ = NULL;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (project_id != NULL, 0);
	g_return_val_if_fail (section_id != NULL, 0);
	child_order = 0;
	{
		GeeArrayList* _tmp0_;
		gint _tmp20_ = -1;
		_tmp0_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _item_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _item_index = 0;
				_tmp1_ = services_store_get_items (self);
				_tmp2_ = _tmp1_;
				_item_list = _tmp2_;
				_tmp3_ = _item_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_item_size = _tmp5_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					gboolean _tmp10_ = FALSE;
					ObjectsItem* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					_item_index = _item_index + 1;
					_tmp6_ = _item_index;
					_tmp7_ = _item_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _item_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _item_index);
					item = (ObjectsItem*) _tmp9_;
					_tmp11_ = item;
					_tmp12_ = objects_item_get_project_id (_tmp11_);
					_tmp13_ = _tmp12_;
					if (g_strcmp0 (_tmp13_, project_id) == 0) {
						ObjectsItem* _tmp14_;
						const gchar* _tmp15_;
						const gchar* _tmp16_;
						_tmp14_ = item;
						_tmp15_ = objects_item_get_section_id (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp10_ = g_strcmp0 (_tmp16_, section_id) == 0;
					} else {
						_tmp10_ = FALSE;
					}
					if (_tmp10_) {
						gint _tmp17_;
						_tmp17_ = child_order;
						child_order = _tmp17_ + 1;
					}
					_g_object_unref0 (item);
				}
			}
			result = child_order;
			{
				GeeArrayList* _tmp18_;
				_tmp18_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
			_tmp19_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp20_;
	}
}

ObjectsItem*
services_store_get_item (ServicesStore* self,
                         const gchar* id)
{
	ObjectsItem* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			ObjectsItem* _tmp15_;
			ObjectsItem* _tmp16_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _item_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _item_index = 0;
				_tmp1_ = services_store_get_items (self);
				_tmp2_ = _tmp1_;
				_item_list = _tmp2_;
				_tmp3_ = _item_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_item_size = _tmp5_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsItem* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_item_index = _item_index + 1;
					_tmp6_ = _item_index;
					_tmp7_ = _item_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _item_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _item_index);
					item = (ObjectsItem*) _tmp9_;
					_tmp10_ = item;
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, id) == 0) {
						ObjectsItem* _tmp13_;
						ObjectsItem* _tmp14_;
						_tmp13_ = item;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (item);
						break;
					}
					_g_object_unref0 (item);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

ObjectsItem*
services_store_get_item_by_ics (ServicesStore* self,
                                const gchar* ics)
{
	ObjectsItem* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (ics != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			ObjectsItem* _tmp15_;
			ObjectsItem* _tmp16_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _item_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _item_index = 0;
				_tmp1_ = services_store_get_items (self);
				_tmp2_ = _tmp1_;
				_item_list = _tmp2_;
				_tmp3_ = _item_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_item_size = _tmp5_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsItem* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_item_index = _item_index + 1;
					_tmp6_ = _item_index;
					_tmp7_ = _item_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _item_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _item_index);
					item = (ObjectsItem*) _tmp9_;
					_tmp10_ = item;
					_tmp11_ = objects_item_get_ics (_tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, ics) == 0) {
						ObjectsItem* _tmp13_;
						ObjectsItem* _tmp14_;
						_tmp13_ = item;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (item);
						break;
					}
					_g_object_unref0 (item);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_item_by_baseobject (ServicesStore* self,
                                       ObjectsBaseObject* object)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (object != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					if (OBJECTS_IS_PROJECT (object)) {
						gboolean _tmp11_ = FALSE;
						gboolean _tmp12_ = FALSE;
						ObjectsItem* _tmp13_;
						const gchar* _tmp14_;
						const gchar* _tmp15_;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						_tmp13_ = item;
						_tmp14_ = objects_item_get_project_id (_tmp13_);
						_tmp15_ = _tmp14_;
						_tmp16_ = objects_base_object_get_id (object);
						_tmp17_ = _tmp16_;
						if (g_strcmp0 (_tmp15_, _tmp17_) == 0) {
							ObjectsItem* _tmp18_;
							const gchar* _tmp19_;
							const gchar* _tmp20_;
							_tmp18_ = item;
							_tmp19_ = objects_item_get_section_id (_tmp18_);
							_tmp20_ = _tmp19_;
							_tmp12_ = g_strcmp0 (_tmp20_, "") == 0;
						} else {
							_tmp12_ = FALSE;
						}
						if (_tmp12_) {
							ObjectsItem* _tmp21_;
							gboolean _tmp22_;
							gboolean _tmp23_;
							_tmp21_ = item;
							_tmp22_ = objects_item_get_has_parent (_tmp21_);
							_tmp23_ = _tmp22_;
							_tmp11_ = !_tmp23_;
						} else {
							_tmp11_ = FALSE;
						}
						if (_tmp11_) {
							GeeArrayList* _tmp24_;
							ObjectsItem* _tmp25_;
							_tmp24_ = return_value;
							_tmp25_ = item;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
						}
					}
					if (OBJECTS_IS_SECTION (object)) {
						gboolean _tmp26_ = FALSE;
						ObjectsItem* _tmp27_;
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						const gchar* _tmp30_;
						const gchar* _tmp31_;
						_tmp27_ = item;
						_tmp28_ = objects_item_get_section_id (_tmp27_);
						_tmp29_ = _tmp28_;
						_tmp30_ = objects_base_object_get_id (object);
						_tmp31_ = _tmp30_;
						if (g_strcmp0 (_tmp29_, _tmp31_) == 0) {
							ObjectsItem* _tmp32_;
							gboolean _tmp33_;
							gboolean _tmp34_;
							_tmp32_ = item;
							_tmp33_ = objects_item_get_has_parent (_tmp32_);
							_tmp34_ = _tmp33_;
							_tmp26_ = !_tmp34_;
						} else {
							_tmp26_ = FALSE;
						}
						if (_tmp26_) {
							GeeArrayList* _tmp35_;
							ObjectsItem* _tmp36_;
							_tmp35_ = return_value;
							_tmp36_ = item;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp36_);
						}
					}
					_g_object_unref0 (item);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp37_;
			_tmp37_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (return_value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = return_value;
	return result;
}

GeeArrayList*
services_store_get_items_checked (ServicesStore* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp11_ = item;
					_tmp12_ = objects_item_get_checked (_tmp11_);
					_tmp13_ = _tmp12_;
					if (_tmp13_) {
						GeeArrayList* _tmp14_;
						ObjectsItem* _tmp15_;
						_tmp14_ = return_value;
						_tmp15_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp16_ = return_value;
			_tmp17_ = _g_object_ref0 (_tmp16_);
			result = _tmp17_;
			{
				GeeArrayList* _tmp18_;
				_tmp18_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
			_tmp19_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_checked_by_project (ServicesStore* self,
                                             ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp12_ = item;
					_tmp13_ = objects_item_get_project_id (_tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
					_tmp16_ = _tmp15_;
					if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
						ObjectsItem* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_;
						_tmp17_ = item;
						_tmp18_ = objects_item_get_checked (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp11_ = _tmp19_;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
						_tmp20_ = return_value;
						_tmp21_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp22_ = return_value;
			_tmp23_ = _g_object_ref0 (_tmp22_);
			result = _tmp23_;
			{
				GeeArrayList* _tmp24_;
				_tmp24_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
			_tmp25_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_subitems (ServicesStore* self,
                             ObjectsItem* i)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (i != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp11_ = item;
					_tmp12_ = objects_item_get_parent_id (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) i);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
						GeeArrayList* _tmp16_;
						ObjectsItem* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (item);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (return_value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = return_value;
	return result;
}

GeeArrayList*
services_store_get_subitems_uncomplete (ServicesStore* self,
                                        ObjectsItem* i)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (i != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp12_ = item;
					_tmp13_ = objects_item_get_parent_id (_tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = objects_base_object_get_id ((ObjectsBaseObject*) i);
					_tmp16_ = _tmp15_;
					if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
						ObjectsItem* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_;
						_tmp17_ = item;
						_tmp18_ = objects_item_get_checked (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp11_ = !_tmp19_;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
						_tmp20_ = return_value;
						_tmp21_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
					}
					_g_object_unref0 (item);
				}
			}
		}
		__finally0:
		{
			GeeArrayList* _tmp22_;
			_tmp22_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (return_value);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = return_value;
	return result;
}

GeeArrayList*
services_store_get_items_by_project (ServicesStore* self,
                                     ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp11_ = item;
					if (objects_item_exists_project (_tmp11_, project)) {
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
						_tmp12_ = return_value;
						_tmp13_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp14_ = return_value;
			_tmp15_ = _g_object_ref0 (_tmp14_);
			result = _tmp15_;
			{
				GeeArrayList* _tmp16_;
				_tmp16_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
			_tmp17_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_project_pinned (ServicesStore* self,
                                            ObjectsProject* project)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp12_ = item;
					if (objects_item_exists_project (_tmp12_, project)) {
						ObjectsItem* _tmp13_;
						gboolean _tmp14_;
						gboolean _tmp15_;
						_tmp13_ = item;
						_tmp14_ = objects_item_get_pinned (_tmp13_);
						_tmp15_ = _tmp14_;
						_tmp11_ = _tmp15_;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp16_;
						ObjectsItem* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp18_ = return_value;
			_tmp19_ = _g_object_ref0 (_tmp18_);
			result = _tmp19_;
			{
				GeeArrayList* _tmp20_;
				_tmp20_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
			_tmp21_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_date (ServicesStore* self,
                                  GDateTime* date,
                                  gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp11_ = item;
					if (services_store_valid_item_by_date (self, _tmp11_, date, checked)) {
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
						_tmp12_ = return_value;
						_tmp13_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp14_ = return_value;
			_tmp15_ = _g_object_ref0 (_tmp14_);
			result = _tmp15_;
			{
				GeeArrayList* _tmp16_;
				_tmp16_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
			_tmp17_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_no_date (ServicesStore* self,
                                  gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp20_;
			GeeArrayList* _tmp21_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp12_ = item;
					_tmp13_ = objects_item_get_has_due (_tmp12_);
					_tmp14_ = _tmp13_;
					if (!_tmp14_) {
						ObjectsItem* _tmp15_;
						gboolean _tmp16_;
						gboolean _tmp17_;
						_tmp15_ = item;
						_tmp16_ = objects_item_get_checked (_tmp15_);
						_tmp17_ = _tmp16_;
						_tmp11_ = _tmp17_ == checked;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp18_;
						ObjectsItem* _tmp19_;
						_tmp18_ = return_value;
						_tmp19_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp20_ = return_value;
			_tmp21_ = _g_object_ref0 (_tmp20_);
			result = _tmp21_;
			{
				GeeArrayList* _tmp22_;
				_tmp22_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp23_;
			_tmp23_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_repeating (ServicesStore* self,
                                    gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					ObjectsItem* _tmp14_;
					gboolean _tmp15_;
					gboolean _tmp16_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp14_ = item;
					_tmp15_ = objects_item_get_has_due (_tmp14_);
					_tmp16_ = _tmp15_;
					if (_tmp16_) {
						ObjectsItem* _tmp17_;
						ObjectsDueDate* _tmp18_;
						ObjectsDueDate* _tmp19_;
						gboolean _tmp20_;
						gboolean _tmp21_;
						_tmp17_ = item;
						_tmp18_ = objects_item_get_due (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp20_ = objects_due_date_get_is_recurring (_tmp19_);
						_tmp21_ = _tmp20_;
						_tmp13_ = _tmp21_;
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						ObjectsItem* _tmp22_;
						gboolean _tmp23_;
						gboolean _tmp24_;
						_tmp22_ = item;
						_tmp23_ = objects_item_get_checked (_tmp22_);
						_tmp24_ = _tmp23_;
						_tmp12_ = _tmp24_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp25_;
						_tmp25_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp25_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp26_;
						ObjectsItem* _tmp27_;
						_tmp26_ = return_value;
						_tmp27_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp28_ = return_value;
			_tmp29_ = _g_object_ref0 (_tmp28_);
			result = _tmp29_;
			{
				GeeArrayList* _tmp30_;
				_tmp30_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp31_;
			_tmp31_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_date_range (ServicesStore* self,
                                        GDateTime* start_date,
                                        GDateTime* end_date,
                                        gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (start_date != NULL, NULL);
	g_return_val_if_fail (end_date != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp11_ = item;
					if (services_store_valid_item_by_date_range (self, _tmp11_, start_date, end_date, checked)) {
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
						_tmp12_ = return_value;
						_tmp13_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp14_ = return_value;
			_tmp15_ = _g_object_ref0 (_tmp14_);
			result = _tmp15_;
			{
				GeeArrayList* _tmp16_;
				_tmp16_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
			_tmp17_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_month (ServicesStore* self,
                                   GDateTime* date,
                                   gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsItem* _tmp11_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp11_ = item;
					if (services_store_valid_item_by_month (self, _tmp11_, date, checked)) {
						GeeArrayList* _tmp12_;
						ObjectsItem* _tmp13_;
						_tmp12_ = return_value;
						_tmp13_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp14_ = return_value;
			_tmp15_ = _g_object_ref0 (_tmp14_);
			result = _tmp15_;
			{
				GeeArrayList* _tmp16_;
				_tmp16_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp17_;
			_tmp17_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_pinned (ServicesStore* self,
                                 gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					_tmp14_ = objects_item_get_pinned (_tmp13_);
					_tmp15_ = _tmp14_;
					if (_tmp15_) {
						ObjectsItem* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
						_tmp16_ = item;
						_tmp17_ = objects_item_get_checked (_tmp16_);
						_tmp18_ = _tmp17_;
						_tmp12_ = _tmp18_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp19_;
						_tmp19_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp19_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
						_tmp20_ = return_value;
						_tmp21_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp22_ = return_value;
			_tmp23_ = _g_object_ref0 (_tmp22_);
			result = _tmp23_;
			{
				GeeArrayList* _tmp24_;
				_tmp24_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
			_tmp25_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_priority (ServicesStore* self,
                                      gint priority,
                                      gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					_tmp14_ = objects_item_get_priority (_tmp13_);
					_tmp15_ = _tmp14_;
					if (_tmp15_ == priority) {
						ObjectsItem* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
						_tmp16_ = item;
						_tmp17_ = objects_item_get_checked (_tmp16_);
						_tmp18_ = _tmp17_;
						_tmp12_ = _tmp18_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp19_;
						_tmp19_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp19_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
						_tmp20_ = return_value;
						_tmp21_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp22_ = return_value;
			_tmp23_ = _g_object_ref0 (_tmp22_);
			result = _tmp23_;
			{
				GeeArrayList* _tmp24_;
				_tmp24_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
			_tmp25_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_completed (ServicesStore* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsItem* _tmp12_;
					gboolean _tmp13_;
					gboolean _tmp14_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp12_ = item;
					_tmp13_ = objects_item_get_checked (_tmp12_);
					_tmp14_ = _tmp13_;
					if (_tmp14_) {
						ObjectsItem* _tmp15_;
						_tmp15_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp15_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp16_;
						ObjectsItem* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp18_ = return_value;
			_tmp19_ = _g_object_ref0 (_tmp18_);
			result = _tmp19_;
			{
				GeeArrayList* _tmp20_;
				_tmp20_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
			_tmp21_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_label (ServicesStore* self,
                                   ObjectsLabel* label,
                                   gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) label);
					_tmp15_ = _tmp14_;
					if (objects_item_has_label (_tmp13_, _tmp15_)) {
						ObjectsItem* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
						_tmp16_ = item;
						_tmp17_ = objects_item_get_checked (_tmp16_);
						_tmp18_ = _tmp17_;
						_tmp12_ = _tmp18_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp19_;
						_tmp19_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp19_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
						_tmp20_ = return_value;
						_tmp21_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp22_ = return_value;
			_tmp23_ = _g_object_ref0 (_tmp22_);
			result = _tmp23_;
			{
				GeeArrayList* _tmp24_;
				_tmp24_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
			_tmp25_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_unlabeled (ServicesStore* self,
                                    gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp24_;
			GeeArrayList* _tmp25_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					GeeArrayList* _tmp14_;
					GeeArrayList* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					_tmp14_ = objects_item_get_labels (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
					_tmp17_ = _tmp16_;
					if (_tmp17_ <= 0) {
						ObjectsItem* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
						_tmp18_ = item;
						_tmp19_ = objects_item_get_checked (_tmp18_);
						_tmp20_ = _tmp19_;
						_tmp12_ = _tmp20_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp21_;
						_tmp21_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp21_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp22_;
						ObjectsItem* _tmp23_;
						_tmp22_ = return_value;
						_tmp23_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp24_ = return_value;
			_tmp25_ = _g_object_ref0 (_tmp24_);
			result = _tmp25_;
			{
				GeeArrayList* _tmp26_;
				_tmp26_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp27_;
			_tmp27_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_by_scheduled (ServicesStore* self,
                                       gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp30_;
			GeeArrayList* _tmp31_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					ObjectsItem* _tmp14_;
					gboolean _tmp15_;
					gboolean _tmp16_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp14_ = item;
					_tmp15_ = objects_item_get_has_due (_tmp14_);
					_tmp16_ = _tmp15_;
					if (_tmp16_) {
						ObjectsItem* _tmp17_;
						_tmp17_ = item;
						_tmp13_ = !objects_item_was_archived (_tmp17_);
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						ObjectsItem* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
						_tmp18_ = item;
						_tmp19_ = objects_item_get_checked (_tmp18_);
						_tmp20_ = _tmp19_;
						_tmp12_ = _tmp20_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp21_;
						ObjectsDueDate* _tmp22_;
						ObjectsDueDate* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
						GDateTime* _tmp26_;
						GDateTime* _tmp27_;
						_tmp21_ = item;
						_tmp22_ = objects_item_get_due (_tmp21_);
						_tmp23_ = _tmp22_;
						_tmp24_ = objects_due_date_get_datetime (_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp26_ = g_date_time_new_now_local ();
						_tmp27_ = _tmp26_;
						_tmp11_ = g_date_time_compare (_tmp25_, _tmp27_) > 0;
						_g_date_time_unref0 (_tmp27_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp28_;
						ObjectsItem* _tmp29_;
						_tmp28_ = return_value;
						_tmp29_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp30_ = return_value;
			_tmp31_ = _g_object_ref0 (_tmp30_);
			result = _tmp31_;
			{
				GeeArrayList* _tmp32_;
				_tmp32_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp33_;
			_tmp33_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_items_no_parent (ServicesStore* self,
                                    gboolean checked)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp22_;
			GeeArrayList* _tmp23_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					if (!objects_item_was_archived (_tmp13_)) {
						ObjectsItem* _tmp14_;
						gboolean _tmp15_;
						gboolean _tmp16_;
						_tmp14_ = item;
						_tmp15_ = objects_item_get_checked (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp12_ = _tmp16_ == checked;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_;
						_tmp17_ = item;
						_tmp18_ = objects_item_get_has_parent (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp11_ = !_tmp19_;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp20_;
						ObjectsItem* _tmp21_;
						_tmp20_ = return_value;
						_tmp21_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp22_ = return_value;
			_tmp23_ = _g_object_ref0 (_tmp22_);
			result = _tmp23_;
			{
				GeeArrayList* _tmp24_;
				_tmp24_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp25_;
			_tmp25_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

gboolean
services_store_valid_item_by_date (ServicesStore* self,
                                   ObjectsItem* item,
                                   GDateTime* date,
                                   gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp1_ = objects_item_get_has_due (item);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = objects_item_was_archived (item);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = objects_item_get_checked (item);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == checked) {
		ObjectsDueDate* _tmp6_;
		ObjectsDueDate* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		_tmp6_ = objects_item_get_due (item);
		_tmp7_ = _tmp6_;
		_tmp8_ = objects_due_date_get_datetime (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp3_ = utils_datetime_is_same_day (_tmp9_, date);
	} else {
		_tmp3_ = FALSE;
	}
	result = _tmp3_;
	return result;
}

gboolean
services_store_valid_item_by_date_range (ServicesStore* self,
                                         ObjectsItem* item,
                                         GDateTime* start_date,
                                         GDateTime* end_date,
                                         gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GDateTime* date = NULL;
	ObjectsDueDate* _tmp3_;
	ObjectsDueDate* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* start = NULL;
	GDateTime* _tmp8_;
	GDateTime* end = NULL;
	GDateTime* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	g_return_val_if_fail (start_date != NULL, FALSE);
	g_return_val_if_fail (end_date != NULL, FALSE);
	_tmp1_ = objects_item_get_has_due (item);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = objects_item_was_archived (item);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = objects_item_get_due (item);
	_tmp4_ = _tmp3_;
	_tmp5_ = objects_due_date_get_datetime (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = utils_datetime_get_date_only (_tmp6_);
	date = _tmp7_;
	_tmp8_ = utils_datetime_get_date_only (start_date);
	start = _tmp8_;
	_tmp9_ = utils_datetime_get_date_only (end_date);
	end = _tmp9_;
	_tmp12_ = objects_item_get_checked (item);
	_tmp13_ = _tmp12_;
	if (_tmp13_ == checked) {
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		_tmp14_ = date;
		_tmp15_ = start;
		_tmp11_ = g_date_time_compare (_tmp14_, _tmp15_) >= 0;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
		_tmp16_ = date;
		_tmp17_ = end;
		_tmp10_ = g_date_time_compare (_tmp16_, _tmp17_) <= 0;
	} else {
		_tmp10_ = FALSE;
	}
	result = _tmp10_;
	_g_date_time_unref0 (end);
	_g_date_time_unref0 (start);
	_g_date_time_unref0 (date);
	return result;
}

gboolean
services_store_valid_item_by_month (ServicesStore* self,
                                    ObjectsItem* item,
                                    GDateTime* date,
                                    gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp1_ = objects_item_get_has_due (item);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = objects_item_was_archived (item);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = objects_item_get_checked (item);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == checked) {
		ObjectsDueDate* _tmp7_;
		ObjectsDueDate* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		_tmp7_ = objects_item_get_due (item);
		_tmp8_ = _tmp7_;
		_tmp9_ = objects_due_date_get_datetime (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp4_ = g_date_time_get_month (_tmp10_) == g_date_time_get_month (date);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		ObjectsDueDate* _tmp11_;
		ObjectsDueDate* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp14_;
		_tmp11_ = objects_item_get_due (item);
		_tmp12_ = _tmp11_;
		_tmp13_ = objects_due_date_get_datetime (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp3_ = g_date_time_get_year (_tmp14_) == g_date_time_get_year (date);
	} else {
		_tmp3_ = FALSE;
	}
	result = _tmp3_;
	return result;
}

GeeArrayList*
services_store_get_items_by_overdeue_view (ServicesStore* self,
                                           gboolean checked)
{
	GDateTime* date_now = NULL;
	GDateTime* _tmp0_;
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	date_now = _tmp0_;
	_tmp1_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp1_;
	{
		GeeArrayList* _tmp2_;
		_tmp2_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp37_;
			GeeArrayList* _tmp38_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp3_;
				GeeArrayList* _tmp4_;
				gint _item_size = 0;
				GeeArrayList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _item_index = 0;
				_tmp3_ = services_store_get_items (self);
				_tmp4_ = _tmp3_;
				_item_list = _tmp4_;
				_tmp5_ = _item_list;
				_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
				_tmp7_ = _tmp6_;
				_item_size = _tmp7_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp8_;
					gint _tmp9_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp10_;
					gpointer _tmp11_;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_ = FALSE;
					ObjectsItem* _tmp16_;
					gboolean _tmp17_;
					gboolean _tmp18_;
					_item_index = _item_index + 1;
					_tmp8_ = _item_index;
					_tmp9_ = _item_size;
					if (!(_tmp8_ < _tmp9_)) {
						break;
					}
					_tmp10_ = _item_list;
					_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
					item = (ObjectsItem*) _tmp11_;
					_tmp16_ = item;
					_tmp17_ = objects_item_get_has_due (_tmp16_);
					_tmp18_ = _tmp17_;
					if (_tmp18_) {
						ObjectsItem* _tmp19_;
						_tmp19_ = item;
						_tmp15_ = !objects_item_was_archived (_tmp19_);
					} else {
						_tmp15_ = FALSE;
					}
					if (_tmp15_) {
						ObjectsItem* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
						_tmp20_ = item;
						_tmp21_ = objects_item_get_checked (_tmp20_);
						_tmp22_ = _tmp21_;
						_tmp14_ = _tmp22_ == checked;
					} else {
						_tmp14_ = FALSE;
					}
					if (_tmp14_) {
						ObjectsItem* _tmp23_;
						ObjectsDueDate* _tmp24_;
						ObjectsDueDate* _tmp25_;
						GDateTime* _tmp26_;
						GDateTime* _tmp27_;
						GDateTime* _tmp28_;
						_tmp23_ = item;
						_tmp24_ = objects_item_get_due (_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp26_ = objects_due_date_get_datetime (_tmp25_);
						_tmp27_ = _tmp26_;
						_tmp28_ = date_now;
						_tmp13_ = g_date_time_compare (_tmp27_, _tmp28_) < 0;
					} else {
						_tmp13_ = FALSE;
					}
					if (_tmp13_) {
						ObjectsItem* _tmp29_;
						ObjectsDueDate* _tmp30_;
						ObjectsDueDate* _tmp31_;
						GDateTime* _tmp32_;
						GDateTime* _tmp33_;
						GDateTime* _tmp34_;
						_tmp29_ = item;
						_tmp30_ = objects_item_get_due (_tmp29_);
						_tmp31_ = _tmp30_;
						_tmp32_ = objects_due_date_get_datetime (_tmp31_);
						_tmp33_ = _tmp32_;
						_tmp34_ = date_now;
						_tmp12_ = !utils_datetime_is_same_day (_tmp33_, _tmp34_);
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						GeeArrayList* _tmp35_;
						ObjectsItem* _tmp36_;
						_tmp35_ = return_value;
						_tmp36_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp36_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp37_ = return_value;
			_tmp38_ = _g_object_ref0 (_tmp37_);
			result = _tmp38_;
			{
				GeeArrayList* _tmp39_;
				_tmp39_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			_g_date_time_unref0 (date_now);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp40_;
			_tmp40_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		_g_date_time_unref0 (date_now);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

gboolean
services_store_valid_item_by_overdue (ServicesStore* self,
                                      ObjectsItem* item,
                                      GDateTime* date,
                                      gboolean checked)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	g_return_val_if_fail (date != NULL, FALSE);
	_tmp1_ = objects_item_get_has_due (item);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = objects_item_was_archived (item);
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = objects_item_get_checked (item);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == checked) {
		ObjectsDueDate* _tmp7_;
		ObjectsDueDate* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GDateTime* _tmp12_;
		_tmp7_ = objects_item_get_due (item);
		_tmp8_ = _tmp7_;
		_tmp9_ = objects_due_date_get_datetime (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_date_time_new_now_local ();
		_tmp12_ = _tmp11_;
		_tmp4_ = g_date_time_compare (_tmp10_, _tmp12_) < 0;
		_g_date_time_unref0 (_tmp12_);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		ObjectsDueDate* _tmp13_;
		ObjectsDueDate* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
		GDateTime* _tmp18_;
		_tmp13_ = objects_item_get_due (item);
		_tmp14_ = _tmp13_;
		_tmp15_ = objects_due_date_get_datetime (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_date_time_new_now_local ();
		_tmp18_ = _tmp17_;
		_tmp3_ = !utils_datetime_is_same_day (_tmp16_, _tmp18_);
		_g_date_time_unref0 (_tmp18_);
	} else {
		_tmp3_ = FALSE;
	}
	result = _tmp3_;
	return result;
}

void
services_store_insert_label (ServicesStore* self,
                             ObjectsLabel* label)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_insert_label (_tmp1_, label);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		_tmp3_ = services_store_get_labels (self);
		_tmp4_ = _tmp3_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, label);
		g_signal_emit (self, services_store_signals[SERVICES_STORE_LABEL_ADDED_SIGNAL], 0, label);
	}
}

void
services_store_delete_label (ServicesStore* self,
                             ObjectsLabel* label)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_label (_tmp1_, label);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		g_signal_emit_by_name ((ObjectsBaseObject*) label, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_LABEL_DELETED_SIGNAL], 0, label);
		_tmp3_ = self->priv->_labels;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, label);
	}
}

void
services_store_update_label (ServicesStore* self,
                             ObjectsLabel* label)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_update_label (_tmp1_, label);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		g_signal_emit_by_name ((ObjectsBaseObject*) label, "updated", "");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_LABEL_UPDATED_SIGNAL], 0, label);
	}
}

GeeArrayList*
services_store_get_labels_by_item_labels (ServicesStore* self,
                                          const gchar* labels)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (labels != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	_tmp2_ = _tmp1_ = g_strsplit (labels, ";", 0);
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
		id_collection = _tmp2_;
		id_collection_length1 = _vala_array_length (_tmp1_);
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
			gchar* _tmp3_;
			gchar* id = NULL;
			_tmp3_ = g_strdup (id_collection[id_it]);
			id = _tmp3_;
			{
				ObjectsLabel* label = NULL;
				const gchar* _tmp4_;
				ObjectsLabel* _tmp5_;
				ObjectsLabel* _tmp6_;
				_tmp4_ = id;
				_tmp5_ = services_store_get_label (self, _tmp4_);
				label = _tmp5_;
				_tmp6_ = label;
				if (_tmp6_ != NULL) {
					GeeArrayList* _tmp7_;
					ObjectsLabel* _tmp8_;
					_tmp7_ = return_value;
					_tmp8_ = label;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
				}
				_g_object_unref0 (label);
				_g_free0 (id);
			}
		}
		id_collection = (_vala_array_free (id_collection, id_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = return_value;
	return result;
}

GeeArrayList*
services_store_get_items_has_labels (ServicesStore* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp20_;
			GeeArrayList* _tmp21_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					if (objects_item_has_labels (_tmp13_)) {
						ObjectsItem* _tmp14_;
						gboolean _tmp15_;
						gboolean _tmp16_;
						_tmp14_ = item;
						_tmp15_ = objects_item_get_completed (_tmp14_);
						_tmp16_ = _tmp15_;
						_tmp12_ = !_tmp16_;
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						ObjectsItem* _tmp17_;
						_tmp17_ = item;
						_tmp11_ = !objects_item_was_archived (_tmp17_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp18_;
						ObjectsItem* _tmp19_;
						_tmp18_ = return_value;
						_tmp19_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp20_ = return_value;
			_tmp21_ = _g_object_ref0 (_tmp20_);
			result = _tmp21_;
			{
				GeeArrayList* _tmp22_;
				_tmp22_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp23_;
			_tmp23_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

gboolean
services_store_label_exists (ServicesStore* self,
                             const gchar* id)
{
	gboolean return_value = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	return_value = FALSE;
	{
		GeeArrayList* _tmp0_;
		gboolean _tmp14_ = FALSE;
		_tmp0_ = self->priv->_labels;
		g_rec_mutex_lock (&self->priv->__lock__labels);
		{
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp1_;
				gint _label_size = 0;
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _label_index = 0;
				_tmp1_ = self->priv->_labels;
				_label_list = _tmp1_;
				_tmp2_ = _label_list;
				_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				_label_size = _tmp4_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp7_;
					gpointer _tmp8_;
					ObjectsLabel* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					_label_index = _label_index + 1;
					_tmp5_ = _label_index;
					_tmp6_ = _label_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _label_list;
					_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _label_index);
					label = (ObjectsLabel*) _tmp8_;
					_tmp9_ = label;
					_tmp10_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp9_);
					_tmp11_ = _tmp10_;
					if (g_strcmp0 (_tmp11_, id) == 0) {
						return_value = TRUE;
						_g_object_unref0 (label);
						break;
					}
					_g_object_unref0 (label);
				}
			}
			result = return_value;
			{
				GeeArrayList* _tmp12_;
				_tmp12_ = self->priv->_labels;
				g_rec_mutex_unlock (&self->priv->__lock__labels);
			}
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp13_;
			_tmp13_ = self->priv->_labels;
			g_rec_mutex_unlock (&self->priv->__lock__labels);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp14_;
	}
}

ObjectsLabel*
services_store_get_label (ServicesStore* self,
                          const gchar* id)
{
	ObjectsLabel* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsLabel* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_labels;
		g_rec_mutex_lock (&self->priv->__lock__labels);
		{
			ObjectsLabel* _tmp15_;
			ObjectsLabel* _tmp16_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _label_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _label_index = 0;
				_tmp1_ = services_store_get_labels (self);
				_tmp2_ = _tmp1_;
				_label_list = _tmp2_;
				_tmp3_ = _label_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_label_size = _tmp5_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsLabel* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_label_index = _label_index + 1;
					_tmp6_ = _label_index;
					_tmp7_ = _label_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _label_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _label_index);
					label = (ObjectsLabel*) _tmp9_;
					_tmp10_ = label;
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, id) == 0) {
						ObjectsLabel* _tmp13_;
						ObjectsLabel* _tmp14_;
						_tmp13_ = label;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (label);
						break;
					}
					_g_object_unref0 (label);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_labels;
				g_rec_mutex_unlock (&self->priv->__lock__labels);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_labels;
			g_rec_mutex_unlock (&self->priv->__lock__labels);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

ObjectsLabel*
services_store_get_label_by_name (ServicesStore* self,
                                  const gchar* name,
                                  gboolean lowercase,
                                  const gchar* source_id)
{
	GError* _inner_error0_ = NULL;
	ObjectsLabel* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (source_id != NULL, NULL);
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_labels;
		g_rec_mutex_lock (&self->priv->__lock__labels);
		{
			gchar* _tmp1_ = NULL;
			gchar* compare_name = NULL;
			gchar* _tmp4_;
			if (lowercase) {
				gchar* _tmp2_;
				_tmp2_ = g_utf8_strdown (name, (gssize) -1);
				_g_free0 (_tmp1_);
				_tmp1_ = _tmp2_;
			} else {
				gchar* _tmp3_;
				_tmp3_ = g_strdup (name);
				_g_free0 (_tmp1_);
				_tmp1_ = _tmp3_;
			}
			_tmp4_ = g_strdup (_tmp1_);
			compare_name = _tmp4_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp5_;
				GeeArrayList* _tmp6_;
				gint _label_size = 0;
				GeeArrayList* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gint _label_index = 0;
				_tmp5_ = services_store_get_labels (self);
				_tmp6_ = _tmp5_;
				_label_list = _tmp6_;
				_tmp7_ = _label_list;
				_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
				_tmp9_ = _tmp8_;
				_label_size = _tmp9_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp10_;
					gint _tmp11_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp12_;
					gpointer _tmp13_;
					gchar* _tmp14_ = NULL;
					gchar* label_name = NULL;
					gchar* _tmp23_;
					gboolean _tmp24_ = FALSE;
					ObjectsLabel* _tmp25_;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					_label_index = _label_index + 1;
					_tmp10_ = _label_index;
					_tmp11_ = _label_size;
					if (!(_tmp10_ < _tmp11_)) {
						break;
					}
					_tmp12_ = _label_list;
					_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _label_index);
					label = (ObjectsLabel*) _tmp13_;
					if (lowercase) {
						ObjectsLabel* _tmp15_;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						_tmp15_ = label;
						_tmp16_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp15_);
						_tmp17_ = _tmp16_;
						_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) -1);
						_g_free0 (_tmp14_);
						_tmp14_ = _tmp18_;
					} else {
						ObjectsLabel* _tmp19_;
						const gchar* _tmp20_;
						const gchar* _tmp21_;
						gchar* _tmp22_;
						_tmp19_ = label;
						_tmp20_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp19_);
						_tmp21_ = _tmp20_;
						_tmp22_ = g_strdup (_tmp21_);
						_g_free0 (_tmp14_);
						_tmp14_ = _tmp22_;
					}
					_tmp23_ = g_strdup (_tmp14_);
					label_name = _tmp23_;
					_tmp25_ = label;
					_tmp26_ = objects_label_get_source_id (_tmp25_);
					_tmp27_ = _tmp26_;
					if (g_strcmp0 (_tmp27_, source_id) == 0) {
						const gchar* _tmp28_;
						const gchar* _tmp29_;
						_tmp28_ = label_name;
						_tmp29_ = compare_name;
						_tmp24_ = g_strcmp0 (_tmp28_, _tmp29_) == 0;
					} else {
						_tmp24_ = FALSE;
					}
					if (_tmp24_) {
						result = label;
						_g_free0 (label_name);
						_g_free0 (_tmp14_);
						_g_free0 (compare_name);
						_g_free0 (_tmp1_);
						{
							GeeArrayList* _tmp30_;
							_tmp30_ = self->priv->_labels;
							g_rec_mutex_unlock (&self->priv->__lock__labels);
						}
						return result;
					}
					_g_free0 (label_name);
					_g_free0 (_tmp14_);
					_g_object_unref0 (label);
				}
			}
			result = NULL;
			_g_free0 (compare_name);
			_g_free0 (_tmp1_);
			{
				GeeArrayList* _tmp31_;
				_tmp31_ = self->priv->_labels;
				g_rec_mutex_unlock (&self->priv->__lock__labels);
			}
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp32_;
			_tmp32_ = self->priv->_labels;
			g_rec_mutex_unlock (&self->priv->__lock__labels);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_labels_by_source (ServicesStore* self,
                                     const gchar* source_id)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (source_id != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_labels;
		g_rec_mutex_lock (&self->priv->__lock__labels);
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _label_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _label_index = 0;
				_tmp2_ = services_store_get_labels (self);
				_tmp3_ = _tmp2_;
				_label_list = _tmp3_;
				_tmp4_ = _label_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_label_size = _tmp6_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsLabel* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					_label_index = _label_index + 1;
					_tmp7_ = _label_index;
					_tmp8_ = _label_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _label_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _label_index);
					label = (ObjectsLabel*) _tmp10_;
					_tmp11_ = label;
					_tmp12_ = objects_label_get_source_id (_tmp11_);
					_tmp13_ = _tmp12_;
					if (g_strcmp0 (_tmp13_, source_id) == 0) {
						GeeArrayList* _tmp14_;
						ObjectsLabel* _tmp15_;
						_tmp14_ = return_value;
						_tmp15_ = label;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
					}
					_g_object_unref0 (label);
				}
			}
			_tmp16_ = return_value;
			_tmp17_ = _g_object_ref0 (_tmp16_);
			result = _tmp17_;
			{
				GeeArrayList* _tmp18_;
				_tmp18_ = self->priv->_labels;
				g_rec_mutex_unlock (&self->priv->__lock__labels);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
			_tmp19_ = self->priv->_labels;
			g_rec_mutex_unlock (&self->priv->__lock__labels);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

GeeArrayList*
services_store_get_all_labels_by_search (ServicesStore* self,
                                         const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (search_text != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_labels;
		g_rec_mutex_lock (&self->priv->__lock__labels);
		{
			GeeArrayList* _tmp21_;
			GeeArrayList* _tmp22_;
			{
				GeeArrayList* _label_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _label_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _label_index = 0;
				_tmp2_ = services_store_get_labels (self);
				_tmp3_ = _tmp2_;
				_label_list = _tmp3_;
				_tmp4_ = _label_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_label_size = _tmp6_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsLabel* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gboolean _tmp18_;
					_label_index = _label_index + 1;
					_tmp7_ = _label_index;
					_tmp8_ = _label_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _label_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _label_index);
					label = (ObjectsLabel*) _tmp10_;
					_tmp11_ = label;
					_tmp12_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = g_utf8_strdown (_tmp13_, (gssize) -1);
					_tmp15_ = _tmp14_;
					_tmp16_ = g_utf8_strdown (search_text, (gssize) -1);
					_tmp17_ = _tmp16_;
					_tmp18_ = string_contains (_tmp15_, _tmp17_);
					_g_free0 (_tmp17_);
					_g_free0 (_tmp15_);
					if (_tmp18_) {
						GeeArrayList* _tmp19_;
						ObjectsLabel* _tmp20_;
						_tmp19_ = return_value;
						_tmp20_ = label;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
					}
					_g_object_unref0 (label);
				}
			}
			_tmp21_ = return_value;
			_tmp22_ = _g_object_ref0 (_tmp21_);
			result = _tmp22_;
			{
				GeeArrayList* _tmp23_;
				_tmp23_ = self->priv->_labels;
				g_rec_mutex_unlock (&self->priv->__lock__labels);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp24_;
			_tmp24_ = self->priv->_labels;
			g_rec_mutex_unlock (&self->priv->__lock__labels);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_all_projects_by_search (ServicesStore* self,
                                           const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (search_text != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			GeeArrayList* _tmp25_;
			GeeArrayList* _tmp26_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
				_tmp2_ = services_store_get_projects (self);
				_tmp3_ = _tmp2_;
				_project_list = _tmp3_;
				_tmp4_ = _project_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_project_size = _tmp6_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsProject* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gboolean _tmp19_;
					_project_index = _project_index + 1;
					_tmp7_ = _project_index;
					_tmp8_ = _project_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _project_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
					project = (ObjectsProject*) _tmp10_;
					_tmp12_ = project;
					_tmp13_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = g_utf8_strdown (_tmp14_, (gssize) -1);
					_tmp16_ = _tmp15_;
					_tmp17_ = g_utf8_strdown (search_text, (gssize) -1);
					_tmp18_ = _tmp17_;
					_tmp19_ = string_contains (_tmp16_, _tmp18_);
					_g_free0 (_tmp18_);
					_g_free0 (_tmp16_);
					if (_tmp19_) {
						ObjectsProject* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
						_tmp20_ = project;
						_tmp21_ = objects_project_get_is_archived (_tmp20_);
						_tmp22_ = _tmp21_;
						_tmp11_ = !_tmp22_;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp23_;
						ObjectsProject* _tmp24_;
						_tmp23_ = return_value;
						_tmp24_ = project;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
					}
					_g_object_unref0 (project);
				}
			}
			_tmp25_ = return_value;
			_tmp26_ = _g_object_ref0 (_tmp25_);
			result = _tmp26_;
			{
				GeeArrayList* _tmp27_;
				_tmp27_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp28_;
			_tmp28_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_all_sections_by_search (ServicesStore* self,
                                           const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (search_text != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			GeeArrayList* _tmp23_;
			GeeArrayList* _tmp24_;
			{
				GeeArrayList* _section_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _section_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _section_index = 0;
				_tmp2_ = services_store_get_sections (self);
				_tmp3_ = _tmp2_;
				_section_list = _tmp3_;
				_tmp4_ = _section_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_section_size = _tmp6_;
				_section_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsSection* section = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					ObjectsSection* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gboolean _tmp19_;
					_section_index = _section_index + 1;
					_tmp7_ = _section_index;
					_tmp8_ = _section_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _section_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _section_index);
					section = (ObjectsSection*) _tmp10_;
					_tmp12_ = section;
					_tmp13_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = g_utf8_strdown (_tmp14_, (gssize) -1);
					_tmp16_ = _tmp15_;
					_tmp17_ = g_utf8_strdown (search_text, (gssize) -1);
					_tmp18_ = _tmp17_;
					_tmp19_ = string_contains (_tmp16_, _tmp18_);
					_g_free0 (_tmp18_);
					_g_free0 (_tmp16_);
					if (_tmp19_) {
						ObjectsSection* _tmp20_;
						_tmp20_ = section;
						_tmp11_ = !objects_section_was_archived (_tmp20_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp21_;
						ObjectsSection* _tmp22_;
						_tmp21_ = return_value;
						_tmp22_ = section;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
					}
					_g_object_unref0 (section);
				}
			}
			_tmp23_ = return_value;
			_tmp24_ = _g_object_ref0 (_tmp23_);
			result = _tmp24_;
			{
				GeeArrayList* _tmp25_;
				_tmp25_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp26_;
			_tmp26_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_all_projects_archived (ServicesStore* self)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_projects;
		g_rec_mutex_lock (&self->priv->__lock__projects);
		{
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			{
				GeeArrayList* _project_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _project_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _project_index = 0;
				_tmp2_ = services_store_get_projects (self);
				_tmp3_ = _tmp2_;
				_project_list = _tmp3_;
				_tmp4_ = _project_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_project_size = _tmp6_;
				_project_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsProject* project = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsProject* _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
					_project_index = _project_index + 1;
					_tmp7_ = _project_index;
					_tmp8_ = _project_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _project_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _project_index);
					project = (ObjectsProject*) _tmp10_;
					_tmp11_ = project;
					_tmp12_ = objects_project_get_is_archived (_tmp11_);
					_tmp13_ = _tmp12_;
					if (_tmp13_) {
						GeeArrayList* _tmp14_;
						ObjectsProject* _tmp15_;
						_tmp14_ = return_value;
						_tmp15_ = project;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
					}
					_g_object_unref0 (project);
				}
			}
			_tmp16_ = return_value;
			_tmp17_ = _g_object_ref0 (_tmp16_);
			result = _tmp17_;
			{
				GeeArrayList* _tmp18_;
				_tmp18_ = self->priv->_projects;
				g_rec_mutex_unlock (&self->priv->__lock__projects);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp19_;
			_tmp19_ = self->priv->_projects;
			g_rec_mutex_unlock (&self->priv->__lock__projects);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

GeeArrayList*
services_store_get_all_items_by_search (ServicesStore* self,
                                        const gchar* search_text)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (search_text != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_items;
		g_rec_mutex_lock (&self->priv->__lock__items);
		{
			GeeArrayList* _tmp35_;
			GeeArrayList* _tmp36_;
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _item_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _item_index = 0;
				_tmp2_ = services_store_get_items (self);
				_tmp3_ = _tmp2_;
				_item_list = _tmp3_;
				_tmp4_ = _item_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_item_size = _tmp6_;
				_item_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsItem* item = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					ObjectsItem* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
					_item_index = _item_index + 1;
					_tmp7_ = _item_index;
					_tmp8_ = _item_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _item_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
					item = (ObjectsItem*) _tmp10_;
					_tmp13_ = item;
					_tmp14_ = objects_item_get_checked (_tmp13_);
					_tmp15_ = _tmp14_;
					if (!_tmp15_) {
						ObjectsItem* _tmp16_;
						_tmp16_ = item;
						_tmp12_ = !objects_item_was_archived (_tmp16_);
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						gboolean _tmp17_ = FALSE;
						ObjectsItem* _tmp18_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gboolean _tmp25_;
						_tmp18_ = item;
						_tmp19_ = objects_item_get_content (_tmp18_);
						_tmp20_ = _tmp19_;
						_tmp21_ = g_utf8_strdown (_tmp20_, (gssize) -1);
						_tmp22_ = _tmp21_;
						_tmp23_ = g_utf8_strdown (search_text, (gssize) -1);
						_tmp24_ = _tmp23_;
						_tmp25_ = string_contains (_tmp22_, _tmp24_);
						_g_free0 (_tmp24_);
						_g_free0 (_tmp22_);
						if (_tmp25_) {
							_tmp17_ = TRUE;
						} else {
							ObjectsItem* _tmp26_;
							const gchar* _tmp27_;
							const gchar* _tmp28_;
							gchar* _tmp29_;
							gchar* _tmp30_;
							gchar* _tmp31_;
							gchar* _tmp32_;
							_tmp26_ = item;
							_tmp27_ = objects_item_get_description (_tmp26_);
							_tmp28_ = _tmp27_;
							_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
							_tmp30_ = _tmp29_;
							_tmp31_ = g_utf8_strdown (search_text, (gssize) -1);
							_tmp32_ = _tmp31_;
							_tmp17_ = string_contains (_tmp30_, _tmp32_);
							_g_free0 (_tmp32_);
							_g_free0 (_tmp30_);
						}
						_tmp11_ = _tmp17_;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						GeeArrayList* _tmp33_;
						ObjectsItem* _tmp34_;
						_tmp33_ = return_value;
						_tmp34_ = item;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, _tmp34_);
					}
					_g_object_unref0 (item);
				}
			}
			_tmp35_ = return_value;
			_tmp36_ = _g_object_ref0 (_tmp35_);
			result = _tmp36_;
			{
				GeeArrayList* _tmp37_;
				_tmp37_ = self->priv->_items;
				g_rec_mutex_unlock (&self->priv->__lock__items);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp38_;
			_tmp38_ = self->priv->_items;
			g_rec_mutex_unlock (&self->priv->__lock__items);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

void
services_store_insert_reminder (ServicesStore* self,
                                ObjectsReminder* reminder)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (reminder != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_insert_reminder (_tmp1_, reminder);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		ObjectsItem* _tmp5_;
		ObjectsItem* _tmp6_;
		_tmp3_ = services_store_get_reminders (self);
		_tmp4_ = _tmp3_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, reminder);
		g_signal_emit (self, services_store_signals[SERVICES_STORE_REMINDER_ADDED_SIGNAL], 0, reminder);
		_tmp5_ = objects_reminder_get_item (reminder);
		_tmp6_ = _tmp5_;
		g_signal_emit_by_name (_tmp6_, "reminder-added", reminder);
	}
}

void
services_store_delete_reminder (ServicesStore* self,
                                ObjectsReminder* reminder)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (reminder != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_reminder (_tmp1_, reminder);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		ObjectsItem* _tmp4_;
		ObjectsItem* _tmp5_;
		g_signal_emit_by_name ((ObjectsBaseObject*) reminder, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_REMINDER_DELETED_SIGNAL], 0, reminder);
		_tmp3_ = self->priv->_reminders;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, reminder);
		_tmp4_ = objects_reminder_get_item (reminder);
		_tmp5_ = _tmp4_;
		g_signal_emit_by_name (_tmp5_, "reminder-deleted", reminder);
	}
}

GeeArrayList*
services_store_get_reminders_by_item (ServicesStore* self,
                                      ObjectsItem* item)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_REMINDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_reminders;
		g_rec_mutex_lock (&self->priv->__lock__reminders);
		{
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
			{
				GeeArrayList* _reminder_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _reminder_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _reminder_index = 0;
				_tmp2_ = services_store_get_reminders (self);
				_tmp3_ = _tmp2_;
				_reminder_list = _tmp3_;
				_tmp4_ = _reminder_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_reminder_size = _tmp6_;
				_reminder_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsReminder* reminder = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsReminder* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_reminder_index = _reminder_index + 1;
					_tmp7_ = _reminder_index;
					_tmp8_ = _reminder_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _reminder_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _reminder_index);
					reminder = (ObjectsReminder*) _tmp10_;
					_tmp11_ = reminder;
					_tmp12_ = objects_reminder_get_item_id (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
						GeeArrayList* _tmp16_;
						ObjectsReminder* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = reminder;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (reminder);
				}
			}
			_tmp18_ = return_value;
			_tmp19_ = _g_object_ref0 (_tmp18_);
			result = _tmp19_;
			{
				GeeArrayList* _tmp20_;
				_tmp20_ = self->priv->_reminders;
				g_rec_mutex_unlock (&self->priv->__lock__reminders);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
			_tmp21_ = self->priv->_reminders;
			g_rec_mutex_unlock (&self->priv->__lock__reminders);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

ObjectsReminder*
services_store_get_reminder (ServicesStore* self,
                             const gchar* id)
{
	ObjectsReminder* return_value = NULL;
	GError* _inner_error0_ = NULL;
	ObjectsReminder* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	return_value = NULL;
	{
		GeeArrayList* _tmp0_;
		_tmp0_ = self->priv->_reminders;
		g_rec_mutex_lock (&self->priv->__lock__reminders);
		{
			ObjectsReminder* _tmp15_;
			ObjectsReminder* _tmp16_;
			{
				GeeArrayList* _reminder_list = NULL;
				GeeArrayList* _tmp1_;
				GeeArrayList* _tmp2_;
				gint _reminder_size = 0;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _reminder_index = 0;
				_tmp1_ = services_store_get_reminders (self);
				_tmp2_ = _tmp1_;
				_reminder_list = _tmp2_;
				_tmp3_ = _reminder_list;
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				_reminder_size = _tmp5_;
				_reminder_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					ObjectsReminder* reminder = NULL;
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					ObjectsReminder* _tmp10_;
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					_reminder_index = _reminder_index + 1;
					_tmp6_ = _reminder_index;
					_tmp7_ = _reminder_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _reminder_list;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _reminder_index);
					reminder = (ObjectsReminder*) _tmp9_;
					_tmp10_ = reminder;
					_tmp11_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp10_);
					_tmp12_ = _tmp11_;
					if (g_strcmp0 (_tmp12_, id) == 0) {
						ObjectsReminder* _tmp13_;
						ObjectsReminder* _tmp14_;
						_tmp13_ = reminder;
						_tmp14_ = _g_object_ref0 (_tmp13_);
						_g_object_unref0 (return_value);
						return_value = _tmp14_;
						_g_object_unref0 (reminder);
						break;
					}
					_g_object_unref0 (reminder);
				}
			}
			_tmp15_ = return_value;
			_tmp16_ = _g_object_ref0 (_tmp15_);
			result = _tmp16_;
			{
				GeeArrayList* _tmp17_;
				_tmp17_ = self->priv->_reminders;
				g_rec_mutex_unlock (&self->priv->__lock__reminders);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp18_;
			_tmp18_ = self->priv->_reminders;
			g_rec_mutex_unlock (&self->priv->__lock__reminders);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

void
services_store_insert_attachment (ServicesStore* self,
                                  ObjectsAttachment* attachment)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (attachment != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_insert_attachment (_tmp1_, attachment);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		ObjectsItem* _tmp5_;
		ObjectsItem* _tmp6_;
		_tmp3_ = services_store_get_attachments (self);
		_tmp4_ = _tmp3_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, attachment);
		_tmp5_ = objects_attachment_get_item (attachment);
		_tmp6_ = _tmp5_;
		g_signal_emit_by_name (_tmp6_, "attachment-added", attachment);
	}
}

void
services_store_delete_attachment (ServicesStore* self,
                                  ObjectsAttachment* attachment)
{
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (attachment != NULL);
	_tmp0_ = services_database_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = services_database_delete_attachment (_tmp1_, attachment);
	_g_object_unref0 (_tmp1_);
	if (_tmp2_) {
		GeeArrayList* _tmp3_;
		ObjectsItem* _tmp4_;
		ObjectsItem* _tmp5_;
		g_signal_emit_by_name (attachment, "deleted");
		g_signal_emit (self, services_store_signals[SERVICES_STORE_ATTACHMENT_DELETED_SIGNAL], 0, attachment);
		_tmp3_ = self->priv->_attachments;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp3_, attachment);
		_tmp4_ = objects_attachment_get_item (attachment);
		_tmp5_ = _tmp4_;
		g_signal_emit_by_name (_tmp5_, "attachment-deleted", attachment);
	}
}

GeeArrayList*
services_store_get_attachments_by_item (ServicesStore* self,
                                        ObjectsItem* item)
{
	GeeArrayList* return_value = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	_tmp0_ = gee_array_list_new (OBJECTS_TYPE_ATTACHMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	return_value = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		_tmp1_ = self->priv->_attachments;
		g_rec_mutex_lock (&self->priv->__lock__attachments);
		{
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
			{
				GeeArrayList* _attachment_list = NULL;
				GeeArrayList* _tmp2_;
				GeeArrayList* _tmp3_;
				gint _attachment_size = 0;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _attachment_index = 0;
				_tmp2_ = services_store_get_attachments (self);
				_tmp3_ = _tmp2_;
				_attachment_list = _tmp3_;
				_tmp4_ = _attachment_list;
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
				_tmp6_ = _tmp5_;
				_attachment_size = _tmp6_;
				_attachment_index = -1;
				while (TRUE) {
					gint _tmp7_;
					gint _tmp8_;
					ObjectsAttachment* attachment = NULL;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					ObjectsAttachment* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_attachment_index = _attachment_index + 1;
					_tmp7_ = _attachment_index;
					_tmp8_ = _attachment_size;
					if (!(_tmp7_ < _tmp8_)) {
						break;
					}
					_tmp9_ = _attachment_list;
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _attachment_index);
					attachment = (ObjectsAttachment*) _tmp10_;
					_tmp11_ = attachment;
					_tmp12_ = objects_attachment_get_item_id (_tmp11_);
					_tmp13_ = _tmp12_;
					_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) item);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
						GeeArrayList* _tmp16_;
						ObjectsAttachment* _tmp17_;
						_tmp16_ = return_value;
						_tmp17_ = attachment;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
					}
					_g_object_unref0 (attachment);
				}
			}
			_tmp18_ = return_value;
			_tmp19_ = _g_object_ref0 (_tmp18_);
			result = _tmp19_;
			{
				GeeArrayList* _tmp20_;
				_tmp20_ = self->priv->_attachments;
				g_rec_mutex_unlock (&self->priv->__lock__attachments);
			}
			_g_object_unref0 (return_value);
			return result;
		}
		__finally0:
		{
			GeeArrayList* _tmp21_;
			_tmp21_ = self->priv->_attachments;
			g_rec_mutex_unlock (&self->priv->__lock__attachments);
		}
		_g_object_unref0 (return_value);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

ServicesStore*
services_store_construct (GType object_type)
{
	ServicesStore * self = NULL;
	self = (ServicesStore*) g_object_new (object_type, NULL);
	return self;
}

ServicesStore*
services_store_new (void)
{
	return services_store_construct (SERVICES_TYPE_STORE);
}

GeeArrayList*
services_store_get_sources (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sources;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_sources_collection (_tmp2_);
		_g_object_unref0 (self->priv->_sources);
		self->priv->_sources = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_sources;
	result = _tmp4_;
	return result;
}

GeeArrayList*
services_store_get_projects (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_projects;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_projects_collection (_tmp2_);
		_g_object_unref0 (self->priv->_projects);
		self->priv->_projects = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_projects;
	result = _tmp4_;
	return result;
}

GeeArrayList*
services_store_get_sections (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sections;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_sections_collection (_tmp2_);
		_g_object_unref0 (self->priv->_sections);
		self->priv->_sections = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_sections;
	result = _tmp4_;
	return result;
}

GeeArrayList*
services_store_get_items (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_items;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_items_collection (_tmp2_);
		_g_object_unref0 (self->priv->_items);
		self->priv->_items = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_items;
	result = _tmp4_;
	return result;
}

GeeArrayList*
services_store_get_labels (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_labels;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_labels_collection (_tmp2_);
		_g_object_unref0 (self->priv->_labels);
		self->priv->_labels = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_labels;
	result = _tmp4_;
	return result;
}

GeeArrayList*
services_store_get_reminders (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_reminders;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_reminders_collection (_tmp2_);
		_g_object_unref0 (self->priv->_reminders);
		self->priv->_reminders = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_reminders;
	result = _tmp4_;
	return result;
}

GeeArrayList*
services_store_get_attachments (ServicesStore* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_attachments;
	if (_tmp0_ == NULL) {
		ServicesDatabase* _tmp1_;
		ServicesDatabase* _tmp2_;
		GeeArrayList* _tmp3_;
		_tmp1_ = services_database_get_default ();
		_tmp2_ = _tmp1_;
		_tmp3_ = services_database_get_attachments_collection (_tmp2_);
		_g_object_unref0 (self->priv->_attachments);
		self->priv->_attachments = _tmp3_;
		_g_object_unref0 (_tmp2_);
	}
	_tmp4_ = self->priv->_attachments;
	result = _tmp4_;
	return result;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}

static void
services_store_class_init (ServicesStoreClass * klass,
                           gpointer klass_data)
{
	services_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ServicesStore_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_services_store_get_property;
	G_OBJECT_CLASS (klass)->finalize = services_store_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_SOURCES_PROPERTY, services_store_properties[SERVICES_STORE_SOURCES_PROPERTY] = g_param_spec_object ("sources", "sources", "sources", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_PROJECTS_PROPERTY, services_store_properties[SERVICES_STORE_PROJECTS_PROPERTY] = g_param_spec_object ("projects", "projects", "projects", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_SECTIONS_PROPERTY, services_store_properties[SERVICES_STORE_SECTIONS_PROPERTY] = g_param_spec_object ("sections", "sections", "sections", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_ITEMS_PROPERTY, services_store_properties[SERVICES_STORE_ITEMS_PROPERTY] = g_param_spec_object ("items", "items", "items", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_LABELS_PROPERTY, services_store_properties[SERVICES_STORE_LABELS_PROPERTY] = g_param_spec_object ("labels", "labels", "labels", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_REMINDERS_PROPERTY, services_store_properties[SERVICES_STORE_REMINDERS_PROPERTY] = g_param_spec_object ("reminders", "reminders", "reminders", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_STORE_ATTACHMENTS_PROPERTY, services_store_properties[SERVICES_STORE_ATTACHMENTS_PROPERTY] = g_param_spec_object ("attachments", "attachments", "attachments", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	services_store_signals[SERVICES_STORE_SOURCE_ADDED_SIGNAL] = g_signal_new ("source-added", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SOURCE);
	services_store_signals[SERVICES_STORE_SOURCE_DELETED_SIGNAL] = g_signal_new ("source-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SOURCE);
	services_store_signals[SERVICES_STORE_SOURCE_UPDATED_SIGNAL] = g_signal_new ("source-updated", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SOURCE);
	services_store_signals[SERVICES_STORE_PROJECT_ADDED_SIGNAL] = g_signal_new ("project-added", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
	services_store_signals[SERVICES_STORE_PROJECT_UPDATED_SIGNAL] = g_signal_new ("project-updated", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
	services_store_signals[SERVICES_STORE_PROJECT_DELETED_SIGNAL] = g_signal_new ("project-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
	services_store_signals[SERVICES_STORE_PROJECT_ARCHIVED_SIGNAL] = g_signal_new ("project-archived", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
	services_store_signals[SERVICES_STORE_PROJECT_UNARCHIVED_SIGNAL] = g_signal_new ("project-unarchived", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_PROJECT);
	services_store_signals[SERVICES_STORE_LABEL_ADDED_SIGNAL] = g_signal_new ("label-added", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
	services_store_signals[SERVICES_STORE_LABEL_UPDATED_SIGNAL] = g_signal_new ("label-updated", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
	services_store_signals[SERVICES_STORE_LABEL_DELETED_SIGNAL] = g_signal_new ("label-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
	services_store_signals[SERVICES_STORE_SECTION_DELETED_SIGNAL] = g_signal_new ("section-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SECTION);
	services_store_signals[SERVICES_STORE_SECTION_MOVED_SIGNAL] = g_signal_new ("section-moved", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, OBJECTS_TYPE_SECTION, G_TYPE_STRING);
	services_store_signals[SERVICES_STORE_SECTION_ARCHIVED_SIGNAL] = g_signal_new ("section-archived", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SECTION);
	services_store_signals[SERVICES_STORE_SECTION_UNARCHIVED_SIGNAL] = g_signal_new ("section-unarchived", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_SECTION);
	services_store_signals[SERVICES_STORE_ITEM_DELETED_SIGNAL] = g_signal_new ("item-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_ITEM);
	services_store_signals[SERVICES_STORE_ITEM_ADDED_SIGNAL] = g_signal_new ("item-added", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, OBJECTS_TYPE_ITEM, G_TYPE_BOOLEAN);
	services_store_signals[SERVICES_STORE_ITEM_UPDATED_SIGNAL] = g_signal_new ("item-updated", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, OBJECTS_TYPE_ITEM, G_TYPE_STRING);
	services_store_signals[SERVICES_STORE_ITEM_ARCHIVED_SIGNAL] = g_signal_new ("item-archived", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_ITEM);
	services_store_signals[SERVICES_STORE_ITEM_UNARCHIVED_SIGNAL] = g_signal_new ("item-unarchived", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_ITEM);
	services_store_signals[SERVICES_STORE_ITEM_PIN_CHANGE_SIGNAL] = g_signal_new ("item-pin-change", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_ITEM);
	services_store_signals[SERVICES_STORE_ITEM_LABEL_ADDED_SIGNAL] = g_signal_new ("item-label-added", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
	services_store_signals[SERVICES_STORE_ITEM_LABEL_DELETED_SIGNAL] = g_signal_new ("item-label-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_LABEL);
	services_store_signals[SERVICES_STORE_REMINDER_ADDED_SIGNAL] = g_signal_new ("reminder-added", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_REMINDER);
	services_store_signals[SERVICES_STORE_REMINDER_DELETED_SIGNAL] = g_signal_new ("reminder-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_REMINDER);
	services_store_signals[SERVICES_STORE_ATTACHMENT_DELETED_SIGNAL] = g_signal_new ("attachment-deleted", SERVICES_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_TYPE_ATTACHMENT);
}

static void
services_store_instance_init (ServicesStore * self,
                              gpointer klass)
{
	self->priv = services_store_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock__sources);
	self->priv->_sources = NULL;
	g_rec_mutex_init (&self->priv->__lock__projects);
	self->priv->_projects = NULL;
	g_rec_mutex_init (&self->priv->__lock__sections);
	self->priv->_sections = NULL;
	g_rec_mutex_init (&self->priv->__lock__items);
	self->priv->_items = NULL;
	g_rec_mutex_init (&self->priv->__lock__labels);
	self->priv->_labels = NULL;
	g_rec_mutex_init (&self->priv->__lock__reminders);
	self->priv->_reminders = NULL;
	g_rec_mutex_init (&self->priv->__lock__attachments);
	self->priv->_attachments = NULL;
}

static void
services_store_finalize (GObject * obj)
{
	ServicesStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_STORE, ServicesStore);
	g_rec_mutex_clear (&self->priv->__lock__sources);
	_g_object_unref0 (self->priv->_sources);
	g_rec_mutex_clear (&self->priv->__lock__projects);
	_g_object_unref0 (self->priv->_projects);
	g_rec_mutex_clear (&self->priv->__lock__sections);
	_g_object_unref0 (self->priv->_sections);
	g_rec_mutex_clear (&self->priv->__lock__items);
	_g_object_unref0 (self->priv->_items);
	g_rec_mutex_clear (&self->priv->__lock__labels);
	_g_object_unref0 (self->priv->_labels);
	g_rec_mutex_clear (&self->priv->__lock__reminders);
	_g_object_unref0 (self->priv->_reminders);
	g_rec_mutex_clear (&self->priv->__lock__attachments);
	_g_object_unref0 (self->priv->_attachments);
	G_OBJECT_CLASS (services_store_parent_class)->finalize (obj);
}

static GType
services_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesStore), 0, (GInstanceInitFunc) services_store_instance_init, NULL };
	GType services_store_type_id;
	services_store_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesStore", &g_define_type_info, 0);
	ServicesStore_private_offset = g_type_add_instance_private (services_store_type_id, sizeof (ServicesStorePrivate));
	return services_store_type_id;
}

GType
services_store_get_type (void)
{
	static volatile gsize services_store_type_id__once = 0;
	if (g_once_init_enter (&services_store_type_id__once)) {
		GType services_store_type_id;
		services_store_type_id = services_store_get_type_once ();
		g_once_init_leave (&services_store_type_id__once, services_store_type_id);
	}
	return services_store_type_id__once;
}

static void
_vala_services_store_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ServicesStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SERVICES_TYPE_STORE, ServicesStore);
	switch (property_id) {
		case SERVICES_STORE_SOURCES_PROPERTY:
		g_value_set_object (value, services_store_get_sources (self));
		break;
		case SERVICES_STORE_PROJECTS_PROPERTY:
		g_value_set_object (value, services_store_get_projects (self));
		break;
		case SERVICES_STORE_SECTIONS_PROPERTY:
		g_value_set_object (value, services_store_get_sections (self));
		break;
		case SERVICES_STORE_ITEMS_PROPERTY:
		g_value_set_object (value, services_store_get_items (self));
		break;
		case SERVICES_STORE_LABELS_PROPERTY:
		g_value_set_object (value, services_store_get_labels (self));
		break;
		case SERVICES_STORE_REMINDERS_PROPERTY:
		g_value_set_object (value, services_store_get_reminders (self));
		break;
		case SERVICES_STORE_ATTACHMENTS_PROPERTY:
		g_value_set_object (value, services_store_get_attachments (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

