/* Todoist.c generated by valac 0.56.18, the Vala compiler
 * generated from Todoist.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gxml/gxml.h>
#include <gobject/gvaluecollector.h>

#define SERVICES_TODOIST_TODOIST_SYNC_URL "https://api.todoist.com/sync/v9/sync"
#define SERVICES_TODOIST_RESOURCE_TYPES "[\"user\", \"projects\", \"sections\", \"items\", \"labels\", \"remind" \
"ers\"]"
#define SERVICES_TODOIST_PROJECTS_COLLECTION "projects"
#define SERVICES_TODOIST_SECTIONS_COLLECTION "sections"
#define SERVICES_TODOIST_ITEMS_COLLECTION "items"
#define SERVICES_TODOIST_LABELS_COLLECTION "labels"
#define SERVICES_TODOIST_REMINDERS_COLLECTION "reminders"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SERVICES_TODOIST_0_PROPERTY,
	SERVICES_TODOIST_NUM_PROPERTIES
};
static GParamSpec* services_todoist_properties[SERVICES_TODOIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _http_response_unref0(var) ((var == NULL) ? NULL : (var = (http_response_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ServicesTodoistLoginData ServicesTodoistLoginData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _ServicesTodoistAddTodoistAccountData ServicesTodoistAddTodoistAccountData;
typedef struct _ServicesTodoistSyncData ServicesTodoistSyncData;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
typedef struct _ServicesTodoistQueueData ServicesTodoistQueueData;
typedef struct _ServicesTodoistAddData ServicesTodoistAddData;
typedef struct _ServicesTodoistUpdateData ServicesTodoistUpdateData;
typedef struct _ServicesTodoistUpdateItemsData ServicesTodoistUpdateItemsData;
typedef struct _ServicesTodoistDeleteData ServicesTodoistDeleteData;
typedef struct _ServicesTodoistCompleteItemData ServicesTodoistCompleteItemData;
typedef struct _ServicesTodoistMoveItemData ServicesTodoistMoveItemData;
typedef struct _ServicesTodoistMoveProjectSectionData ServicesTodoistMoveProjectSectionData;
typedef struct _ServicesTodoistDuplicateProjectData ServicesTodoistDuplicateProjectData;
enum  {
	SERVICES_TODOIST_SYNC_STARTED_SIGNAL,
	SERVICES_TODOIST_SYNC_FINISHED_SIGNAL,
	SERVICES_TODOIST_FIRST_SYNC_STARTED_SIGNAL,
	SERVICES_TODOIST_FIRST_SYNC_FINISHED_SIGNAL,
	SERVICES_TODOIST_NUM_SIGNALS
};
static guint services_todoist_signals[SERVICES_TODOIST_NUM_SIGNALS] = {0};
typedef struct _ParamSpecHttpResponse ParamSpecHttpResponse;

struct _ServicesTodoistPrivate {
	SoupSession* session;
	JsonParser* parser;
};

struct _ServicesTodoistLoginData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	gchar* _url;
	HttpResponse* result;
	gchar* code;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* url;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	SoupMessage* message;
	const gchar* _tmp14_;
	SoupMessage* _tmp15_;
	HttpResponse* response;
	HttpResponse* _tmp16_;
	GBytes* stream;
	SoupSession* _tmp17_;
	SoupMessage* _tmp18_;
	GBytes* _tmp19_;
	JsonParser* _tmp20_;
	GBytes* _tmp21_;
	gsize _tmp22_;
	guint8* _tmp23_;
	JsonParser* _tmp24_;
	JsonNode* _tmp25_;
	JsonObject* root;
	JsonParser* _tmp26_;
	JsonNode* _tmp27_;
	JsonObject* _tmp28_;
	JsonObject* _tmp29_;
	gchar* token;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	HttpResponse* _tmp32_;
	GError* e;
	HttpResponse* _tmp33_;
	HttpResponse* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	GError* _inner_error0_;
};

struct _ServicesTodoistAddTodoistAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	gchar* token;
	HttpResponse* response;
	gchar* url;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	SoupMessage* message;
	const gchar* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GBytes* stream;
	SoupSession* _tmp16_;
	SoupMessage* _tmp17_;
	GBytes* _tmp18_;
	JsonParser* _tmp19_;
	GBytes* _tmp20_;
	gsize _tmp21_;
	guint8* _tmp22_;
	JsonParser* _tmp23_;
	JsonNode* _tmp24_;
	ObjectsSource* source;
	ObjectsSource* _tmp25_;
	ObjectsSource* _tmp26_;
	Util* _tmp27_;
	Util* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	ObjectsSource* _tmp31_;
	ObjectsSourceTodoistData* todoist_data;
	ObjectsSourceTodoistData* _tmp32_;
	ObjectsSourceTodoistData* _tmp33_;
	JsonParser* _tmp34_;
	JsonNode* _tmp35_;
	JsonObject* _tmp36_;
	const gchar* _tmp37_;
	ObjectsSourceTodoistData* _tmp38_;
	ObjectsSource* _tmp39_;
	JsonObject* user_object;
	JsonParser* _tmp40_;
	JsonNode* _tmp41_;
	JsonObject* _tmp42_;
	JsonObject* _tmp43_;
	JsonObject* _tmp44_;
	JsonObject* _tmp45_;
	ObjectsSourceTodoistData* _tmp46_;
	JsonObject* _tmp47_;
	const gchar* _tmp48_;
	ObjectsSourceTodoistData* _tmp49_;
	JsonObject* _tmp50_;
	const gchar* _tmp51_;
	ObjectsSourceTodoistData* _tmp52_;
	JsonObject* _tmp53_;
	const gchar* _tmp54_;
	ObjectsSourceTodoistData* _tmp55_;
	JsonObject* _tmp56_;
	const gchar* _tmp57_;
	ObjectsSourceTodoistData* _tmp58_;
	JsonObject* _tmp59_;
	ObjectsSource* _tmp60_;
	JsonObject* _tmp61_;
	const gchar* _tmp62_;
	ObjectsSource* _tmp63_;
	ObjectsSourceTodoistData* _tmp64_;
	ServicesStore* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	ServicesStore* _tmp69_;
	ObjectsSource* _tmp70_;
	JsonArray* labels;
	JsonParser* _tmp71_;
	JsonNode* _tmp72_;
	JsonObject* _tmp73_;
	JsonArray* _tmp74_;
	JsonArray* _tmp75_;
	GList* _tmp76_;
	GList* _node_collection;
	GList* _node_it;
	JsonNode* _node;
	ObjectsLabel* _label;
	JsonNode* _tmp77_;
	ObjectsLabel* _tmp78_;
	ObjectsLabel* _tmp79_;
	ObjectsSource* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	ServicesStore* _tmp83_;
	ObjectsLabel* _tmp84_;
	JsonArray* projects;
	JsonParser* _tmp85_;
	JsonNode* _tmp86_;
	JsonObject* _tmp87_;
	JsonArray* _tmp88_;
	JsonArray* _tmp89_;
	GList* _tmp90_;
	GList* _vala1__node_collection;
	GList* _vala1__node_it;
	JsonNode* _vala1__node;
	ObjectsProject* _project;
	JsonNode* _tmp91_;
	ObjectsProject* _tmp92_;
	ObjectsProject* _tmp93_;
	ObjectsSource* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	JsonNode* _tmp97_;
	JsonObject* _tmp98_;
	ObjectsProject* project;
	ServicesStore* _tmp99_;
	JsonNode* _tmp100_;
	JsonObject* _tmp101_;
	const gchar* _tmp102_;
	ObjectsProject* _tmp103_;
	ObjectsProject* _tmp104_;
	ObjectsProject* _tmp105_;
	ObjectsProject* _tmp106_;
	ObjectsProject* _tmp107_;
	ObjectsProject* _tmp108_;
	ServicesStore* _tmp109_;
	ObjectsProject* _tmp110_;
	JsonArray* sections;
	JsonParser* _tmp111_;
	JsonNode* _tmp112_;
	JsonObject* _tmp113_;
	JsonArray* _tmp114_;
	JsonArray* _tmp115_;
	GList* _tmp116_;
	GList* _vala2__node_collection;
	GList* _vala2__node_it;
	JsonNode* _vala2__node;
	JsonNode* _tmp117_;
	JsonArray* items;
	JsonParser* _tmp118_;
	JsonNode* _tmp119_;
	JsonObject* _tmp120_;
	JsonArray* _tmp121_;
	JsonArray* _tmp122_;
	GList* _tmp123_;
	GList* _vala3__node_collection;
	GList* _vala3__node_it;
	JsonNode* _vala3__node;
	JsonNode* _tmp124_;
	JsonArray* reminders;
	JsonParser* _tmp125_;
	JsonNode* _tmp126_;
	JsonObject* _tmp127_;
	JsonArray* _tmp128_;
	JsonArray* _tmp129_;
	GList* _tmp130_;
	GList* _vala4__node_collection;
	GList* _vala4__node_it;
	JsonNode* _vala4__node;
	ObjectsReminder* reminder;
	JsonNode* _tmp131_;
	ObjectsReminder* _tmp132_;
	ObjectsItem* item;
	ServicesStore* _tmp133_;
	ObjectsReminder* _tmp134_;
	const gchar* _tmp135_;
	const gchar* _tmp136_;
	ObjectsItem* _tmp137_;
	ObjectsItem* _tmp138_;
	ObjectsItem* _tmp139_;
	ObjectsReminder* _tmp140_;
	ObjectsReminder* _tmp141_;
	ObjectsReminder* _tmp142_;
	JsonObject* _tmp143_;
	Util* _tmp144_;
	Util* _tmp145_;
	ObjectsSource* _tmp146_;
	ObjectsSourceTodoistData* _tmp147_;
	ObjectsSourceTodoistData* _tmp148_;
	const gchar* _tmp149_;
	const gchar* _tmp150_;
	JsonObject* _tmp151_;
	const gchar* _tmp152_;
	ObjectsSource* _tmp153_;
	GDateTime* _tmp154_;
	GDateTime* _tmp155_;
	gchar* _tmp156_;
	gchar* _tmp157_;
	ObjectsSource* _tmp158_;
	GError* e;
	GError* _tmp159_;
	GError* _tmp160_;
	const gchar* _tmp161_;
	GError* _tmp162_;
	const gchar* _tmp163_;
	GError* _inner_error0_;
};

struct _ServicesTodoistSyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsSource* source;
	ObjectsSourceTodoistData* _tmp0_;
	ObjectsSourceTodoistData* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* url;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	ObjectsSourceTodoistData* _tmp8_;
	ObjectsSourceTodoistData* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	SoupMessage* message;
	const gchar* _tmp20_;
	SoupMessage* _tmp21_;
	SoupMessage* _tmp22_;
	SoupMessageHeaders* _tmp23_;
	SoupMessageHeaders* _tmp24_;
	ObjectsSourceTodoistData* _tmp25_;
	ObjectsSourceTodoistData* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GBytes* stream;
	SoupSession* _tmp31_;
	SoupMessage* _tmp32_;
	GBytes* _tmp33_;
	JsonParser* _tmp34_;
	GBytes* _tmp35_;
	gsize _tmp36_;
	guint8* _tmp37_;
	JsonParser* _tmp38_;
	JsonNode* _tmp39_;
	JsonParser* _tmp40_;
	JsonNode* _tmp41_;
	JsonObject* _tmp42_;
	ObjectsSourceTodoistData* _tmp43_;
	ObjectsSourceTodoistData* _tmp44_;
	JsonParser* _tmp45_;
	JsonNode* _tmp46_;
	JsonObject* _tmp47_;
	const gchar* _tmp48_;
	JsonParser* _tmp49_;
	JsonNode* _tmp50_;
	JsonObject* _tmp51_;
	JsonObject* user_object;
	JsonParser* _tmp52_;
	JsonNode* _tmp53_;
	JsonObject* _tmp54_;
	JsonObject* _tmp55_;
	JsonObject* _tmp56_;
	ObjectsSourceTodoistData* _tmp57_;
	ObjectsSourceTodoistData* _tmp58_;
	JsonObject* _tmp59_;
	ObjectsSourceTodoistData* _tmp60_;
	ObjectsSourceTodoistData* _tmp61_;
	JsonObject* _tmp62_;
	const gchar* _tmp63_;
	ObjectsSourceTodoistData* _tmp64_;
	ObjectsSourceTodoistData* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	JsonArray* _labels;
	JsonParser* _tmp68_;
	JsonNode* _tmp69_;
	JsonObject* _tmp70_;
	JsonArray* _tmp71_;
	JsonArray* _tmp72_;
	GList* _tmp73_;
	GList* _node_collection;
	GList* _node_it;
	JsonNode* _node;
	gchar* _id;
	JsonNode* _tmp74_;
	JsonObject* _tmp75_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
	ObjectsLabel* label;
	ServicesStore* _tmp78_;
	const gchar* _tmp79_;
	ObjectsLabel* _tmp80_;
	ObjectsLabel* _tmp81_;
	JsonNode* _tmp82_;
	JsonObject* _tmp83_;
	ServicesStore* _tmp84_;
	ObjectsLabel* _tmp85_;
	ObjectsLabel* _tmp86_;
	JsonNode* _tmp87_;
	ServicesStore* _tmp88_;
	ObjectsLabel* _tmp89_;
	ObjectsLabel* _label;
	JsonNode* _tmp90_;
	ObjectsLabel* _tmp91_;
	ObjectsLabel* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	ServicesStore* _tmp95_;
	ObjectsLabel* _tmp96_;
	JsonArray* projects;
	JsonParser* _tmp97_;
	JsonNode* _tmp98_;
	JsonObject* _tmp99_;
	JsonArray* _tmp100_;
	JsonArray* _tmp101_;
	GList* _tmp102_;
	GList* _vala1__node_collection;
	GList* _vala1__node_it;
	JsonNode* _vala1__node;
	ObjectsProject* project;
	ServicesStore* _tmp103_;
	JsonNode* _tmp104_;
	JsonObject* _tmp105_;
	const gchar* _tmp106_;
	ObjectsProject* _tmp107_;
	ObjectsProject* _tmp108_;
	JsonNode* _tmp109_;
	JsonObject* _tmp110_;
	ServicesStore* _tmp111_;
	ObjectsProject* _tmp112_;
	gchar* old_parent_id;
	ObjectsProject* _tmp113_;
	const gchar* _tmp114_;
	const gchar* _tmp115_;
	gchar* _tmp116_;
	gboolean old_is_favorite;
	ObjectsProject* _tmp117_;
	gboolean _tmp118_;
	gboolean _tmp119_;
	ObjectsProject* _tmp120_;
	JsonNode* _tmp121_;
	ServicesStore* _tmp122_;
	ObjectsProject* _tmp123_;
	ObjectsProject* _tmp124_;
	const gchar* _tmp125_;
	const gchar* _tmp126_;
	const gchar* _tmp127_;
	ServicesEventBus* _tmp128_;
	ServicesEventBus* _tmp129_;
	ObjectsProject* _tmp130_;
	const gchar* _tmp131_;
	ObjectsProject* _tmp132_;
	gboolean _tmp133_;
	gboolean _tmp134_;
	ServicesEventBus* _tmp135_;
	ServicesEventBus* _tmp136_;
	ObjectsProject* _tmp137_;
	ObjectsProject* _project;
	JsonNode* _tmp138_;
	ObjectsProject* _tmp139_;
	ObjectsProject* _tmp140_;
	const gchar* _tmp141_;
	const gchar* _tmp142_;
	ServicesStore* _tmp143_;
	ObjectsProject* _tmp144_;
	JsonArray* sections;
	JsonParser* _tmp145_;
	JsonNode* _tmp146_;
	JsonObject* _tmp147_;
	JsonArray* _tmp148_;
	JsonArray* _tmp149_;
	GList* _tmp150_;
	GList* _vala2__node_collection;
	GList* _vala2__node_it;
	JsonNode* _vala2__node;
	ObjectsSection* section;
	ServicesStore* _tmp151_;
	JsonNode* _tmp152_;
	JsonObject* _tmp153_;
	const gchar* _tmp154_;
	ObjectsSection* _tmp155_;
	ObjectsSection* _tmp156_;
	JsonNode* _tmp157_;
	JsonObject* _tmp158_;
	ServicesStore* _tmp159_;
	ObjectsSection* _tmp160_;
	ObjectsSection* _tmp161_;
	JsonNode* _tmp162_;
	ServicesStore* _tmp163_;
	ObjectsSection* _tmp164_;
	JsonNode* _tmp165_;
	JsonArray* items;
	JsonParser* _tmp166_;
	JsonNode* _tmp167_;
	JsonObject* _tmp168_;
	JsonArray* _tmp169_;
	JsonArray* _tmp170_;
	GList* _tmp171_;
	GList* _vala3__node_collection;
	GList* _vala3__node_it;
	JsonNode* _vala3__node;
	ObjectsItem* item;
	ServicesStore* _tmp172_;
	JsonNode* _tmp173_;
	JsonObject* _tmp174_;
	const gchar* _tmp175_;
	ObjectsItem* _tmp176_;
	ObjectsItem* _tmp177_;
	JsonNode* _tmp178_;
	JsonObject* _tmp179_;
	ServicesStore* _tmp180_;
	ObjectsItem* _tmp181_;
	gchar* old_project_id;
	ObjectsItem* _tmp182_;
	const gchar* _tmp183_;
	const gchar* _tmp184_;
	gchar* _tmp185_;
	gchar* old_section_id;
	ObjectsItem* _tmp186_;
	const gchar* _tmp187_;
	const gchar* _tmp188_;
	gchar* _tmp189_;
	gchar* _vala1_old_parent_id;
	ObjectsItem* _tmp190_;
	const gchar* _tmp191_;
	const gchar* _tmp192_;
	gchar* _tmp193_;
	gboolean old_checked;
	ObjectsItem* _tmp194_;
	gboolean _tmp195_;
	gboolean _tmp196_;
	ObjectsItem* _tmp197_;
	JsonNode* _tmp198_;
	ServicesStore* _tmp199_;
	ObjectsItem* _tmp200_;
	gboolean _tmp201_;
	gboolean _tmp202_;
	const gchar* _tmp203_;
	ObjectsItem* _tmp204_;
	const gchar* _tmp205_;
	const gchar* _tmp206_;
	const gchar* _tmp207_;
	ObjectsItem* _tmp208_;
	const gchar* _tmp209_;
	const gchar* _tmp210_;
	const gchar* _tmp211_;
	ObjectsItem* _tmp212_;
	const gchar* _tmp213_;
	const gchar* _tmp214_;
	ServicesEventBus* _tmp215_;
	ServicesEventBus* _tmp216_;
	ObjectsItem* _tmp217_;
	const gchar* _tmp218_;
	const gchar* _tmp219_;
	const gchar* _tmp220_;
	ObjectsItem* _tmp221_;
	gboolean _tmp222_;
	gboolean _tmp223_;
	ServicesStore* _tmp224_;
	ObjectsItem* _tmp225_;
	JsonNode* _tmp226_;
	JsonArray* reminders;
	JsonParser* _tmp227_;
	JsonNode* _tmp228_;
	JsonObject* _tmp229_;
	JsonArray* _tmp230_;
	JsonArray* _tmp231_;
	GList* _tmp232_;
	GList* _vala4__node_collection;
	GList* _vala4__node_it;
	JsonNode* _vala4__node;
	ObjectsReminder* reminder;
	ServicesStore* _tmp233_;
	JsonNode* _tmp234_;
	JsonObject* _tmp235_;
	const gchar* _tmp236_;
	ObjectsReminder* _tmp237_;
	ObjectsReminder* _tmp238_;
	JsonNode* _tmp239_;
	JsonObject* _tmp240_;
	ServicesStore* _tmp241_;
	ObjectsReminder* _tmp242_;
	JsonNode* _tmp243_;
	ObjectsReminder* _tmp244_;
	ObjectsItem* _vala1_item;
	ServicesStore* _tmp245_;
	ObjectsReminder* _tmp246_;
	const gchar* _tmp247_;
	const gchar* _tmp248_;
	ObjectsItem* _tmp249_;
	ObjectsItem* _tmp250_;
	ObjectsItem* _tmp251_;
	ObjectsReminder* _tmp252_;
	ObjectsReminder* _tmp253_;
	ObjectsReminder* _tmp254_;
	GError* e;
	GError* _tmp255_;
	const gchar* _tmp256_;
	gchar* _tmp257_;
	gchar* _tmp258_;
	GDateTime* _tmp259_;
	GDateTime* _tmp260_;
	gchar* _tmp261_;
	gchar* _tmp262_;
	GError* _inner_error0_;
};

struct _ServicesTodoistQueueData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsSource* source;
	GeeArrayList* queue_collection;
	ServicesDatabase* _tmp0_;
	ServicesDatabase* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* json;
	GeeArrayList* _tmp7_;
	gchar* _tmp8_;
	SoupMessage* message;
	SoupMessage* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	ObjectsSourceTodoistData* _tmp13_;
	ObjectsSourceTodoistData* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	SoupMessage* _tmp19_;
	const gchar* _tmp20_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp22_;
	guint8* _tmp23_;
	gint _tmp23__length1;
	GBytes* _tmp24_;
	GBytes* _tmp25_;
	GBytes* stream;
	SoupSession* _tmp26_;
	SoupMessage* _tmp27_;
	GBytes* _tmp28_;
	JsonParser* _tmp29_;
	GBytes* _tmp30_;
	gsize _tmp31_;
	guint8* _tmp32_;
	JsonParser* _tmp33_;
	JsonNode* _tmp34_;
	JsonObject* node;
	JsonParser* _tmp35_;
	JsonNode* _tmp36_;
	JsonObject* _tmp37_;
	JsonObject* _tmp38_;
	gchar* sync_token;
	JsonObject* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	ObjectsSourceTodoistData* _tmp42_;
	ObjectsSourceTodoistData* _tmp43_;
	const gchar* _tmp44_;
	GeeArrayList* _q_list;
	GeeArrayList* _tmp45_;
	gint _q_size;
	GeeArrayList* _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gint _q_index;
	gint _tmp49_;
	gint _tmp50_;
	ObjectsQueue* q;
	GeeArrayList* _tmp51_;
	gpointer _tmp52_;
	JsonNode* uuid_member;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	ObjectsQueue* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	JsonNode* _tmp58_;
	JsonNode* _tmp59_;
	JsonNode* _tmp60_;
	ObjectsQueue* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	gchar* id;
	JsonObject* _tmp64_;
	JsonObject* _tmp65_;
	ObjectsQueue* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	ServicesStore* _tmp71_;
	ObjectsQueue* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	ServicesDatabase* _tmp76_;
	ServicesDatabase* _tmp77_;
	ObjectsQueue* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	ObjectsQueue* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gchar* _vala1_id;
	JsonObject* _tmp84_;
	JsonObject* _tmp85_;
	ObjectsQueue* _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	gchar* _tmp90_;
	ServicesStore* _tmp91_;
	ObjectsQueue* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	const gchar* _tmp95_;
	ServicesDatabase* _tmp96_;
	ServicesDatabase* _tmp97_;
	ObjectsQueue* _tmp98_;
	const gchar* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	gchar* _vala2_id;
	JsonObject* _tmp104_;
	JsonObject* _tmp105_;
	ObjectsQueue* _tmp106_;
	const gchar* _tmp107_;
	const gchar* _tmp108_;
	const gchar* _tmp109_;
	gchar* _tmp110_;
	ServicesStore* _tmp111_;
	ObjectsQueue* _tmp112_;
	const gchar* _tmp113_;
	const gchar* _tmp114_;
	const gchar* _tmp115_;
	ServicesDatabase* _tmp116_;
	ServicesDatabase* _tmp117_;
	ObjectsQueue* _tmp118_;
	const gchar* _tmp119_;
	const gchar* _tmp120_;
	ServicesDatabase* _tmp121_;
	ServicesDatabase* _tmp122_;
	ObjectsQueue* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	GError* e;
	GError* _tmp126_;
	const gchar* _tmp127_;
	GError* _inner_error0_;
};

struct _ServicesTodoistAddData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* object;
	HttpResponse* result;
	gchar* temp_id;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* uuid;
	Util* _tmp4_;
	Util* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* id;
	gchar* json;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	SoupMessage* message;
	SoupMessage* _tmp11_;
	SoupMessage* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	SoupMessageHeaders* _tmp14_;
	ObjectsSource* _tmp15_;
	ObjectsSource* _tmp16_;
	ObjectsSourceTodoistData* _tmp17_;
	ObjectsSourceTodoistData* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	SoupMessage* _tmp23_;
	const gchar* _tmp24_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	gint _tmp26_;
	guint8* _tmp27_;
	gint _tmp27__length1;
	GBytes* _tmp28_;
	GBytes* _tmp29_;
	HttpResponse* response;
	HttpResponse* _tmp30_;
	GBytes* stream;
	SoupSession* _tmp31_;
	SoupMessage* _tmp32_;
	GBytes* _tmp33_;
	JsonParser* _tmp34_;
	GBytes* _tmp35_;
	gsize _tmp36_;
	guint8* _tmp37_;
	JsonParser* _tmp38_;
	JsonNode* _tmp39_;
	SoupMessage* _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	HttpResponse* _tmp43_;
	JsonParser* _tmp44_;
	JsonNode* _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	SoupMessage* _tmp49_;
	guint _tmp50_;
	guint _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	JsonObject* sync_status;
	JsonParser* _tmp54_;
	JsonNode* _tmp55_;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonObject* _tmp58_;
	JsonNode* uuid_member;
	JsonObject* _tmp59_;
	const gchar* _tmp60_;
	JsonNode* _tmp61_;
	JsonNode* _tmp62_;
	JsonNode* _tmp63_;
	ObjectsSource* _tmp64_;
	ObjectsSource* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	ObjectsSourceTodoistData* _tmp67_;
	JsonParser* _tmp68_;
	JsonNode* _tmp69_;
	JsonObject* _tmp70_;
	const gchar* _tmp71_;
	ObjectsSource* _tmp72_;
	ObjectsSource* _tmp73_;
	GDateTime* _tmp74_;
	GDateTime* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	ObjectsSource* _tmp78_;
	ObjectsSource* _tmp79_;
	JsonParser* _tmp80_;
	JsonNode* _tmp81_;
	JsonObject* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	gchar* _tmp86_;
	HttpResponse* _tmp87_;
	HttpResponse* _tmp88_;
	const gchar* _tmp89_;
	HttpResponse* _tmp90_;
	JsonObject* _tmp91_;
	const gchar* _tmp92_;
	JsonObject* _tmp93_;
	const gchar* _tmp94_;
	JsonObject* _tmp95_;
	const gchar* _tmp96_;
	JsonObject* _tmp97_;
	JsonObject* _tmp98_;
	const gchar* _tmp99_;
	JsonObject* _tmp100_;
	const gchar* _tmp101_;
	GError* e;
	SoupMessage* _tmp102_;
	guint _tmp103_;
	guint _tmp104_;
	HttpResponse* _tmp105_;
	GError* _tmp106_;
	const gchar* _tmp107_;
	SoupMessage* _tmp108_;
	guint _tmp109_;
	guint _tmp110_;
	GError* _tmp111_;
	const gchar* _tmp112_;
	Util* _tmp113_;
	Util* _tmp114_;
	gchar* _tmp115_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp116_;
	ObjectsQueue* _tmp117_;
	const gchar* _tmp118_;
	ObjectsQueue* _tmp119_;
	const gchar* _tmp120_;
	ObjectsQueue* _tmp121_;
	const gchar* _tmp122_;
	ObjectsQueue* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	ObjectsQueue* _tmp126_;
	gchar* _tmp127_;
	gchar* _tmp128_;
	ServicesDatabase* _tmp129_;
	ServicesDatabase* _tmp130_;
	ObjectsQueue* _tmp131_;
	ServicesDatabase* _tmp132_;
	ServicesDatabase* _tmp133_;
	const gchar* _tmp134_;
	const gchar* _tmp135_;
	const gchar* _tmp136_;
	const gchar* _tmp137_;
	const gchar* _tmp138_;
	HttpResponse* _tmp139_;
	HttpResponse* _tmp140_;
	ObjectsQueue* _tmp141_;
	const gchar* _tmp142_;
	const gchar* _tmp143_;
	GError* _inner_error0_;
};

struct _ServicesTodoistUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* object;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	ObjectsSource* source;
	ObjectsSource* _tmp6_;
	ObjectsSource* _tmp7_;
	ObjectsSource* _tmp8_;
	SoupMessage* message;
	SoupMessage* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	ObjectsSource* _tmp13_;
	ObjectsSourceTodoistData* _tmp14_;
	ObjectsSourceTodoistData* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	SoupMessage* _tmp20_;
	const gchar* _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	gint _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	GBytes* _tmp25_;
	GBytes* _tmp26_;
	HttpResponse* response;
	HttpResponse* _tmp27_;
	GBytes* stream;
	SoupSession* _tmp28_;
	SoupMessage* _tmp29_;
	GBytes* _tmp30_;
	JsonParser* _tmp31_;
	GBytes* _tmp32_;
	gsize _tmp33_;
	guint8* _tmp34_;
	JsonParser* _tmp35_;
	JsonNode* _tmp36_;
	SoupMessage* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	HttpResponse* _tmp40_;
	JsonParser* _tmp41_;
	JsonNode* _tmp42_;
	SoupMessage* _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	JsonObject* sync_status;
	JsonParser* _tmp51_;
	JsonNode* _tmp52_;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	JsonObject* _tmp55_;
	JsonNode* uuid_member;
	JsonObject* _tmp56_;
	const gchar* _tmp57_;
	JsonNode* _tmp58_;
	JsonNode* _tmp59_;
	JsonNode* _tmp60_;
	ObjectsSource* _tmp61_;
	ObjectsSourceTodoistData* _tmp62_;
	ObjectsSourceTodoistData* _tmp63_;
	JsonParser* _tmp64_;
	JsonNode* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	HttpResponse* _tmp68_;
	ObjectsSource* _tmp69_;
	GDateTime* _tmp70_;
	GDateTime* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ObjectsSource* _tmp74_;
	HttpResponse* _tmp75_;
	JsonObject* _tmp76_;
	const gchar* _tmp77_;
	JsonObject* _tmp78_;
	const gchar* _tmp79_;
	JsonObject* _tmp80_;
	const gchar* _tmp81_;
	JsonObject* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	const gchar* _tmp86_;
	GError* e;
	SoupMessage* _tmp87_;
	guint _tmp88_;
	guint _tmp89_;
	HttpResponse* _tmp90_;
	GError* _tmp91_;
	const gchar* _tmp92_;
	SoupMessage* _tmp93_;
	guint _tmp94_;
	guint _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp98_;
	ObjectsQueue* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	ObjectsQueue* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	ObjectsQueue* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	ServicesDatabase* _tmp110_;
	ServicesDatabase* _tmp111_;
	ObjectsQueue* _tmp112_;
	HttpResponse* _tmp113_;
	GError* _inner_error0_;
};

struct _ServicesTodoistUpdateItemsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	GeeArrayList* objects;
	gchar* json;
	gchar* _tmp0_;
	SoupMessage* message;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	SoupMessageHeaders* _tmp3_;
	SoupMessageHeaders* _tmp4_;
	ServicesSettings* _tmp5_;
	ServicesSettings* _tmp6_;
	GSettings* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	SoupMessage* _tmp12_;
	const gchar* _tmp13_;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_;
	guint8* _tmp16_;
	gint _tmp16__length1;
	GBytes* _tmp17_;
	GBytes* _tmp18_;
	GBytes* stream;
	SoupSession* _tmp19_;
	SoupMessage* _tmp20_;
	GBytes* _tmp21_;
	JsonParser* _tmp22_;
	GBytes* _tmp23_;
	gsize _tmp24_;
	guint8* _tmp25_;
	JsonParser* _tmp26_;
	JsonNode* _tmp27_;
	SoupMessage* _tmp28_;
	guint _tmp29_;
	guint _tmp30_;
	SoupMessage* _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	SoupMessage* _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	ServicesSettings* _tmp39_;
	ServicesSettings* _tmp40_;
	GSettings* _tmp41_;
	JsonParser* _tmp42_;
	JsonNode* _tmp43_;
	JsonObject* _tmp44_;
	const gchar* _tmp45_;
	GError* e;
	const gchar* _tmp46_;
	GError* _inner_error0_;
};

struct _ServicesTodoistDeleteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* object;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	SoupMessage* message;
	SoupMessage* _tmp10_;
	SoupMessage* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	SoupMessageHeaders* _tmp13_;
	ObjectsSource* _tmp14_;
	ObjectsSource* _tmp15_;
	ObjectsSourceTodoistData* _tmp16_;
	ObjectsSourceTodoistData* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	SoupMessage* _tmp22_;
	const gchar* _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	gint _tmp25_;
	guint8* _tmp26_;
	gint _tmp26__length1;
	GBytes* _tmp27_;
	GBytes* _tmp28_;
	HttpResponse* response;
	HttpResponse* _tmp29_;
	GBytes* stream;
	SoupSession* _tmp30_;
	SoupMessage* _tmp31_;
	GBytes* _tmp32_;
	JsonParser* _tmp33_;
	GBytes* _tmp34_;
	gsize _tmp35_;
	guint8* _tmp36_;
	JsonParser* _tmp37_;
	JsonNode* _tmp38_;
	SoupMessage* _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	HttpResponse* _tmp42_;
	JsonParser* _tmp43_;
	JsonNode* _tmp44_;
	SoupMessage* _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	SoupMessage* _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	JsonObject* sync_status;
	JsonParser* _tmp53_;
	JsonNode* _tmp54_;
	JsonObject* _tmp55_;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonNode* uuid_member;
	JsonObject* _tmp58_;
	const gchar* _tmp59_;
	JsonNode* _tmp60_;
	JsonNode* _tmp61_;
	JsonNode* _tmp62_;
	ObjectsSource* _tmp63_;
	ObjectsSource* _tmp64_;
	ObjectsSourceTodoistData* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	JsonParser* _tmp67_;
	JsonNode* _tmp68_;
	JsonObject* _tmp69_;
	const gchar* _tmp70_;
	ObjectsSource* _tmp71_;
	ObjectsSource* _tmp72_;
	GDateTime* _tmp73_;
	GDateTime* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	ObjectsSource* _tmp77_;
	ObjectsSource* _tmp78_;
	HttpResponse* _tmp79_;
	HttpResponse* _tmp80_;
	JsonObject* _tmp81_;
	const gchar* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	const gchar* _tmp86_;
	JsonObject* _tmp87_;
	JsonObject* _tmp88_;
	const gchar* _tmp89_;
	JsonObject* _tmp90_;
	const gchar* _tmp91_;
	GError* e;
	SoupMessage* _tmp92_;
	guint _tmp93_;
	guint _tmp94_;
	HttpResponse* _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	SoupMessage* _tmp98_;
	guint _tmp99_;
	guint _tmp100_;
	GError* _tmp101_;
	const gchar* _tmp102_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp103_;
	ObjectsQueue* _tmp104_;
	const gchar* _tmp105_;
	ObjectsQueue* _tmp106_;
	const gchar* _tmp107_;
	const gchar* _tmp108_;
	ObjectsQueue* _tmp109_;
	const gchar* _tmp110_;
	const gchar* _tmp111_;
	ObjectsQueue* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	ServicesDatabase* _tmp115_;
	ServicesDatabase* _tmp116_;
	ObjectsQueue* _tmp117_;
	HttpResponse* _tmp118_;
	GError* _inner_error0_;
};

struct _ServicesTodoistCompleteItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsItem* item;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gchar* json;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	ObjectsSource* source;
	ObjectsSource* _tmp9_;
	ObjectsSource* _tmp10_;
	ObjectsSource* _tmp11_;
	SoupMessage* message;
	SoupMessage* _tmp12_;
	SoupMessage* _tmp13_;
	SoupMessageHeaders* _tmp14_;
	SoupMessageHeaders* _tmp15_;
	ObjectsSource* _tmp16_;
	ObjectsSourceTodoistData* _tmp17_;
	ObjectsSourceTodoistData* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	SoupMessage* _tmp23_;
	const gchar* _tmp24_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	gint _tmp26_;
	guint8* _tmp27_;
	gint _tmp27__length1;
	GBytes* _tmp28_;
	GBytes* _tmp29_;
	HttpResponse* response;
	HttpResponse* _tmp30_;
	GBytes* stream;
	SoupSession* _tmp31_;
	SoupMessage* _tmp32_;
	GBytes* _tmp33_;
	JsonParser* _tmp34_;
	GBytes* _tmp35_;
	gsize _tmp36_;
	guint8* _tmp37_;
	JsonParser* _tmp38_;
	JsonNode* _tmp39_;
	SoupMessage* _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	HttpResponse* _tmp43_;
	JsonParser* _tmp44_;
	JsonNode* _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	SoupMessage* _tmp49_;
	guint _tmp50_;
	guint _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	JsonObject* sync_status;
	JsonParser* _tmp54_;
	JsonNode* _tmp55_;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonObject* _tmp58_;
	JsonNode* uuid_member;
	JsonObject* _tmp59_;
	const gchar* _tmp60_;
	JsonNode* _tmp61_;
	JsonNode* _tmp62_;
	JsonNode* _tmp63_;
	ObjectsSource* _tmp64_;
	ObjectsSourceTodoistData* _tmp65_;
	ObjectsSourceTodoistData* _tmp66_;
	JsonParser* _tmp67_;
	JsonNode* _tmp68_;
	JsonObject* _tmp69_;
	const gchar* _tmp70_;
	HttpResponse* _tmp71_;
	ObjectsSource* _tmp72_;
	GDateTime* _tmp73_;
	GDateTime* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	ObjectsSource* _tmp77_;
	HttpResponse* _tmp78_;
	JsonObject* _tmp79_;
	const gchar* _tmp80_;
	JsonObject* _tmp81_;
	const gchar* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	JsonObject* _tmp86_;
	const gchar* _tmp87_;
	JsonObject* _tmp88_;
	const gchar* _tmp89_;
	GError* e;
	SoupMessage* _tmp90_;
	guint _tmp91_;
	guint _tmp92_;
	HttpResponse* _tmp93_;
	GError* _tmp94_;
	const gchar* _tmp95_;
	SoupMessage* _tmp96_;
	guint _tmp97_;
	guint _tmp98_;
	GError* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp101_;
	ObjectsQueue* _tmp102_;
	const gchar* _tmp103_;
	ObjectsQueue* _tmp104_;
	const gchar* _tmp105_;
	const gchar* _tmp106_;
	const gchar* _tmp107_;
	gboolean _tmp108_;
	gboolean _tmp109_;
	ObjectsQueue* _tmp110_;
	ObjectsQueue* _tmp111_;
	gchar* _tmp112_;
	gchar* _tmp113_;
	ServicesDatabase* _tmp114_;
	ServicesDatabase* _tmp115_;
	ObjectsQueue* _tmp116_;
	HttpResponse* _tmp117_;
	GError* _inner_error0_;
};

struct _ServicesTodoistMoveItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsItem* item;
	gchar* type;
	gchar* id;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	ObjectsSource* source;
	ObjectsSource* _tmp6_;
	ObjectsSource* _tmp7_;
	ObjectsSource* _tmp8_;
	SoupMessage* message;
	SoupMessage* _tmp9_;
	SoupMessage* _tmp10_;
	SoupMessageHeaders* _tmp11_;
	SoupMessageHeaders* _tmp12_;
	ObjectsSource* _tmp13_;
	ObjectsSourceTodoistData* _tmp14_;
	ObjectsSourceTodoistData* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	SoupMessage* _tmp20_;
	const gchar* _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	gint _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	GBytes* _tmp25_;
	GBytes* _tmp26_;
	HttpResponse* response;
	HttpResponse* _tmp27_;
	GBytes* stream;
	SoupSession* _tmp28_;
	SoupMessage* _tmp29_;
	GBytes* _tmp30_;
	JsonParser* _tmp31_;
	GBytes* _tmp32_;
	gsize _tmp33_;
	guint8* _tmp34_;
	JsonParser* _tmp35_;
	JsonNode* _tmp36_;
	SoupMessage* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	HttpResponse* _tmp40_;
	JsonParser* _tmp41_;
	JsonNode* _tmp42_;
	SoupMessage* _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	SoupMessage* _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	JsonObject* sync_status;
	JsonParser* _tmp51_;
	JsonNode* _tmp52_;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	JsonObject* _tmp55_;
	JsonNode* uuid_member;
	JsonObject* _tmp56_;
	const gchar* _tmp57_;
	JsonNode* _tmp58_;
	JsonNode* _tmp59_;
	JsonNode* _tmp60_;
	ObjectsSource* _tmp61_;
	ObjectsSourceTodoistData* _tmp62_;
	ObjectsSourceTodoistData* _tmp63_;
	JsonParser* _tmp64_;
	JsonNode* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	HttpResponse* _tmp68_;
	ObjectsSource* _tmp69_;
	GDateTime* _tmp70_;
	GDateTime* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ObjectsSource* _tmp74_;
	HttpResponse* _tmp75_;
	JsonObject* _tmp76_;
	const gchar* _tmp77_;
	JsonObject* _tmp78_;
	const gchar* _tmp79_;
	JsonObject* _tmp80_;
	const gchar* _tmp81_;
	JsonObject* _tmp82_;
	JsonObject* _tmp83_;
	const gchar* _tmp84_;
	JsonObject* _tmp85_;
	const gchar* _tmp86_;
	GError* e;
	SoupMessage* _tmp87_;
	guint _tmp88_;
	guint _tmp89_;
	HttpResponse* _tmp90_;
	GError* _tmp91_;
	const gchar* _tmp92_;
	SoupMessage* _tmp93_;
	guint _tmp94_;
	guint _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp98_;
	ObjectsQueue* _tmp99_;
	const gchar* _tmp100_;
	ObjectsQueue* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	ObjectsQueue* _tmp104_;
	ObjectsQueue* _tmp105_;
	gchar* _tmp106_;
	gchar* _tmp107_;
	ServicesDatabase* _tmp108_;
	ServicesDatabase* _tmp109_;
	ObjectsQueue* _tmp110_;
	HttpResponse* _tmp111_;
	GError* _inner_error0_;
};

struct _ServicesTodoistMoveProjectSectionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsBaseObject* base_object;
	gchar* project_id;
	HttpResponse* result;
	gchar* uuid;
	Util* _tmp0_;
	Util* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* json;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	SoupMessage* message;
	SoupMessage* _tmp6_;
	SoupMessage* _tmp7_;
	SoupMessageHeaders* _tmp8_;
	SoupMessageHeaders* _tmp9_;
	ObjectsSource* _tmp10_;
	ObjectsSource* _tmp11_;
	ObjectsSourceTodoistData* _tmp12_;
	ObjectsSourceTodoistData* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	SoupMessage* _tmp18_;
	const gchar* _tmp19_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gint _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	GBytes* _tmp23_;
	GBytes* _tmp24_;
	HttpResponse* response;
	HttpResponse* _tmp25_;
	GBytes* stream;
	SoupSession* _tmp26_;
	SoupMessage* _tmp27_;
	GBytes* _tmp28_;
	JsonParser* _tmp29_;
	GBytes* _tmp30_;
	gsize _tmp31_;
	guint8* _tmp32_;
	JsonParser* _tmp33_;
	JsonNode* _tmp34_;
	SoupMessage* _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	HttpResponse* _tmp38_;
	JsonParser* _tmp39_;
	JsonNode* _tmp40_;
	SoupMessage* _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	SoupMessage* _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	JsonObject* sync_status;
	JsonParser* _tmp49_;
	JsonNode* _tmp50_;
	JsonObject* _tmp51_;
	JsonObject* _tmp52_;
	JsonObject* _tmp53_;
	JsonNode* uuid_member;
	JsonObject* _tmp54_;
	const gchar* _tmp55_;
	JsonNode* _tmp56_;
	JsonNode* _tmp57_;
	JsonNode* _tmp58_;
	ObjectsSource* _tmp59_;
	ObjectsSource* _tmp60_;
	ObjectsSourceTodoistData* _tmp61_;
	ObjectsSourceTodoistData* _tmp62_;
	JsonParser* _tmp63_;
	JsonNode* _tmp64_;
	JsonObject* _tmp65_;
	const gchar* _tmp66_;
	HttpResponse* _tmp67_;
	ObjectsSource* _tmp68_;
	ObjectsSource* _tmp69_;
	GDateTime* _tmp70_;
	GDateTime* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ObjectsSource* _tmp74_;
	ObjectsSource* _tmp75_;
	HttpResponse* _tmp76_;
	JsonObject* _tmp77_;
	const gchar* _tmp78_;
	JsonObject* _tmp79_;
	const gchar* _tmp80_;
	JsonObject* _tmp81_;
	const gchar* _tmp82_;
	JsonObject* _tmp83_;
	JsonObject* _tmp84_;
	const gchar* _tmp85_;
	JsonObject* _tmp86_;
	const gchar* _tmp87_;
	GError* e;
	SoupMessage* _tmp88_;
	guint _tmp89_;
	guint _tmp90_;
	HttpResponse* _tmp91_;
	GError* _tmp92_;
	const gchar* _tmp93_;
	SoupMessage* _tmp94_;
	guint _tmp95_;
	guint _tmp96_;
	GError* _tmp97_;
	const gchar* _tmp98_;
	ObjectsQueue* queue;
	ObjectsQueue* _tmp99_;
	ObjectsQueue* _tmp100_;
	const gchar* _tmp101_;
	ObjectsQueue* _tmp102_;
	const gchar* _tmp103_;
	const gchar* _tmp104_;
	ObjectsQueue* _tmp105_;
	ObjectsQueue* _tmp106_;
	ObjectsQueue* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	HttpResponse* _tmp110_;
	ServicesDatabase* _tmp111_;
	ServicesDatabase* _tmp112_;
	ObjectsQueue* _tmp113_;
	GError* _inner_error0_;
};

struct _ServicesTodoistDuplicateProjectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ServicesTodoist* self;
	ObjectsProject* project;
	HttpResponse* result;
	gchar* json;
	gchar* _tmp0_;
	SoupMessage* message;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	SoupMessageHeaders* _tmp3_;
	SoupMessageHeaders* _tmp4_;
	ObjectsSource* _tmp5_;
	ObjectsSource* _tmp6_;
	ObjectsSourceTodoistData* _tmp7_;
	ObjectsSourceTodoistData* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	SoupMessage* _tmp13_;
	const gchar* _tmp14_;
	guint8* _tmp15_;
	gint _tmp15__length1;
	gint _tmp16_;
	guint8* _tmp17_;
	gint _tmp17__length1;
	GBytes* _tmp18_;
	GBytes* _tmp19_;
	HttpResponse* response;
	HttpResponse* _tmp20_;
	GBytes* stream;
	SoupSession* _tmp21_;
	SoupMessage* _tmp22_;
	GBytes* _tmp23_;
	JsonParser* _tmp24_;
	GBytes* _tmp25_;
	gsize _tmp26_;
	guint8* _tmp27_;
	JsonParser* _tmp28_;
	JsonNode* _tmp29_;
	SoupMessage* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	HttpResponse* _tmp33_;
	JsonParser* _tmp34_;
	JsonNode* _tmp35_;
	SoupMessage* _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	SoupMessage* _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	HttpResponse* _tmp44_;
	GError* _inner_error0_;
};

struct _HttpResponsePrivate {
	gboolean _status;
	gchar* _error;
	gint _error_code;
	gint _http_code;
	gchar* _data;
	GValue _data_object;
};

struct _ParamSpecHttpResponse {
	GParamSpec parent_instance;
};

static gint ServicesTodoist_private_offset;
static gpointer services_todoist_parent_class = NULL;
static ServicesTodoist* services_todoist__instance;
static ServicesTodoist* services_todoist__instance = NULL;
static gint HttpResponse_private_offset;
static gpointer http_response_parent_class = NULL;

static void services_todoist_login_data_free (gpointer _data);
static gboolean services_todoist_login_co (ServicesTodoistLoginData* _data_);
static void services_todoist_login_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static void services_todoist_print_root (ServicesTodoist* self,
                                  JsonNode* root);
static void services_todoist_add_todoist_account_data_free (gpointer _data);
static gboolean services_todoist_add_todoist_account_co (ServicesTodoistAddTodoistAccountData* _data_);
static void services_todoist_add_todoist_account_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void services_todoist_add_section_if_not_exists (ServicesTodoist* self,
                                                 JsonNode* node);
static void services_todoist_add_item_if_not_exists (ServicesTodoist* self,
                                              JsonNode* node);
static void services_todoist_sync_data_free (gpointer _data);
static gboolean services_todoist_sync_co (ServicesTodoistSyncData* _data_);
static void services_todoist_sync_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_);
static void services_todoist_queue_data_free (gpointer _data);
static gboolean services_todoist_queue_co (ServicesTodoistQueueData* _data_);
static void services_todoist_queue_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void services_todoist_add_data_free (gpointer _data);
static gboolean services_todoist_add_co (ServicesTodoistAddData* _data_);
static void services_todoist_add_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_);
static void services_todoist_debug_error (ServicesTodoist* self,
                                   guint status_code,
                                   const gchar* message);
static void services_todoist_update_data_free (gpointer _data);
static gboolean services_todoist_update_co (ServicesTodoistUpdateData* _data_);
static void services_todoist_update_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static void services_todoist_update_items_data_free (gpointer _data);
static gboolean services_todoist_update_items_co (ServicesTodoistUpdateItemsData* _data_);
static void services_todoist_update_items_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void services_todoist_delete_data_free (gpointer _data);
static gboolean services_todoist_delete_co (ServicesTodoistDeleteData* _data_);
static void services_todoist_delete_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
static void services_todoist_complete_item_data_free (gpointer _data);
static gboolean services_todoist_complete_item_co (ServicesTodoistCompleteItemData* _data_);
static void services_todoist_complete_item_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void services_todoist_move_item_data_free (gpointer _data);
static gboolean services_todoist_move_item_co (ServicesTodoistMoveItemData* _data_);
static void services_todoist_move_item_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void services_todoist_move_project_section_data_free (gpointer _data);
static gboolean services_todoist_move_project_section_co (ServicesTodoistMoveProjectSectionData* _data_);
static void services_todoist_move_project_section_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void services_todoist_duplicate_project_data_free (gpointer _data);
static gboolean services_todoist_duplicate_project_co (ServicesTodoistDuplicateProjectData* _data_);
static gchar* services_todoist_get_duplicate_project_json (ServicesTodoist* self,
                                                    ObjectsProject* project);
static void services_todoist_duplicate_project_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void services_todoist_finalize (GObject * obj);
static GType services_todoist_get_type_once (void);
static void http_response_finalize (HttpResponse * obj);
static GType http_response_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
services_todoist_get_instance_private (ServicesTodoist* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesTodoist_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ServicesTodoist*
services_todoist_get_default (void)
{
	ServicesTodoist* _tmp0_;
	ServicesTodoist* _tmp2_;
	ServicesTodoist* _tmp3_;
	ServicesTodoist* result;
	_tmp0_ = services_todoist__instance;
	if (_tmp0_ == NULL) {
		ServicesTodoist* _tmp1_;
		_tmp1_ = services_todoist_new ();
		_g_object_unref0 (services_todoist__instance);
		services_todoist__instance = _tmp1_;
	}
	_tmp2_ = services_todoist__instance;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

ServicesTodoist*
services_todoist_construct (GType object_type)
{
	ServicesTodoist * self = NULL;
	SoupSession* _tmp0_;
	JsonParser* _tmp1_;
	self = (ServicesTodoist*) g_object_new (object_type, NULL);
	_tmp0_ = soup_session_new ();
	_g_object_unref0 (self->priv->session);
	self->priv->session = _tmp0_;
	_tmp1_ = json_parser_new ();
	_g_object_unref0 (self->priv->parser);
	self->priv->parser = _tmp1_;
	return self;
}

ServicesTodoist*
services_todoist_new (void)
{
	return services_todoist_construct (SERVICES_TYPE_TODOIST);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

gboolean
services_todoist_invalid_token (ServicesTodoist* self)
{
	ServicesSettings* _tmp0_;
	ServicesSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = services_settings_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_->settings;
	_tmp3_ = g_settings_get_string (_tmp2_, "todoist-access-token");
	_tmp4_ = _tmp3_;
	_tmp5_ = string_strip (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strcmp0 (_tmp6_, "") == 0;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_object_unref0 (_tmp1_);
	result = _tmp7_;
	return result;
}

gboolean
services_todoist_is_logged_in (ServicesTodoist* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = !services_todoist_invalid_token (self);
	return result;
}

static void
services_todoist_login_data_free (gpointer _data)
{
	ServicesTodoistLoginData* _data_;
	_data_ = _data;
	_g_free0 (_data_->_url);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistLoginData, _data_);
}

void
services_todoist_login (ServicesTodoist* self,
                        const gchar* _url,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ServicesTodoistLoginData* _data_;
	ServicesTodoist* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_url != NULL);
	_data_ = g_slice_new0 (ServicesTodoistLoginData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_login_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (_url);
	_g_free0 (_data_->_url);
	_data_->_url = _tmp1_;
	services_todoist_login_co (_data_);
}

HttpResponse*
services_todoist_login_finish (ServicesTodoist* self,
                               GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistLoginData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_login_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	ServicesTodoistLoginData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_login_co (_data_);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static gboolean
services_todoist_login_co (ServicesTodoistLoginData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = _data_->_tmp0_ = g_strsplit (_data_->_url, "=", 0);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp2__length1 = _vala_array_length (_data_->_tmp0_);
	_data_->_tmp3_ = _data_->_tmp2_[1];
	_data_->_tmp4_ = g_strdup (_data_->_tmp3_);
	_data_->_tmp5_ = _data_->_tmp4_;
	_data_->_tmp2_ = (_vala_array_free (_data_->_tmp2_, _data_->_tmp2__length1, (GDestroyNotify) g_free), NULL);
	_data_->code = _data_->_tmp5_;
	_data_->_tmp6_ = _data_->code;
	_data_->_tmp8_ = _data_->_tmp7_ = g_strsplit (_data_->_tmp6_, "&", 0);
	_data_->_tmp9_ = _data_->_tmp8_;
	_data_->_tmp9__length1 = _vala_array_length (_data_->_tmp7_);
	_data_->_tmp10_ = _data_->_tmp9_[0];
	_data_->_tmp11_ = g_strdup (_data_->_tmp10_);
	_g_free0 (_data_->code);
	_data_->code = _data_->_tmp11_;
	_data_->_tmp9_ = (_vala_array_free (_data_->_tmp9_, _data_->_tmp9__length1, (GDestroyNotify) g_free), NULL);
	_data_->_tmp12_ = _data_->code;
	_data_->_tmp13_ = g_strdup_printf ("https://todoist.com/oauth/access_token?client_id=%s&client_secret=%s&c" \
"ode=%s", CONSTANTS_TODOIST_CLIENT_ID, CONSTANTS_TODOIST_CLIENT_SECRET, _data_->_tmp12_);
	_data_->url = _data_->_tmp13_;
	_data_->_tmp14_ = _data_->url;
	_data_->_tmp15_ = soup_message_new ("POST", _data_->_tmp14_);
	_data_->message = _data_->_tmp15_;
	_data_->_tmp16_ = http_response_new ();
	_data_->response = _data_->_tmp16_;
	{
		_data_->_tmp17_ = _data_->self->priv->session;
		_data_->_tmp18_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp17_, _data_->_tmp18_, G_PRIORITY_HIGH, NULL, services_todoist_login_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp19_ = soup_session_send_and_read_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp19_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp20_ = _data_->self->priv->parser;
		_data_->_tmp21_ = _data_->stream;
		_data_->_tmp22_ = 0;
		_data_->_tmp23_ = g_bytes_get_data (_data_->_tmp21_, &_data_->_tmp22_);
		json_parser_load_from_data (_data_->_tmp20_, (const gchar*) _data_->_tmp23_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp24_ = _data_->self->priv->parser;
		_data_->_tmp25_ = json_parser_get_root (_data_->_tmp24_);
		services_todoist_print_root (_data_->self, _data_->_tmp25_);
		_data_->_tmp26_ = _data_->self->priv->parser;
		_data_->_tmp27_ = json_parser_get_root (_data_->_tmp26_);
		_data_->_tmp28_ = json_node_get_object (_data_->_tmp27_);
		_data_->_tmp29_ = _json_object_ref0 (_data_->_tmp28_);
		_data_->root = _data_->_tmp29_;
		_data_->_tmp30_ = json_object_get_string_member (_data_->root, "access_token");
		_data_->_tmp31_ = g_strdup (_data_->_tmp30_);
		_data_->token = _data_->_tmp31_;
		_data_->_tmp32_ = _data_->response;
		_data_->_state_ = 2;
		services_todoist_add_todoist_account (_data_->self, _data_->token, _data_->_tmp32_, services_todoist_login_ready, _data_);
		return FALSE;
		_state_2:
		services_todoist_add_todoist_account_finish (_data_->self, _data_->_res_);
		_g_free0 (_data_->token);
		_json_object_unref0 (_data_->root);
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp33_ = _data_->response;
		http_response_set_error_code (_data_->_tmp33_, _data_->e->code);
		_data_->_tmp34_ = _data_->response;
		_data_->_tmp35_ = _data_->e->message;
		http_response_set_error (_data_->_tmp34_, _data_->_tmp35_);
		_data_->_tmp36_ = _data_->e->message;
		g_error ("Todoist.vala:87: %s", _data_->_tmp36_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->url);
		_g_free0 (_data_->code);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->url);
	_g_free0 (_data_->code);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_add_todoist_account_data_free (gpointer _data)
{
	ServicesTodoistAddTodoistAccountData* _data_;
	_data_ = _data;
	_g_free0 (_data_->token);
	_http_response_unref0 (_data_->response);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistAddTodoistAccountData, _data_);
}

static gpointer
_http_response_ref0 (gpointer self)
{
	return self ? http_response_ref (self) : NULL;
}

void
services_todoist_add_todoist_account (ServicesTodoist* self,
                                      const gchar* token,
                                      HttpResponse* response,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	ServicesTodoistAddTodoistAccountData* _data_;
	ServicesTodoist* _tmp0_;
	gchar* _tmp1_;
	HttpResponse* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (token != NULL);
	g_return_if_fail (response != NULL);
	_data_ = g_slice_new0 (ServicesTodoistAddTodoistAccountData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_add_todoist_account_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (token);
	_g_free0 (_data_->token);
	_data_->token = _tmp1_;
	_tmp2_ = _http_response_ref0 (response);
	_http_response_unref0 (_data_->response);
	_data_->response = _tmp2_;
	services_todoist_add_todoist_account_co (_data_);
}

void
services_todoist_add_todoist_account_finish (ServicesTodoist* self,
                                             GAsyncResult* _res_)
{
	ServicesTodoistAddTodoistAccountData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
services_todoist_add_todoist_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	ServicesTodoistAddTodoistAccountData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_add_todoist_account_co (_data_);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static gboolean
services_todoist_add_todoist_account_co (ServicesTodoistAddTodoistAccountData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_strdup (SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->url = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->url;
	_data_->_tmp2_ = g_strconcat (_data_->_tmp1_, "?sync_token=", NULL);
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_tmp4_ = g_strconcat (_data_->_tmp3_, "*", NULL);
	_g_free0 (_data_->url);
	_data_->url = _data_->_tmp4_;
	_g_free0 (_data_->_tmp3_);
	_data_->_tmp5_ = _data_->url;
	_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "&resource_types=", NULL);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = g_strconcat (_data_->_tmp7_, SERVICES_TODOIST_RESOURCE_TYPES, NULL);
	_g_free0 (_data_->url);
	_data_->url = _data_->_tmp8_;
	_g_free0 (_data_->_tmp7_);
	_data_->_tmp9_ = _data_->url;
	_data_->_tmp10_ = soup_message_new ("POST", _data_->_tmp9_);
	_data_->message = _data_->_tmp10_;
	_data_->_tmp11_ = _data_->message;
	_data_->_tmp12_ = soup_message_get_request_headers (_data_->_tmp11_);
	_data_->_tmp13_ = _data_->_tmp12_;
	_data_->_tmp14_ = g_strdup_printf ("Bearer %s", _data_->token);
	_data_->_tmp15_ = _data_->_tmp14_;
	soup_message_headers_append (_data_->_tmp13_, "Authorization", _data_->_tmp15_);
	_g_free0 (_data_->_tmp15_);
	{
		_data_->_tmp16_ = _data_->self->priv->session;
		_data_->_tmp17_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp16_, _data_->_tmp17_, G_PRIORITY_HIGH, NULL, services_todoist_add_todoist_account_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp18_ = soup_session_send_and_read_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp18_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp19_ = _data_->self->priv->parser;
		_data_->_tmp20_ = _data_->stream;
		_data_->_tmp21_ = 0;
		_data_->_tmp22_ = g_bytes_get_data (_data_->_tmp20_, &_data_->_tmp21_);
		json_parser_load_from_data (_data_->_tmp19_, (const gchar*) _data_->_tmp22_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp23_ = _data_->self->priv->parser;
		_data_->_tmp24_ = json_parser_get_root (_data_->_tmp23_);
		services_todoist_print_root (_data_->self, _data_->_tmp24_);
		_data_->_tmp25_ = objects_source_new ();
		_data_->source = _data_->_tmp25_;
		_data_->_tmp26_ = _data_->source;
		_data_->_tmp27_ = util_get_default ();
		_data_->_tmp28_ = _data_->_tmp27_;
		_data_->_tmp29_ = util_generate_id (_data_->_tmp28_, NULL);
		_data_->_tmp30_ = _data_->_tmp29_;
		objects_base_object_set_id ((ObjectsBaseObject*) _data_->_tmp26_, _data_->_tmp30_);
		_g_free0 (_data_->_tmp30_);
		_g_object_unref0 (_data_->_tmp28_);
		_data_->_tmp31_ = _data_->source;
		objects_source_set_source_type (_data_->_tmp31_, SOURCE_TYPE_TODOIST);
		_data_->_tmp32_ = objects_source_todoist_data_new ();
		_data_->todoist_data = _data_->_tmp32_;
		_data_->_tmp33_ = _data_->todoist_data;
		_data_->_tmp34_ = _data_->self->priv->parser;
		_data_->_tmp35_ = json_parser_get_root (_data_->_tmp34_);
		_data_->_tmp36_ = json_node_get_object (_data_->_tmp35_);
		_data_->_tmp37_ = json_object_get_string_member (_data_->_tmp36_, "sync_token");
		objects_source_todoist_data_set_sync_token (_data_->_tmp33_, _data_->_tmp37_);
		_data_->_tmp38_ = _data_->todoist_data;
		objects_source_todoist_data_set_access_token (_data_->_tmp38_, _data_->token);
		_data_->_tmp39_ = _data_->source;
		objects_source_set_sync_server (_data_->_tmp39_, TRUE);
		_data_->_tmp40_ = _data_->self->priv->parser;
		_data_->_tmp41_ = json_parser_get_root (_data_->_tmp40_);
		_data_->_tmp42_ = json_node_get_object (_data_->_tmp41_);
		_data_->_tmp43_ = json_object_get_object_member (_data_->_tmp42_, "user");
		_data_->_tmp44_ = _json_object_ref0 (_data_->_tmp43_);
		_data_->user_object = _data_->_tmp44_;
		_data_->_tmp45_ = _data_->user_object;
		if (json_object_get_null_member (_data_->_tmp45_, "image_id") == FALSE) {
			_data_->_tmp46_ = _data_->todoist_data;
			_data_->_tmp47_ = _data_->user_object;
			_data_->_tmp48_ = json_object_get_string_member (_data_->_tmp47_, "image_id");
			objects_source_todoist_data_set_user_image_id (_data_->_tmp46_, _data_->_tmp48_);
			_data_->_tmp49_ = _data_->todoist_data;
			_data_->_tmp50_ = _data_->user_object;
			_data_->_tmp51_ = json_object_get_string_member (_data_->_tmp50_, "avatar_s640");
			objects_source_todoist_data_set_user_avatar (_data_->_tmp49_, _data_->_tmp51_);
		}
		_data_->_tmp52_ = _data_->todoist_data;
		_data_->_tmp53_ = _data_->user_object;
		_data_->_tmp54_ = json_object_get_string_member (_data_->_tmp53_, "full_name");
		objects_source_todoist_data_set_user_name (_data_->_tmp52_, _data_->_tmp54_);
		_data_->_tmp55_ = _data_->todoist_data;
		_data_->_tmp56_ = _data_->user_object;
		_data_->_tmp57_ = json_object_get_string_member (_data_->_tmp56_, "email");
		objects_source_todoist_data_set_user_email (_data_->_tmp55_, _data_->_tmp57_);
		_data_->_tmp58_ = _data_->todoist_data;
		_data_->_tmp59_ = _data_->user_object;
		objects_source_todoist_data_set_user_is_premium (_data_->_tmp58_, json_object_get_boolean_member (_data_->_tmp59_, "is_premium"));
		_data_->_tmp60_ = _data_->source;
		_data_->_tmp61_ = _data_->user_object;
		_data_->_tmp62_ = json_object_get_string_member (_data_->_tmp61_, "email");
		objects_source_set_display_name (_data_->_tmp60_, _data_->_tmp62_);
		_data_->_tmp63_ = _data_->source;
		_data_->_tmp64_ = _data_->todoist_data;
		objects_source_set_data (_data_->_tmp63_, (ObjectsSourceData*) _data_->_tmp64_);
		_data_->_tmp65_ = services_store_instance ();
		_data_->_tmp66_ = _data_->todoist_data;
		_data_->_tmp67_ = objects_source_todoist_data_get_user_email (_data_->_tmp66_);
		_data_->_tmp68_ = _data_->_tmp67_;
		if (services_store_source_todoist_exists (_data_->_tmp65_, _data_->_tmp68_)) {
			http_response_set_error_code (_data_->response, 409);
			http_response_set_error (_data_->response, "Source already exists");
			http_response_set_status (_data_->response, FALSE);
			_json_object_unref0 (_data_->user_object);
			_g_object_unref0 (_data_->todoist_data);
			_g_object_unref0 (_data_->source);
			_g_bytes_unref0 (_data_->stream);
			_g_object_unref0 (_data_->message);
			_g_free0 (_data_->url);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp69_ = services_store_instance ();
		_data_->_tmp70_ = _data_->source;
		services_store_insert_source (_data_->_tmp69_, _data_->_tmp70_);
		_data_->_tmp71_ = _data_->self->priv->parser;
		_data_->_tmp72_ = json_parser_get_root (_data_->_tmp71_);
		_data_->_tmp73_ = json_node_get_object (_data_->_tmp72_);
		_data_->_tmp74_ = json_object_get_array_member (_data_->_tmp73_, SERVICES_TODOIST_LABELS_COLLECTION);
		_data_->labels = _data_->_tmp74_;
		_data_->_tmp75_ = _data_->labels;
		_data_->_tmp76_ = json_array_get_elements (_data_->_tmp75_);
		{
			_data_->_node_collection = _data_->_tmp76_;
			for (_data_->_node_it = _data_->_node_collection; _data_->_node_it != NULL; _data_->_node_it = _data_->_node_it->next) {
				_data_->_node = (JsonNode*) _data_->_node_it->data;
				{
					_data_->_tmp77_ = _data_->_node;
					_data_->_tmp78_ = objects_label_new_from_json (_data_->_tmp77_);
					_data_->_label = _data_->_tmp78_;
					_data_->_tmp79_ = _data_->_label;
					_data_->_tmp80_ = _data_->source;
					_data_->_tmp81_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->_tmp80_);
					_data_->_tmp82_ = _data_->_tmp81_;
					objects_label_set_source_id (_data_->_tmp79_, _data_->_tmp82_);
					_data_->_tmp83_ = services_store_instance ();
					_data_->_tmp84_ = _data_->_label;
					services_store_insert_label (_data_->_tmp83_, _data_->_tmp84_);
					_g_object_unref0 (_data_->_label);
				}
			}
			(_data_->_node_collection == NULL) ? NULL : (_data_->_node_collection = (g_list_free (_data_->_node_collection), NULL));
		}
		_data_->_tmp85_ = _data_->self->priv->parser;
		_data_->_tmp86_ = json_parser_get_root (_data_->_tmp85_);
		_data_->_tmp87_ = json_node_get_object (_data_->_tmp86_);
		_data_->_tmp88_ = json_object_get_array_member (_data_->_tmp87_, SERVICES_TODOIST_PROJECTS_COLLECTION);
		_data_->projects = _data_->_tmp88_;
		_data_->_tmp89_ = _data_->projects;
		_data_->_tmp90_ = json_array_get_elements (_data_->_tmp89_);
		{
			_data_->_vala1__node_collection = _data_->_tmp90_;
			for (_data_->_vala1__node_it = _data_->_vala1__node_collection; _data_->_vala1__node_it != NULL; _data_->_vala1__node_it = _data_->_vala1__node_it->next) {
				_data_->_vala1__node = (JsonNode*) _data_->_vala1__node_it->data;
				{
					_data_->_tmp91_ = _data_->_vala1__node;
					_data_->_tmp92_ = objects_project_new_from_json (_data_->_tmp91_);
					_data_->_project = _data_->_tmp92_;
					_data_->_tmp93_ = _data_->_project;
					_data_->_tmp94_ = _data_->source;
					_data_->_tmp95_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->_tmp94_);
					_data_->_tmp96_ = _data_->_tmp95_;
					objects_project_set_source_id (_data_->_tmp93_, _data_->_tmp96_);
					_data_->_tmp97_ = _data_->_vala1__node;
					_data_->_tmp98_ = json_node_get_object (_data_->_tmp97_);
					if (!json_object_get_null_member (_data_->_tmp98_, "parent_id")) {
						_data_->_tmp99_ = services_store_instance ();
						_data_->_tmp100_ = _data_->_vala1__node;
						_data_->_tmp101_ = json_node_get_object (_data_->_tmp100_);
						_data_->_tmp102_ = json_object_get_string_member (_data_->_tmp101_, "parent_id");
						_data_->_tmp103_ = services_store_get_project (_data_->_tmp99_, _data_->_tmp102_);
						_data_->project = _data_->_tmp103_;
						_data_->_tmp104_ = _data_->project;
						if (_data_->_tmp104_ != NULL) {
							_data_->_tmp105_ = _data_->project;
							_data_->_tmp106_ = _data_->_project;
							_data_->_tmp107_ = objects_project_add_subproject_if_not_exists (_data_->_tmp105_, _data_->_tmp106_);
							_data_->_tmp108_ = _data_->_tmp107_;
							_g_object_unref0 (_data_->_tmp108_);
						}
						_g_object_unref0 (_data_->project);
					} else {
						_data_->_tmp109_ = services_store_instance ();
						_data_->_tmp110_ = _data_->_project;
						services_store_insert_project (_data_->_tmp109_, _data_->_tmp110_);
					}
					_g_object_unref0 (_data_->_project);
				}
			}
			(_data_->_vala1__node_collection == NULL) ? NULL : (_data_->_vala1__node_collection = (g_list_free (_data_->_vala1__node_collection), NULL));
		}
		_data_->_tmp111_ = _data_->self->priv->parser;
		_data_->_tmp112_ = json_parser_get_root (_data_->_tmp111_);
		_data_->_tmp113_ = json_node_get_object (_data_->_tmp112_);
		_data_->_tmp114_ = json_object_get_array_member (_data_->_tmp113_, SERVICES_TODOIST_SECTIONS_COLLECTION);
		_data_->sections = _data_->_tmp114_;
		_data_->_tmp115_ = _data_->sections;
		_data_->_tmp116_ = json_array_get_elements (_data_->_tmp115_);
		{
			_data_->_vala2__node_collection = _data_->_tmp116_;
			for (_data_->_vala2__node_it = _data_->_vala2__node_collection; _data_->_vala2__node_it != NULL; _data_->_vala2__node_it = _data_->_vala2__node_it->next) {
				_data_->_vala2__node = (JsonNode*) _data_->_vala2__node_it->data;
				{
					_data_->_tmp117_ = _data_->_vala2__node;
					services_todoist_add_section_if_not_exists (_data_->self, _data_->_tmp117_);
				}
			}
			(_data_->_vala2__node_collection == NULL) ? NULL : (_data_->_vala2__node_collection = (g_list_free (_data_->_vala2__node_collection), NULL));
		}
		_data_->_tmp118_ = _data_->self->priv->parser;
		_data_->_tmp119_ = json_parser_get_root (_data_->_tmp118_);
		_data_->_tmp120_ = json_node_get_object (_data_->_tmp119_);
		_data_->_tmp121_ = json_object_get_array_member (_data_->_tmp120_, SERVICES_TODOIST_ITEMS_COLLECTION);
		_data_->items = _data_->_tmp121_;
		_data_->_tmp122_ = _data_->items;
		_data_->_tmp123_ = json_array_get_elements (_data_->_tmp122_);
		{
			_data_->_vala3__node_collection = _data_->_tmp123_;
			for (_data_->_vala3__node_it = _data_->_vala3__node_collection; _data_->_vala3__node_it != NULL; _data_->_vala3__node_it = _data_->_vala3__node_it->next) {
				_data_->_vala3__node = (JsonNode*) _data_->_vala3__node_it->data;
				{
					_data_->_tmp124_ = _data_->_vala3__node;
					services_todoist_add_item_if_not_exists (_data_->self, _data_->_tmp124_);
				}
			}
			(_data_->_vala3__node_collection == NULL) ? NULL : (_data_->_vala3__node_collection = (g_list_free (_data_->_vala3__node_collection), NULL));
		}
		_data_->_tmp125_ = _data_->self->priv->parser;
		_data_->_tmp126_ = json_parser_get_root (_data_->_tmp125_);
		_data_->_tmp127_ = json_node_get_object (_data_->_tmp126_);
		_data_->_tmp128_ = json_object_get_array_member (_data_->_tmp127_, SERVICES_TODOIST_REMINDERS_COLLECTION);
		_data_->reminders = _data_->_tmp128_;
		_data_->_tmp129_ = _data_->reminders;
		_data_->_tmp130_ = json_array_get_elements (_data_->_tmp129_);
		{
			_data_->_vala4__node_collection = _data_->_tmp130_;
			for (_data_->_vala4__node_it = _data_->_vala4__node_collection; _data_->_vala4__node_it != NULL; _data_->_vala4__node_it = _data_->_vala4__node_it->next) {
				_data_->_vala4__node = (JsonNode*) _data_->_vala4__node_it->data;
				{
					_data_->_tmp131_ = _data_->_vala4__node;
					_data_->_tmp132_ = objects_reminder_new_from_json (_data_->_tmp131_);
					_data_->reminder = _data_->_tmp132_;
					_data_->_tmp133_ = services_store_instance ();
					_data_->_tmp134_ = _data_->reminder;
					_data_->_tmp135_ = objects_reminder_get_item_id (_data_->_tmp134_);
					_data_->_tmp136_ = _data_->_tmp135_;
					_data_->_tmp137_ = services_store_get_item (_data_->_tmp133_, _data_->_tmp136_);
					_data_->item = _data_->_tmp137_;
					_data_->_tmp138_ = _data_->item;
					if (_data_->_tmp138_ != NULL) {
						_data_->_tmp139_ = _data_->item;
						_data_->_tmp140_ = _data_->reminder;
						_data_->_tmp141_ = objects_item_add_reminder_if_not_exists (_data_->_tmp139_, _data_->_tmp140_, TRUE);
						_data_->_tmp142_ = _data_->_tmp141_;
						_g_object_unref0 (_data_->_tmp142_);
					}
					_g_object_unref0 (_data_->item);
					_g_object_unref0 (_data_->reminder);
				}
			}
			(_data_->_vala4__node_collection == NULL) ? NULL : (_data_->_vala4__node_collection = (g_list_free (_data_->_vala4__node_collection), NULL));
		}
		_data_->_tmp143_ = _data_->user_object;
		if (json_object_get_null_member (_data_->_tmp143_, "image_id") == FALSE) {
			_data_->_tmp144_ = util_get_default ();
			_data_->_tmp145_ = _data_->_tmp144_;
			_data_->_tmp146_ = _data_->source;
			_data_->_tmp147_ = objects_source_get_todoist_data (_data_->_tmp146_);
			_data_->_tmp148_ = _data_->_tmp147_;
			_data_->_tmp149_ = objects_source_todoist_data_get_user_image_id (_data_->_tmp148_);
			_data_->_tmp150_ = _data_->_tmp149_;
			_data_->_tmp151_ = _data_->user_object;
			_data_->_tmp152_ = json_object_get_string_member (_data_->_tmp151_, "avatar_s640");
			util_download_profile_image (_data_->_tmp145_, _data_->_tmp150_, _data_->_tmp152_);
			_g_object_unref0 (_data_->_tmp145_);
		}
		_data_->_tmp153_ = _data_->source;
		_data_->_tmp154_ = g_date_time_new_now_local ();
		_data_->_tmp155_ = _data_->_tmp154_;
		_data_->_tmp156_ = g_date_time_to_string (_data_->_tmp155_);
		_data_->_tmp157_ = _data_->_tmp156_;
		objects_source_set_last_sync (_data_->_tmp153_, _data_->_tmp157_);
		_g_free0 (_data_->_tmp157_);
		_g_date_time_unref0 (_data_->_tmp155_);
		_data_->_tmp158_ = _data_->source;
		objects_source_save (_data_->_tmp158_);
		http_response_set_status (_data_->response, TRUE);
		_json_object_unref0 (_data_->user_object);
		_g_object_unref0 (_data_->todoist_data);
		_g_object_unref0 (_data_->source);
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp159_ = _data_->e;
		http_response_set_error_code (_data_->response, _data_->_tmp159_->code);
		_data_->_tmp160_ = _data_->e;
		_data_->_tmp161_ = _data_->_tmp160_->message;
		http_response_set_error (_data_->response, _data_->_tmp161_);
		_data_->_tmp162_ = _data_->e;
		_data_->_tmp163_ = _data_->_tmp162_->message;
		g_debug ("Todoist.vala:202: %s", _data_->_tmp163_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->url);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->url);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_sync_data_free (gpointer _data)
{
	ServicesTodoistSyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->source);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistSyncData, _data_);
}

void
services_todoist_sync (ServicesTodoist* self,
                       ObjectsSource* source,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_)
{
	ServicesTodoistSyncData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsSource* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_data_ = g_slice_new0 (ServicesTodoistSyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_sync_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (source);
	_g_object_unref0 (_data_->source);
	_data_->source = _tmp1_;
	services_todoist_sync_co (_data_);
}

void
services_todoist_sync_finish (ServicesTodoist* self,
                              GAsyncResult* _res_)
{
	ServicesTodoistSyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
services_todoist_sync_ready (GObject* source_object,
                             GAsyncResult* _res_,
                             gpointer _user_data_)
{
	ServicesTodoistSyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_sync_co (_data_);
}

static gboolean
services_todoist_sync_co (ServicesTodoistSyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = objects_source_get_todoist_data (_data_->source);
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = objects_source_todoist_data_get_access_token (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	if (_data_->_tmp3_ == NULL) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_signal_emit_by_name (_data_->source, "sync-started");
	_data_->_tmp4_ = g_strdup (SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->url = _data_->_tmp4_;
	_data_->_tmp5_ = _data_->url;
	_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "?sync_token=", NULL);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = objects_source_get_todoist_data (_data_->source);
	_data_->_tmp9_ = _data_->_tmp8_;
	_data_->_tmp10_ = objects_source_todoist_data_get_sync_token (_data_->_tmp9_);
	_data_->_tmp11_ = _data_->_tmp10_;
	_data_->_tmp12_ = g_strconcat (_data_->_tmp7_, _data_->_tmp11_, NULL);
	_g_free0 (_data_->url);
	_data_->url = _data_->_tmp12_;
	_g_free0 (_data_->_tmp7_);
	_data_->_tmp13_ = _data_->url;
	_data_->_tmp14_ = g_strconcat (_data_->_tmp13_, "&resource_types=", NULL);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp16_ = g_strconcat (_data_->_tmp15_, SERVICES_TODOIST_RESOURCE_TYPES, NULL);
	_g_free0 (_data_->url);
	_data_->url = _data_->_tmp16_;
	_g_free0 (_data_->_tmp15_);
	_data_->_tmp17_ = _data_->url;
	_data_->_tmp18_ = g_strdup_printf ("SYNC URL: %s\n", _data_->_tmp17_);
	_data_->_tmp19_ = _data_->_tmp18_;
	g_print ("%s", _data_->_tmp19_);
	_g_free0 (_data_->_tmp19_);
	_data_->_tmp20_ = _data_->url;
	_data_->_tmp21_ = soup_message_new ("POST", _data_->_tmp20_);
	_data_->message = _data_->_tmp21_;
	_data_->_tmp22_ = _data_->message;
	_data_->_tmp23_ = soup_message_get_request_headers (_data_->_tmp22_);
	_data_->_tmp24_ = _data_->_tmp23_;
	_data_->_tmp25_ = objects_source_get_todoist_data (_data_->source);
	_data_->_tmp26_ = _data_->_tmp25_;
	_data_->_tmp27_ = objects_source_todoist_data_get_access_token (_data_->_tmp26_);
	_data_->_tmp28_ = _data_->_tmp27_;
	_data_->_tmp29_ = g_strdup_printf ("Bearer %s", _data_->_tmp28_);
	_data_->_tmp30_ = _data_->_tmp29_;
	soup_message_headers_append (_data_->_tmp24_, "Authorization", _data_->_tmp30_);
	_g_free0 (_data_->_tmp30_);
	{
		_data_->_tmp31_ = _data_->self->priv->session;
		_data_->_tmp32_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp31_, _data_->_tmp32_, G_PRIORITY_LOW, NULL, services_todoist_sync_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp33_ = soup_session_send_and_read_finish (_data_->_tmp31_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp33_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp34_ = _data_->self->priv->parser;
		_data_->_tmp35_ = _data_->stream;
		_data_->_tmp36_ = 0;
		_data_->_tmp37_ = g_bytes_get_data (_data_->_tmp35_, &_data_->_tmp36_);
		json_parser_load_from_data (_data_->_tmp34_, (const gchar*) _data_->_tmp37_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp38_ = _data_->self->priv->parser;
		_data_->_tmp39_ = json_parser_get_root (_data_->_tmp38_);
		services_todoist_print_root (_data_->self, _data_->_tmp39_);
		_data_->_tmp40_ = _data_->self->priv->parser;
		_data_->_tmp41_ = json_parser_get_root (_data_->_tmp40_);
		_data_->_tmp42_ = json_node_get_object (_data_->_tmp41_);
		if (!json_object_has_member (_data_->_tmp42_, "error")) {
			_data_->_tmp43_ = objects_source_get_todoist_data (_data_->source);
			_data_->_tmp44_ = _data_->_tmp43_;
			_data_->_tmp45_ = _data_->self->priv->parser;
			_data_->_tmp46_ = json_parser_get_root (_data_->_tmp45_);
			_data_->_tmp47_ = json_node_get_object (_data_->_tmp46_);
			_data_->_tmp48_ = json_object_get_string_member (_data_->_tmp47_, "sync_token");
			objects_source_todoist_data_set_sync_token (_data_->_tmp44_, _data_->_tmp48_);
			_data_->_tmp49_ = _data_->self->priv->parser;
			_data_->_tmp50_ = json_parser_get_root (_data_->_tmp49_);
			_data_->_tmp51_ = json_node_get_object (_data_->_tmp50_);
			if (json_object_has_member (_data_->_tmp51_, "user")) {
				_data_->_tmp52_ = _data_->self->priv->parser;
				_data_->_tmp53_ = json_parser_get_root (_data_->_tmp52_);
				_data_->_tmp54_ = json_node_get_object (_data_->_tmp53_);
				_data_->_tmp55_ = json_object_get_object_member (_data_->_tmp54_, "user");
				_data_->_tmp56_ = _json_object_ref0 (_data_->_tmp55_);
				_data_->user_object = _data_->_tmp56_;
				_data_->_tmp57_ = objects_source_get_todoist_data (_data_->source);
				_data_->_tmp58_ = _data_->_tmp57_;
				_data_->_tmp59_ = _data_->user_object;
				objects_source_todoist_data_set_user_is_premium (_data_->_tmp58_, json_object_get_boolean_member (_data_->_tmp59_, "is_premium"));
				_data_->_tmp60_ = objects_source_get_todoist_data (_data_->source);
				_data_->_tmp61_ = _data_->_tmp60_;
				_data_->_tmp62_ = _data_->user_object;
				_data_->_tmp63_ = json_object_get_string_member (_data_->_tmp62_, "email");
				objects_source_todoist_data_set_user_email (_data_->_tmp61_, _data_->_tmp63_);
				_data_->_tmp64_ = objects_source_get_todoist_data (_data_->source);
				_data_->_tmp65_ = _data_->_tmp64_;
				_data_->_tmp66_ = _data_->user_object;
				_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "full_name");
				objects_source_todoist_data_set_user_name (_data_->_tmp65_, _data_->_tmp67_);
				_json_object_unref0 (_data_->user_object);
			}
			_data_->_tmp68_ = _data_->self->priv->parser;
			_data_->_tmp69_ = json_parser_get_root (_data_->_tmp68_);
			_data_->_tmp70_ = json_node_get_object (_data_->_tmp69_);
			_data_->_tmp71_ = json_object_get_array_member (_data_->_tmp70_, SERVICES_TODOIST_LABELS_COLLECTION);
			_data_->_labels = _data_->_tmp71_;
			_data_->_tmp72_ = _data_->_labels;
			_data_->_tmp73_ = json_array_get_elements (_data_->_tmp72_);
			{
				_data_->_node_collection = _data_->_tmp73_;
				for (_data_->_node_it = _data_->_node_collection; _data_->_node_it != NULL; _data_->_node_it = _data_->_node_it->next) {
					_data_->_node = (JsonNode*) _data_->_node_it->data;
					{
						_data_->_tmp74_ = _data_->_node;
						_data_->_tmp75_ = json_node_get_object (_data_->_tmp74_);
						_data_->_tmp76_ = json_object_get_string_member (_data_->_tmp75_, "id");
						_data_->_tmp77_ = g_strdup (_data_->_tmp76_);
						_data_->_id = _data_->_tmp77_;
						_data_->_tmp78_ = services_store_instance ();
						_data_->_tmp79_ = _data_->_id;
						_data_->_tmp80_ = services_store_get_label (_data_->_tmp78_, _data_->_tmp79_);
						_data_->label = _data_->_tmp80_;
						_data_->_tmp81_ = _data_->label;
						if (_data_->_tmp81_ != NULL) {
							_data_->_tmp82_ = _data_->_node;
							_data_->_tmp83_ = json_node_get_object (_data_->_tmp82_);
							if (json_object_get_boolean_member (_data_->_tmp83_, "is_deleted")) {
								_data_->_tmp84_ = services_store_instance ();
								_data_->_tmp85_ = _data_->label;
								services_store_delete_label (_data_->_tmp84_, _data_->_tmp85_);
							} else {
								_data_->_tmp86_ = _data_->label;
								_data_->_tmp87_ = _data_->_node;
								objects_label_update_from_json (_data_->_tmp86_, _data_->_tmp87_);
								_data_->_tmp88_ = services_store_instance ();
								_data_->_tmp89_ = _data_->label;
								services_store_update_label (_data_->_tmp88_, _data_->_tmp89_);
							}
						} else {
							_data_->_tmp90_ = _data_->_node;
							_data_->_tmp91_ = objects_label_new_from_json (_data_->_tmp90_);
							_data_->_label = _data_->_tmp91_;
							_data_->_tmp92_ = _data_->_label;
							_data_->_tmp93_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->source);
							_data_->_tmp94_ = _data_->_tmp93_;
							objects_label_set_source_id (_data_->_tmp92_, _data_->_tmp94_);
							_data_->_tmp95_ = services_store_instance ();
							_data_->_tmp96_ = _data_->_label;
							services_store_insert_label (_data_->_tmp95_, _data_->_tmp96_);
							_g_object_unref0 (_data_->_label);
						}
						_g_object_unref0 (_data_->label);
						_g_free0 (_data_->_id);
					}
				}
				(_data_->_node_collection == NULL) ? NULL : (_data_->_node_collection = (g_list_free (_data_->_node_collection), NULL));
			}
			_data_->_tmp97_ = _data_->self->priv->parser;
			_data_->_tmp98_ = json_parser_get_root (_data_->_tmp97_);
			_data_->_tmp99_ = json_node_get_object (_data_->_tmp98_);
			_data_->_tmp100_ = json_object_get_array_member (_data_->_tmp99_, SERVICES_TODOIST_PROJECTS_COLLECTION);
			_data_->projects = _data_->_tmp100_;
			_data_->_tmp101_ = _data_->projects;
			_data_->_tmp102_ = json_array_get_elements (_data_->_tmp101_);
			{
				_data_->_vala1__node_collection = _data_->_tmp102_;
				for (_data_->_vala1__node_it = _data_->_vala1__node_collection; _data_->_vala1__node_it != NULL; _data_->_vala1__node_it = _data_->_vala1__node_it->next) {
					_data_->_vala1__node = (JsonNode*) _data_->_vala1__node_it->data;
					{
						_data_->_tmp103_ = services_store_instance ();
						_data_->_tmp104_ = _data_->_vala1__node;
						_data_->_tmp105_ = json_node_get_object (_data_->_tmp104_);
						_data_->_tmp106_ = json_object_get_string_member (_data_->_tmp105_, "id");
						_data_->_tmp107_ = services_store_get_project (_data_->_tmp103_, _data_->_tmp106_);
						_data_->project = _data_->_tmp107_;
						_data_->_tmp108_ = _data_->project;
						if (_data_->_tmp108_ != NULL) {
							_data_->_tmp109_ = _data_->_vala1__node;
							_data_->_tmp110_ = json_node_get_object (_data_->_tmp109_);
							if (json_object_get_boolean_member (_data_->_tmp110_, "is_deleted")) {
								_data_->_tmp111_ = services_store_instance ();
								_data_->_tmp112_ = _data_->project;
								services_store_delete_project (_data_->_tmp111_, _data_->_tmp112_);
							} else {
								_data_->_tmp113_ = _data_->project;
								_data_->_tmp114_ = objects_project_get_parent_id (_data_->_tmp113_);
								_data_->_tmp115_ = _data_->_tmp114_;
								_data_->_tmp116_ = g_strdup (_data_->_tmp115_);
								_data_->old_parent_id = _data_->_tmp116_;
								_data_->_tmp117_ = _data_->project;
								_data_->_tmp118_ = objects_project_get_is_favorite (_data_->_tmp117_);
								_data_->_tmp119_ = _data_->_tmp118_;
								_data_->old_is_favorite = _data_->_tmp119_;
								_data_->_tmp120_ = _data_->project;
								_data_->_tmp121_ = _data_->_vala1__node;
								objects_project_update_from_json (_data_->_tmp120_, _data_->_tmp121_);
								_data_->_tmp122_ = services_store_instance ();
								_data_->_tmp123_ = _data_->project;
								services_store_update_project (_data_->_tmp122_, _data_->_tmp123_);
								_data_->_tmp124_ = _data_->project;
								_data_->_tmp125_ = objects_project_get_parent_id (_data_->_tmp124_);
								_data_->_tmp126_ = _data_->_tmp125_;
								_data_->_tmp127_ = _data_->old_parent_id;
								if (g_strcmp0 (_data_->_tmp126_, _data_->_tmp127_) != 0) {
									_data_->_tmp128_ = services_event_bus_get_default ();
									_data_->_tmp129_ = _data_->_tmp128_;
									_data_->_tmp130_ = _data_->project;
									_data_->_tmp131_ = _data_->old_parent_id;
									g_signal_emit_by_name (_data_->_tmp129_, "project-parent-changed", _data_->_tmp130_, _data_->_tmp131_, FALSE);
									_g_object_unref0 (_data_->_tmp129_);
								}
								_data_->_tmp132_ = _data_->project;
								_data_->_tmp133_ = objects_project_get_is_favorite (_data_->_tmp132_);
								_data_->_tmp134_ = _data_->_tmp133_;
								if (_data_->_tmp134_ != _data_->old_is_favorite) {
									_data_->_tmp135_ = services_event_bus_get_default ();
									_data_->_tmp136_ = _data_->_tmp135_;
									_data_->_tmp137_ = _data_->project;
									g_signal_emit_by_name (_data_->_tmp136_, "favorite-toggled", _data_->_tmp137_);
									_g_object_unref0 (_data_->_tmp136_);
								}
								_g_free0 (_data_->old_parent_id);
							}
						} else {
							_data_->_tmp138_ = _data_->_vala1__node;
							_data_->_tmp139_ = objects_project_new_from_json (_data_->_tmp138_);
							_data_->_project = _data_->_tmp139_;
							_data_->_tmp140_ = _data_->_project;
							_data_->_tmp141_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->source);
							_data_->_tmp142_ = _data_->_tmp141_;
							objects_project_set_source_id (_data_->_tmp140_, _data_->_tmp142_);
							_data_->_tmp143_ = services_store_instance ();
							_data_->_tmp144_ = _data_->_project;
							services_store_insert_project (_data_->_tmp143_, _data_->_tmp144_);
							_g_object_unref0 (_data_->_project);
						}
						_g_object_unref0 (_data_->project);
					}
				}
				(_data_->_vala1__node_collection == NULL) ? NULL : (_data_->_vala1__node_collection = (g_list_free (_data_->_vala1__node_collection), NULL));
			}
			_data_->_tmp145_ = _data_->self->priv->parser;
			_data_->_tmp146_ = json_parser_get_root (_data_->_tmp145_);
			_data_->_tmp147_ = json_node_get_object (_data_->_tmp146_);
			_data_->_tmp148_ = json_object_get_array_member (_data_->_tmp147_, SERVICES_TODOIST_SECTIONS_COLLECTION);
			_data_->sections = _data_->_tmp148_;
			_data_->_tmp149_ = _data_->sections;
			_data_->_tmp150_ = json_array_get_elements (_data_->_tmp149_);
			{
				_data_->_vala2__node_collection = _data_->_tmp150_;
				for (_data_->_vala2__node_it = _data_->_vala2__node_collection; _data_->_vala2__node_it != NULL; _data_->_vala2__node_it = _data_->_vala2__node_it->next) {
					_data_->_vala2__node = (JsonNode*) _data_->_vala2__node_it->data;
					{
						_data_->_tmp151_ = services_store_instance ();
						_data_->_tmp152_ = _data_->_vala2__node;
						_data_->_tmp153_ = json_node_get_object (_data_->_tmp152_);
						_data_->_tmp154_ = json_object_get_string_member (_data_->_tmp153_, "id");
						_data_->_tmp155_ = services_store_get_section (_data_->_tmp151_, _data_->_tmp154_);
						_data_->section = _data_->_tmp155_;
						_data_->_tmp156_ = _data_->section;
						if (_data_->_tmp156_ != NULL) {
							_data_->_tmp157_ = _data_->_vala2__node;
							_data_->_tmp158_ = json_node_get_object (_data_->_tmp157_);
							if (json_object_get_boolean_member (_data_->_tmp158_, "is_deleted")) {
								_data_->_tmp159_ = services_store_instance ();
								_data_->_tmp160_ = _data_->section;
								services_store_delete_section (_data_->_tmp159_, _data_->_tmp160_);
							} else {
								_data_->_tmp161_ = _data_->section;
								_data_->_tmp162_ = _data_->_vala2__node;
								objects_section_update_from_json (_data_->_tmp161_, _data_->_tmp162_);
								_data_->_tmp163_ = services_store_instance ();
								_data_->_tmp164_ = _data_->section;
								services_store_update_section (_data_->_tmp163_, _data_->_tmp164_);
							}
						} else {
							_data_->_tmp165_ = _data_->_vala2__node;
							services_todoist_add_section_if_not_exists (_data_->self, _data_->_tmp165_);
						}
						_g_object_unref0 (_data_->section);
					}
				}
				(_data_->_vala2__node_collection == NULL) ? NULL : (_data_->_vala2__node_collection = (g_list_free (_data_->_vala2__node_collection), NULL));
			}
			_data_->_tmp166_ = _data_->self->priv->parser;
			_data_->_tmp167_ = json_parser_get_root (_data_->_tmp166_);
			_data_->_tmp168_ = json_node_get_object (_data_->_tmp167_);
			_data_->_tmp169_ = json_object_get_array_member (_data_->_tmp168_, SERVICES_TODOIST_ITEMS_COLLECTION);
			_data_->items = _data_->_tmp169_;
			_data_->_tmp170_ = _data_->items;
			_data_->_tmp171_ = json_array_get_elements (_data_->_tmp170_);
			{
				_data_->_vala3__node_collection = _data_->_tmp171_;
				for (_data_->_vala3__node_it = _data_->_vala3__node_collection; _data_->_vala3__node_it != NULL; _data_->_vala3__node_it = _data_->_vala3__node_it->next) {
					_data_->_vala3__node = (JsonNode*) _data_->_vala3__node_it->data;
					{
						_data_->_tmp172_ = services_store_instance ();
						_data_->_tmp173_ = _data_->_vala3__node;
						_data_->_tmp174_ = json_node_get_object (_data_->_tmp173_);
						_data_->_tmp175_ = json_object_get_string_member (_data_->_tmp174_, "id");
						_data_->_tmp176_ = services_store_get_item (_data_->_tmp172_, _data_->_tmp175_);
						_data_->item = _data_->_tmp176_;
						_data_->_tmp177_ = _data_->item;
						if (_data_->_tmp177_ != NULL) {
							_data_->_tmp178_ = _data_->_vala3__node;
							_data_->_tmp179_ = json_node_get_object (_data_->_tmp178_);
							if (json_object_get_boolean_member (_data_->_tmp179_, "is_deleted")) {
								_data_->_tmp180_ = services_store_instance ();
								_data_->_tmp181_ = _data_->item;
								services_store_delete_item (_data_->_tmp180_, _data_->_tmp181_);
							} else {
								_data_->_tmp182_ = _data_->item;
								_data_->_tmp183_ = objects_item_get_project_id (_data_->_tmp182_);
								_data_->_tmp184_ = _data_->_tmp183_;
								_data_->_tmp185_ = g_strdup (_data_->_tmp184_);
								_data_->old_project_id = _data_->_tmp185_;
								_data_->_tmp186_ = _data_->item;
								_data_->_tmp187_ = objects_item_get_section_id (_data_->_tmp186_);
								_data_->_tmp188_ = _data_->_tmp187_;
								_data_->_tmp189_ = g_strdup (_data_->_tmp188_);
								_data_->old_section_id = _data_->_tmp189_;
								_data_->_tmp190_ = _data_->item;
								_data_->_tmp191_ = objects_item_get_parent_id (_data_->_tmp190_);
								_data_->_tmp192_ = _data_->_tmp191_;
								_data_->_tmp193_ = g_strdup (_data_->_tmp192_);
								_data_->_vala1_old_parent_id = _data_->_tmp193_;
								_data_->_tmp194_ = _data_->item;
								_data_->_tmp195_ = objects_item_get_checked (_data_->_tmp194_);
								_data_->_tmp196_ = _data_->_tmp195_;
								_data_->old_checked = _data_->_tmp196_;
								_data_->_tmp197_ = _data_->item;
								_data_->_tmp198_ = _data_->_vala3__node;
								objects_item_update_from_json (_data_->_tmp197_, _data_->_tmp198_);
								_data_->_tmp199_ = services_store_instance ();
								_data_->_tmp200_ = _data_->item;
								services_store_update_item (_data_->_tmp199_, _data_->_tmp200_, "");
								_data_->_tmp203_ = _data_->old_project_id;
								_data_->_tmp204_ = _data_->item;
								_data_->_tmp205_ = objects_item_get_project_id (_data_->_tmp204_);
								_data_->_tmp206_ = _data_->_tmp205_;
								if (g_strcmp0 (_data_->_tmp203_, _data_->_tmp206_) != 0) {
									_data_->_tmp202_ = TRUE;
								} else {
									_data_->_tmp207_ = _data_->old_section_id;
									_data_->_tmp208_ = _data_->item;
									_data_->_tmp209_ = objects_item_get_section_id (_data_->_tmp208_);
									_data_->_tmp210_ = _data_->_tmp209_;
									_data_->_tmp202_ = g_strcmp0 (_data_->_tmp207_, _data_->_tmp210_) != 0;
								}
								if (_data_->_tmp202_) {
									_data_->_tmp201_ = TRUE;
								} else {
									_data_->_tmp211_ = _data_->_vala1_old_parent_id;
									_data_->_tmp212_ = _data_->item;
									_data_->_tmp213_ = objects_item_get_parent_id (_data_->_tmp212_);
									_data_->_tmp214_ = _data_->_tmp213_;
									_data_->_tmp201_ = g_strcmp0 (_data_->_tmp211_, _data_->_tmp214_) != 0;
								}
								if (_data_->_tmp201_) {
									_data_->_tmp215_ = services_event_bus_get_default ();
									_data_->_tmp216_ = _data_->_tmp215_;
									_data_->_tmp217_ = _data_->item;
									_data_->_tmp218_ = _data_->old_project_id;
									_data_->_tmp219_ = _data_->old_section_id;
									_data_->_tmp220_ = _data_->_vala1_old_parent_id;
									g_signal_emit_by_name (_data_->_tmp216_, "item-moved", _data_->_tmp217_, _data_->_tmp218_, _data_->_tmp219_, _data_->_tmp220_);
									_g_object_unref0 (_data_->_tmp216_);
								}
								_data_->_tmp221_ = _data_->item;
								_data_->_tmp222_ = objects_item_get_checked (_data_->_tmp221_);
								_data_->_tmp223_ = _data_->_tmp222_;
								if (_data_->old_checked != _data_->_tmp223_) {
									_data_->_tmp224_ = services_store_instance ();
									_data_->_tmp225_ = _data_->item;
									services_store_complete_item (_data_->_tmp224_, _data_->_tmp225_, _data_->old_checked, TRUE);
								}
								_g_free0 (_data_->_vala1_old_parent_id);
								_g_free0 (_data_->old_section_id);
								_g_free0 (_data_->old_project_id);
							}
						} else {
							_data_->_tmp226_ = _data_->_vala3__node;
							services_todoist_add_item_if_not_exists (_data_->self, _data_->_tmp226_);
						}
						_g_object_unref0 (_data_->item);
					}
				}
				(_data_->_vala3__node_collection == NULL) ? NULL : (_data_->_vala3__node_collection = (g_list_free (_data_->_vala3__node_collection), NULL));
			}
			_data_->_tmp227_ = _data_->self->priv->parser;
			_data_->_tmp228_ = json_parser_get_root (_data_->_tmp227_);
			_data_->_tmp229_ = json_node_get_object (_data_->_tmp228_);
			_data_->_tmp230_ = json_object_get_array_member (_data_->_tmp229_, SERVICES_TODOIST_REMINDERS_COLLECTION);
			_data_->reminders = _data_->_tmp230_;
			_data_->_tmp231_ = _data_->reminders;
			_data_->_tmp232_ = json_array_get_elements (_data_->_tmp231_);
			{
				_data_->_vala4__node_collection = _data_->_tmp232_;
				for (_data_->_vala4__node_it = _data_->_vala4__node_collection; _data_->_vala4__node_it != NULL; _data_->_vala4__node_it = _data_->_vala4__node_it->next) {
					_data_->_vala4__node = (JsonNode*) _data_->_vala4__node_it->data;
					{
						_data_->_tmp233_ = services_store_instance ();
						_data_->_tmp234_ = _data_->_vala4__node;
						_data_->_tmp235_ = json_node_get_object (_data_->_tmp234_);
						_data_->_tmp236_ = json_object_get_string_member (_data_->_tmp235_, "id");
						_data_->_tmp237_ = services_store_get_reminder (_data_->_tmp233_, _data_->_tmp236_);
						_data_->reminder = _data_->_tmp237_;
						_data_->_tmp238_ = _data_->reminder;
						if (_data_->_tmp238_ != NULL) {
							_data_->_tmp239_ = _data_->_vala4__node;
							_data_->_tmp240_ = json_node_get_object (_data_->_tmp239_);
							if (json_object_get_boolean_member (_data_->_tmp240_, "is_deleted")) {
								_data_->_tmp241_ = services_store_instance ();
								_data_->_tmp242_ = _data_->reminder;
								services_store_delete_reminder (_data_->_tmp241_, _data_->_tmp242_);
							}
						} else {
							_data_->_tmp243_ = _data_->_vala4__node;
							_data_->_tmp244_ = objects_reminder_new_from_json (_data_->_tmp243_);
							_g_object_unref0 (_data_->reminder);
							_data_->reminder = _data_->_tmp244_;
							_data_->_tmp245_ = services_store_instance ();
							_data_->_tmp246_ = _data_->reminder;
							_data_->_tmp247_ = objects_reminder_get_item_id (_data_->_tmp246_);
							_data_->_tmp248_ = _data_->_tmp247_;
							_data_->_tmp249_ = services_store_get_item (_data_->_tmp245_, _data_->_tmp248_);
							_data_->_vala1_item = _data_->_tmp249_;
							_data_->_tmp250_ = _data_->_vala1_item;
							if (_data_->_tmp250_ != NULL) {
								_data_->_tmp251_ = _data_->_vala1_item;
								_data_->_tmp252_ = _data_->reminder;
								_data_->_tmp253_ = objects_item_add_reminder_if_not_exists (_data_->_tmp251_, _data_->_tmp252_, TRUE);
								_data_->_tmp254_ = _data_->_tmp253_;
								_g_object_unref0 (_data_->_tmp254_);
							}
							_g_object_unref0 (_data_->_vala1_item);
						}
						_g_object_unref0 (_data_->reminder);
					}
				}
				(_data_->_vala4__node_collection == NULL) ? NULL : (_data_->_vala4__node_collection = (g_list_free (_data_->_vala4__node_collection), NULL));
			}
			_data_->_state_ = 2;
			services_todoist_queue (_data_->self, _data_->source, services_todoist_sync_ready, _data_);
			return FALSE;
			_state_2:
			services_todoist_queue_finish (_data_->self, _data_->_res_);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp255_ = _data_->e;
		_data_->_tmp256_ = _data_->_tmp255_->message;
		_data_->_tmp257_ = g_strconcat ("Failed to sync: ", _data_->_tmp256_, NULL);
		_data_->_tmp258_ = _data_->_tmp257_;
		g_debug ("Todoist.vala:363: %s", _data_->_tmp258_);
		_g_free0 (_data_->_tmp258_);
		g_signal_emit_by_name (_data_->source, "sync-failed");
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->url);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp259_ = g_date_time_new_now_local ();
	_data_->_tmp260_ = _data_->_tmp259_;
	_data_->_tmp261_ = g_date_time_to_string (_data_->_tmp260_);
	_data_->_tmp262_ = _data_->_tmp261_;
	objects_source_set_last_sync (_data_->source, _data_->_tmp262_);
	_g_free0 (_data_->_tmp262_);
	_g_date_time_unref0 (_data_->_tmp260_);
	g_signal_emit_by_name (_data_->source, "sync-finished");
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->url);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_queue_data_free (gpointer _data)
{
	ServicesTodoistQueueData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->source);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistQueueData, _data_);
}

void
services_todoist_queue (ServicesTodoist* self,
                        ObjectsSource* source,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ServicesTodoistQueueData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsSource* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_data_ = g_slice_new0 (ServicesTodoistQueueData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_queue_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (source);
	_g_object_unref0 (_data_->source);
	_data_->source = _tmp1_;
	services_todoist_queue_co (_data_);
}

void
services_todoist_queue_finish (ServicesTodoist* self,
                               GAsyncResult* _res_)
{
	ServicesTodoistQueueData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

static void
services_todoist_queue_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	ServicesTodoistQueueData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_queue_co (_data_);
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static gboolean
services_todoist_queue_co (ServicesTodoistQueueData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = services_database_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = services_database_get_all_queue (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->queue_collection = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->queue_collection;
	_data_->_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp4_);
	_data_->_tmp6_ = _data_->_tmp5_;
	if (_data_->_tmp6_ <= 0) {
		_g_object_unref0 (_data_->queue_collection);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp7_ = _data_->queue_collection;
	_data_->_tmp8_ = services_todoist_get_queue_json (_data_->self, _data_->_tmp7_);
	_data_->json = _data_->_tmp8_;
	_data_->_tmp9_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp9_;
	_data_->_tmp10_ = _data_->message;
	_data_->_tmp11_ = soup_message_get_request_headers (_data_->_tmp10_);
	_data_->_tmp12_ = _data_->_tmp11_;
	_data_->_tmp13_ = objects_source_get_todoist_data (_data_->source);
	_data_->_tmp14_ = _data_->_tmp13_;
	_data_->_tmp15_ = objects_source_todoist_data_get_access_token (_data_->_tmp14_);
	_data_->_tmp16_ = _data_->_tmp15_;
	_data_->_tmp17_ = g_strdup_printf ("Bearer %s", _data_->_tmp16_);
	_data_->_tmp18_ = _data_->_tmp17_;
	soup_message_headers_append (_data_->_tmp12_, "Authorization", _data_->_tmp18_);
	_g_free0 (_data_->_tmp18_);
	_data_->_tmp19_ = _data_->message;
	_data_->_tmp20_ = _data_->json;
	_data_->_tmp22_ = 0;
	_data_->_tmp21_ = string_get_data (_data_->_tmp20_, &_data_->_tmp22_);
	_data_->_tmp21__length1 = _data_->_tmp22_;
	_data_->_tmp23_ = _data_->_tmp21_;
	_data_->_tmp23__length1 = _data_->_tmp21__length1;
	_data_->_tmp24_ = g_bytes_new (_data_->_tmp23_, _data_->_tmp23__length1);
	_data_->_tmp25_ = _data_->_tmp24_;
	soup_message_set_request_body_from_bytes (_data_->_tmp19_, "application/json", _data_->_tmp25_);
	_g_bytes_unref0 (_data_->_tmp25_);
	{
		_data_->_tmp26_ = _data_->self->priv->session;
		_data_->_tmp27_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp26_, _data_->_tmp27_, G_PRIORITY_LOW, NULL, services_todoist_queue_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp28_ = soup_session_send_and_read_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp28_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp29_ = _data_->self->priv->parser;
		_data_->_tmp30_ = _data_->stream;
		_data_->_tmp31_ = 0;
		_data_->_tmp32_ = g_bytes_get_data (_data_->_tmp30_, &_data_->_tmp31_);
		json_parser_load_from_data (_data_->_tmp29_, (const gchar*) _data_->_tmp32_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp33_ = _data_->self->priv->parser;
		_data_->_tmp34_ = json_parser_get_root (_data_->_tmp33_);
		services_todoist_print_root (_data_->self, _data_->_tmp34_);
		_data_->_tmp35_ = _data_->self->priv->parser;
		_data_->_tmp36_ = json_parser_get_root (_data_->_tmp35_);
		_data_->_tmp37_ = json_node_get_object (_data_->_tmp36_);
		_data_->_tmp38_ = _json_object_ref0 (_data_->_tmp37_);
		_data_->node = _data_->_tmp38_;
		_data_->_tmp39_ = _data_->node;
		_data_->_tmp40_ = json_object_get_string_member (_data_->_tmp39_, "sync_token");
		_data_->_tmp41_ = g_strdup (_data_->_tmp40_);
		_data_->sync_token = _data_->_tmp41_;
		_data_->_tmp42_ = objects_source_get_todoist_data (_data_->source);
		_data_->_tmp43_ = _data_->_tmp42_;
		_data_->_tmp44_ = _data_->sync_token;
		objects_source_todoist_data_set_sync_token (_data_->_tmp43_, _data_->_tmp44_);
		{
			_data_->_tmp45_ = _data_->queue_collection;
			_data_->_q_list = _data_->_tmp45_;
			_data_->_tmp46_ = _data_->_q_list;
			_data_->_tmp47_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp46_);
			_data_->_tmp48_ = _data_->_tmp47_;
			_data_->_q_size = _data_->_tmp48_;
			_data_->_q_index = -1;
			while (TRUE) {
				_data_->_q_index = _data_->_q_index + 1;
				_data_->_tmp49_ = _data_->_q_index;
				_data_->_tmp50_ = _data_->_q_size;
				if (!(_data_->_tmp49_ < _data_->_tmp50_)) {
					break;
				}
				_data_->_tmp51_ = _data_->_q_list;
				_data_->_tmp52_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp51_, _data_->_q_index);
				_data_->q = (ObjectsQueue*) _data_->_tmp52_;
				_data_->_tmp53_ = _data_->node;
				_data_->_tmp54_ = json_object_get_object_member (_data_->_tmp53_, "sync_status");
				_data_->_tmp55_ = _data_->q;
				_data_->_tmp56_ = objects_queue_get_uuid (_data_->_tmp55_);
				_data_->_tmp57_ = _data_->_tmp56_;
				_data_->_tmp58_ = json_object_get_member (_data_->_tmp54_, _data_->_tmp57_);
				_data_->_tmp59_ = __vala_JsonNode_copy0 (_data_->_tmp58_);
				_data_->uuid_member = _data_->_tmp59_;
				_data_->_tmp60_ = _data_->uuid_member;
				if (json_node_get_node_type (_data_->_tmp60_) == JSON_NODE_VALUE) {
					_data_->_tmp61_ = _data_->q;
					_data_->_tmp62_ = objects_queue_get_query (_data_->_tmp61_);
					_data_->_tmp63_ = _data_->_tmp62_;
					if (g_strcmp0 (_data_->_tmp63_, "project_add") == 0) {
						_data_->_tmp64_ = _data_->node;
						_data_->_tmp65_ = json_object_get_object_member (_data_->_tmp64_, "temp_id_mapping");
						_data_->_tmp66_ = _data_->q;
						_data_->_tmp67_ = objects_queue_get_temp_id (_data_->_tmp66_);
						_data_->_tmp68_ = _data_->_tmp67_;
						_data_->_tmp69_ = json_object_get_string_member (_data_->_tmp65_, _data_->_tmp68_);
						_data_->_tmp70_ = g_strdup (_data_->_tmp69_);
						_data_->id = _data_->_tmp70_;
						_data_->_tmp71_ = services_store_instance ();
						_data_->_tmp72_ = _data_->q;
						_data_->_tmp73_ = objects_queue_get_object_id (_data_->_tmp72_);
						_data_->_tmp74_ = _data_->_tmp73_;
						_data_->_tmp75_ = _data_->id;
						services_store_update_project_id (_data_->_tmp71_, _data_->_tmp74_, _data_->_tmp75_);
						_data_->_tmp76_ = services_database_get_default ();
						_data_->_tmp77_ = _data_->_tmp76_;
						_data_->_tmp78_ = _data_->q;
						_data_->_tmp79_ = objects_queue_get_object_id (_data_->_tmp78_);
						_data_->_tmp80_ = _data_->_tmp79_;
						services_database_remove_CurTempIds (_data_->_tmp77_, _data_->_tmp80_);
						_g_object_unref0 (_data_->_tmp77_);
						_g_free0 (_data_->id);
					}
					_data_->_tmp81_ = _data_->q;
					_data_->_tmp82_ = objects_queue_get_query (_data_->_tmp81_);
					_data_->_tmp83_ = _data_->_tmp82_;
					if (g_strcmp0 (_data_->_tmp83_, "section_add") == 0) {
						_data_->_tmp84_ = _data_->node;
						_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp84_, "temp_id_mapping");
						_data_->_tmp86_ = _data_->q;
						_data_->_tmp87_ = objects_queue_get_temp_id (_data_->_tmp86_);
						_data_->_tmp88_ = _data_->_tmp87_;
						_data_->_tmp89_ = json_object_get_string_member (_data_->_tmp85_, _data_->_tmp88_);
						_data_->_tmp90_ = g_strdup (_data_->_tmp89_);
						_data_->_vala1_id = _data_->_tmp90_;
						_data_->_tmp91_ = services_store_instance ();
						_data_->_tmp92_ = _data_->q;
						_data_->_tmp93_ = objects_queue_get_object_id (_data_->_tmp92_);
						_data_->_tmp94_ = _data_->_tmp93_;
						_data_->_tmp95_ = _data_->_vala1_id;
						services_store_update_section_id (_data_->_tmp91_, _data_->_tmp94_, _data_->_tmp95_);
						_data_->_tmp96_ = services_database_get_default ();
						_data_->_tmp97_ = _data_->_tmp96_;
						_data_->_tmp98_ = _data_->q;
						_data_->_tmp99_ = objects_queue_get_object_id (_data_->_tmp98_);
						_data_->_tmp100_ = _data_->_tmp99_;
						services_database_remove_CurTempIds (_data_->_tmp97_, _data_->_tmp100_);
						_g_object_unref0 (_data_->_tmp97_);
						_g_free0 (_data_->_vala1_id);
					}
					_data_->_tmp101_ = _data_->q;
					_data_->_tmp102_ = objects_queue_get_query (_data_->_tmp101_);
					_data_->_tmp103_ = _data_->_tmp102_;
					if (g_strcmp0 (_data_->_tmp103_, "item_add") == 0) {
						_data_->_tmp104_ = _data_->node;
						_data_->_tmp105_ = json_object_get_object_member (_data_->_tmp104_, "temp_id_mapping");
						_data_->_tmp106_ = _data_->q;
						_data_->_tmp107_ = objects_queue_get_temp_id (_data_->_tmp106_);
						_data_->_tmp108_ = _data_->_tmp107_;
						_data_->_tmp109_ = json_object_get_string_member (_data_->_tmp105_, _data_->_tmp108_);
						_data_->_tmp110_ = g_strdup (_data_->_tmp109_);
						_data_->_vala2_id = _data_->_tmp110_;
						_data_->_tmp111_ = services_store_instance ();
						_data_->_tmp112_ = _data_->q;
						_data_->_tmp113_ = objects_queue_get_object_id (_data_->_tmp112_);
						_data_->_tmp114_ = _data_->_tmp113_;
						_data_->_tmp115_ = _data_->_vala2_id;
						services_store_update_item_id (_data_->_tmp111_, _data_->_tmp114_, _data_->_tmp115_);
						_data_->_tmp116_ = services_database_get_default ();
						_data_->_tmp117_ = _data_->_tmp116_;
						_data_->_tmp118_ = _data_->q;
						_data_->_tmp119_ = objects_queue_get_object_id (_data_->_tmp118_);
						_data_->_tmp120_ = _data_->_tmp119_;
						services_database_remove_CurTempIds (_data_->_tmp117_, _data_->_tmp120_);
						_g_object_unref0 (_data_->_tmp117_);
						_g_free0 (_data_->_vala2_id);
					}
					_data_->_tmp121_ = services_database_get_default ();
					_data_->_tmp122_ = _data_->_tmp121_;
					_data_->_tmp123_ = _data_->q;
					_data_->_tmp124_ = objects_queue_get_uuid (_data_->_tmp123_);
					_data_->_tmp125_ = _data_->_tmp124_;
					services_database_remove_queue (_data_->_tmp122_, _data_->_tmp125_);
					_g_object_unref0 (_data_->_tmp122_);
				}
				__vala_JsonNode_free0 (_data_->uuid_member);
				_g_object_unref0 (_data_->q);
			}
		}
		_g_free0 (_data_->sync_token);
		_json_object_unref0 (_data_->node);
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp126_ = _data_->e;
		_data_->_tmp127_ = _data_->_tmp126_->message;
		g_debug ("Todoist.vala:426: %s", _data_->_tmp127_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->json);
		_g_object_unref0 (_data_->queue_collection);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->json);
	_g_object_unref0 (_data_->queue_collection);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

gchar*
services_todoist_get_queue_json (ServicesTodoist* self,
                                 GeeArrayList* queue)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp420_;
	JsonBuilder* _tmp421_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp422_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp423_;
	JsonNode* _tmp424_;
	gchar* _tmp425_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (queue != NULL, NULL);
	_tmp0_ = json_builder_new ();
	builder = _tmp0_;
	_tmp1_ = builder;
	json_builder_begin_object (_tmp1_);
	_tmp2_ = builder;
	json_builder_set_member_name (_tmp2_, "commands");
	_tmp3_ = builder;
	json_builder_begin_array (_tmp3_);
	{
		GeeArrayList* _q_list = NULL;
		gint _q_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _q_index = 0;
		_q_list = queue;
		_tmp4_ = _q_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_q_size = _tmp6_;
		_q_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			ObjectsQueue* q = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			JsonBuilder* _tmp11_;
			ObjectsQueue* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			JsonBuilder* _tmp419_;
			_q_index = _q_index + 1;
			_tmp7_ = _q_index;
			_tmp8_ = _q_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _q_list;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _q_index);
			q = (ObjectsQueue*) _tmp10_;
			_tmp11_ = builder;
			json_builder_begin_object (_tmp11_);
			_tmp12_ = q;
			_tmp13_ = objects_queue_get_query (_tmp12_);
			_tmp14_ = _tmp13_;
			if (g_strcmp0 (_tmp14_, "project_add") == 0) {
				JsonBuilder* _tmp15_;
				JsonBuilder* _tmp16_;
				JsonBuilder* _tmp17_;
				JsonBuilder* _tmp18_;
				ObjectsQueue* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				JsonBuilder* _tmp22_;
				JsonBuilder* _tmp23_;
				ObjectsQueue* _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				JsonBuilder* _tmp27_;
				JsonBuilder* _tmp28_;
				JsonBuilder* _tmp29_;
				JsonBuilder* _tmp30_;
				ObjectsQueue* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				JsonBuilder* _tmp36_;
				JsonBuilder* _tmp37_;
				ObjectsQueue* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				JsonBuilder* _tmp43_;
				JsonBuilder* _tmp44_;
				_tmp15_ = builder;
				json_builder_set_member_name (_tmp15_, "type");
				_tmp16_ = builder;
				json_builder_add_string_value (_tmp16_, "project_add");
				_tmp17_ = builder;
				json_builder_set_member_name (_tmp17_, "temp_id");
				_tmp18_ = builder;
				_tmp19_ = q;
				_tmp20_ = objects_queue_get_temp_id (_tmp19_);
				_tmp21_ = _tmp20_;
				json_builder_add_string_value (_tmp18_, _tmp21_);
				_tmp22_ = builder;
				json_builder_set_member_name (_tmp22_, "uuid");
				_tmp23_ = builder;
				_tmp24_ = q;
				_tmp25_ = objects_queue_get_uuid (_tmp24_);
				_tmp26_ = _tmp25_;
				json_builder_add_string_value (_tmp23_, _tmp26_);
				_tmp27_ = builder;
				json_builder_set_member_name (_tmp27_, "args");
				_tmp28_ = builder;
				json_builder_begin_object (_tmp28_);
				_tmp29_ = builder;
				json_builder_set_member_name (_tmp29_, "name");
				_tmp30_ = builder;
				_tmp31_ = q;
				_tmp32_ = objects_queue_get_args (_tmp31_);
				_tmp33_ = _tmp32_;
				_tmp34_ = services_todoist_get_string_member_by_object (self, _tmp33_, "name");
				_tmp35_ = _tmp34_;
				json_builder_add_string_value (_tmp30_, _tmp35_);
				_g_free0 (_tmp35_);
				_tmp36_ = builder;
				json_builder_set_member_name (_tmp36_, "color");
				_tmp37_ = builder;
				_tmp38_ = q;
				_tmp39_ = objects_queue_get_args (_tmp38_);
				_tmp40_ = _tmp39_;
				_tmp41_ = services_todoist_get_string_member_by_object (self, _tmp40_, "color");
				_tmp42_ = _tmp41_;
				json_builder_add_string_value (_tmp37_, _tmp42_);
				_g_free0 (_tmp42_);
				_tmp43_ = builder;
				json_builder_end_object (_tmp43_);
				_tmp44_ = builder;
				json_builder_end_object (_tmp44_);
			} else {
				ObjectsQueue* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				_tmp45_ = q;
				_tmp46_ = objects_queue_get_query (_tmp45_);
				_tmp47_ = _tmp46_;
				if (g_strcmp0 (_tmp47_, "project_update") == 0) {
					JsonBuilder* _tmp48_;
					JsonBuilder* _tmp49_;
					JsonBuilder* _tmp50_;
					JsonBuilder* _tmp51_;
					ObjectsQueue* _tmp52_;
					const gchar* _tmp53_;
					const gchar* _tmp54_;
					JsonBuilder* _tmp55_;
					JsonBuilder* _tmp56_;
					JsonBuilder* _tmp57_;
					JsonBuilder* _tmp58_;
					ObjectsQueue* _tmp59_;
					const gchar* _tmp60_;
					const gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
					JsonBuilder* _tmp64_;
					JsonBuilder* _tmp65_;
					ObjectsQueue* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
					JsonBuilder* _tmp71_;
					JsonBuilder* _tmp72_;
					ObjectsQueue* _tmp73_;
					const gchar* _tmp74_;
					const gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					JsonBuilder* _tmp78_;
					JsonBuilder* _tmp79_;
					_tmp48_ = builder;
					json_builder_set_member_name (_tmp48_, "type");
					_tmp49_ = builder;
					json_builder_add_string_value (_tmp49_, "project_update");
					_tmp50_ = builder;
					json_builder_set_member_name (_tmp50_, "uuid");
					_tmp51_ = builder;
					_tmp52_ = q;
					_tmp53_ = objects_queue_get_uuid (_tmp52_);
					_tmp54_ = _tmp53_;
					json_builder_add_string_value (_tmp51_, _tmp54_);
					_tmp55_ = builder;
					json_builder_set_member_name (_tmp55_, "args");
					_tmp56_ = builder;
					json_builder_begin_object (_tmp56_);
					_tmp57_ = builder;
					json_builder_set_member_name (_tmp57_, "id");
					_tmp58_ = builder;
					_tmp59_ = q;
					_tmp60_ = objects_queue_get_args (_tmp59_);
					_tmp61_ = _tmp60_;
					_tmp62_ = services_todoist_get_string_member_by_object (self, _tmp61_, "id");
					_tmp63_ = _tmp62_;
					json_builder_add_string_value (_tmp58_, _tmp63_);
					_g_free0 (_tmp63_);
					_tmp64_ = builder;
					json_builder_set_member_name (_tmp64_, "name");
					_tmp65_ = builder;
					_tmp66_ = q;
					_tmp67_ = objects_queue_get_args (_tmp66_);
					_tmp68_ = _tmp67_;
					_tmp69_ = services_todoist_get_string_member_by_object (self, _tmp68_, "name");
					_tmp70_ = _tmp69_;
					json_builder_add_string_value (_tmp65_, _tmp70_);
					_g_free0 (_tmp70_);
					_tmp71_ = builder;
					json_builder_set_member_name (_tmp71_, "color");
					_tmp72_ = builder;
					_tmp73_ = q;
					_tmp74_ = objects_queue_get_args (_tmp73_);
					_tmp75_ = _tmp74_;
					_tmp76_ = services_todoist_get_string_member_by_object (self, _tmp75_, "color");
					_tmp77_ = _tmp76_;
					json_builder_add_string_value (_tmp72_, _tmp77_);
					_g_free0 (_tmp77_);
					_tmp78_ = builder;
					json_builder_end_object (_tmp78_);
					_tmp79_ = builder;
					json_builder_end_object (_tmp79_);
				} else {
					ObjectsQueue* _tmp80_;
					const gchar* _tmp81_;
					const gchar* _tmp82_;
					_tmp80_ = q;
					_tmp81_ = objects_queue_get_query (_tmp80_);
					_tmp82_ = _tmp81_;
					if (g_strcmp0 (_tmp82_, "project_delete") == 0) {
						JsonBuilder* _tmp83_;
						JsonBuilder* _tmp84_;
						JsonBuilder* _tmp85_;
						JsonBuilder* _tmp86_;
						ObjectsQueue* _tmp87_;
						const gchar* _tmp88_;
						const gchar* _tmp89_;
						JsonBuilder* _tmp90_;
						JsonBuilder* _tmp91_;
						JsonBuilder* _tmp92_;
						JsonBuilder* _tmp93_;
						ObjectsQueue* _tmp94_;
						const gchar* _tmp95_;
						const gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						JsonBuilder* _tmp99_;
						JsonBuilder* _tmp100_;
						_tmp83_ = builder;
						json_builder_set_member_name (_tmp83_, "type");
						_tmp84_ = builder;
						json_builder_add_string_value (_tmp84_, "project_delete");
						_tmp85_ = builder;
						json_builder_set_member_name (_tmp85_, "uuid");
						_tmp86_ = builder;
						_tmp87_ = q;
						_tmp88_ = objects_queue_get_uuid (_tmp87_);
						_tmp89_ = _tmp88_;
						json_builder_add_string_value (_tmp86_, _tmp89_);
						_tmp90_ = builder;
						json_builder_set_member_name (_tmp90_, "args");
						_tmp91_ = builder;
						json_builder_begin_object (_tmp91_);
						_tmp92_ = builder;
						json_builder_set_member_name (_tmp92_, "id");
						_tmp93_ = builder;
						_tmp94_ = q;
						_tmp95_ = objects_queue_get_args (_tmp94_);
						_tmp96_ = _tmp95_;
						_tmp97_ = services_todoist_get_string_member_by_object (self, _tmp96_, "id");
						_tmp98_ = _tmp97_;
						json_builder_add_string_value (_tmp93_, _tmp98_);
						_g_free0 (_tmp98_);
						_tmp99_ = builder;
						json_builder_end_object (_tmp99_);
						_tmp100_ = builder;
						json_builder_end_object (_tmp100_);
					} else {
						ObjectsQueue* _tmp101_;
						const gchar* _tmp102_;
						const gchar* _tmp103_;
						_tmp101_ = q;
						_tmp102_ = objects_queue_get_query (_tmp101_);
						_tmp103_ = _tmp102_;
						if (g_strcmp0 (_tmp103_, "section_add") == 0) {
							JsonBuilder* _tmp104_;
							JsonBuilder* _tmp105_;
							JsonBuilder* _tmp106_;
							JsonBuilder* _tmp107_;
							ObjectsQueue* _tmp108_;
							const gchar* _tmp109_;
							const gchar* _tmp110_;
							JsonBuilder* _tmp111_;
							JsonBuilder* _tmp112_;
							ObjectsQueue* _tmp113_;
							const gchar* _tmp114_;
							const gchar* _tmp115_;
							JsonBuilder* _tmp116_;
							JsonBuilder* _tmp117_;
							JsonBuilder* _tmp118_;
							JsonBuilder* _tmp119_;
							ObjectsQueue* _tmp120_;
							const gchar* _tmp121_;
							const gchar* _tmp122_;
							gchar* _tmp123_;
							gchar* _tmp124_;
							JsonBuilder* _tmp125_;
							ObjectsQueue* _tmp126_;
							const gchar* _tmp127_;
							const gchar* _tmp128_;
							JsonBuilder* _tmp141_;
							JsonBuilder* _tmp142_;
							_tmp104_ = builder;
							json_builder_set_member_name (_tmp104_, "type");
							_tmp105_ = builder;
							json_builder_add_string_value (_tmp105_, "section_add");
							_tmp106_ = builder;
							json_builder_set_member_name (_tmp106_, "temp_id");
							_tmp107_ = builder;
							_tmp108_ = q;
							_tmp109_ = objects_queue_get_temp_id (_tmp108_);
							_tmp110_ = _tmp109_;
							json_builder_add_string_value (_tmp107_, _tmp110_);
							_tmp111_ = builder;
							json_builder_set_member_name (_tmp111_, "uuid");
							_tmp112_ = builder;
							_tmp113_ = q;
							_tmp114_ = objects_queue_get_uuid (_tmp113_);
							_tmp115_ = _tmp114_;
							json_builder_add_string_value (_tmp112_, _tmp115_);
							_tmp116_ = builder;
							json_builder_set_member_name (_tmp116_, "args");
							_tmp117_ = builder;
							json_builder_begin_object (_tmp117_);
							_tmp118_ = builder;
							json_builder_set_member_name (_tmp118_, "name");
							_tmp119_ = builder;
							_tmp120_ = q;
							_tmp121_ = objects_queue_get_args (_tmp120_);
							_tmp122_ = _tmp121_;
							_tmp123_ = services_todoist_get_string_member_by_object (self, _tmp122_, "name");
							_tmp124_ = _tmp123_;
							json_builder_add_string_value (_tmp119_, _tmp124_);
							_g_free0 (_tmp124_);
							_tmp125_ = builder;
							json_builder_set_member_name (_tmp125_, "project_id");
							_tmp126_ = q;
							_tmp127_ = objects_queue_get_args (_tmp126_);
							_tmp128_ = _tmp127_;
							if (services_todoist_get_type_by_member (self, _tmp128_, "project_id") == G_TYPE_STRING) {
								JsonBuilder* _tmp129_;
								ObjectsQueue* _tmp130_;
								const gchar* _tmp131_;
								const gchar* _tmp132_;
								gchar* _tmp133_;
								gchar* _tmp134_;
								_tmp129_ = builder;
								_tmp130_ = q;
								_tmp131_ = objects_queue_get_args (_tmp130_);
								_tmp132_ = _tmp131_;
								_tmp133_ = services_todoist_get_string_member_by_object (self, _tmp132_, "project_id");
								_tmp134_ = _tmp133_;
								json_builder_add_string_value (_tmp129_, _tmp134_);
								_g_free0 (_tmp134_);
							} else {
								JsonBuilder* _tmp135_;
								ObjectsQueue* _tmp136_;
								const gchar* _tmp137_;
								const gchar* _tmp138_;
								gchar* _tmp139_;
								gchar* _tmp140_;
								_tmp135_ = builder;
								_tmp136_ = q;
								_tmp137_ = objects_queue_get_args (_tmp136_);
								_tmp138_ = _tmp137_;
								_tmp139_ = services_todoist_get_string_member_by_object (self, _tmp138_, "project_id");
								_tmp140_ = _tmp139_;
								json_builder_add_string_value (_tmp135_, _tmp140_);
								_g_free0 (_tmp140_);
							}
							_tmp141_ = builder;
							json_builder_end_object (_tmp141_);
							_tmp142_ = builder;
							json_builder_end_object (_tmp142_);
						} else {
							ObjectsQueue* _tmp143_;
							const gchar* _tmp144_;
							const gchar* _tmp145_;
							_tmp143_ = q;
							_tmp144_ = objects_queue_get_query (_tmp143_);
							_tmp145_ = _tmp144_;
							if (g_strcmp0 (_tmp145_, "section_update") == 0) {
								JsonBuilder* _tmp146_;
								JsonBuilder* _tmp147_;
								JsonBuilder* _tmp148_;
								JsonBuilder* _tmp149_;
								ObjectsQueue* _tmp150_;
								const gchar* _tmp151_;
								const gchar* _tmp152_;
								JsonBuilder* _tmp153_;
								JsonBuilder* _tmp154_;
								JsonBuilder* _tmp155_;
								JsonBuilder* _tmp156_;
								ObjectsQueue* _tmp157_;
								const gchar* _tmp158_;
								const gchar* _tmp159_;
								gchar* _tmp160_;
								gchar* _tmp161_;
								JsonBuilder* _tmp162_;
								JsonBuilder* _tmp163_;
								ObjectsQueue* _tmp164_;
								const gchar* _tmp165_;
								const gchar* _tmp166_;
								gchar* _tmp167_;
								gchar* _tmp168_;
								JsonBuilder* _tmp169_;
								JsonBuilder* _tmp170_;
								_tmp146_ = builder;
								json_builder_set_member_name (_tmp146_, "type");
								_tmp147_ = builder;
								json_builder_add_string_value (_tmp147_, "section_update");
								_tmp148_ = builder;
								json_builder_set_member_name (_tmp148_, "uuid");
								_tmp149_ = builder;
								_tmp150_ = q;
								_tmp151_ = objects_queue_get_uuid (_tmp150_);
								_tmp152_ = _tmp151_;
								json_builder_add_string_value (_tmp149_, _tmp152_);
								_tmp153_ = builder;
								json_builder_set_member_name (_tmp153_, "args");
								_tmp154_ = builder;
								json_builder_begin_object (_tmp154_);
								_tmp155_ = builder;
								json_builder_set_member_name (_tmp155_, "id");
								_tmp156_ = builder;
								_tmp157_ = q;
								_tmp158_ = objects_queue_get_args (_tmp157_);
								_tmp159_ = _tmp158_;
								_tmp160_ = services_todoist_get_string_member_by_object (self, _tmp159_, "id");
								_tmp161_ = _tmp160_;
								json_builder_add_string_value (_tmp156_, _tmp161_);
								_g_free0 (_tmp161_);
								_tmp162_ = builder;
								json_builder_set_member_name (_tmp162_, "name");
								_tmp163_ = builder;
								_tmp164_ = q;
								_tmp165_ = objects_queue_get_args (_tmp164_);
								_tmp166_ = _tmp165_;
								_tmp167_ = services_todoist_get_string_member_by_object (self, _tmp166_, "name");
								_tmp168_ = _tmp167_;
								json_builder_add_string_value (_tmp163_, _tmp168_);
								_g_free0 (_tmp168_);
								_tmp169_ = builder;
								json_builder_end_object (_tmp169_);
								_tmp170_ = builder;
								json_builder_end_object (_tmp170_);
							} else {
								ObjectsQueue* _tmp171_;
								const gchar* _tmp172_;
								const gchar* _tmp173_;
								_tmp171_ = q;
								_tmp172_ = objects_queue_get_query (_tmp171_);
								_tmp173_ = _tmp172_;
								if (g_strcmp0 (_tmp173_, "section_delete") == 0) {
									JsonBuilder* _tmp174_;
									JsonBuilder* _tmp175_;
									JsonBuilder* _tmp176_;
									JsonBuilder* _tmp177_;
									ObjectsQueue* _tmp178_;
									const gchar* _tmp179_;
									const gchar* _tmp180_;
									JsonBuilder* _tmp181_;
									JsonBuilder* _tmp182_;
									JsonBuilder* _tmp183_;
									JsonBuilder* _tmp184_;
									ObjectsQueue* _tmp185_;
									const gchar* _tmp186_;
									const gchar* _tmp187_;
									gchar* _tmp188_;
									gchar* _tmp189_;
									JsonBuilder* _tmp190_;
									JsonBuilder* _tmp191_;
									_tmp174_ = builder;
									json_builder_set_member_name (_tmp174_, "type");
									_tmp175_ = builder;
									json_builder_add_string_value (_tmp175_, "section_delete");
									_tmp176_ = builder;
									json_builder_set_member_name (_tmp176_, "uuid");
									_tmp177_ = builder;
									_tmp178_ = q;
									_tmp179_ = objects_queue_get_uuid (_tmp178_);
									_tmp180_ = _tmp179_;
									json_builder_add_string_value (_tmp177_, _tmp180_);
									_tmp181_ = builder;
									json_builder_set_member_name (_tmp181_, "args");
									_tmp182_ = builder;
									json_builder_begin_object (_tmp182_);
									_tmp183_ = builder;
									json_builder_set_member_name (_tmp183_, "id");
									_tmp184_ = builder;
									_tmp185_ = q;
									_tmp186_ = objects_queue_get_args (_tmp185_);
									_tmp187_ = _tmp186_;
									_tmp188_ = services_todoist_get_string_member_by_object (self, _tmp187_, "id");
									_tmp189_ = _tmp188_;
									json_builder_add_string_value (_tmp184_, _tmp189_);
									_g_free0 (_tmp189_);
									_tmp190_ = builder;
									json_builder_end_object (_tmp190_);
									_tmp191_ = builder;
									json_builder_end_object (_tmp191_);
								} else {
									ObjectsQueue* _tmp192_;
									const gchar* _tmp193_;
									const gchar* _tmp194_;
									_tmp192_ = q;
									_tmp193_ = objects_queue_get_query (_tmp192_);
									_tmp194_ = _tmp193_;
									if (g_strcmp0 (_tmp194_, "section_move") == 0) {
										JsonBuilder* _tmp195_;
										JsonBuilder* _tmp196_;
										JsonBuilder* _tmp197_;
										JsonBuilder* _tmp198_;
										ObjectsQueue* _tmp199_;
										const gchar* _tmp200_;
										const gchar* _tmp201_;
										JsonBuilder* _tmp202_;
										JsonBuilder* _tmp203_;
										JsonBuilder* _tmp204_;
										JsonBuilder* _tmp205_;
										ObjectsQueue* _tmp206_;
										const gchar* _tmp207_;
										const gchar* _tmp208_;
										gchar* _tmp209_;
										gchar* _tmp210_;
										JsonBuilder* _tmp211_;
										JsonBuilder* _tmp212_;
										ObjectsQueue* _tmp213_;
										const gchar* _tmp214_;
										const gchar* _tmp215_;
										gchar* _tmp216_;
										gchar* _tmp217_;
										JsonBuilder* _tmp218_;
										JsonBuilder* _tmp219_;
										_tmp195_ = builder;
										json_builder_set_member_name (_tmp195_, "type");
										_tmp196_ = builder;
										json_builder_add_string_value (_tmp196_, "section_move");
										_tmp197_ = builder;
										json_builder_set_member_name (_tmp197_, "uuid");
										_tmp198_ = builder;
										_tmp199_ = q;
										_tmp200_ = objects_queue_get_uuid (_tmp199_);
										_tmp201_ = _tmp200_;
										json_builder_add_string_value (_tmp198_, _tmp201_);
										_tmp202_ = builder;
										json_builder_set_member_name (_tmp202_, "args");
										_tmp203_ = builder;
										json_builder_begin_object (_tmp203_);
										_tmp204_ = builder;
										json_builder_set_member_name (_tmp204_, "id");
										_tmp205_ = builder;
										_tmp206_ = q;
										_tmp207_ = objects_queue_get_args (_tmp206_);
										_tmp208_ = _tmp207_;
										_tmp209_ = services_todoist_get_string_member_by_object (self, _tmp208_, "id");
										_tmp210_ = _tmp209_;
										json_builder_add_string_value (_tmp205_, _tmp210_);
										_g_free0 (_tmp210_);
										_tmp211_ = builder;
										json_builder_set_member_name (_tmp211_, "project_id");
										_tmp212_ = builder;
										_tmp213_ = q;
										_tmp214_ = objects_queue_get_args (_tmp213_);
										_tmp215_ = _tmp214_;
										_tmp216_ = services_todoist_get_string_member_by_object (self, _tmp215_, "project_id");
										_tmp217_ = _tmp216_;
										json_builder_add_string_value (_tmp212_, _tmp217_);
										_g_free0 (_tmp217_);
										_tmp218_ = builder;
										json_builder_end_object (_tmp218_);
										_tmp219_ = builder;
										json_builder_end_object (_tmp219_);
									} else {
										ObjectsQueue* _tmp220_;
										const gchar* _tmp221_;
										const gchar* _tmp222_;
										_tmp220_ = q;
										_tmp221_ = objects_queue_get_query (_tmp220_);
										_tmp222_ = _tmp221_;
										if (g_strcmp0 (_tmp222_, "item_add") == 0) {
											JsonBuilder* _tmp223_;
											JsonBuilder* _tmp224_;
											JsonBuilder* _tmp225_;
											JsonBuilder* _tmp226_;
											ObjectsQueue* _tmp227_;
											const gchar* _tmp228_;
											const gchar* _tmp229_;
											JsonBuilder* _tmp230_;
											JsonBuilder* _tmp231_;
											ObjectsQueue* _tmp232_;
											const gchar* _tmp233_;
											const gchar* _tmp234_;
											JsonBuilder* _tmp235_;
											JsonBuilder* _tmp236_;
											JsonBuilder* _tmp237_;
											JsonBuilder* _tmp238_;
											ObjectsQueue* _tmp239_;
											const gchar* _tmp240_;
											const gchar* _tmp241_;
											gchar* _tmp242_;
											gchar* _tmp243_;
											JsonBuilder* _tmp244_;
											JsonBuilder* _tmp245_;
											ObjectsQueue* _tmp246_;
											const gchar* _tmp247_;
											const gchar* _tmp248_;
											gchar* _tmp249_;
											gchar* _tmp250_;
											JsonBuilder* _tmp251_;
											JsonBuilder* _tmp252_;
											ObjectsQueue* _tmp253_;
											const gchar* _tmp254_;
											const gchar* _tmp255_;
											JsonBuilder* _tmp256_;
											JsonBuilder* _tmp257_;
											ObjectsQueue* _tmp258_;
											const gchar* _tmp259_;
											const gchar* _tmp260_;
											gchar* _tmp261_;
											gchar* _tmp262_;
											JsonBuilder* _tmp263_;
											JsonBuilder* _tmp264_;
											ObjectsQueue* _tmp265_;
											const gchar* _tmp266_;
											const gchar* _tmp267_;
											gchar* _tmp268_;
											gchar* _tmp269_;
											JsonBuilder* _tmp270_;
											JsonBuilder* _tmp271_;
											ObjectsQueue* _tmp272_;
											const gchar* _tmp273_;
											const gchar* _tmp274_;
											gchar* _tmp275_;
											gchar* _tmp276_;
											JsonBuilder* _tmp277_;
											JsonBuilder* _tmp278_;
											_tmp223_ = builder;
											json_builder_set_member_name (_tmp223_, "type");
											_tmp224_ = builder;
											json_builder_add_string_value (_tmp224_, "item_add");
											_tmp225_ = builder;
											json_builder_set_member_name (_tmp225_, "temp_id");
											_tmp226_ = builder;
											_tmp227_ = q;
											_tmp228_ = objects_queue_get_temp_id (_tmp227_);
											_tmp229_ = _tmp228_;
											json_builder_add_string_value (_tmp226_, _tmp229_);
											_tmp230_ = builder;
											json_builder_set_member_name (_tmp230_, "uuid");
											_tmp231_ = builder;
											_tmp232_ = q;
											_tmp233_ = objects_queue_get_uuid (_tmp232_);
											_tmp234_ = _tmp233_;
											json_builder_add_string_value (_tmp231_, _tmp234_);
											_tmp235_ = builder;
											json_builder_set_member_name (_tmp235_, "args");
											_tmp236_ = builder;
											json_builder_begin_object (_tmp236_);
											_tmp237_ = builder;
											json_builder_set_member_name (_tmp237_, "content");
											_tmp238_ = builder;
											_tmp239_ = q;
											_tmp240_ = objects_queue_get_args (_tmp239_);
											_tmp241_ = _tmp240_;
											_tmp242_ = services_todoist_get_string_member_by_object (self, _tmp241_, "content");
											_tmp243_ = _tmp242_;
											json_builder_add_string_value (_tmp238_, _tmp243_);
											_g_free0 (_tmp243_);
											_tmp244_ = builder;
											json_builder_set_member_name (_tmp244_, "description");
											_tmp245_ = builder;
											_tmp246_ = q;
											_tmp247_ = objects_queue_get_args (_tmp246_);
											_tmp248_ = _tmp247_;
											_tmp249_ = services_todoist_get_string_member_by_object (self, _tmp248_, "description");
											_tmp250_ = _tmp249_;
											json_builder_add_string_value (_tmp245_, _tmp250_);
											_g_free0 (_tmp250_);
											_tmp251_ = builder;
											json_builder_set_member_name (_tmp251_, "priority");
											_tmp252_ = builder;
											_tmp253_ = q;
											_tmp254_ = objects_queue_get_args (_tmp253_);
											_tmp255_ = _tmp254_;
											json_builder_add_int_value (_tmp252_, services_todoist_get_int_member_by_object (self, _tmp255_, "priority"));
											_tmp256_ = builder;
											json_builder_set_member_name (_tmp256_, "project_id");
											_tmp257_ = builder;
											_tmp258_ = q;
											_tmp259_ = objects_queue_get_args (_tmp258_);
											_tmp260_ = _tmp259_;
											_tmp261_ = services_todoist_get_string_member_by_object (self, _tmp260_, "project_id");
											_tmp262_ = _tmp261_;
											json_builder_add_string_value (_tmp257_, _tmp262_);
											_g_free0 (_tmp262_);
											_tmp263_ = builder;
											json_builder_set_member_name (_tmp263_, "section_id");
											_tmp264_ = builder;
											_tmp265_ = q;
											_tmp266_ = objects_queue_get_args (_tmp265_);
											_tmp267_ = _tmp266_;
											_tmp268_ = services_todoist_get_string_member_by_object (self, _tmp267_, "section_id");
											_tmp269_ = _tmp268_;
											json_builder_add_string_value (_tmp264_, _tmp269_);
											_g_free0 (_tmp269_);
											_tmp270_ = builder;
											json_builder_set_member_name (_tmp270_, "parent_id");
											_tmp271_ = builder;
											_tmp272_ = q;
											_tmp273_ = objects_queue_get_args (_tmp272_);
											_tmp274_ = _tmp273_;
											_tmp275_ = services_todoist_get_string_member_by_object (self, _tmp274_, "parent_id");
											_tmp276_ = _tmp275_;
											json_builder_add_string_value (_tmp271_, _tmp276_);
											_g_free0 (_tmp276_);
											_tmp277_ = builder;
											json_builder_end_object (_tmp277_);
											_tmp278_ = builder;
											json_builder_end_object (_tmp278_);
										} else {
											ObjectsQueue* _tmp279_;
											const gchar* _tmp280_;
											const gchar* _tmp281_;
											_tmp279_ = q;
											_tmp280_ = objects_queue_get_query (_tmp279_);
											_tmp281_ = _tmp280_;
											if (g_strcmp0 (_tmp281_, "item_update") == 0) {
												JsonBuilder* _tmp282_;
												JsonBuilder* _tmp283_;
												JsonBuilder* _tmp284_;
												JsonBuilder* _tmp285_;
												ObjectsQueue* _tmp286_;
												const gchar* _tmp287_;
												const gchar* _tmp288_;
												JsonBuilder* _tmp289_;
												JsonBuilder* _tmp290_;
												JsonBuilder* _tmp291_;
												JsonBuilder* _tmp292_;
												ObjectsQueue* _tmp293_;
												const gchar* _tmp294_;
												const gchar* _tmp295_;
												gchar* _tmp296_;
												gchar* _tmp297_;
												JsonBuilder* _tmp298_;
												JsonBuilder* _tmp299_;
												ObjectsQueue* _tmp300_;
												const gchar* _tmp301_;
												const gchar* _tmp302_;
												gchar* _tmp303_;
												gchar* _tmp304_;
												JsonBuilder* _tmp305_;
												JsonBuilder* _tmp306_;
												ObjectsQueue* _tmp307_;
												const gchar* _tmp308_;
												const gchar* _tmp309_;
												gchar* _tmp310_;
												gchar* _tmp311_;
												JsonBuilder* _tmp312_;
												JsonBuilder* _tmp313_;
												ObjectsQueue* _tmp314_;
												const gchar* _tmp315_;
												const gchar* _tmp316_;
												ObjectsQueue* _tmp317_;
												const gchar* _tmp318_;
												const gchar* _tmp319_;
												JsonBuilder* _tmp333_;
												JsonBuilder* _tmp334_;
												JsonBuilder* _tmp335_;
												_tmp282_ = builder;
												json_builder_set_member_name (_tmp282_, "type");
												_tmp283_ = builder;
												json_builder_add_string_value (_tmp283_, "item_update");
												_tmp284_ = builder;
												json_builder_set_member_name (_tmp284_, "uuid");
												_tmp285_ = builder;
												_tmp286_ = q;
												_tmp287_ = objects_queue_get_uuid (_tmp286_);
												_tmp288_ = _tmp287_;
												json_builder_add_string_value (_tmp285_, _tmp288_);
												_tmp289_ = builder;
												json_builder_set_member_name (_tmp289_, "args");
												_tmp290_ = builder;
												json_builder_begin_object (_tmp290_);
												_tmp291_ = builder;
												json_builder_set_member_name (_tmp291_, "id");
												_tmp292_ = builder;
												_tmp293_ = q;
												_tmp294_ = objects_queue_get_args (_tmp293_);
												_tmp295_ = _tmp294_;
												_tmp296_ = services_todoist_get_string_member_by_object (self, _tmp295_, "id");
												_tmp297_ = _tmp296_;
												json_builder_add_string_value (_tmp292_, _tmp297_);
												_g_free0 (_tmp297_);
												_tmp298_ = builder;
												json_builder_set_member_name (_tmp298_, "content");
												_tmp299_ = builder;
												_tmp300_ = q;
												_tmp301_ = objects_queue_get_args (_tmp300_);
												_tmp302_ = _tmp301_;
												_tmp303_ = services_todoist_get_string_member_by_object (self, _tmp302_, "content");
												_tmp304_ = _tmp303_;
												json_builder_add_string_value (_tmp299_, _tmp304_);
												_g_free0 (_tmp304_);
												_tmp305_ = builder;
												json_builder_set_member_name (_tmp305_, "description");
												_tmp306_ = builder;
												_tmp307_ = q;
												_tmp308_ = objects_queue_get_args (_tmp307_);
												_tmp309_ = _tmp308_;
												_tmp310_ = services_todoist_get_string_member_by_object (self, _tmp309_, "description");
												_tmp311_ = _tmp310_;
												json_builder_add_string_value (_tmp306_, _tmp311_);
												_g_free0 (_tmp311_);
												_tmp312_ = builder;
												json_builder_set_member_name (_tmp312_, "priority");
												_tmp313_ = builder;
												_tmp314_ = q;
												_tmp315_ = objects_queue_get_args (_tmp314_);
												_tmp316_ = _tmp315_;
												json_builder_add_int_value (_tmp313_, services_todoist_get_int_member_by_object (self, _tmp316_, "priority"));
												_tmp317_ = q;
												_tmp318_ = objects_queue_get_args (_tmp317_);
												_tmp319_ = _tmp318_;
												if (services_todoist_is_null_member (self, _tmp319_, "due")) {
													JsonBuilder* _tmp320_;
													JsonBuilder* _tmp321_;
													_tmp320_ = builder;
													json_builder_set_member_name (_tmp320_, "due");
													_tmp321_ = builder;
													json_builder_add_null_value (_tmp321_);
												} else {
													JsonBuilder* _tmp322_;
													JsonBuilder* _tmp323_;
													JsonObject* due = NULL;
													ObjectsQueue* _tmp324_;
													const gchar* _tmp325_;
													const gchar* _tmp326_;
													JsonObject* _tmp327_;
													JsonBuilder* _tmp328_;
													JsonBuilder* _tmp329_;
													JsonObject* _tmp330_;
													const gchar* _tmp331_;
													JsonBuilder* _tmp332_;
													_tmp322_ = builder;
													json_builder_set_member_name (_tmp322_, "due");
													_tmp323_ = builder;
													json_builder_begin_object (_tmp323_);
													_tmp324_ = q;
													_tmp325_ = objects_queue_get_args (_tmp324_);
													_tmp326_ = _tmp325_;
													_tmp327_ = services_todoist_get_object_member_by_object (self, _tmp326_, "due");
													due = _tmp327_;
													_tmp328_ = builder;
													json_builder_set_member_name (_tmp328_, "date");
													_tmp329_ = builder;
													_tmp330_ = due;
													_tmp331_ = json_object_get_string_member (_tmp330_, "date");
													json_builder_add_string_value (_tmp329_, _tmp331_);
													_tmp332_ = builder;
													json_builder_end_object (_tmp332_);
													_json_object_unref0 (due);
												}
												_tmp333_ = builder;
												json_builder_end_object (_tmp333_);
												_tmp334_ = builder;
												json_builder_end_object (_tmp334_);
												_tmp335_ = builder;
												json_builder_begin_object (_tmp335_);
											} else {
												ObjectsQueue* _tmp336_;
												const gchar* _tmp337_;
												const gchar* _tmp338_;
												_tmp336_ = q;
												_tmp337_ = objects_queue_get_query (_tmp336_);
												_tmp338_ = _tmp337_;
												if (g_strcmp0 (_tmp338_, "item_delete") == 0) {
													JsonBuilder* _tmp339_;
													JsonBuilder* _tmp340_;
													JsonBuilder* _tmp341_;
													JsonBuilder* _tmp342_;
													ObjectsQueue* _tmp343_;
													const gchar* _tmp344_;
													const gchar* _tmp345_;
													JsonBuilder* _tmp346_;
													JsonBuilder* _tmp347_;
													JsonBuilder* _tmp348_;
													JsonBuilder* _tmp349_;
													ObjectsQueue* _tmp350_;
													const gchar* _tmp351_;
													const gchar* _tmp352_;
													gchar* _tmp353_;
													gchar* _tmp354_;
													JsonBuilder* _tmp355_;
													JsonBuilder* _tmp356_;
													_tmp339_ = builder;
													json_builder_set_member_name (_tmp339_, "type");
													_tmp340_ = builder;
													json_builder_add_string_value (_tmp340_, "item_delete");
													_tmp341_ = builder;
													json_builder_set_member_name (_tmp341_, "uuid");
													_tmp342_ = builder;
													_tmp343_ = q;
													_tmp344_ = objects_queue_get_uuid (_tmp343_);
													_tmp345_ = _tmp344_;
													json_builder_add_string_value (_tmp342_, _tmp345_);
													_tmp346_ = builder;
													json_builder_set_member_name (_tmp346_, "args");
													_tmp347_ = builder;
													json_builder_begin_object (_tmp347_);
													_tmp348_ = builder;
													json_builder_set_member_name (_tmp348_, "id");
													_tmp349_ = builder;
													_tmp350_ = q;
													_tmp351_ = objects_queue_get_args (_tmp350_);
													_tmp352_ = _tmp351_;
													_tmp353_ = services_todoist_get_string_member_by_object (self, _tmp352_, "id");
													_tmp354_ = _tmp353_;
													json_builder_add_string_value (_tmp349_, _tmp354_);
													_g_free0 (_tmp354_);
													_tmp355_ = builder;
													json_builder_end_object (_tmp355_);
													_tmp356_ = builder;
													json_builder_end_object (_tmp356_);
												} else {
													ObjectsQueue* _tmp357_;
													const gchar* _tmp358_;
													const gchar* _tmp359_;
													_tmp357_ = q;
													_tmp358_ = objects_queue_get_query (_tmp357_);
													_tmp359_ = _tmp358_;
													if (g_strcmp0 (_tmp359_, "item_move") == 0) {
														JsonBuilder* _tmp360_;
														JsonBuilder* _tmp361_;
														JsonBuilder* _tmp362_;
														JsonBuilder* _tmp363_;
														ObjectsQueue* _tmp364_;
														const gchar* _tmp365_;
														const gchar* _tmp366_;
														JsonBuilder* _tmp367_;
														JsonBuilder* _tmp368_;
														JsonBuilder* _tmp369_;
														JsonBuilder* _tmp370_;
														ObjectsQueue* _tmp371_;
														const gchar* _tmp372_;
														const gchar* _tmp373_;
														gchar* _tmp374_;
														gchar* _tmp375_;
														gchar* type = NULL;
														ObjectsQueue* _tmp376_;
														const gchar* _tmp377_;
														const gchar* _tmp378_;
														gchar* _tmp379_;
														JsonBuilder* _tmp380_;
														const gchar* _tmp381_;
														JsonBuilder* _tmp382_;
														ObjectsQueue* _tmp383_;
														const gchar* _tmp384_;
														const gchar* _tmp385_;
														const gchar* _tmp386_;
														gchar* _tmp387_;
														gchar* _tmp388_;
														JsonBuilder* _tmp389_;
														JsonBuilder* _tmp390_;
														_tmp360_ = builder;
														json_builder_set_member_name (_tmp360_, "type");
														_tmp361_ = builder;
														json_builder_add_string_value (_tmp361_, "item_move");
														_tmp362_ = builder;
														json_builder_set_member_name (_tmp362_, "uuid");
														_tmp363_ = builder;
														_tmp364_ = q;
														_tmp365_ = objects_queue_get_uuid (_tmp364_);
														_tmp366_ = _tmp365_;
														json_builder_add_string_value (_tmp363_, _tmp366_);
														_tmp367_ = builder;
														json_builder_set_member_name (_tmp367_, "args");
														_tmp368_ = builder;
														json_builder_begin_object (_tmp368_);
														_tmp369_ = builder;
														json_builder_set_member_name (_tmp369_, "id");
														_tmp370_ = builder;
														_tmp371_ = q;
														_tmp372_ = objects_queue_get_args (_tmp371_);
														_tmp373_ = _tmp372_;
														_tmp374_ = services_todoist_get_string_member_by_object (self, _tmp373_, "id");
														_tmp375_ = _tmp374_;
														json_builder_add_string_value (_tmp370_, _tmp375_);
														_g_free0 (_tmp375_);
														_tmp376_ = q;
														_tmp377_ = objects_queue_get_args (_tmp376_);
														_tmp378_ = _tmp377_;
														_tmp379_ = services_todoist_get_string_member_by_object (self, _tmp378_, "type");
														type = _tmp379_;
														_tmp380_ = builder;
														_tmp381_ = type;
														json_builder_set_member_name (_tmp380_, _tmp381_);
														_tmp382_ = builder;
														_tmp383_ = q;
														_tmp384_ = objects_queue_get_args (_tmp383_);
														_tmp385_ = _tmp384_;
														_tmp386_ = type;
														_tmp387_ = services_todoist_get_string_member_by_object (self, _tmp385_, _tmp386_);
														_tmp388_ = _tmp387_;
														json_builder_add_string_value (_tmp382_, _tmp388_);
														_g_free0 (_tmp388_);
														_tmp389_ = builder;
														json_builder_end_object (_tmp389_);
														_tmp390_ = builder;
														json_builder_end_object (_tmp390_);
														_g_free0 (type);
													} else {
														gboolean _tmp391_ = FALSE;
														ObjectsQueue* _tmp392_;
														const gchar* _tmp393_;
														const gchar* _tmp394_;
														_tmp392_ = q;
														_tmp393_ = objects_queue_get_query (_tmp392_);
														_tmp394_ = _tmp393_;
														if (g_strcmp0 (_tmp394_, "item_complete") == 0) {
															_tmp391_ = TRUE;
														} else {
															ObjectsQueue* _tmp395_;
															const gchar* _tmp396_;
															const gchar* _tmp397_;
															_tmp395_ = q;
															_tmp396_ = objects_queue_get_query (_tmp395_);
															_tmp397_ = _tmp396_;
															_tmp391_ = g_strcmp0 (_tmp397_, "item_uncomplete") == 0;
														}
														if (_tmp391_) {
															JsonBuilder* _tmp398_;
															JsonBuilder* _tmp399_;
															ObjectsQueue* _tmp400_;
															const gchar* _tmp401_;
															const gchar* _tmp402_;
															JsonBuilder* _tmp403_;
															JsonBuilder* _tmp404_;
															ObjectsQueue* _tmp405_;
															const gchar* _tmp406_;
															const gchar* _tmp407_;
															JsonBuilder* _tmp408_;
															JsonBuilder* _tmp409_;
															JsonBuilder* _tmp410_;
															JsonBuilder* _tmp411_;
															ObjectsQueue* _tmp412_;
															const gchar* _tmp413_;
															const gchar* _tmp414_;
															gchar* _tmp415_;
															gchar* _tmp416_;
															JsonBuilder* _tmp417_;
															JsonBuilder* _tmp418_;
															_tmp398_ = builder;
															json_builder_set_member_name (_tmp398_, "type");
															_tmp399_ = builder;
															_tmp400_ = q;
															_tmp401_ = objects_queue_get_query (_tmp400_);
															_tmp402_ = _tmp401_;
															json_builder_add_string_value (_tmp399_, _tmp402_);
															_tmp403_ = builder;
															json_builder_set_member_name (_tmp403_, "uuid");
															_tmp404_ = builder;
															_tmp405_ = q;
															_tmp406_ = objects_queue_get_uuid (_tmp405_);
															_tmp407_ = _tmp406_;
															json_builder_add_string_value (_tmp404_, _tmp407_);
															_tmp408_ = builder;
															json_builder_set_member_name (_tmp408_, "args");
															_tmp409_ = builder;
															json_builder_begin_object (_tmp409_);
															_tmp410_ = builder;
															json_builder_set_member_name (_tmp410_, "id");
															_tmp411_ = builder;
															_tmp412_ = q;
															_tmp413_ = objects_queue_get_args (_tmp412_);
															_tmp414_ = _tmp413_;
															_tmp415_ = services_todoist_get_string_member_by_object (self, _tmp414_, "id");
															_tmp416_ = _tmp415_;
															json_builder_add_string_value (_tmp411_, _tmp416_);
															_g_free0 (_tmp416_);
															_tmp417_ = builder;
															json_builder_end_object (_tmp417_);
															_tmp418_ = builder;
															json_builder_end_object (_tmp418_);
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
			_tmp419_ = builder;
			json_builder_end_object (_tmp419_);
			_g_object_unref0 (q);
		}
	}
	_tmp420_ = builder;
	json_builder_end_array (_tmp420_);
	_tmp421_ = builder;
	json_builder_end_object (_tmp421_);
	_tmp422_ = json_generator_new ();
	generator = _tmp422_;
	_tmp423_ = builder;
	_tmp424_ = json_builder_get_root (_tmp423_);
	root = _tmp424_;
	json_generator_set_root (generator, root);
	_tmp425_ = json_generator_to_data (generator, NULL);
	result = _tmp425_;
	__vala_JsonNode_free0 (root);
	_g_object_unref0 (generator);
	_g_object_unref0 (builder);
	return result;
}

JsonObject*
services_todoist_get_object_by_string (ServicesTodoist* self,
                                       const gchar* object)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* _tmp3_;
	JsonObject* _tmp4_;
	JsonObject* _tmp5_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (object != NULL, NULL);
	_tmp0_ = json_parser_new ();
	parser = _tmp0_;
	{
		json_parser_load_from_data (parser, object, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_debug ("Todoist.vala:714: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (parser);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp3_ = json_parser_get_root (parser);
	_tmp4_ = json_node_get_object (_tmp3_);
	_tmp5_ = _json_object_ref0 (_tmp4_);
	result = _tmp5_;
	_g_object_unref0 (parser);
	return result;
}

gint64
services_todoist_get_int_member_by_object (ServicesTodoist* self,
                                           const gchar* object,
                                           const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	gint64 _tmp2_;
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	g_return_val_if_fail (object != NULL, 0LL);
	g_return_val_if_fail (member != NULL, 0LL);
	_tmp0_ = services_todoist_get_object_by_string (self, object);
	_tmp1_ = _tmp0_;
	_tmp2_ = json_object_get_int_member (_tmp1_, member);
	_json_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

gchar*
services_todoist_get_string_member_by_object (ServicesTodoist* self,
                                              const gchar* object,
                                              const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (object != NULL, NULL);
	g_return_val_if_fail (member != NULL, NULL);
	_tmp0_ = services_todoist_get_object_by_string (self, object);
	_tmp1_ = _tmp0_;
	_tmp2_ = json_object_get_string_member (_tmp1_, member);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_json_object_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

JsonObject*
services_todoist_get_object_member_by_object (ServicesTodoist* self,
                                              const gchar* object,
                                              const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonObject* _tmp2_;
	JsonObject* _tmp3_;
	JsonObject* _tmp4_;
	JsonObject* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (object != NULL, NULL);
	g_return_val_if_fail (member != NULL, NULL);
	_tmp0_ = services_todoist_get_object_by_string (self, object);
	_tmp1_ = _tmp0_;
	_tmp2_ = json_object_get_object_member (_tmp1_, member);
	_tmp3_ = _json_object_ref0 (_tmp2_);
	_tmp4_ = _tmp3_;
	_json_object_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

GType
services_todoist_get_type_by_member (ServicesTodoist* self,
                                     const gchar* object,
                                     const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonNode* _tmp2_;
	GType _tmp3_;
	GType result;
	g_return_val_if_fail (self != NULL, 0UL);
	g_return_val_if_fail (object != NULL, 0UL);
	g_return_val_if_fail (member != NULL, 0UL);
	_tmp0_ = services_todoist_get_object_by_string (self, object);
	_tmp1_ = _tmp0_;
	_tmp2_ = json_object_get_member (_tmp1_, member);
	_tmp3_ = json_node_get_value_type (_tmp2_);
	_json_object_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}

gboolean
services_todoist_is_null_member (ServicesTodoist* self,
                                 const gchar* object,
                                 const gchar* member)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (object != NULL, FALSE);
	g_return_val_if_fail (member != NULL, FALSE);
	_tmp0_ = services_todoist_get_object_by_string (self, object);
	_tmp1_ = _tmp0_;
	_tmp2_ = json_object_get_null_member (_tmp1_, member);
	_json_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

static void
services_todoist_add_item_if_not_exists (ServicesTodoist* self,
                                         JsonNode* node)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = json_node_get_object (node);
	if (!json_object_get_null_member (_tmp0_, "parent_id")) {
		ObjectsItem* item = NULL;
		ServicesStore* _tmp1_;
		JsonObject* _tmp2_;
		const gchar* _tmp3_;
		ObjectsItem* _tmp4_;
		ObjectsItem* _tmp5_;
		_tmp1_ = services_store_instance ();
		_tmp2_ = json_node_get_object (node);
		_tmp3_ = json_object_get_string_member (_tmp2_, "parent_id");
		_tmp4_ = services_store_get_item (_tmp1_, _tmp3_);
		item = _tmp4_;
		_tmp5_ = item;
		if (_tmp5_ != NULL) {
			ObjectsItem* _tmp6_;
			ObjectsItem* _tmp7_;
			ObjectsItem* _tmp8_;
			ObjectsItem* _tmp9_;
			ObjectsItem* _tmp10_;
			_tmp6_ = item;
			_tmp7_ = objects_item_new_from_json (node);
			_tmp8_ = _tmp7_;
			_tmp9_ = objects_item_add_item_if_not_exists (_tmp6_, _tmp8_, TRUE);
			_tmp10_ = _tmp9_;
			_g_object_unref0 (_tmp10_);
			_g_object_unref0 (_tmp8_);
		}
		_g_object_unref0 (item);
		return;
	}
	_tmp11_ = json_node_get_object (node);
	if (!json_object_get_null_member (_tmp11_, "section_id")) {
		ObjectsSection* section = NULL;
		ServicesStore* _tmp12_;
		JsonObject* _tmp13_;
		const gchar* _tmp14_;
		ObjectsSection* _tmp15_;
		ObjectsSection* _tmp16_;
		_tmp12_ = services_store_instance ();
		_tmp13_ = json_node_get_object (node);
		_tmp14_ = json_object_get_string_member (_tmp13_, "section_id");
		_tmp15_ = services_store_get_section (_tmp12_, _tmp14_);
		section = _tmp15_;
		_tmp16_ = section;
		if (_tmp16_ != NULL) {
			ObjectsSection* _tmp17_;
			ObjectsItem* _tmp18_;
			ObjectsItem* _tmp19_;
			ObjectsItem* _tmp20_;
			ObjectsItem* _tmp21_;
			_tmp17_ = section;
			_tmp18_ = objects_item_new_from_json (node);
			_tmp19_ = _tmp18_;
			_tmp20_ = objects_section_add_item_if_not_exists (_tmp17_, _tmp19_, TRUE);
			_tmp21_ = _tmp20_;
			_g_object_unref0 (_tmp21_);
			_g_object_unref0 (_tmp19_);
		}
		_g_object_unref0 (section);
	} else {
		ObjectsProject* project = NULL;
		ServicesStore* _tmp22_;
		JsonObject* _tmp23_;
		const gchar* _tmp24_;
		ObjectsProject* _tmp25_;
		ObjectsProject* _tmp26_;
		_tmp22_ = services_store_instance ();
		_tmp23_ = json_node_get_object (node);
		_tmp24_ = json_object_get_string_member (_tmp23_, "project_id");
		_tmp25_ = services_store_get_project (_tmp22_, _tmp24_);
		project = _tmp25_;
		_tmp26_ = project;
		if (_tmp26_ != NULL) {
			ObjectsProject* _tmp27_;
			ObjectsItem* _tmp28_;
			ObjectsItem* _tmp29_;
			ObjectsItem* _tmp30_;
			ObjectsItem* _tmp31_;
			_tmp27_ = project;
			_tmp28_ = objects_item_new_from_json (node);
			_tmp29_ = _tmp28_;
			_tmp30_ = objects_project_add_item_if_not_exists (_tmp27_, _tmp29_, TRUE);
			_tmp31_ = _tmp30_;
			_g_object_unref0 (_tmp31_);
			_g_object_unref0 (_tmp29_);
		}
		_g_object_unref0 (project);
	}
}

static void
services_todoist_add_data_free (gpointer _data)
{
	ServicesTodoistAddData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->object);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistAddData, _data_);
}

void
services_todoist_add (ServicesTodoist* self,
                      ObjectsBaseObject* object,
                      GAsyncReadyCallback _callback_,
                      gpointer _user_data_)
{
	ServicesTodoistAddData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (object != NULL);
	_data_ = g_slice_new0 (ServicesTodoistAddData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_add_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (object);
	_g_object_unref0 (_data_->object);
	_data_->object = _tmp1_;
	services_todoist_add_co (_data_);
}

HttpResponse*
services_todoist_add_finish (ServicesTodoist* self,
                             GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistAddData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_add_ready (GObject* source_object,
                            GAsyncResult* _res_,
                            gpointer _user_data_)
{
	ServicesTodoistAddData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_add_co (_data_);
}

static gboolean
services_todoist_add_co (ServicesTodoistAddData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->temp_id = _data_->_tmp3_;
	_data_->_tmp4_ = util_get_default ();
	_data_->_tmp5_ = _data_->_tmp4_;
	_data_->_tmp6_ = util_generate_string (_data_->_tmp5_);
	_data_->_tmp7_ = _data_->_tmp6_;
	_g_object_unref0 (_data_->_tmp5_);
	_data_->uuid = _data_->_tmp7_;
	_data_->_tmp8_ = _data_->temp_id;
	_data_->_tmp9_ = _data_->uuid;
	_data_->_tmp10_ = objects_base_object_get_add_json (_data_->object, _data_->_tmp8_, _data_->_tmp9_);
	_data_->json = _data_->_tmp10_;
	_data_->_tmp11_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp11_;
	_data_->_tmp12_ = _data_->message;
	_data_->_tmp13_ = soup_message_get_request_headers (_data_->_tmp12_);
	_data_->_tmp14_ = _data_->_tmp13_;
	_data_->_tmp15_ = objects_base_object_get_source (_data_->object);
	_data_->_tmp16_ = _data_->_tmp15_;
	_data_->_tmp17_ = objects_source_get_todoist_data (_data_->_tmp16_);
	_data_->_tmp18_ = _data_->_tmp17_;
	_data_->_tmp19_ = objects_source_todoist_data_get_access_token (_data_->_tmp18_);
	_data_->_tmp20_ = _data_->_tmp19_;
	_data_->_tmp21_ = g_strdup_printf ("Bearer %s", _data_->_tmp20_);
	_data_->_tmp22_ = _data_->_tmp21_;
	soup_message_headers_append (_data_->_tmp14_, "Authorization", _data_->_tmp22_);
	_g_free0 (_data_->_tmp22_);
	_data_->_tmp23_ = _data_->message;
	_data_->_tmp24_ = _data_->json;
	_data_->_tmp26_ = 0;
	_data_->_tmp25_ = string_get_data (_data_->_tmp24_, &_data_->_tmp26_);
	_data_->_tmp25__length1 = _data_->_tmp26_;
	_data_->_tmp27_ = _data_->_tmp25_;
	_data_->_tmp27__length1 = _data_->_tmp25__length1;
	_data_->_tmp28_ = g_bytes_new (_data_->_tmp27_, _data_->_tmp27__length1);
	_data_->_tmp29_ = _data_->_tmp28_;
	soup_message_set_request_body_from_bytes (_data_->_tmp23_, "application/json", _data_->_tmp29_);
	_g_bytes_unref0 (_data_->_tmp29_);
	_data_->_tmp30_ = http_response_new ();
	_data_->response = _data_->_tmp30_;
	{
		_data_->_tmp31_ = _data_->self->priv->session;
		_data_->_tmp32_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp31_, _data_->_tmp32_, G_PRIORITY_HIGH, NULL, services_todoist_add_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp33_ = soup_session_send_and_read_finish (_data_->_tmp31_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp33_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp34_ = _data_->self->priv->parser;
		_data_->_tmp35_ = _data_->stream;
		_data_->_tmp36_ = 0;
		_data_->_tmp37_ = g_bytes_get_data (_data_->_tmp35_, &_data_->_tmp36_);
		json_parser_load_from_data (_data_->_tmp34_, (const gchar*) _data_->_tmp37_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp38_ = _data_->self->priv->parser;
		_data_->_tmp39_ = json_parser_get_root (_data_->_tmp38_);
		services_todoist_print_root (_data_->self, _data_->_tmp39_);
		_data_->_tmp40_ = _data_->message;
		g_object_get (_data_->_tmp40_, "status-code", &_data_->_tmp41_, NULL);
		_data_->_tmp42_ = _data_->_tmp41_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp42_)) {
			_data_->_tmp43_ = _data_->response;
			_data_->_tmp44_ = _data_->self->priv->parser;
			_data_->_tmp45_ = json_parser_get_root (_data_->_tmp44_);
			http_response_from_error_json (_data_->_tmp43_, _data_->_tmp45_);
			_data_->_tmp46_ = _data_->message;
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
			_data_->_tmp48_ = _data_->_tmp47_;
			_data_->_tmp49_ = _data_->message;
			g_object_get (_data_->_tmp49_, "status-code", &_data_->_tmp50_, NULL);
			_data_->_tmp51_ = _data_->_tmp50_;
			_data_->_tmp52_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp51_);
			_data_->_tmp53_ = _data_->_tmp52_;
			services_todoist_debug_error (_data_->self, _data_->_tmp48_, _data_->_tmp53_);
			_g_free0 (_data_->_tmp53_);
		} else {
			_data_->_tmp54_ = _data_->self->priv->parser;
			_data_->_tmp55_ = json_parser_get_root (_data_->_tmp54_);
			_data_->_tmp56_ = json_node_get_object (_data_->_tmp55_);
			_data_->_tmp57_ = json_object_get_object_member (_data_->_tmp56_, "sync_status");
			_data_->_tmp58_ = _json_object_ref0 (_data_->_tmp57_);
			_data_->sync_status = _data_->_tmp58_;
			_data_->_tmp59_ = _data_->sync_status;
			_data_->_tmp60_ = _data_->uuid;
			_data_->_tmp61_ = json_object_get_member (_data_->_tmp59_, _data_->_tmp60_);
			_data_->_tmp62_ = __vala_JsonNode_copy0 (_data_->_tmp61_);
			_data_->uuid_member = _data_->_tmp62_;
			_data_->_tmp63_ = _data_->uuid_member;
			if (json_node_get_node_type (_data_->_tmp63_) == JSON_NODE_VALUE) {
				_data_->_tmp64_ = objects_base_object_get_source (_data_->object);
				_data_->_tmp65_ = _data_->_tmp64_;
				_data_->_tmp66_ = objects_source_get_todoist_data (_data_->_tmp65_);
				_data_->_tmp67_ = _data_->_tmp66_;
				_data_->_tmp68_ = _data_->self->priv->parser;
				_data_->_tmp69_ = json_parser_get_root (_data_->_tmp68_);
				_data_->_tmp70_ = json_node_get_object (_data_->_tmp69_);
				_data_->_tmp71_ = json_object_get_string_member (_data_->_tmp70_, "sync_token");
				objects_source_todoist_data_set_sync_token (_data_->_tmp67_, _data_->_tmp71_);
				_data_->_tmp72_ = objects_base_object_get_source (_data_->object);
				_data_->_tmp73_ = _data_->_tmp72_;
				_data_->_tmp74_ = g_date_time_new_now_local ();
				_data_->_tmp75_ = _data_->_tmp74_;
				_data_->_tmp76_ = g_date_time_to_string (_data_->_tmp75_);
				_data_->_tmp77_ = _data_->_tmp76_;
				objects_source_set_last_sync (_data_->_tmp73_, _data_->_tmp77_);
				_g_free0 (_data_->_tmp77_);
				_g_date_time_unref0 (_data_->_tmp75_);
				_data_->_tmp78_ = objects_base_object_get_source (_data_->object);
				_data_->_tmp79_ = _data_->_tmp78_;
				objects_source_save (_data_->_tmp79_);
				_data_->_tmp80_ = _data_->self->priv->parser;
				_data_->_tmp81_ = json_parser_get_root (_data_->_tmp80_);
				_data_->_tmp82_ = json_node_get_object (_data_->_tmp81_);
				_data_->_tmp83_ = json_object_get_object_member (_data_->_tmp82_, "temp_id_mapping");
				_data_->_tmp84_ = _data_->temp_id;
				_data_->_tmp85_ = json_object_get_string_member (_data_->_tmp83_, _data_->_tmp84_);
				_data_->_tmp86_ = g_strdup (_data_->_tmp85_);
				_g_free0 (_data_->id);
				_data_->id = _data_->_tmp86_;
				_data_->_tmp87_ = _data_->response;
				http_response_set_status (_data_->_tmp87_, TRUE);
				_data_->_tmp88_ = _data_->response;
				_data_->_tmp89_ = _data_->id;
				http_response_set_data (_data_->_tmp88_, _data_->_tmp89_);
			} else {
				_data_->_tmp90_ = _data_->response;
				_data_->_tmp91_ = _data_->sync_status;
				_data_->_tmp92_ = _data_->uuid;
				_data_->_tmp93_ = json_object_get_object_member (_data_->_tmp91_, _data_->_tmp92_);
				_data_->_tmp94_ = json_object_get_string_member (_data_->_tmp93_, "error");
				http_response_set_error (_data_->_tmp90_, _data_->_tmp94_);
				_data_->_tmp95_ = _data_->sync_status;
				_data_->_tmp96_ = _data_->uuid;
				_data_->_tmp97_ = json_object_get_object_member (_data_->_tmp95_, _data_->_tmp96_);
				_data_->_tmp98_ = _data_->sync_status;
				_data_->_tmp99_ = _data_->uuid;
				_data_->_tmp100_ = json_object_get_object_member (_data_->_tmp98_, _data_->_tmp99_);
				_data_->_tmp101_ = json_object_get_string_member (_data_->_tmp100_, "error");
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp97_, "http_code"), _data_->_tmp101_);
			}
			__vala_JsonNode_free0 (_data_->uuid_member);
			_json_object_unref0 (_data_->sync_status);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp102_ = _data_->message;
		g_object_get (_data_->_tmp102_, "status-code", &_data_->_tmp103_, NULL);
		_data_->_tmp104_ = _data_->_tmp103_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp104_)) {
			_data_->_tmp105_ = _data_->response;
			_data_->_tmp106_ = _data_->e;
			_data_->_tmp107_ = _data_->_tmp106_->message;
			http_response_set_error (_data_->_tmp105_, _data_->_tmp107_);
			_data_->_tmp108_ = _data_->message;
			g_object_get (_data_->_tmp108_, "status-code", &_data_->_tmp109_, NULL);
			_data_->_tmp110_ = _data_->_tmp109_;
			_data_->_tmp111_ = _data_->e;
			_data_->_tmp112_ = _data_->_tmp111_->message;
			services_todoist_debug_error (_data_->self, _data_->_tmp110_, _data_->_tmp112_);
		} else {
			_data_->_tmp113_ = util_get_default ();
			_data_->_tmp114_ = _data_->_tmp113_;
			_data_->_tmp115_ = util_generate_id (_data_->_tmp114_, _data_->object);
			_g_free0 (_data_->id);
			_data_->id = _data_->_tmp115_;
			_g_object_unref0 (_data_->_tmp114_);
			_data_->_tmp116_ = objects_queue_new ();
			_data_->queue = _data_->_tmp116_;
			_data_->_tmp117_ = _data_->queue;
			_data_->_tmp118_ = _data_->uuid;
			objects_queue_set_uuid (_data_->_tmp117_, _data_->_tmp118_);
			_data_->_tmp119_ = _data_->queue;
			_data_->_tmp120_ = _data_->id;
			objects_queue_set_object_id (_data_->_tmp119_, _data_->_tmp120_);
			_data_->_tmp121_ = _data_->queue;
			_data_->_tmp122_ = _data_->temp_id;
			objects_queue_set_temp_id (_data_->_tmp121_, _data_->_tmp122_);
			_data_->_tmp123_ = _data_->queue;
			_data_->_tmp124_ = objects_base_object_get_type_add (_data_->object);
			_data_->_tmp125_ = _data_->_tmp124_;
			objects_queue_set_query (_data_->_tmp123_, _data_->_tmp125_);
			_data_->_tmp126_ = _data_->queue;
			_data_->_tmp127_ = objects_base_object_to_json (_data_->object);
			_data_->_tmp128_ = _data_->_tmp127_;
			objects_queue_set_args (_data_->_tmp126_, _data_->_tmp128_);
			_g_free0 (_data_->_tmp128_);
			_data_->_tmp129_ = services_database_get_default ();
			_data_->_tmp130_ = _data_->_tmp129_;
			_data_->_tmp131_ = _data_->queue;
			services_database_insert_queue (_data_->_tmp130_, _data_->_tmp131_);
			_g_object_unref0 (_data_->_tmp130_);
			_data_->_tmp132_ = services_database_get_default ();
			_data_->_tmp133_ = _data_->_tmp132_;
			_data_->_tmp134_ = objects_base_object_get_id (_data_->object);
			_data_->_tmp135_ = _data_->_tmp134_;
			_data_->_tmp136_ = _data_->temp_id;
			_data_->_tmp137_ = objects_base_object_get_object_type_string (_data_->object);
			_data_->_tmp138_ = _data_->_tmp137_;
			services_database_insert_CurTempIds (_data_->_tmp133_, _data_->_tmp135_, _data_->_tmp136_, _data_->_tmp138_);
			_g_object_unref0 (_data_->_tmp133_);
			_data_->_tmp139_ = _data_->response;
			http_response_set_status (_data_->_tmp139_, TRUE);
			_data_->_tmp140_ = _data_->response;
			_data_->_tmp141_ = _data_->queue;
			_data_->_tmp142_ = objects_queue_get_object_id (_data_->_tmp141_);
			_data_->_tmp143_ = _data_->_tmp142_;
			http_response_set_data (_data_->_tmp140_, _data_->_tmp143_);
			_g_object_unref0 (_data_->queue);
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->json);
		_g_free0 (_data_->id);
		_g_free0 (_data_->uuid);
		_g_free0 (_data_->temp_id);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->json);
	_g_free0 (_data_->id);
	_g_free0 (_data_->uuid);
	_g_free0 (_data_->temp_id);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_debug_error (ServicesTodoist* self,
                              guint status_code,
                              const gchar* message)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	_tmp0_ = g_strdup_printf ("%u", status_code);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("Code: %s - %s", _tmp1_, message);
	_tmp3_ = _tmp2_;
	g_debug ("Todoist.vala:844: %s", _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
}

static void
services_todoist_update_data_free (gpointer _data)
{
	ServicesTodoistUpdateData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->object);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistUpdateData, _data_);
}

void
services_todoist_update (ServicesTodoist* self,
                         ObjectsBaseObject* object,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	ServicesTodoistUpdateData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (object != NULL);
	_data_ = g_slice_new0 (ServicesTodoistUpdateData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_update_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (object);
	_g_object_unref0 (_data_->object);
	_data_->object = _tmp1_;
	services_todoist_update_co (_data_);
}

HttpResponse*
services_todoist_update_finish (ServicesTodoist* self,
                                GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistUpdateData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_update_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	ServicesTodoistUpdateData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_update_co (_data_);
}

static gboolean
services_todoist_update_co (ServicesTodoistUpdateData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->uuid = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->uuid;
	_data_->_tmp5_ = objects_base_object_get_update_json (_data_->object, _data_->_tmp4_, NULL);
	_data_->json = _data_->_tmp5_;
	_data_->_tmp6_ = objects_base_object_get_source (_data_->object);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
	_data_->source = _data_->_tmp8_;
	_data_->_tmp9_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp9_;
	_data_->_tmp10_ = _data_->message;
	_data_->_tmp11_ = soup_message_get_request_headers (_data_->_tmp10_);
	_data_->_tmp12_ = _data_->_tmp11_;
	_data_->_tmp13_ = _data_->source;
	_data_->_tmp14_ = objects_source_get_todoist_data (_data_->_tmp13_);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp16_ = objects_source_todoist_data_get_access_token (_data_->_tmp15_);
	_data_->_tmp17_ = _data_->_tmp16_;
	_data_->_tmp18_ = g_strdup_printf ("Bearer %s", _data_->_tmp17_);
	_data_->_tmp19_ = _data_->_tmp18_;
	soup_message_headers_append (_data_->_tmp12_, "Authorization", _data_->_tmp19_);
	_g_free0 (_data_->_tmp19_);
	_data_->_tmp20_ = _data_->message;
	_data_->_tmp21_ = _data_->json;
	_data_->_tmp23_ = 0;
	_data_->_tmp22_ = string_get_data (_data_->_tmp21_, &_data_->_tmp23_);
	_data_->_tmp22__length1 = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->_tmp22_;
	_data_->_tmp24__length1 = _data_->_tmp22__length1;
	_data_->_tmp25_ = g_bytes_new (_data_->_tmp24_, _data_->_tmp24__length1);
	_data_->_tmp26_ = _data_->_tmp25_;
	soup_message_set_request_body_from_bytes (_data_->_tmp20_, "application/json", _data_->_tmp26_);
	_g_bytes_unref0 (_data_->_tmp26_);
	_data_->_tmp27_ = http_response_new ();
	_data_->response = _data_->_tmp27_;
	{
		_data_->_tmp28_ = _data_->self->priv->session;
		_data_->_tmp29_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp28_, _data_->_tmp29_, G_PRIORITY_HIGH, NULL, services_todoist_update_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp30_ = soup_session_send_and_read_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp30_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp31_ = _data_->self->priv->parser;
		_data_->_tmp32_ = _data_->stream;
		_data_->_tmp33_ = 0;
		_data_->_tmp34_ = g_bytes_get_data (_data_->_tmp32_, &_data_->_tmp33_);
		json_parser_load_from_data (_data_->_tmp31_, (const gchar*) _data_->_tmp34_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp35_ = _data_->self->priv->parser;
		_data_->_tmp36_ = json_parser_get_root (_data_->_tmp35_);
		services_todoist_print_root (_data_->self, _data_->_tmp36_);
		_data_->_tmp37_ = _data_->message;
		g_object_get (_data_->_tmp37_, "status-code", &_data_->_tmp38_, NULL);
		_data_->_tmp39_ = _data_->_tmp38_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp39_)) {
			_data_->_tmp40_ = _data_->response;
			_data_->_tmp41_ = _data_->self->priv->parser;
			_data_->_tmp42_ = json_parser_get_root (_data_->_tmp41_);
			http_response_from_error_json (_data_->_tmp40_, _data_->_tmp42_);
			_data_->_tmp43_ = _data_->message;
			g_object_get (_data_->_tmp43_, "status-code", &_data_->_tmp44_, NULL);
			_data_->_tmp45_ = _data_->_tmp44_;
			_data_->_tmp46_ = _data_->message;
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
			_data_->_tmp48_ = _data_->_tmp47_;
			_data_->_tmp49_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp48_);
			_data_->_tmp50_ = _data_->_tmp49_;
			services_todoist_debug_error (_data_->self, _data_->_tmp45_, _data_->_tmp50_);
			_g_free0 (_data_->_tmp50_);
		} else {
			_data_->_tmp51_ = _data_->self->priv->parser;
			_data_->_tmp52_ = json_parser_get_root (_data_->_tmp51_);
			_data_->_tmp53_ = json_node_get_object (_data_->_tmp52_);
			_data_->_tmp54_ = json_object_get_object_member (_data_->_tmp53_, "sync_status");
			_data_->_tmp55_ = _json_object_ref0 (_data_->_tmp54_);
			_data_->sync_status = _data_->_tmp55_;
			_data_->_tmp56_ = _data_->sync_status;
			_data_->_tmp57_ = _data_->uuid;
			_data_->_tmp58_ = json_object_get_member (_data_->_tmp56_, _data_->_tmp57_);
			_data_->_tmp59_ = __vala_JsonNode_copy0 (_data_->_tmp58_);
			_data_->uuid_member = _data_->_tmp59_;
			_data_->_tmp60_ = _data_->uuid_member;
			if (json_node_get_node_type (_data_->_tmp60_) == JSON_NODE_VALUE) {
				_data_->_tmp61_ = _data_->source;
				_data_->_tmp62_ = objects_source_get_todoist_data (_data_->_tmp61_);
				_data_->_tmp63_ = _data_->_tmp62_;
				_data_->_tmp64_ = _data_->self->priv->parser;
				_data_->_tmp65_ = json_parser_get_root (_data_->_tmp64_);
				_data_->_tmp66_ = json_node_get_object (_data_->_tmp65_);
				_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "sync_token");
				objects_source_todoist_data_set_sync_token (_data_->_tmp63_, _data_->_tmp67_);
				_data_->_tmp68_ = _data_->response;
				http_response_set_status (_data_->_tmp68_, TRUE);
				_data_->_tmp69_ = _data_->source;
				_data_->_tmp70_ = g_date_time_new_now_local ();
				_data_->_tmp71_ = _data_->_tmp70_;
				_data_->_tmp72_ = g_date_time_to_string (_data_->_tmp71_);
				_data_->_tmp73_ = _data_->_tmp72_;
				objects_source_set_last_sync (_data_->_tmp69_, _data_->_tmp73_);
				_g_free0 (_data_->_tmp73_);
				_g_date_time_unref0 (_data_->_tmp71_);
				_data_->_tmp74_ = _data_->source;
				objects_source_save (_data_->_tmp74_);
			} else {
				_data_->_tmp75_ = _data_->response;
				_data_->_tmp76_ = _data_->sync_status;
				_data_->_tmp77_ = _data_->uuid;
				_data_->_tmp78_ = json_object_get_object_member (_data_->_tmp76_, _data_->_tmp77_);
				_data_->_tmp79_ = json_object_get_string_member (_data_->_tmp78_, "error");
				http_response_set_error (_data_->_tmp75_, _data_->_tmp79_);
				_data_->_tmp80_ = _data_->sync_status;
				_data_->_tmp81_ = _data_->uuid;
				_data_->_tmp82_ = json_object_get_object_member (_data_->_tmp80_, _data_->_tmp81_);
				_data_->_tmp83_ = _data_->sync_status;
				_data_->_tmp84_ = _data_->uuid;
				_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp83_, _data_->_tmp84_);
				_data_->_tmp86_ = json_object_get_string_member (_data_->_tmp85_, "error");
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp82_, "http_code"), _data_->_tmp86_);
			}
			__vala_JsonNode_free0 (_data_->uuid_member);
			_json_object_unref0 (_data_->sync_status);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp87_ = _data_->message;
		g_object_get (_data_->_tmp87_, "status-code", &_data_->_tmp88_, NULL);
		_data_->_tmp89_ = _data_->_tmp88_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp89_)) {
			_data_->_tmp90_ = _data_->response;
			_data_->_tmp91_ = _data_->e;
			_data_->_tmp92_ = _data_->_tmp91_->message;
			http_response_set_error (_data_->_tmp90_, _data_->_tmp92_);
			_data_->_tmp93_ = _data_->message;
			g_object_get (_data_->_tmp93_, "status-code", &_data_->_tmp94_, NULL);
			_data_->_tmp95_ = _data_->_tmp94_;
			_data_->_tmp96_ = _data_->e;
			_data_->_tmp97_ = _data_->_tmp96_->message;
			services_todoist_debug_error (_data_->self, _data_->_tmp95_, _data_->_tmp97_);
		} else {
			_data_->_tmp98_ = objects_queue_new ();
			_data_->queue = _data_->_tmp98_;
			_data_->_tmp99_ = _data_->queue;
			_data_->_tmp100_ = _data_->uuid;
			objects_queue_set_uuid (_data_->_tmp99_, _data_->_tmp100_);
			_data_->_tmp101_ = _data_->queue;
			_data_->_tmp102_ = objects_base_object_get_id (_data_->object);
			_data_->_tmp103_ = _data_->_tmp102_;
			objects_queue_set_object_id (_data_->_tmp101_, _data_->_tmp103_);
			_data_->_tmp104_ = _data_->queue;
			_data_->_tmp105_ = objects_base_object_get_type_update (_data_->object);
			_data_->_tmp106_ = _data_->_tmp105_;
			objects_queue_set_query (_data_->_tmp104_, _data_->_tmp106_);
			_data_->_tmp107_ = _data_->queue;
			_data_->_tmp108_ = objects_base_object_to_json (_data_->object);
			_data_->_tmp109_ = _data_->_tmp108_;
			objects_queue_set_args (_data_->_tmp107_, _data_->_tmp109_);
			_g_free0 (_data_->_tmp109_);
			_data_->_tmp110_ = services_database_get_default ();
			_data_->_tmp111_ = _data_->_tmp110_;
			_data_->_tmp112_ = _data_->queue;
			services_database_insert_queue (_data_->_tmp111_, _data_->_tmp112_);
			_g_object_unref0 (_data_->_tmp111_);
			_data_->_tmp113_ = _data_->response;
			http_response_set_status (_data_->_tmp113_, TRUE);
			_g_object_unref0 (_data_->queue);
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_object_unref0 (_data_->source);
		_g_free0 (_data_->json);
		_g_free0 (_data_->uuid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_object_unref0 (_data_->source);
	_g_free0 (_data_->json);
	_g_free0 (_data_->uuid);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_update_items_data_free (gpointer _data)
{
	ServicesTodoistUpdateItemsData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->objects);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistUpdateItemsData, _data_);
}

void
services_todoist_update_items (ServicesTodoist* self,
                               GeeArrayList* objects,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ServicesTodoistUpdateItemsData* _data_;
	ServicesTodoist* _tmp0_;
	GeeArrayList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (objects != NULL);
	_data_ = g_slice_new0 (ServicesTodoistUpdateItemsData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_update_items_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (objects);
	_g_object_unref0 (_data_->objects);
	_data_->objects = _tmp1_;
	services_todoist_update_items_co (_data_);
}

void
services_todoist_update_items_finish (ServicesTodoist* self,
                                      GAsyncResult* _res_)
{
	ServicesTodoistUpdateItemsData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
services_todoist_update_items_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ServicesTodoistUpdateItemsData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_update_items_co (_data_);
}

static gboolean
services_todoist_update_items_co (ServicesTodoistUpdateItemsData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = services_todoist_get_update_items_json (_data_->self, _data_->objects);
	_data_->json = _data_->_tmp0_;
	_data_->_tmp1_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->message;
	_data_->_tmp3_ = soup_message_get_request_headers (_data_->_tmp2_);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = services_settings_get_default ();
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = _data_->_tmp6_->settings;
	_data_->_tmp8_ = g_settings_get_string (_data_->_tmp7_, "todoist-access-token");
	_data_->_tmp9_ = _data_->_tmp8_;
	_data_->_tmp10_ = g_strdup_printf ("Bearer %s", _data_->_tmp9_);
	_data_->_tmp11_ = _data_->_tmp10_;
	soup_message_headers_append (_data_->_tmp4_, "Authorization", _data_->_tmp11_);
	_g_free0 (_data_->_tmp11_);
	_g_free0 (_data_->_tmp9_);
	_g_object_unref0 (_data_->_tmp6_);
	_data_->_tmp12_ = _data_->message;
	_data_->_tmp13_ = _data_->json;
	_data_->_tmp15_ = 0;
	_data_->_tmp14_ = string_get_data (_data_->_tmp13_, &_data_->_tmp15_);
	_data_->_tmp14__length1 = _data_->_tmp15_;
	_data_->_tmp16_ = _data_->_tmp14_;
	_data_->_tmp16__length1 = _data_->_tmp14__length1;
	_data_->_tmp17_ = g_bytes_new (_data_->_tmp16_, _data_->_tmp16__length1);
	_data_->_tmp18_ = _data_->_tmp17_;
	soup_message_set_request_body_from_bytes (_data_->_tmp12_, "application/json", _data_->_tmp18_);
	_g_bytes_unref0 (_data_->_tmp18_);
	{
		_data_->_tmp19_ = _data_->self->priv->session;
		_data_->_tmp20_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp19_, _data_->_tmp20_, G_PRIORITY_HIGH, NULL, services_todoist_update_items_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp21_ = soup_session_send_and_read_finish (_data_->_tmp19_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp21_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp22_ = _data_->self->priv->parser;
		_data_->_tmp23_ = _data_->stream;
		_data_->_tmp24_ = 0;
		_data_->_tmp25_ = g_bytes_get_data (_data_->_tmp23_, &_data_->_tmp24_);
		json_parser_load_from_data (_data_->_tmp22_, (const gchar*) _data_->_tmp25_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp26_ = _data_->self->priv->parser;
		_data_->_tmp27_ = json_parser_get_root (_data_->_tmp26_);
		services_todoist_print_root (_data_->self, _data_->_tmp27_);
		_data_->_tmp28_ = _data_->message;
		g_object_get (_data_->_tmp28_, "status-code", &_data_->_tmp29_, NULL);
		_data_->_tmp30_ = _data_->_tmp29_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp30_)) {
			_data_->_tmp31_ = _data_->message;
			g_object_get (_data_->_tmp31_, "status-code", &_data_->_tmp32_, NULL);
			_data_->_tmp33_ = _data_->_tmp32_;
			_data_->_tmp34_ = _data_->message;
			g_object_get (_data_->_tmp34_, "status-code", &_data_->_tmp35_, NULL);
			_data_->_tmp36_ = _data_->_tmp35_;
			_data_->_tmp37_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp36_);
			_data_->_tmp38_ = _data_->_tmp37_;
			services_todoist_debug_error (_data_->self, _data_->_tmp33_, _data_->_tmp38_);
			_g_free0 (_data_->_tmp38_);
		} else {
			_data_->_tmp39_ = services_settings_get_default ();
			_data_->_tmp40_ = _data_->_tmp39_;
			_data_->_tmp41_ = _data_->_tmp40_->settings;
			_data_->_tmp42_ = _data_->self->priv->parser;
			_data_->_tmp43_ = json_parser_get_root (_data_->_tmp42_);
			_data_->_tmp44_ = json_node_get_object (_data_->_tmp43_);
			_data_->_tmp45_ = json_object_get_string_member (_data_->_tmp44_, "sync_token");
			g_settings_set_string (_data_->_tmp41_, "todoist-sync-token", _data_->_tmp45_);
			_g_object_unref0 (_data_->_tmp40_);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp46_ = _data_->e->message;
		g_error ("Todoist.vala:946: %s", _data_->_tmp46_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->json);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->json);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

gchar*
services_todoist_get_update_items_json (ServicesTodoist* self,
                                        GeeArrayList* objects)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp88_;
	JsonBuilder* _tmp89_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp90_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp91_;
	JsonNode* _tmp92_;
	gchar* _tmp93_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (objects != NULL, NULL);
	_tmp0_ = json_builder_new ();
	builder = _tmp0_;
	_tmp1_ = builder;
	json_builder_begin_object (_tmp1_);
	_tmp2_ = builder;
	json_builder_set_member_name (_tmp2_, "commands");
	_tmp3_ = builder;
	json_builder_begin_array (_tmp3_);
	{
		GeeArrayList* _item_list = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _item_index = 0;
		_item_list = objects;
		_tmp4_ = _item_list;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_item_size = _tmp6_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			ObjectsItem* item = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			JsonBuilder* _tmp11_;
			JsonBuilder* _tmp12_;
			JsonBuilder* _tmp13_;
			JsonBuilder* _tmp14_;
			JsonBuilder* _tmp15_;
			Util* _tmp16_;
			Util* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			JsonBuilder* _tmp20_;
			JsonBuilder* _tmp21_;
			JsonBuilder* _tmp22_;
			JsonBuilder* _tmp23_;
			ObjectsItem* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			JsonBuilder* _tmp27_;
			JsonBuilder* _tmp28_;
			Util* _tmp29_;
			Util* _tmp30_;
			ObjectsItem* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			JsonBuilder* _tmp36_;
			JsonBuilder* _tmp37_;
			Util* _tmp38_;
			Util* _tmp39_;
			ObjectsItem* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			JsonBuilder* _tmp45_;
			ObjectsItem* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
			ObjectsItem* _tmp54_;
			gboolean _tmp55_;
			gboolean _tmp56_;
			JsonBuilder* _tmp69_;
			JsonBuilder* _tmp70_;
			JsonBuilder* _tmp85_;
			JsonBuilder* _tmp86_;
			JsonBuilder* _tmp87_;
			_item_index = _item_index + 1;
			_tmp7_ = _item_index;
			_tmp8_ = _item_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _item_list;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _item_index);
			item = (ObjectsItem*) _tmp10_;
			_tmp11_ = builder;
			json_builder_begin_object (_tmp11_);
			_tmp12_ = builder;
			json_builder_set_member_name (_tmp12_, "type");
			_tmp13_ = builder;
			json_builder_add_string_value (_tmp13_, "item_update");
			_tmp14_ = builder;
			json_builder_set_member_name (_tmp14_, "uuid");
			_tmp15_ = builder;
			_tmp16_ = util_get_default ();
			_tmp17_ = _tmp16_;
			_tmp18_ = util_generate_string (_tmp17_);
			_tmp19_ = _tmp18_;
			json_builder_add_string_value (_tmp15_, _tmp19_);
			_g_free0 (_tmp19_);
			_g_object_unref0 (_tmp17_);
			_tmp20_ = builder;
			json_builder_set_member_name (_tmp20_, "args");
			_tmp21_ = builder;
			json_builder_begin_object (_tmp21_);
			_tmp22_ = builder;
			json_builder_set_member_name (_tmp22_, "id");
			_tmp23_ = builder;
			_tmp24_ = item;
			_tmp25_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp24_);
			_tmp26_ = _tmp25_;
			json_builder_add_string_value (_tmp23_, _tmp26_);
			_tmp27_ = builder;
			json_builder_set_member_name (_tmp27_, "content");
			_tmp28_ = builder;
			_tmp29_ = util_get_default ();
			_tmp30_ = _tmp29_;
			_tmp31_ = item;
			_tmp32_ = objects_item_get_content (_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp34_ = util_get_encode_text (_tmp30_, _tmp33_);
			_tmp35_ = _tmp34_;
			json_builder_add_string_value (_tmp28_, _tmp35_);
			_g_free0 (_tmp35_);
			_g_object_unref0 (_tmp30_);
			_tmp36_ = builder;
			json_builder_set_member_name (_tmp36_, "description");
			_tmp37_ = builder;
			_tmp38_ = util_get_default ();
			_tmp39_ = _tmp38_;
			_tmp40_ = item;
			_tmp41_ = objects_item_get_description (_tmp40_);
			_tmp42_ = _tmp41_;
			_tmp43_ = util_get_encode_text (_tmp39_, _tmp42_);
			_tmp44_ = _tmp43_;
			json_builder_add_string_value (_tmp37_, _tmp44_);
			_g_free0 (_tmp44_);
			_g_object_unref0 (_tmp39_);
			_tmp45_ = builder;
			json_builder_set_member_name (_tmp45_, "priority");
			_tmp46_ = item;
			_tmp47_ = objects_item_get_priority (_tmp46_);
			_tmp48_ = _tmp47_;
			if (_tmp48_ == 0) {
				JsonBuilder* _tmp49_;
				_tmp49_ = builder;
				json_builder_add_int_value (_tmp49_, (gint64) CONSTANTS_PRIORITY_4);
			} else {
				JsonBuilder* _tmp50_;
				ObjectsItem* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				_tmp50_ = builder;
				_tmp51_ = item;
				_tmp52_ = objects_item_get_priority (_tmp51_);
				_tmp53_ = _tmp52_;
				json_builder_add_int_value (_tmp50_, (gint64) _tmp53_);
			}
			_tmp54_ = item;
			_tmp55_ = objects_item_get_has_due (_tmp54_);
			_tmp56_ = _tmp55_;
			if (_tmp56_) {
				JsonBuilder* _tmp57_;
				JsonBuilder* _tmp58_;
				JsonBuilder* _tmp59_;
				JsonBuilder* _tmp60_;
				ObjectsItem* _tmp61_;
				ObjectsDueDate* _tmp62_;
				ObjectsDueDate* _tmp63_;
				const gchar* _tmp64_;
				const gchar* _tmp65_;
				JsonBuilder* _tmp66_;
				_tmp57_ = builder;
				json_builder_set_member_name (_tmp57_, "due");
				_tmp58_ = builder;
				json_builder_begin_object (_tmp58_);
				_tmp59_ = builder;
				json_builder_set_member_name (_tmp59_, "date");
				_tmp60_ = builder;
				_tmp61_ = item;
				_tmp62_ = objects_item_get_due (_tmp61_);
				_tmp63_ = _tmp62_;
				_tmp64_ = objects_due_date_get_date (_tmp63_);
				_tmp65_ = _tmp64_;
				json_builder_add_string_value (_tmp60_, _tmp65_);
				_tmp66_ = builder;
				json_builder_end_object (_tmp66_);
			} else {
				JsonBuilder* _tmp67_;
				JsonBuilder* _tmp68_;
				_tmp67_ = builder;
				json_builder_set_member_name (_tmp67_, "due");
				_tmp68_ = builder;
				json_builder_add_null_value (_tmp68_);
			}
			_tmp69_ = builder;
			json_builder_set_member_name (_tmp69_, "labels");
			_tmp70_ = builder;
			json_builder_begin_array (_tmp70_);
			{
				GeeArrayList* _label_list = NULL;
				ObjectsItem* _tmp71_;
				GeeArrayList* _tmp72_;
				GeeArrayList* _tmp73_;
				gint _label_size = 0;
				GeeArrayList* _tmp74_;
				gint _tmp75_;
				gint _tmp76_;
				gint _label_index = 0;
				_tmp71_ = item;
				_tmp72_ = objects_item_get_labels (_tmp71_);
				_tmp73_ = _tmp72_;
				_label_list = _tmp73_;
				_tmp74_ = _label_list;
				_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
				_tmp76_ = _tmp75_;
				_label_size = _tmp76_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp77_;
					gint _tmp78_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp79_;
					gpointer _tmp80_;
					JsonBuilder* _tmp81_;
					ObjectsLabel* _tmp82_;
					const gchar* _tmp83_;
					const gchar* _tmp84_;
					_label_index = _label_index + 1;
					_tmp77_ = _label_index;
					_tmp78_ = _label_size;
					if (!(_tmp77_ < _tmp78_)) {
						break;
					}
					_tmp79_ = _label_list;
					_tmp80_ = gee_abstract_list_get ((GeeAbstractList*) _tmp79_, _label_index);
					label = (ObjectsLabel*) _tmp80_;
					_tmp81_ = builder;
					_tmp82_ = label;
					_tmp83_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp82_);
					_tmp84_ = _tmp83_;
					json_builder_add_string_value (_tmp81_, _tmp84_);
					_g_object_unref0 (label);
				}
			}
			_tmp85_ = builder;
			json_builder_end_array (_tmp85_);
			_tmp86_ = builder;
			json_builder_end_object (_tmp86_);
			_tmp87_ = builder;
			json_builder_end_object (_tmp87_);
			_g_object_unref0 (item);
		}
	}
	_tmp88_ = builder;
	json_builder_end_array (_tmp88_);
	_tmp89_ = builder;
	json_builder_end_object (_tmp89_);
	_tmp90_ = json_generator_new ();
	generator = _tmp90_;
	_tmp91_ = builder;
	_tmp92_ = json_builder_get_root (_tmp91_);
	root = _tmp92_;
	json_generator_set_root (generator, root);
	_tmp93_ = json_generator_to_data (generator, NULL);
	result = _tmp93_;
	__vala_JsonNode_free0 (root);
	_g_object_unref0 (generator);
	_g_object_unref0 (builder);
	return result;
}

static void
services_todoist_delete_data_free (gpointer _data)
{
	ServicesTodoistDeleteData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->object);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistDeleteData, _data_);
}

void
services_todoist_delete (ServicesTodoist* self,
                         ObjectsBaseObject* object,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	ServicesTodoistDeleteData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (object != NULL);
	_data_ = g_slice_new0 (ServicesTodoistDeleteData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_delete_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (object);
	_g_object_unref0 (_data_->object);
	_data_->object = _tmp1_;
	services_todoist_delete_co (_data_);
}

HttpResponse*
services_todoist_delete_finish (ServicesTodoist* self,
                                GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistDeleteData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_delete_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	ServicesTodoistDeleteData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_delete_co (_data_);
}

static gboolean
services_todoist_delete_co (ServicesTodoistDeleteData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->uuid = _data_->_tmp3_;
	_data_->_tmp4_ = objects_base_object_get_id (_data_->object);
	_data_->_tmp5_ = _data_->_tmp4_;
	_data_->_tmp6_ = objects_base_object_get_type_delete (_data_->object);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = _data_->uuid;
	_data_->_tmp9_ = services_todoist_get_delete_json (_data_->self, _data_->_tmp5_, _data_->_tmp7_, _data_->_tmp8_);
	_data_->json = _data_->_tmp9_;
	_data_->_tmp10_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp10_;
	_data_->_tmp11_ = _data_->message;
	_data_->_tmp12_ = soup_message_get_request_headers (_data_->_tmp11_);
	_data_->_tmp13_ = _data_->_tmp12_;
	_data_->_tmp14_ = objects_base_object_get_source (_data_->object);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp16_ = objects_source_get_todoist_data (_data_->_tmp15_);
	_data_->_tmp17_ = _data_->_tmp16_;
	_data_->_tmp18_ = objects_source_todoist_data_get_access_token (_data_->_tmp17_);
	_data_->_tmp19_ = _data_->_tmp18_;
	_data_->_tmp20_ = g_strdup_printf ("Bearer %s", _data_->_tmp19_);
	_data_->_tmp21_ = _data_->_tmp20_;
	soup_message_headers_append (_data_->_tmp13_, "Authorization", _data_->_tmp21_);
	_g_free0 (_data_->_tmp21_);
	_data_->_tmp22_ = _data_->message;
	_data_->_tmp23_ = _data_->json;
	_data_->_tmp25_ = 0;
	_data_->_tmp24_ = string_get_data (_data_->_tmp23_, &_data_->_tmp25_);
	_data_->_tmp24__length1 = _data_->_tmp25_;
	_data_->_tmp26_ = _data_->_tmp24_;
	_data_->_tmp26__length1 = _data_->_tmp24__length1;
	_data_->_tmp27_ = g_bytes_new (_data_->_tmp26_, _data_->_tmp26__length1);
	_data_->_tmp28_ = _data_->_tmp27_;
	soup_message_set_request_body_from_bytes (_data_->_tmp22_, "application/json", _data_->_tmp28_);
	_g_bytes_unref0 (_data_->_tmp28_);
	_data_->_tmp29_ = http_response_new ();
	_data_->response = _data_->_tmp29_;
	{
		_data_->_tmp30_ = _data_->self->priv->session;
		_data_->_tmp31_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp30_, _data_->_tmp31_, G_PRIORITY_HIGH, NULL, services_todoist_delete_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp32_ = soup_session_send_and_read_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp32_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp33_ = _data_->self->priv->parser;
		_data_->_tmp34_ = _data_->stream;
		_data_->_tmp35_ = 0;
		_data_->_tmp36_ = g_bytes_get_data (_data_->_tmp34_, &_data_->_tmp35_);
		json_parser_load_from_data (_data_->_tmp33_, (const gchar*) _data_->_tmp36_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp37_ = _data_->self->priv->parser;
		_data_->_tmp38_ = json_parser_get_root (_data_->_tmp37_);
		services_todoist_print_root (_data_->self, _data_->_tmp38_);
		_data_->_tmp39_ = _data_->message;
		g_object_get (_data_->_tmp39_, "status-code", &_data_->_tmp40_, NULL);
		_data_->_tmp41_ = _data_->_tmp40_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp41_)) {
			_data_->_tmp42_ = _data_->response;
			_data_->_tmp43_ = _data_->self->priv->parser;
			_data_->_tmp44_ = json_parser_get_root (_data_->_tmp43_);
			http_response_from_error_json (_data_->_tmp42_, _data_->_tmp44_);
			_data_->_tmp45_ = _data_->message;
			g_object_get (_data_->_tmp45_, "status-code", &_data_->_tmp46_, NULL);
			_data_->_tmp47_ = _data_->_tmp46_;
			_data_->_tmp48_ = _data_->message;
			g_object_get (_data_->_tmp48_, "status-code", &_data_->_tmp49_, NULL);
			_data_->_tmp50_ = _data_->_tmp49_;
			_data_->_tmp51_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp50_);
			_data_->_tmp52_ = _data_->_tmp51_;
			services_todoist_debug_error (_data_->self, _data_->_tmp47_, _data_->_tmp52_);
			_g_free0 (_data_->_tmp52_);
		} else {
			_data_->_tmp53_ = _data_->self->priv->parser;
			_data_->_tmp54_ = json_parser_get_root (_data_->_tmp53_);
			_data_->_tmp55_ = json_node_get_object (_data_->_tmp54_);
			_data_->_tmp56_ = json_object_get_object_member (_data_->_tmp55_, "sync_status");
			_data_->_tmp57_ = _json_object_ref0 (_data_->_tmp56_);
			_data_->sync_status = _data_->_tmp57_;
			_data_->_tmp58_ = _data_->sync_status;
			_data_->_tmp59_ = _data_->uuid;
			_data_->_tmp60_ = json_object_get_member (_data_->_tmp58_, _data_->_tmp59_);
			_data_->_tmp61_ = __vala_JsonNode_copy0 (_data_->_tmp60_);
			_data_->uuid_member = _data_->_tmp61_;
			_data_->_tmp62_ = _data_->uuid_member;
			if (json_node_get_node_type (_data_->_tmp62_) == JSON_NODE_VALUE) {
				_data_->_tmp63_ = objects_base_object_get_source (_data_->object);
				_data_->_tmp64_ = _data_->_tmp63_;
				_data_->_tmp65_ = objects_source_get_todoist_data (_data_->_tmp64_);
				_data_->_tmp66_ = _data_->_tmp65_;
				_data_->_tmp67_ = _data_->self->priv->parser;
				_data_->_tmp68_ = json_parser_get_root (_data_->_tmp67_);
				_data_->_tmp69_ = json_node_get_object (_data_->_tmp68_);
				_data_->_tmp70_ = json_object_get_string_member (_data_->_tmp69_, "sync_token");
				objects_source_todoist_data_set_sync_token (_data_->_tmp66_, _data_->_tmp70_);
				_data_->_tmp71_ = objects_base_object_get_source (_data_->object);
				_data_->_tmp72_ = _data_->_tmp71_;
				_data_->_tmp73_ = g_date_time_new_now_local ();
				_data_->_tmp74_ = _data_->_tmp73_;
				_data_->_tmp75_ = g_date_time_to_string (_data_->_tmp74_);
				_data_->_tmp76_ = _data_->_tmp75_;
				objects_source_set_last_sync (_data_->_tmp72_, _data_->_tmp76_);
				_g_free0 (_data_->_tmp76_);
				_g_date_time_unref0 (_data_->_tmp74_);
				_data_->_tmp77_ = objects_base_object_get_source (_data_->object);
				_data_->_tmp78_ = _data_->_tmp77_;
				objects_source_save (_data_->_tmp78_);
				_data_->_tmp79_ = _data_->response;
				http_response_set_status (_data_->_tmp79_, TRUE);
			} else {
				_data_->_tmp80_ = _data_->response;
				_data_->_tmp81_ = _data_->sync_status;
				_data_->_tmp82_ = _data_->uuid;
				_data_->_tmp83_ = json_object_get_object_member (_data_->_tmp81_, _data_->_tmp82_);
				_data_->_tmp84_ = json_object_get_string_member (_data_->_tmp83_, "error");
				http_response_set_error (_data_->_tmp80_, _data_->_tmp84_);
				_data_->_tmp85_ = _data_->sync_status;
				_data_->_tmp86_ = _data_->uuid;
				_data_->_tmp87_ = json_object_get_object_member (_data_->_tmp85_, _data_->_tmp86_);
				_data_->_tmp88_ = _data_->sync_status;
				_data_->_tmp89_ = _data_->uuid;
				_data_->_tmp90_ = json_object_get_object_member (_data_->_tmp88_, _data_->_tmp89_);
				_data_->_tmp91_ = json_object_get_string_member (_data_->_tmp90_, "error");
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp87_, "http_code"), _data_->_tmp91_);
			}
			__vala_JsonNode_free0 (_data_->uuid_member);
			_json_object_unref0 (_data_->sync_status);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp92_ = _data_->message;
		g_object_get (_data_->_tmp92_, "status-code", &_data_->_tmp93_, NULL);
		_data_->_tmp94_ = _data_->_tmp93_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp94_)) {
			_data_->_tmp95_ = _data_->response;
			_data_->_tmp96_ = _data_->e;
			_data_->_tmp97_ = _data_->_tmp96_->message;
			http_response_set_error (_data_->_tmp95_, _data_->_tmp97_);
			_data_->_tmp98_ = _data_->message;
			g_object_get (_data_->_tmp98_, "status-code", &_data_->_tmp99_, NULL);
			_data_->_tmp100_ = _data_->_tmp99_;
			_data_->_tmp101_ = _data_->e;
			_data_->_tmp102_ = _data_->_tmp101_->message;
			services_todoist_debug_error (_data_->self, _data_->_tmp100_, _data_->_tmp102_);
		} else {
			_data_->_tmp103_ = objects_queue_new ();
			_data_->queue = _data_->_tmp103_;
			_data_->_tmp104_ = _data_->queue;
			_data_->_tmp105_ = _data_->uuid;
			objects_queue_set_uuid (_data_->_tmp104_, _data_->_tmp105_);
			_data_->_tmp106_ = _data_->queue;
			_data_->_tmp107_ = objects_base_object_get_id (_data_->object);
			_data_->_tmp108_ = _data_->_tmp107_;
			objects_queue_set_object_id (_data_->_tmp106_, _data_->_tmp108_);
			_data_->_tmp109_ = _data_->queue;
			_data_->_tmp110_ = objects_base_object_get_type_delete (_data_->object);
			_data_->_tmp111_ = _data_->_tmp110_;
			objects_queue_set_query (_data_->_tmp109_, _data_->_tmp111_);
			_data_->_tmp112_ = _data_->queue;
			_data_->_tmp113_ = objects_base_object_to_json (_data_->object);
			_data_->_tmp114_ = _data_->_tmp113_;
			objects_queue_set_args (_data_->_tmp112_, _data_->_tmp114_);
			_g_free0 (_data_->_tmp114_);
			_data_->_tmp115_ = services_database_get_default ();
			_data_->_tmp116_ = _data_->_tmp115_;
			_data_->_tmp117_ = _data_->queue;
			services_database_insert_queue (_data_->_tmp116_, _data_->_tmp117_);
			_g_object_unref0 (_data_->_tmp116_);
			_data_->_tmp118_ = _data_->response;
			http_response_set_status (_data_->_tmp118_, TRUE);
			_g_object_unref0 (_data_->queue);
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->json);
		_g_free0 (_data_->uuid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->json);
	_g_free0 (_data_->uuid);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_add_section_if_not_exists (ServicesTodoist* self,
                                            JsonNode* node)
{
	gchar* _id = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	ObjectsProject* project = NULL;
	ServicesStore* _tmp3_;
	const gchar* _tmp4_;
	ObjectsProject* _tmp5_;
	ObjectsProject* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = json_node_get_object (node);
	_tmp1_ = json_object_get_string_member (_tmp0_, "project_id");
	_tmp2_ = g_strdup (_tmp1_);
	_id = _tmp2_;
	_tmp3_ = services_store_instance ();
	_tmp4_ = _id;
	_tmp5_ = services_store_get_project (_tmp3_, _tmp4_);
	project = _tmp5_;
	_tmp6_ = project;
	if (_tmp6_ != NULL) {
		ObjectsProject* _tmp7_;
		ObjectsSection* _tmp8_;
		ObjectsSection* _tmp9_;
		ObjectsSection* _tmp10_;
		ObjectsSection* _tmp11_;
		_tmp7_ = project;
		_tmp8_ = objects_section_new_from_json (node);
		_tmp9_ = _tmp8_;
		_tmp10_ = objects_project_add_section_if_not_exists (_tmp7_, _tmp9_);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp11_);
		_g_object_unref0 (_tmp9_);
	}
	_g_object_unref0 (project);
	_g_free0 (_id);
}

static void
services_todoist_complete_item_data_free (gpointer _data)
{
	ServicesTodoistCompleteItemData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->item);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistCompleteItemData, _data_);
}

void
services_todoist_complete_item (ServicesTodoist* self,
                                ObjectsItem* item,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	ServicesTodoistCompleteItemData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_data_ = g_slice_new0 (ServicesTodoistCompleteItemData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_complete_item_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (item);
	_g_object_unref0 (_data_->item);
	_data_->item = _tmp1_;
	services_todoist_complete_item_co (_data_);
}

HttpResponse*
services_todoist_complete_item_finish (ServicesTodoist* self,
                                       GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistCompleteItemData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_complete_item_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	ServicesTodoistCompleteItemData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_complete_item_co (_data_);
}

static gboolean
services_todoist_complete_item_co (ServicesTodoistCompleteItemData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->uuid = _data_->_tmp3_;
	_data_->_tmp5_ = objects_item_get_checked (_data_->item);
	_data_->_tmp6_ = _data_->_tmp5_;
	if (_data_->_tmp6_) {
		_data_->_tmp4_ = "item_complete";
	} else {
		_data_->_tmp4_ = "item_uncomplete";
	}
	_data_->_tmp7_ = _data_->uuid;
	_data_->_tmp8_ = objects_item_get_check_json (_data_->item, _data_->_tmp7_, _data_->_tmp4_);
	_data_->json = _data_->_tmp8_;
	_data_->_tmp9_ = objects_base_object_get_source ((ObjectsBaseObject*) _data_->item);
	_data_->_tmp10_ = _data_->_tmp9_;
	_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
	_data_->source = _data_->_tmp11_;
	_data_->_tmp12_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp12_;
	_data_->_tmp13_ = _data_->message;
	_data_->_tmp14_ = soup_message_get_request_headers (_data_->_tmp13_);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp16_ = _data_->source;
	_data_->_tmp17_ = objects_source_get_todoist_data (_data_->_tmp16_);
	_data_->_tmp18_ = _data_->_tmp17_;
	_data_->_tmp19_ = objects_source_todoist_data_get_access_token (_data_->_tmp18_);
	_data_->_tmp20_ = _data_->_tmp19_;
	_data_->_tmp21_ = g_strdup_printf ("Bearer %s", _data_->_tmp20_);
	_data_->_tmp22_ = _data_->_tmp21_;
	soup_message_headers_append (_data_->_tmp15_, "Authorization", _data_->_tmp22_);
	_g_free0 (_data_->_tmp22_);
	_data_->_tmp23_ = _data_->message;
	_data_->_tmp24_ = _data_->json;
	_data_->_tmp26_ = 0;
	_data_->_tmp25_ = string_get_data (_data_->_tmp24_, &_data_->_tmp26_);
	_data_->_tmp25__length1 = _data_->_tmp26_;
	_data_->_tmp27_ = _data_->_tmp25_;
	_data_->_tmp27__length1 = _data_->_tmp25__length1;
	_data_->_tmp28_ = g_bytes_new (_data_->_tmp27_, _data_->_tmp27__length1);
	_data_->_tmp29_ = _data_->_tmp28_;
	soup_message_set_request_body_from_bytes (_data_->_tmp23_, "application/json", _data_->_tmp29_);
	_g_bytes_unref0 (_data_->_tmp29_);
	_data_->_tmp30_ = http_response_new ();
	_data_->response = _data_->_tmp30_;
	{
		_data_->_tmp31_ = _data_->self->priv->session;
		_data_->_tmp32_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp31_, _data_->_tmp32_, G_PRIORITY_HIGH, NULL, services_todoist_complete_item_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp33_ = soup_session_send_and_read_finish (_data_->_tmp31_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp33_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp34_ = _data_->self->priv->parser;
		_data_->_tmp35_ = _data_->stream;
		_data_->_tmp36_ = 0;
		_data_->_tmp37_ = g_bytes_get_data (_data_->_tmp35_, &_data_->_tmp36_);
		json_parser_load_from_data (_data_->_tmp34_, (const gchar*) _data_->_tmp37_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp38_ = _data_->self->priv->parser;
		_data_->_tmp39_ = json_parser_get_root (_data_->_tmp38_);
		services_todoist_print_root (_data_->self, _data_->_tmp39_);
		_data_->_tmp40_ = _data_->message;
		g_object_get (_data_->_tmp40_, "status-code", &_data_->_tmp41_, NULL);
		_data_->_tmp42_ = _data_->_tmp41_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp42_)) {
			_data_->_tmp43_ = _data_->response;
			_data_->_tmp44_ = _data_->self->priv->parser;
			_data_->_tmp45_ = json_parser_get_root (_data_->_tmp44_);
			http_response_from_error_json (_data_->_tmp43_, _data_->_tmp45_);
			_data_->_tmp46_ = _data_->message;
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
			_data_->_tmp48_ = _data_->_tmp47_;
			_data_->_tmp49_ = _data_->message;
			g_object_get (_data_->_tmp49_, "status-code", &_data_->_tmp50_, NULL);
			_data_->_tmp51_ = _data_->_tmp50_;
			_data_->_tmp52_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp51_);
			_data_->_tmp53_ = _data_->_tmp52_;
			services_todoist_debug_error (_data_->self, _data_->_tmp48_, _data_->_tmp53_);
			_g_free0 (_data_->_tmp53_);
		} else {
			_data_->_tmp54_ = _data_->self->priv->parser;
			_data_->_tmp55_ = json_parser_get_root (_data_->_tmp54_);
			_data_->_tmp56_ = json_node_get_object (_data_->_tmp55_);
			_data_->_tmp57_ = json_object_get_object_member (_data_->_tmp56_, "sync_status");
			_data_->_tmp58_ = _json_object_ref0 (_data_->_tmp57_);
			_data_->sync_status = _data_->_tmp58_;
			_data_->_tmp59_ = _data_->sync_status;
			_data_->_tmp60_ = _data_->uuid;
			_data_->_tmp61_ = json_object_get_member (_data_->_tmp59_, _data_->_tmp60_);
			_data_->_tmp62_ = __vala_JsonNode_copy0 (_data_->_tmp61_);
			_data_->uuid_member = _data_->_tmp62_;
			_data_->_tmp63_ = _data_->uuid_member;
			if (json_node_get_node_type (_data_->_tmp63_) == JSON_NODE_VALUE) {
				_data_->_tmp64_ = _data_->source;
				_data_->_tmp65_ = objects_source_get_todoist_data (_data_->_tmp64_);
				_data_->_tmp66_ = _data_->_tmp65_;
				_data_->_tmp67_ = _data_->self->priv->parser;
				_data_->_tmp68_ = json_parser_get_root (_data_->_tmp67_);
				_data_->_tmp69_ = json_node_get_object (_data_->_tmp68_);
				_data_->_tmp70_ = json_object_get_string_member (_data_->_tmp69_, "sync_token");
				objects_source_todoist_data_set_sync_token (_data_->_tmp66_, _data_->_tmp70_);
				_data_->_tmp71_ = _data_->response;
				http_response_set_status (_data_->_tmp71_, TRUE);
				_data_->_tmp72_ = _data_->source;
				_data_->_tmp73_ = g_date_time_new_now_local ();
				_data_->_tmp74_ = _data_->_tmp73_;
				_data_->_tmp75_ = g_date_time_to_string (_data_->_tmp74_);
				_data_->_tmp76_ = _data_->_tmp75_;
				objects_source_set_last_sync (_data_->_tmp72_, _data_->_tmp76_);
				_g_free0 (_data_->_tmp76_);
				_g_date_time_unref0 (_data_->_tmp74_);
				_data_->_tmp77_ = _data_->source;
				objects_source_save (_data_->_tmp77_);
			} else {
				_data_->_tmp78_ = _data_->response;
				_data_->_tmp79_ = _data_->sync_status;
				_data_->_tmp80_ = _data_->uuid;
				_data_->_tmp81_ = json_object_get_object_member (_data_->_tmp79_, _data_->_tmp80_);
				_data_->_tmp82_ = json_object_get_string_member (_data_->_tmp81_, "error");
				http_response_set_error (_data_->_tmp78_, _data_->_tmp82_);
				_data_->_tmp83_ = _data_->sync_status;
				_data_->_tmp84_ = _data_->uuid;
				_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp83_, _data_->_tmp84_);
				_data_->_tmp86_ = _data_->sync_status;
				_data_->_tmp87_ = _data_->uuid;
				_data_->_tmp88_ = json_object_get_object_member (_data_->_tmp86_, _data_->_tmp87_);
				_data_->_tmp89_ = json_object_get_string_member (_data_->_tmp88_, "error");
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp85_, "http_code"), _data_->_tmp89_);
			}
			__vala_JsonNode_free0 (_data_->uuid_member);
			_json_object_unref0 (_data_->sync_status);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp90_ = _data_->message;
		g_object_get (_data_->_tmp90_, "status-code", &_data_->_tmp91_, NULL);
		_data_->_tmp92_ = _data_->_tmp91_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp92_)) {
			_data_->_tmp93_ = _data_->response;
			_data_->_tmp94_ = _data_->e;
			_data_->_tmp95_ = _data_->_tmp94_->message;
			http_response_set_error (_data_->_tmp93_, _data_->_tmp95_);
			_data_->_tmp96_ = _data_->message;
			g_object_get (_data_->_tmp96_, "status-code", &_data_->_tmp97_, NULL);
			_data_->_tmp98_ = _data_->_tmp97_;
			_data_->_tmp99_ = _data_->e;
			_data_->_tmp100_ = _data_->_tmp99_->message;
			services_todoist_debug_error (_data_->self, _data_->_tmp98_, _data_->_tmp100_);
		} else {
			_data_->_tmp101_ = objects_queue_new ();
			_data_->queue = _data_->_tmp101_;
			_data_->_tmp102_ = _data_->queue;
			_data_->_tmp103_ = _data_->uuid;
			objects_queue_set_uuid (_data_->_tmp102_, _data_->_tmp103_);
			_data_->_tmp104_ = _data_->queue;
			_data_->_tmp105_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->item);
			_data_->_tmp106_ = _data_->_tmp105_;
			objects_queue_set_object_id (_data_->_tmp104_, _data_->_tmp106_);
			_data_->_tmp108_ = objects_item_get_checked (_data_->item);
			_data_->_tmp109_ = _data_->_tmp108_;
			if (_data_->_tmp109_) {
				_data_->_tmp107_ = "item_complete";
			} else {
				_data_->_tmp107_ = "item_uncomplete";
			}
			_data_->_tmp110_ = _data_->queue;
			objects_queue_set_query (_data_->_tmp110_, _data_->_tmp107_);
			_data_->_tmp111_ = _data_->queue;
			_data_->_tmp112_ = objects_base_object_to_json ((ObjectsBaseObject*) _data_->item);
			_data_->_tmp113_ = _data_->_tmp112_;
			objects_queue_set_args (_data_->_tmp111_, _data_->_tmp113_);
			_g_free0 (_data_->_tmp113_);
			_data_->_tmp114_ = services_database_get_default ();
			_data_->_tmp115_ = _data_->_tmp114_;
			_data_->_tmp116_ = _data_->queue;
			services_database_insert_queue (_data_->_tmp115_, _data_->_tmp116_);
			_g_object_unref0 (_data_->_tmp115_);
			_data_->_tmp117_ = _data_->response;
			http_response_set_status (_data_->_tmp117_, TRUE);
			_g_object_unref0 (_data_->queue);
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_object_unref0 (_data_->source);
		_g_free0 (_data_->json);
		_g_free0 (_data_->uuid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_object_unref0 (_data_->source);
	_g_free0 (_data_->json);
	_g_free0 (_data_->uuid);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_print_root (ServicesTodoist* self,
                             JsonNode* root)
{
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (root != NULL);
	_tmp0_ = json_generator_new ();
	generator = _tmp0_;
	json_generator_set_root (generator, root);
	_tmp1_ = json_generator_to_data (generator, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, "\n", NULL);
	_tmp4_ = _tmp3_;
	g_print ("%s", _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_g_object_unref0 (generator);
}

gchar*
services_todoist_get_delete_json (ServicesTodoist* self,
                                  const gchar* id,
                                  const gchar* type,
                                  const gchar* uuid)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp1_;
	JsonNode* root = NULL;
	JsonNode* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (type != NULL, NULL);
	g_return_val_if_fail (uuid != NULL, NULL);
	_tmp0_ = json_builder_new ();
	builder = _tmp0_;
	json_builder_begin_object (builder);
	json_builder_set_member_name (builder, "commands");
	json_builder_begin_array (builder);
	json_builder_begin_object (builder);
	json_builder_set_member_name (builder, "type");
	json_builder_add_string_value (builder, type);
	json_builder_set_member_name (builder, "uuid");
	json_builder_add_string_value (builder, uuid);
	json_builder_set_member_name (builder, "args");
	json_builder_begin_object (builder);
	json_builder_set_member_name (builder, "id");
	json_builder_add_string_value (builder, id);
	json_builder_end_object (builder);
	json_builder_end_object (builder);
	json_builder_end_array (builder);
	json_builder_end_object (builder);
	_tmp1_ = json_generator_new ();
	generator = _tmp1_;
	_tmp2_ = json_builder_get_root (builder);
	root = _tmp2_;
	json_generator_set_root (generator, root);
	_tmp3_ = json_generator_to_data (generator, NULL);
	result = _tmp3_;
	__vala_JsonNode_free0 (root);
	_g_object_unref0 (generator);
	_g_object_unref0 (builder);
	return result;
}

static void
services_todoist_move_item_data_free (gpointer _data)
{
	ServicesTodoistMoveItemData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->item);
	_g_free0 (_data_->type);
	_g_free0 (_data_->id);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistMoveItemData, _data_);
}

void
services_todoist_move_item (ServicesTodoist* self,
                            ObjectsItem* item,
                            const gchar* type,
                            const gchar* id,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	ServicesTodoistMoveItemData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsItem* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (id != NULL);
	_data_ = g_slice_new0 (ServicesTodoistMoveItemData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_move_item_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (item);
	_g_object_unref0 (_data_->item);
	_data_->item = _tmp1_;
	_tmp2_ = g_strdup (type);
	_g_free0 (_data_->type);
	_data_->type = _tmp2_;
	_tmp3_ = g_strdup (id);
	_g_free0 (_data_->id);
	_data_->id = _tmp3_;
	services_todoist_move_item_co (_data_);
}

HttpResponse*
services_todoist_move_item_finish (ServicesTodoist* self,
                                   GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistMoveItemData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_move_item_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	ServicesTodoistMoveItemData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_move_item_co (_data_);
}

static gboolean
services_todoist_move_item_co (ServicesTodoistMoveItemData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->uuid = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->uuid;
	_data_->_tmp5_ = objects_item_get_move_item (_data_->item, _data_->_tmp4_, _data_->type, _data_->id);
	_data_->json = _data_->_tmp5_;
	_data_->_tmp6_ = objects_base_object_get_source ((ObjectsBaseObject*) _data_->item);
	_data_->_tmp7_ = _data_->_tmp6_;
	_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
	_data_->source = _data_->_tmp8_;
	_data_->_tmp9_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp9_;
	_data_->_tmp10_ = _data_->message;
	_data_->_tmp11_ = soup_message_get_request_headers (_data_->_tmp10_);
	_data_->_tmp12_ = _data_->_tmp11_;
	_data_->_tmp13_ = _data_->source;
	_data_->_tmp14_ = objects_source_get_todoist_data (_data_->_tmp13_);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp16_ = objects_source_todoist_data_get_access_token (_data_->_tmp15_);
	_data_->_tmp17_ = _data_->_tmp16_;
	_data_->_tmp18_ = g_strdup_printf ("Bearer %s", _data_->_tmp17_);
	_data_->_tmp19_ = _data_->_tmp18_;
	soup_message_headers_append (_data_->_tmp12_, "Authorization", _data_->_tmp19_);
	_g_free0 (_data_->_tmp19_);
	_data_->_tmp20_ = _data_->message;
	_data_->_tmp21_ = _data_->json;
	_data_->_tmp23_ = 0;
	_data_->_tmp22_ = string_get_data (_data_->_tmp21_, &_data_->_tmp23_);
	_data_->_tmp22__length1 = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->_tmp22_;
	_data_->_tmp24__length1 = _data_->_tmp22__length1;
	_data_->_tmp25_ = g_bytes_new (_data_->_tmp24_, _data_->_tmp24__length1);
	_data_->_tmp26_ = _data_->_tmp25_;
	soup_message_set_request_body_from_bytes (_data_->_tmp20_, "application/json", _data_->_tmp26_);
	_g_bytes_unref0 (_data_->_tmp26_);
	_data_->_tmp27_ = http_response_new ();
	_data_->response = _data_->_tmp27_;
	{
		_data_->_tmp28_ = _data_->self->priv->session;
		_data_->_tmp29_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp28_, _data_->_tmp29_, G_PRIORITY_HIGH, NULL, services_todoist_move_item_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp30_ = soup_session_send_and_read_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp30_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp31_ = _data_->self->priv->parser;
		_data_->_tmp32_ = _data_->stream;
		_data_->_tmp33_ = 0;
		_data_->_tmp34_ = g_bytes_get_data (_data_->_tmp32_, &_data_->_tmp33_);
		json_parser_load_from_data (_data_->_tmp31_, (const gchar*) _data_->_tmp34_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp35_ = _data_->self->priv->parser;
		_data_->_tmp36_ = json_parser_get_root (_data_->_tmp35_);
		services_todoist_print_root (_data_->self, _data_->_tmp36_);
		_data_->_tmp37_ = _data_->message;
		g_object_get (_data_->_tmp37_, "status-code", &_data_->_tmp38_, NULL);
		_data_->_tmp39_ = _data_->_tmp38_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp39_)) {
			_data_->_tmp40_ = _data_->response;
			_data_->_tmp41_ = _data_->self->priv->parser;
			_data_->_tmp42_ = json_parser_get_root (_data_->_tmp41_);
			http_response_from_error_json (_data_->_tmp40_, _data_->_tmp42_);
			_data_->_tmp43_ = _data_->message;
			g_object_get (_data_->_tmp43_, "status-code", &_data_->_tmp44_, NULL);
			_data_->_tmp45_ = _data_->_tmp44_;
			_data_->_tmp46_ = _data_->message;
			g_object_get (_data_->_tmp46_, "status-code", &_data_->_tmp47_, NULL);
			_data_->_tmp48_ = _data_->_tmp47_;
			_data_->_tmp49_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp48_);
			_data_->_tmp50_ = _data_->_tmp49_;
			services_todoist_debug_error (_data_->self, _data_->_tmp45_, _data_->_tmp50_);
			_g_free0 (_data_->_tmp50_);
		} else {
			_data_->_tmp51_ = _data_->self->priv->parser;
			_data_->_tmp52_ = json_parser_get_root (_data_->_tmp51_);
			_data_->_tmp53_ = json_node_get_object (_data_->_tmp52_);
			_data_->_tmp54_ = json_object_get_object_member (_data_->_tmp53_, "sync_status");
			_data_->_tmp55_ = _json_object_ref0 (_data_->_tmp54_);
			_data_->sync_status = _data_->_tmp55_;
			_data_->_tmp56_ = _data_->sync_status;
			_data_->_tmp57_ = _data_->uuid;
			_data_->_tmp58_ = json_object_get_member (_data_->_tmp56_, _data_->_tmp57_);
			_data_->_tmp59_ = __vala_JsonNode_copy0 (_data_->_tmp58_);
			_data_->uuid_member = _data_->_tmp59_;
			_data_->_tmp60_ = _data_->uuid_member;
			if (json_node_get_node_type (_data_->_tmp60_) == JSON_NODE_VALUE) {
				_data_->_tmp61_ = _data_->source;
				_data_->_tmp62_ = objects_source_get_todoist_data (_data_->_tmp61_);
				_data_->_tmp63_ = _data_->_tmp62_;
				_data_->_tmp64_ = _data_->self->priv->parser;
				_data_->_tmp65_ = json_parser_get_root (_data_->_tmp64_);
				_data_->_tmp66_ = json_node_get_object (_data_->_tmp65_);
				_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "sync_token");
				objects_source_todoist_data_set_sync_token (_data_->_tmp63_, _data_->_tmp67_);
				_data_->_tmp68_ = _data_->response;
				http_response_set_status (_data_->_tmp68_, TRUE);
				_data_->_tmp69_ = _data_->source;
				_data_->_tmp70_ = g_date_time_new_now_local ();
				_data_->_tmp71_ = _data_->_tmp70_;
				_data_->_tmp72_ = g_date_time_to_string (_data_->_tmp71_);
				_data_->_tmp73_ = _data_->_tmp72_;
				objects_source_set_last_sync (_data_->_tmp69_, _data_->_tmp73_);
				_g_free0 (_data_->_tmp73_);
				_g_date_time_unref0 (_data_->_tmp71_);
				_data_->_tmp74_ = _data_->source;
				objects_source_save (_data_->_tmp74_);
			} else {
				_data_->_tmp75_ = _data_->response;
				_data_->_tmp76_ = _data_->sync_status;
				_data_->_tmp77_ = _data_->uuid;
				_data_->_tmp78_ = json_object_get_object_member (_data_->_tmp76_, _data_->_tmp77_);
				_data_->_tmp79_ = json_object_get_string_member (_data_->_tmp78_, "error");
				http_response_set_error (_data_->_tmp75_, _data_->_tmp79_);
				_data_->_tmp80_ = _data_->sync_status;
				_data_->_tmp81_ = _data_->uuid;
				_data_->_tmp82_ = json_object_get_object_member (_data_->_tmp80_, _data_->_tmp81_);
				_data_->_tmp83_ = _data_->sync_status;
				_data_->_tmp84_ = _data_->uuid;
				_data_->_tmp85_ = json_object_get_object_member (_data_->_tmp83_, _data_->_tmp84_);
				_data_->_tmp86_ = json_object_get_string_member (_data_->_tmp85_, "error");
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp82_, "http_code"), _data_->_tmp86_);
			}
			__vala_JsonNode_free0 (_data_->uuid_member);
			_json_object_unref0 (_data_->sync_status);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp87_ = _data_->message;
		g_object_get (_data_->_tmp87_, "status-code", &_data_->_tmp88_, NULL);
		_data_->_tmp89_ = _data_->_tmp88_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp89_)) {
			_data_->_tmp90_ = _data_->response;
			_data_->_tmp91_ = _data_->e;
			_data_->_tmp92_ = _data_->_tmp91_->message;
			http_response_set_error (_data_->_tmp90_, _data_->_tmp92_);
			_data_->_tmp93_ = _data_->message;
			g_object_get (_data_->_tmp93_, "status-code", &_data_->_tmp94_, NULL);
			_data_->_tmp95_ = _data_->_tmp94_;
			_data_->_tmp96_ = _data_->e;
			_data_->_tmp97_ = _data_->_tmp96_->message;
			services_todoist_debug_error (_data_->self, _data_->_tmp95_, _data_->_tmp97_);
		} else {
			_data_->_tmp98_ = objects_queue_new ();
			_data_->queue = _data_->_tmp98_;
			_data_->_tmp99_ = _data_->queue;
			_data_->_tmp100_ = _data_->uuid;
			objects_queue_set_uuid (_data_->_tmp99_, _data_->_tmp100_);
			_data_->_tmp101_ = _data_->queue;
			_data_->_tmp102_ = objects_base_object_get_id ((ObjectsBaseObject*) _data_->item);
			_data_->_tmp103_ = _data_->_tmp102_;
			objects_queue_set_object_id (_data_->_tmp101_, _data_->_tmp103_);
			_data_->_tmp104_ = _data_->queue;
			objects_queue_set_query (_data_->_tmp104_, "item_move");
			_data_->_tmp105_ = _data_->queue;
			_data_->_tmp106_ = objects_item_to_move_json (_data_->item, _data_->type, _data_->id);
			_data_->_tmp107_ = _data_->_tmp106_;
			objects_queue_set_args (_data_->_tmp105_, _data_->_tmp107_);
			_g_free0 (_data_->_tmp107_);
			_data_->_tmp108_ = services_database_get_default ();
			_data_->_tmp109_ = _data_->_tmp108_;
			_data_->_tmp110_ = _data_->queue;
			services_database_insert_queue (_data_->_tmp109_, _data_->_tmp110_);
			_g_object_unref0 (_data_->_tmp109_);
			_data_->_tmp111_ = _data_->response;
			http_response_set_status (_data_->_tmp111_, TRUE);
			_g_object_unref0 (_data_->queue);
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_object_unref0 (_data_->source);
		_g_free0 (_data_->json);
		_g_free0 (_data_->uuid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_object_unref0 (_data_->source);
	_g_free0 (_data_->json);
	_g_free0 (_data_->uuid);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_move_project_section_data_free (gpointer _data)
{
	ServicesTodoistMoveProjectSectionData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->base_object);
	_g_free0 (_data_->project_id);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistMoveProjectSectionData, _data_);
}

void
services_todoist_move_project_section (ServicesTodoist* self,
                                       ObjectsBaseObject* base_object,
                                       const gchar* project_id,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ServicesTodoistMoveProjectSectionData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsBaseObject* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (base_object != NULL);
	g_return_if_fail (project_id != NULL);
	_data_ = g_slice_new0 (ServicesTodoistMoveProjectSectionData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_move_project_section_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (base_object);
	_g_object_unref0 (_data_->base_object);
	_data_->base_object = _tmp1_;
	_tmp2_ = g_strdup (project_id);
	_g_free0 (_data_->project_id);
	_data_->project_id = _tmp2_;
	services_todoist_move_project_section_co (_data_);
}

HttpResponse*
services_todoist_move_project_section_finish (ServicesTodoist* self,
                                              GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistMoveProjectSectionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_move_project_section_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ServicesTodoistMoveProjectSectionData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_move_project_section_co (_data_);
}

static gboolean
services_todoist_move_project_section_co (ServicesTodoistMoveProjectSectionData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_get_default ();
	_data_->_tmp1_ = _data_->_tmp0_;
	_data_->_tmp2_ = util_generate_string (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_g_object_unref0 (_data_->_tmp1_);
	_data_->uuid = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->uuid;
	_data_->_tmp5_ = objects_base_object_get_move_json (_data_->base_object, _data_->_tmp4_, _data_->project_id);
	_data_->json = _data_->_tmp5_;
	_data_->_tmp6_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp6_;
	_data_->_tmp7_ = _data_->message;
	_data_->_tmp8_ = soup_message_get_request_headers (_data_->_tmp7_);
	_data_->_tmp9_ = _data_->_tmp8_;
	_data_->_tmp10_ = objects_base_object_get_source (_data_->base_object);
	_data_->_tmp11_ = _data_->_tmp10_;
	_data_->_tmp12_ = objects_source_get_todoist_data (_data_->_tmp11_);
	_data_->_tmp13_ = _data_->_tmp12_;
	_data_->_tmp14_ = objects_source_todoist_data_get_access_token (_data_->_tmp13_);
	_data_->_tmp15_ = _data_->_tmp14_;
	_data_->_tmp16_ = g_strdup_printf ("Bearer %s", _data_->_tmp15_);
	_data_->_tmp17_ = _data_->_tmp16_;
	soup_message_headers_append (_data_->_tmp9_, "Authorization", _data_->_tmp17_);
	_g_free0 (_data_->_tmp17_);
	_data_->_tmp18_ = _data_->message;
	_data_->_tmp19_ = _data_->json;
	_data_->_tmp21_ = 0;
	_data_->_tmp20_ = string_get_data (_data_->_tmp19_, &_data_->_tmp21_);
	_data_->_tmp20__length1 = _data_->_tmp21_;
	_data_->_tmp22_ = _data_->_tmp20_;
	_data_->_tmp22__length1 = _data_->_tmp20__length1;
	_data_->_tmp23_ = g_bytes_new (_data_->_tmp22_, _data_->_tmp22__length1);
	_data_->_tmp24_ = _data_->_tmp23_;
	soup_message_set_request_body_from_bytes (_data_->_tmp18_, "application/json", _data_->_tmp24_);
	_g_bytes_unref0 (_data_->_tmp24_);
	_data_->_tmp25_ = http_response_new ();
	_data_->response = _data_->_tmp25_;
	{
		_data_->_tmp26_ = _data_->self->priv->session;
		_data_->_tmp27_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp26_, _data_->_tmp27_, G_PRIORITY_HIGH, NULL, services_todoist_move_project_section_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp28_ = soup_session_send_and_read_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp28_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp29_ = _data_->self->priv->parser;
		_data_->_tmp30_ = _data_->stream;
		_data_->_tmp31_ = 0;
		_data_->_tmp32_ = g_bytes_get_data (_data_->_tmp30_, &_data_->_tmp31_);
		json_parser_load_from_data (_data_->_tmp29_, (const gchar*) _data_->_tmp32_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp33_ = _data_->self->priv->parser;
		_data_->_tmp34_ = json_parser_get_root (_data_->_tmp33_);
		services_todoist_print_root (_data_->self, _data_->_tmp34_);
		_data_->_tmp35_ = _data_->message;
		g_object_get (_data_->_tmp35_, "status-code", &_data_->_tmp36_, NULL);
		_data_->_tmp37_ = _data_->_tmp36_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp37_)) {
			_data_->_tmp38_ = _data_->response;
			_data_->_tmp39_ = _data_->self->priv->parser;
			_data_->_tmp40_ = json_parser_get_root (_data_->_tmp39_);
			http_response_from_error_json (_data_->_tmp38_, _data_->_tmp40_);
			_data_->_tmp41_ = _data_->message;
			g_object_get (_data_->_tmp41_, "status-code", &_data_->_tmp42_, NULL);
			_data_->_tmp43_ = _data_->_tmp42_;
			_data_->_tmp44_ = _data_->message;
			g_object_get (_data_->_tmp44_, "status-code", &_data_->_tmp45_, NULL);
			_data_->_tmp46_ = _data_->_tmp45_;
			_data_->_tmp47_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp46_);
			_data_->_tmp48_ = _data_->_tmp47_;
			services_todoist_debug_error (_data_->self, _data_->_tmp43_, _data_->_tmp48_);
			_g_free0 (_data_->_tmp48_);
		} else {
			_data_->_tmp49_ = _data_->self->priv->parser;
			_data_->_tmp50_ = json_parser_get_root (_data_->_tmp49_);
			_data_->_tmp51_ = json_node_get_object (_data_->_tmp50_);
			_data_->_tmp52_ = json_object_get_object_member (_data_->_tmp51_, "sync_status");
			_data_->_tmp53_ = _json_object_ref0 (_data_->_tmp52_);
			_data_->sync_status = _data_->_tmp53_;
			_data_->_tmp54_ = _data_->sync_status;
			_data_->_tmp55_ = _data_->uuid;
			_data_->_tmp56_ = json_object_get_member (_data_->_tmp54_, _data_->_tmp55_);
			_data_->_tmp57_ = __vala_JsonNode_copy0 (_data_->_tmp56_);
			_data_->uuid_member = _data_->_tmp57_;
			_data_->_tmp58_ = _data_->uuid_member;
			if (json_node_get_node_type (_data_->_tmp58_) == JSON_NODE_VALUE) {
				_data_->_tmp59_ = objects_base_object_get_source (_data_->base_object);
				_data_->_tmp60_ = _data_->_tmp59_;
				_data_->_tmp61_ = objects_source_get_todoist_data (_data_->_tmp60_);
				_data_->_tmp62_ = _data_->_tmp61_;
				_data_->_tmp63_ = _data_->self->priv->parser;
				_data_->_tmp64_ = json_parser_get_root (_data_->_tmp63_);
				_data_->_tmp65_ = json_node_get_object (_data_->_tmp64_);
				_data_->_tmp66_ = json_object_get_string_member (_data_->_tmp65_, "sync_token");
				objects_source_todoist_data_set_sync_token (_data_->_tmp62_, _data_->_tmp66_);
				_data_->_tmp67_ = _data_->response;
				http_response_set_status (_data_->_tmp67_, TRUE);
				_data_->_tmp68_ = objects_base_object_get_source (_data_->base_object);
				_data_->_tmp69_ = _data_->_tmp68_;
				_data_->_tmp70_ = g_date_time_new_now_local ();
				_data_->_tmp71_ = _data_->_tmp70_;
				_data_->_tmp72_ = g_date_time_to_string (_data_->_tmp71_);
				_data_->_tmp73_ = _data_->_tmp72_;
				objects_source_set_last_sync (_data_->_tmp69_, _data_->_tmp73_);
				_g_free0 (_data_->_tmp73_);
				_g_date_time_unref0 (_data_->_tmp71_);
				_data_->_tmp74_ = objects_base_object_get_source (_data_->base_object);
				_data_->_tmp75_ = _data_->_tmp74_;
				objects_source_save (_data_->_tmp75_);
			} else {
				_data_->_tmp76_ = _data_->response;
				_data_->_tmp77_ = _data_->sync_status;
				_data_->_tmp78_ = _data_->uuid;
				_data_->_tmp79_ = json_object_get_object_member (_data_->_tmp77_, _data_->_tmp78_);
				_data_->_tmp80_ = json_object_get_string_member (_data_->_tmp79_, "error");
				http_response_set_error (_data_->_tmp76_, _data_->_tmp80_);
				_data_->_tmp81_ = _data_->sync_status;
				_data_->_tmp82_ = _data_->uuid;
				_data_->_tmp83_ = json_object_get_object_member (_data_->_tmp81_, _data_->_tmp82_);
				_data_->_tmp84_ = _data_->sync_status;
				_data_->_tmp85_ = _data_->uuid;
				_data_->_tmp86_ = json_object_get_object_member (_data_->_tmp84_, _data_->_tmp85_);
				_data_->_tmp87_ = json_object_get_string_member (_data_->_tmp86_, "error");
				services_todoist_debug_error (_data_->self, (guint) json_object_get_int_member (_data_->_tmp83_, "http_code"), _data_->_tmp87_);
			}
			__vala_JsonNode_free0 (_data_->uuid_member);
			_json_object_unref0 (_data_->sync_status);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp88_ = _data_->message;
		g_object_get (_data_->_tmp88_, "status-code", &_data_->_tmp89_, NULL);
		_data_->_tmp90_ = _data_->_tmp89_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp90_)) {
			_data_->_tmp91_ = _data_->response;
			_data_->_tmp92_ = _data_->e;
			_data_->_tmp93_ = _data_->_tmp92_->message;
			http_response_set_error (_data_->_tmp91_, _data_->_tmp93_);
			_data_->_tmp94_ = _data_->message;
			g_object_get (_data_->_tmp94_, "status-code", &_data_->_tmp95_, NULL);
			_data_->_tmp96_ = _data_->_tmp95_;
			_data_->_tmp97_ = _data_->e;
			_data_->_tmp98_ = _data_->_tmp97_->message;
			services_todoist_debug_error (_data_->self, _data_->_tmp96_, _data_->_tmp98_);
		} else {
			_data_->_tmp99_ = objects_queue_new ();
			_data_->queue = _data_->_tmp99_;
			_data_->_tmp100_ = _data_->queue;
			_data_->_tmp101_ = _data_->uuid;
			objects_queue_set_uuid (_data_->_tmp100_, _data_->_tmp101_);
			_data_->_tmp102_ = _data_->queue;
			_data_->_tmp103_ = objects_base_object_get_id (_data_->base_object);
			_data_->_tmp104_ = _data_->_tmp103_;
			objects_queue_set_object_id (_data_->_tmp102_, _data_->_tmp104_);
			if (OBJECTS_IS_PROJECT (_data_->base_object)) {
				_data_->_tmp105_ = _data_->queue;
				objects_queue_set_query (_data_->_tmp105_, "project_move");
			} else {
				_data_->_tmp106_ = _data_->queue;
				objects_queue_set_query (_data_->_tmp106_, "section_move");
			}
			_data_->_tmp107_ = _data_->queue;
			_data_->_tmp108_ = objects_base_object_to_json (_data_->base_object);
			_data_->_tmp109_ = _data_->_tmp108_;
			objects_queue_set_args (_data_->_tmp107_, _data_->_tmp109_);
			_g_free0 (_data_->_tmp109_);
			_data_->_tmp110_ = _data_->response;
			http_response_set_status (_data_->_tmp110_, TRUE);
			_data_->_tmp111_ = services_database_get_default ();
			_data_->_tmp112_ = _data_->_tmp111_;
			_data_->_tmp113_ = _data_->queue;
			services_database_insert_queue (_data_->_tmp112_, _data_->_tmp113_);
			_g_object_unref0 (_data_->_tmp112_);
			_g_object_unref0 (_data_->queue);
		}
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->json);
		_g_free0 (_data_->uuid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->json);
	_g_free0 (_data_->uuid);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
services_todoist_duplicate_project_data_free (gpointer _data)
{
	ServicesTodoistDuplicateProjectData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->project);
	_http_response_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (ServicesTodoistDuplicateProjectData, _data_);
}

void
services_todoist_duplicate_project (ServicesTodoist* self,
                                    ObjectsProject* project,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	ServicesTodoistDuplicateProjectData* _data_;
	ServicesTodoist* _tmp0_;
	ObjectsProject* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	_data_ = g_slice_new0 (ServicesTodoistDuplicateProjectData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, services_todoist_duplicate_project_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (project);
	_g_object_unref0 (_data_->project);
	_data_->project = _tmp1_;
	services_todoist_duplicate_project_co (_data_);
}

HttpResponse*
services_todoist_duplicate_project_finish (ServicesTodoist* self,
                                           GAsyncResult* _res_)
{
	HttpResponse* result;
	ServicesTodoistDuplicateProjectData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
services_todoist_duplicate_project_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	ServicesTodoistDuplicateProjectData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	services_todoist_duplicate_project_co (_data_);
}

static gboolean
services_todoist_duplicate_project_co (ServicesTodoistDuplicateProjectData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = services_todoist_get_duplicate_project_json (_data_->self, _data_->project);
	_data_->json = _data_->_tmp0_;
	_data_->_tmp1_ = soup_message_new ("POST", SERVICES_TODOIST_TODOIST_SYNC_URL);
	_data_->message = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->message;
	_data_->_tmp3_ = soup_message_get_request_headers (_data_->_tmp2_);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_tmp5_ = objects_project_get_source (_data_->project);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = objects_source_get_todoist_data (_data_->_tmp6_);
	_data_->_tmp8_ = _data_->_tmp7_;
	_data_->_tmp9_ = objects_source_todoist_data_get_access_token (_data_->_tmp8_);
	_data_->_tmp10_ = _data_->_tmp9_;
	_data_->_tmp11_ = g_strdup_printf ("Bearer %s", _data_->_tmp10_);
	_data_->_tmp12_ = _data_->_tmp11_;
	soup_message_headers_append (_data_->_tmp4_, "Authorization", _data_->_tmp12_);
	_g_free0 (_data_->_tmp12_);
	_data_->_tmp13_ = _data_->message;
	_data_->_tmp14_ = _data_->json;
	_data_->_tmp16_ = 0;
	_data_->_tmp15_ = string_get_data (_data_->_tmp14_, &_data_->_tmp16_);
	_data_->_tmp15__length1 = _data_->_tmp16_;
	_data_->_tmp17_ = _data_->_tmp15_;
	_data_->_tmp17__length1 = _data_->_tmp15__length1;
	_data_->_tmp18_ = g_bytes_new (_data_->_tmp17_, _data_->_tmp17__length1);
	_data_->_tmp19_ = _data_->_tmp18_;
	soup_message_set_request_body_from_bytes (_data_->_tmp13_, "application/json", _data_->_tmp19_);
	_g_bytes_unref0 (_data_->_tmp19_);
	_data_->_tmp20_ = http_response_new ();
	_data_->response = _data_->_tmp20_;
	{
		_data_->_tmp21_ = _data_->self->priv->session;
		_data_->_tmp22_ = _data_->message;
		_data_->_state_ = 1;
		soup_session_send_and_read_async (_data_->_tmp21_, _data_->_tmp22_, G_PRIORITY_HIGH, NULL, services_todoist_duplicate_project_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp23_ = soup_session_send_and_read_finish (_data_->_tmp21_, _data_->_res_, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp23_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp24_ = _data_->self->priv->parser;
		_data_->_tmp25_ = _data_->stream;
		_data_->_tmp26_ = 0;
		_data_->_tmp27_ = g_bytes_get_data (_data_->_tmp25_, &_data_->_tmp26_);
		json_parser_load_from_data (_data_->_tmp24_, (const gchar*) _data_->_tmp27_, (gssize) -1, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_bytes_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp28_ = _data_->self->priv->parser;
		_data_->_tmp29_ = json_parser_get_root (_data_->_tmp28_);
		services_todoist_print_root (_data_->self, _data_->_tmp29_);
		_data_->_tmp30_ = _data_->message;
		g_object_get (_data_->_tmp30_, "status-code", &_data_->_tmp31_, NULL);
		_data_->_tmp32_ = _data_->_tmp31_;
		if (services_todoist_is_todoist_error (_data_->self, _data_->_tmp32_)) {
			_data_->_tmp33_ = _data_->response;
			_data_->_tmp34_ = _data_->self->priv->parser;
			_data_->_tmp35_ = json_parser_get_root (_data_->_tmp34_);
			http_response_from_error_json (_data_->_tmp33_, _data_->_tmp35_);
			_data_->_tmp36_ = _data_->message;
			g_object_get (_data_->_tmp36_, "status-code", &_data_->_tmp37_, NULL);
			_data_->_tmp38_ = _data_->_tmp37_;
			_data_->_tmp39_ = _data_->message;
			g_object_get (_data_->_tmp39_, "status-code", &_data_->_tmp40_, NULL);
			_data_->_tmp41_ = _data_->_tmp40_;
			_data_->_tmp42_ = services_todoist_get_todoist_error (_data_->self, _data_->_tmp41_);
			_data_->_tmp43_ = _data_->_tmp42_;
			services_todoist_debug_error (_data_->self, _data_->_tmp38_, _data_->_tmp43_);
			_g_free0 (_data_->_tmp43_);
		} else {
			_data_->_tmp44_ = _data_->response;
			http_response_set_status (_data_->_tmp44_, TRUE);
		}
		_g_bytes_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_data_->_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_http_response_unref0 (_data_->response);
		_g_object_unref0 (_data_->message);
		_g_free0 (_data_->json);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = _data_->response;
	_g_object_unref0 (_data_->message);
	_g_free0 (_data_->json);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gchar*
services_todoist_get_duplicate_project_json (ServicesTodoist* self,
                                             ObjectsProject* project)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	JsonBuilder* _tmp6_;
	JsonBuilder* _tmp7_;
	JsonBuilder* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	JsonBuilder* _tmp13_;
	JsonBuilder* _tmp14_;
	Util* _tmp15_;
	Util* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	JsonBuilder* _tmp19_;
	JsonBuilder* _tmp20_;
	JsonBuilder* _tmp21_;
	JsonBuilder* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	JsonBuilder* _tmp25_;
	JsonBuilder* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	JsonBuilder* _tmp29_;
	JsonBuilder* _tmp30_;
	JsonBuilder* _tmp178_;
	JsonBuilder* _tmp179_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp180_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp181_;
	JsonNode* _tmp182_;
	gchar* _tmp183_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	_tmp0_ = json_builder_new ();
	builder = _tmp0_;
	_tmp1_ = builder;
	json_builder_begin_object (_tmp1_);
	_tmp2_ = builder;
	json_builder_set_member_name (_tmp2_, "commands");
	_tmp3_ = builder;
	json_builder_begin_array (_tmp3_);
	_tmp4_ = builder;
	json_builder_begin_object (_tmp4_);
	_tmp5_ = builder;
	json_builder_set_member_name (_tmp5_, "type");
	_tmp6_ = builder;
	json_builder_add_string_value (_tmp6_, "project_add");
	_tmp7_ = builder;
	json_builder_set_member_name (_tmp7_, "temp_id");
	_tmp8_ = builder;
	_tmp9_ = objects_base_object_get_id ((ObjectsBaseObject*) project);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat ("_", _tmp10_, NULL);
	_tmp12_ = _tmp11_;
	json_builder_add_string_value (_tmp8_, _tmp12_);
	_g_free0 (_tmp12_);
	_tmp13_ = builder;
	json_builder_set_member_name (_tmp13_, "uuid");
	_tmp14_ = builder;
	_tmp15_ = util_get_default ();
	_tmp16_ = _tmp15_;
	_tmp17_ = util_generate_string (_tmp16_);
	_tmp18_ = _tmp17_;
	json_builder_add_string_value (_tmp14_, _tmp18_);
	_g_free0 (_tmp18_);
	_g_object_unref0 (_tmp16_);
	_tmp19_ = builder;
	json_builder_set_member_name (_tmp19_, "args");
	_tmp20_ = builder;
	json_builder_begin_object (_tmp20_);
	_tmp21_ = builder;
	json_builder_set_member_name (_tmp21_, "name");
	_tmp22_ = builder;
	_tmp23_ = objects_base_object_get_name ((ObjectsBaseObject*) project);
	_tmp24_ = _tmp23_;
	json_builder_add_string_value (_tmp22_, _tmp24_);
	_tmp25_ = builder;
	json_builder_set_member_name (_tmp25_, "color");
	_tmp26_ = builder;
	_tmp27_ = objects_project_get_color (project);
	_tmp28_ = _tmp27_;
	json_builder_add_string_value (_tmp26_, _tmp28_);
	_tmp29_ = builder;
	json_builder_end_object (_tmp29_);
	_tmp30_ = builder;
	json_builder_end_object (_tmp30_);
	{
		GeeArrayList* _section_list = NULL;
		GeeArrayList* _tmp31_;
		GeeArrayList* _tmp32_;
		gint _section_size = 0;
		GeeArrayList* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		gint _section_index = 0;
		_tmp31_ = objects_project_get_sections (project);
		_tmp32_ = _tmp31_;
		_section_list = _tmp32_;
		_tmp33_ = _section_list;
		_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
		_tmp35_ = _tmp34_;
		_section_size = _tmp35_;
		_section_index = -1;
		while (TRUE) {
			gint _tmp36_;
			gint _tmp37_;
			ObjectsSection* section = NULL;
			GeeArrayList* _tmp38_;
			gpointer _tmp39_;
			JsonBuilder* _tmp40_;
			JsonBuilder* _tmp41_;
			JsonBuilder* _tmp42_;
			JsonBuilder* _tmp43_;
			JsonBuilder* _tmp44_;
			ObjectsSection* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			JsonBuilder* _tmp50_;
			JsonBuilder* _tmp51_;
			Util* _tmp52_;
			Util* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			JsonBuilder* _tmp56_;
			JsonBuilder* _tmp57_;
			JsonBuilder* _tmp58_;
			JsonBuilder* _tmp59_;
			ObjectsSection* _tmp60_;
			const gchar* _tmp61_;
			const gchar* _tmp62_;
			JsonBuilder* _tmp63_;
			JsonBuilder* _tmp64_;
			ObjectsSection* _tmp65_;
			const gchar* _tmp66_;
			const gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			JsonBuilder* _tmp70_;
			JsonBuilder* _tmp71_;
			_section_index = _section_index + 1;
			_tmp36_ = _section_index;
			_tmp37_ = _section_size;
			if (!(_tmp36_ < _tmp37_)) {
				break;
			}
			_tmp38_ = _section_list;
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp38_, _section_index);
			section = (ObjectsSection*) _tmp39_;
			_tmp40_ = builder;
			json_builder_begin_object (_tmp40_);
			_tmp41_ = builder;
			json_builder_set_member_name (_tmp41_, "type");
			_tmp42_ = builder;
			json_builder_add_string_value (_tmp42_, "section_add");
			_tmp43_ = builder;
			json_builder_set_member_name (_tmp43_, "temp_id");
			_tmp44_ = builder;
			_tmp45_ = section;
			_tmp46_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp45_);
			_tmp47_ = _tmp46_;
			_tmp48_ = g_strconcat ("_", _tmp47_, NULL);
			_tmp49_ = _tmp48_;
			json_builder_add_string_value (_tmp44_, _tmp49_);
			_g_free0 (_tmp49_);
			_tmp50_ = builder;
			json_builder_set_member_name (_tmp50_, "uuid");
			_tmp51_ = builder;
			_tmp52_ = util_get_default ();
			_tmp53_ = _tmp52_;
			_tmp54_ = util_generate_string (_tmp53_);
			_tmp55_ = _tmp54_;
			json_builder_add_string_value (_tmp51_, _tmp55_);
			_g_free0 (_tmp55_);
			_g_object_unref0 (_tmp53_);
			_tmp56_ = builder;
			json_builder_set_member_name (_tmp56_, "args");
			_tmp57_ = builder;
			json_builder_begin_object (_tmp57_);
			_tmp58_ = builder;
			json_builder_set_member_name (_tmp58_, "name");
			_tmp59_ = builder;
			_tmp60_ = section;
			_tmp61_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp60_);
			_tmp62_ = _tmp61_;
			json_builder_add_string_value (_tmp59_, _tmp62_);
			_tmp63_ = builder;
			json_builder_set_member_name (_tmp63_, "project_id");
			_tmp64_ = builder;
			_tmp65_ = section;
			_tmp66_ = objects_section_get_project_id (_tmp65_);
			_tmp67_ = _tmp66_;
			_tmp68_ = g_strconcat ("_", _tmp67_, NULL);
			_tmp69_ = _tmp68_;
			json_builder_add_string_value (_tmp64_, _tmp69_);
			_g_free0 (_tmp69_);
			_tmp70_ = builder;
			json_builder_end_object (_tmp70_);
			_tmp71_ = builder;
			json_builder_end_object (_tmp71_);
			_g_object_unref0 (section);
		}
	}
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp72_;
		GeeArrayList* _tmp73_;
		gint _item_size = 0;
		GeeArrayList* _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint _item_index = 0;
		_tmp72_ = objects_project_get_all_items (project);
		_tmp73_ = _tmp72_;
		_item_list = _tmp73_;
		_tmp74_ = _item_list;
		_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
		_tmp76_ = _tmp75_;
		_item_size = _tmp76_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp77_;
			gint _tmp78_;
			ObjectsItem* item = NULL;
			GeeArrayList* _tmp79_;
			gpointer _tmp80_;
			JsonBuilder* _tmp81_;
			JsonBuilder* _tmp82_;
			JsonBuilder* _tmp83_;
			JsonBuilder* _tmp84_;
			JsonBuilder* _tmp85_;
			ObjectsItem* _tmp86_;
			const gchar* _tmp87_;
			const gchar* _tmp88_;
			gchar* _tmp89_;
			gchar* _tmp90_;
			JsonBuilder* _tmp91_;
			JsonBuilder* _tmp92_;
			Util* _tmp93_;
			Util* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			JsonBuilder* _tmp97_;
			JsonBuilder* _tmp98_;
			JsonBuilder* _tmp99_;
			JsonBuilder* _tmp100_;
			ObjectsItem* _tmp101_;
			const gchar* _tmp102_;
			const gchar* _tmp103_;
			JsonBuilder* _tmp104_;
			JsonBuilder* _tmp105_;
			ObjectsItem* _tmp106_;
			const gchar* _tmp107_;
			const gchar* _tmp108_;
			JsonBuilder* _tmp109_;
			JsonBuilder* _tmp110_;
			ObjectsItem* _tmp111_;
			const gchar* _tmp112_;
			const gchar* _tmp113_;
			gchar* _tmp114_;
			gchar* _tmp115_;
			ObjectsItem* _tmp116_;
			const gchar* _tmp117_;
			const gchar* _tmp118_;
			ObjectsItem* _tmp126_;
			const gchar* _tmp127_;
			const gchar* _tmp128_;
			JsonBuilder* _tmp136_;
			ObjectsItem* _tmp137_;
			gint _tmp138_;
			gint _tmp139_;
			ObjectsItem* _tmp145_;
			gboolean _tmp146_;
			gboolean _tmp147_;
			JsonBuilder* _tmp158_;
			JsonBuilder* _tmp159_;
			JsonBuilder* _tmp174_;
			JsonBuilder* _tmp175_;
			JsonBuilder* _tmp176_;
			JsonBuilder* _tmp177_;
			_item_index = _item_index + 1;
			_tmp77_ = _item_index;
			_tmp78_ = _item_size;
			if (!(_tmp77_ < _tmp78_)) {
				break;
			}
			_tmp79_ = _item_list;
			_tmp80_ = gee_abstract_list_get ((GeeAbstractList*) _tmp79_, _item_index);
			item = (ObjectsItem*) _tmp80_;
			_tmp81_ = builder;
			json_builder_begin_object (_tmp81_);
			_tmp82_ = builder;
			json_builder_set_member_name (_tmp82_, "type");
			_tmp83_ = builder;
			json_builder_add_string_value (_tmp83_, "item_add");
			_tmp84_ = builder;
			json_builder_set_member_name (_tmp84_, "temp_id");
			_tmp85_ = builder;
			_tmp86_ = item;
			_tmp87_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp86_);
			_tmp88_ = _tmp87_;
			_tmp89_ = g_strconcat ("_", _tmp88_, NULL);
			_tmp90_ = _tmp89_;
			json_builder_add_string_value (_tmp85_, _tmp90_);
			_g_free0 (_tmp90_);
			_tmp91_ = builder;
			json_builder_set_member_name (_tmp91_, "uuid");
			_tmp92_ = builder;
			_tmp93_ = util_get_default ();
			_tmp94_ = _tmp93_;
			_tmp95_ = util_generate_string (_tmp94_);
			_tmp96_ = _tmp95_;
			json_builder_add_string_value (_tmp92_, _tmp96_);
			_g_free0 (_tmp96_);
			_g_object_unref0 (_tmp94_);
			_tmp97_ = builder;
			json_builder_set_member_name (_tmp97_, "args");
			_tmp98_ = builder;
			json_builder_begin_object (_tmp98_);
			_tmp99_ = builder;
			json_builder_set_member_name (_tmp99_, "content");
			_tmp100_ = builder;
			_tmp101_ = item;
			_tmp102_ = objects_item_get_content (_tmp101_);
			_tmp103_ = _tmp102_;
			json_builder_add_string_value (_tmp100_, _tmp103_);
			_tmp104_ = builder;
			json_builder_set_member_name (_tmp104_, "description");
			_tmp105_ = builder;
			_tmp106_ = item;
			_tmp107_ = objects_item_get_description (_tmp106_);
			_tmp108_ = _tmp107_;
			json_builder_add_string_value (_tmp105_, _tmp108_);
			_tmp109_ = builder;
			json_builder_set_member_name (_tmp109_, "project_id");
			_tmp110_ = builder;
			_tmp111_ = item;
			_tmp112_ = objects_item_get_project_id (_tmp111_);
			_tmp113_ = _tmp112_;
			_tmp114_ = g_strconcat ("_", _tmp113_, NULL);
			_tmp115_ = _tmp114_;
			json_builder_add_string_value (_tmp110_, _tmp115_);
			_g_free0 (_tmp115_);
			_tmp116_ = item;
			_tmp117_ = objects_item_get_parent_id (_tmp116_);
			_tmp118_ = _tmp117_;
			if (g_strcmp0 (_tmp118_, "") != 0) {
				JsonBuilder* _tmp119_;
				JsonBuilder* _tmp120_;
				ObjectsItem* _tmp121_;
				const gchar* _tmp122_;
				const gchar* _tmp123_;
				gchar* _tmp124_;
				gchar* _tmp125_;
				_tmp119_ = builder;
				json_builder_set_member_name (_tmp119_, "parent_id");
				_tmp120_ = builder;
				_tmp121_ = item;
				_tmp122_ = objects_item_get_parent_id (_tmp121_);
				_tmp123_ = _tmp122_;
				_tmp124_ = g_strconcat ("_", _tmp123_, NULL);
				_tmp125_ = _tmp124_;
				json_builder_add_string_value (_tmp120_, _tmp125_);
				_g_free0 (_tmp125_);
			}
			_tmp126_ = item;
			_tmp127_ = objects_item_get_section_id (_tmp126_);
			_tmp128_ = _tmp127_;
			if (g_strcmp0 (_tmp128_, "") != 0) {
				JsonBuilder* _tmp129_;
				JsonBuilder* _tmp130_;
				ObjectsItem* _tmp131_;
				const gchar* _tmp132_;
				const gchar* _tmp133_;
				gchar* _tmp134_;
				gchar* _tmp135_;
				_tmp129_ = builder;
				json_builder_set_member_name (_tmp129_, "section_id");
				_tmp130_ = builder;
				_tmp131_ = item;
				_tmp132_ = objects_item_get_section_id (_tmp131_);
				_tmp133_ = _tmp132_;
				_tmp134_ = g_strconcat ("_", _tmp133_, NULL);
				_tmp135_ = _tmp134_;
				json_builder_add_string_value (_tmp130_, _tmp135_);
				_g_free0 (_tmp135_);
			}
			_tmp136_ = builder;
			json_builder_set_member_name (_tmp136_, "priority");
			_tmp137_ = item;
			_tmp138_ = objects_item_get_priority (_tmp137_);
			_tmp139_ = _tmp138_;
			if (_tmp139_ == 0) {
				JsonBuilder* _tmp140_;
				_tmp140_ = builder;
				json_builder_add_int_value (_tmp140_, (gint64) CONSTANTS_PRIORITY_4);
			} else {
				JsonBuilder* _tmp141_;
				ObjectsItem* _tmp142_;
				gint _tmp143_;
				gint _tmp144_;
				_tmp141_ = builder;
				_tmp142_ = item;
				_tmp143_ = objects_item_get_priority (_tmp142_);
				_tmp144_ = _tmp143_;
				json_builder_add_int_value (_tmp141_, (gint64) _tmp144_);
			}
			_tmp145_ = item;
			_tmp146_ = objects_item_get_has_due (_tmp145_);
			_tmp147_ = _tmp146_;
			if (_tmp147_) {
				JsonBuilder* _tmp148_;
				JsonBuilder* _tmp149_;
				JsonBuilder* _tmp150_;
				JsonBuilder* _tmp151_;
				ObjectsItem* _tmp152_;
				ObjectsDueDate* _tmp153_;
				ObjectsDueDate* _tmp154_;
				const gchar* _tmp155_;
				const gchar* _tmp156_;
				JsonBuilder* _tmp157_;
				_tmp148_ = builder;
				json_builder_set_member_name (_tmp148_, "due");
				_tmp149_ = builder;
				json_builder_begin_object (_tmp149_);
				_tmp150_ = builder;
				json_builder_set_member_name (_tmp150_, "date");
				_tmp151_ = builder;
				_tmp152_ = item;
				_tmp153_ = objects_item_get_due (_tmp152_);
				_tmp154_ = _tmp153_;
				_tmp155_ = objects_due_date_get_date (_tmp154_);
				_tmp156_ = _tmp155_;
				json_builder_add_string_value (_tmp151_, _tmp156_);
				_tmp157_ = builder;
				json_builder_end_object (_tmp157_);
			}
			_tmp158_ = builder;
			json_builder_set_member_name (_tmp158_, "labels");
			_tmp159_ = builder;
			json_builder_begin_array (_tmp159_);
			{
				GeeArrayList* _label_list = NULL;
				ObjectsItem* _tmp160_;
				GeeArrayList* _tmp161_;
				GeeArrayList* _tmp162_;
				gint _label_size = 0;
				GeeArrayList* _tmp163_;
				gint _tmp164_;
				gint _tmp165_;
				gint _label_index = 0;
				_tmp160_ = item;
				_tmp161_ = objects_item_get_labels (_tmp160_);
				_tmp162_ = _tmp161_;
				_label_list = _tmp162_;
				_tmp163_ = _label_list;
				_tmp164_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp163_);
				_tmp165_ = _tmp164_;
				_label_size = _tmp165_;
				_label_index = -1;
				while (TRUE) {
					gint _tmp166_;
					gint _tmp167_;
					ObjectsLabel* label = NULL;
					GeeArrayList* _tmp168_;
					gpointer _tmp169_;
					JsonBuilder* _tmp170_;
					ObjectsLabel* _tmp171_;
					const gchar* _tmp172_;
					const gchar* _tmp173_;
					_label_index = _label_index + 1;
					_tmp166_ = _label_index;
					_tmp167_ = _label_size;
					if (!(_tmp166_ < _tmp167_)) {
						break;
					}
					_tmp168_ = _label_list;
					_tmp169_ = gee_abstract_list_get ((GeeAbstractList*) _tmp168_, _label_index);
					label = (ObjectsLabel*) _tmp169_;
					_tmp170_ = builder;
					_tmp171_ = label;
					_tmp172_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp171_);
					_tmp173_ = _tmp172_;
					json_builder_add_string_value (_tmp170_, _tmp173_);
					_g_object_unref0 (label);
				}
			}
			_tmp174_ = builder;
			json_builder_end_array (_tmp174_);
			_tmp175_ = builder;
			json_builder_end_object (_tmp175_);
			_tmp176_ = builder;
			json_builder_end_object (_tmp176_);
			_tmp177_ = builder;
			json_builder_end_object (_tmp177_);
			_g_object_unref0 (item);
		}
	}
	_tmp178_ = builder;
	json_builder_end_array (_tmp178_);
	_tmp179_ = builder;
	json_builder_end_object (_tmp179_);
	_tmp180_ = json_generator_new ();
	generator = _tmp180_;
	_tmp181_ = builder;
	_tmp182_ = json_builder_get_root (_tmp181_);
	root = _tmp182_;
	json_generator_set_root (generator, root);
	_tmp183_ = json_generator_to_data (generator, NULL);
	result = _tmp183_;
	__vala_JsonNode_free0 (root);
	_g_object_unref0 (generator);
	_g_object_unref0 (builder);
	return result;
}

gboolean
services_todoist_is_todoist_error (ServicesTodoist* self,
                                   guint status_code)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (status_code == ((guint) 400)) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = status_code == ((guint) 401);
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		_tmp4_ = status_code == ((guint) 403);
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = status_code == ((guint) 404);
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = status_code == ((guint) 429);
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = status_code == ((guint) 500);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = status_code == ((guint) 503);
	}
	result = _tmp0_;
	return result;
}

gchar*
services_todoist_get_todoist_error (ServicesTodoist* self,
                                    guint code)
{
	GeeHashMap* messages = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	gchar* _tmp8_ = NULL;
	GeeHashMap* _tmp9_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	messages = _tmp0_;
	_tmp1_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) 400), _ ("The request was incorrect."));
	_tmp2_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) 401), _ ("Authentication is required, and has failed, or has not yet been provid" \
"ed."));
	_tmp3_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, (gpointer) ((guintptr) 403), _ ("The request was valid, but for something that is forbidden."));
	_tmp4_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((guintptr) 404), _ ("The requested resource could not be found."));
	_tmp5_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, (gpointer) ((guintptr) 429), _ ("The user has sent too many requests in a given amount of time."));
	_tmp6_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((guintptr) 500), _ ("The request failed due to a server error."));
	_tmp7_ = messages;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, (gpointer) ((guintptr) 503), _ ("The server is currently unable to handle the request."));
	_tmp9_ = messages;
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp9_, (gpointer) ((guintptr) code))) {
		GeeHashMap* _tmp10_;
		gpointer _tmp11_;
		_tmp10_ = messages;
		_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((guintptr) code));
		_g_free0 (_tmp8_);
		_tmp8_ = (gchar*) _tmp11_;
	} else {
		gchar* _tmp12_;
		_tmp12_ = g_strdup (_ ("Unknown error"));
		_g_free0 (_tmp8_);
		_tmp8_ = _tmp12_;
	}
	result = _tmp8_;
	_g_object_unref0 (messages);
	return result;
}

static void
services_todoist_class_init (ServicesTodoistClass * klass,
                             gpointer klass_data)
{
	services_todoist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ServicesTodoist_private_offset);
	G_OBJECT_CLASS (klass)->finalize = services_todoist_finalize;
	services_todoist_signals[SERVICES_TODOIST_SYNC_STARTED_SIGNAL] = g_signal_new ("sync-started", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	services_todoist_signals[SERVICES_TODOIST_SYNC_FINISHED_SIGNAL] = g_signal_new ("sync-finished", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	services_todoist_signals[SERVICES_TODOIST_FIRST_SYNC_STARTED_SIGNAL] = g_signal_new ("first-sync-started", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	services_todoist_signals[SERVICES_TODOIST_FIRST_SYNC_FINISHED_SIGNAL] = g_signal_new ("first-sync-finished", SERVICES_TYPE_TODOIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
services_todoist_instance_init (ServicesTodoist * self,
                                gpointer klass)
{
	self->priv = services_todoist_get_instance_private (self);
}

static void
services_todoist_finalize (GObject * obj)
{
	ServicesTodoist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_TODOIST, ServicesTodoist);
	_g_object_unref0 (self->priv->session);
	_g_object_unref0 (self->priv->parser);
	G_OBJECT_CLASS (services_todoist_parent_class)->finalize (obj);
}

static GType
services_todoist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesTodoistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_todoist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesTodoist), 0, (GInstanceInitFunc) services_todoist_instance_init, NULL };
	GType services_todoist_type_id;
	services_todoist_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesTodoist", &g_define_type_info, 0);
	ServicesTodoist_private_offset = g_type_add_instance_private (services_todoist_type_id, sizeof (ServicesTodoistPrivate));
	return services_todoist_type_id;
}

GType
services_todoist_get_type (void)
{
	static volatile gsize services_todoist_type_id__once = 0;
	if (g_once_init_enter (&services_todoist_type_id__once)) {
		GType services_todoist_type_id;
		services_todoist_type_id = services_todoist_get_type_once ();
		g_once_init_leave (&services_todoist_type_id__once, services_todoist_type_id);
	}
	return services_todoist_type_id__once;
}

static inline gpointer
http_response_get_instance_private (HttpResponse* self)
{
	return G_STRUCT_MEMBER_P (self, HttpResponse_private_offset);
}

void
http_response_from_error_json (HttpResponse* self,
                               JsonNode* node)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	JsonObject* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	http_response_set_status (self, FALSE);
	_tmp0_ = json_node_get_object (node);
	http_response_set_error_code (self, (gint) json_object_get_int_member (_tmp0_, "error_code"));
	_tmp1_ = json_node_get_object (node);
	_tmp2_ = json_object_get_string_member (_tmp1_, "error");
	http_response_set_error (self, _tmp2_);
	_tmp3_ = json_node_get_object (node);
	http_response_set_http_code (self, (gint) json_object_get_int_member (_tmp3_, "http_code"));
}

void
http_response_from_error_xml (HttpResponse* self,
                              GXmlDomDocument* doc,
                              gint error_code)
{
	GXmlDomHTMLCollection* _tmp0_;
	GXmlDomHTMLCollection* _tmp1_;
	GXmlDomElement* _tmp2_;
	GXmlDomElement* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (doc != NULL);
	http_response_set_status (self, FALSE);
	http_response_set_error_code (self, error_code);
	http_response_set_http_code (self, error_code);
	_tmp0_ = gxml_dom_document_get_elements_by_tag_name (doc, "o:hint");
	_tmp1_ = _tmp0_;
	_tmp2_ = gxml_dom_html_collection_get_element (_tmp1_, 0);
	_tmp3_ = _tmp2_;
	_tmp4_ = gxml_dom_node_get_text_content ((GXmlDomNode*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	http_response_set_error (self, _tmp6_);
	_g_free0 (_tmp6_);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
}

HttpResponse*
http_response_construct (GType object_type)
{
	HttpResponse* self = NULL;
	self = (HttpResponse*) g_type_create_instance (object_type);
	return self;
}

HttpResponse*
http_response_new (void)
{
	return http_response_construct (TYPE_HTTP_RESPONSE);
}

gboolean
http_response_get_status (HttpResponse* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_status;
	return result;
}

void
http_response_set_status (HttpResponse* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_status = value;
}

const gchar*
http_response_get_error (HttpResponse* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_error;
	result = _tmp0_;
	return result;
}

void
http_response_set_error (HttpResponse* self,
                         const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_error);
	self->priv->_error = _tmp0_;
}

gint
http_response_get_error_code (HttpResponse* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_error_code;
	return result;
}

void
http_response_set_error_code (HttpResponse* self,
                              gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_error_code = value;
}

gint
http_response_get_http_code (HttpResponse* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_http_code;
	return result;
}

void
http_response_set_http_code (HttpResponse* self,
                             gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_http_code = value;
}

const gchar*
http_response_get_data (HttpResponse* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data;
	result = _tmp0_;
	return result;
}

void
http_response_set_data (HttpResponse* self,
                        const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_data);
	self->priv->_data = _tmp0_;
}

void
http_response_get_data_object (HttpResponse* self,
                               GValue * result)
{
	GValue _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_data_object;
	*result = _tmp0_;
	return;
}

void
http_response_set_data_object (HttpResponse* self,
                               GValue * value)
{
	GValue _tmp0_;
	GValue _tmp1_;
	GValue _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = *value;
	_tmp1_ = _tmp0_;
	if (G_IS_VALUE (&_tmp1_)) {
		g_value_init (&_tmp2_, G_VALUE_TYPE (&_tmp1_));
		g_value_copy (&_tmp1_, &_tmp2_);
	} else {
		_tmp2_ = _tmp1_;
	}
	G_IS_VALUE (&self->priv->_data_object) ? (g_value_unset (&self->priv->_data_object), NULL) : NULL;
	self->priv->_data_object = _tmp2_;
}

static void
value_http_response_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_http_response_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		http_response_unref (value->data[0].v_pointer);
	}
}

static void
value_http_response_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = http_response_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_http_response_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_http_response_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		HttpResponse * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = http_response_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_http_response_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	HttpResponse ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = http_response_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_http_response (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecHttpResponse* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HTTP_RESPONSE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_http_response (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTTP_RESPONSE), NULL);
	return value->data[0].v_pointer;
}

void
value_set_http_response (GValue* value,
                         gpointer v_object)
{
	HttpResponse * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTTP_RESPONSE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HTTP_RESPONSE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		http_response_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		http_response_unref (old);
	}
}

void
value_take_http_response (GValue* value,
                          gpointer v_object)
{
	HttpResponse * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTTP_RESPONSE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HTTP_RESPONSE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		http_response_unref (old);
	}
}

static void
http_response_class_init (HttpResponseClass * klass,
                          gpointer klass_data)
{
	http_response_parent_class = g_type_class_peek_parent (klass);
	((HttpResponseClass *) klass)->finalize = http_response_finalize;
	g_type_class_adjust_private_offset (klass, &HttpResponse_private_offset);
}

static void
http_response_instance_init (HttpResponse * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	self->priv = http_response_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->_error = _tmp0_;
	self->priv->_error_code = 0;
	self->priv->_http_code = 0;
	self->ref_count = 1;
}

static void
http_response_finalize (HttpResponse * obj)
{
	HttpResponse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HTTP_RESPONSE, HttpResponse);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->_error);
	_g_free0 (self->priv->_data);
	G_IS_VALUE (&self->priv->_data_object) ? (g_value_unset (&self->priv->_data_object), NULL) : NULL;
}

static GType
http_response_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_http_response_init, value_http_response_free_value, value_http_response_copy_value, value_http_response_peek_pointer, "p", value_http_response_collect_value, "p", value_http_response_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HttpResponseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) http_response_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HttpResponse), 0, (GInstanceInitFunc) http_response_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType http_response_type_id;
	http_response_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HttpResponse", &g_define_type_info, &g_define_type_fundamental_info, 0);
	HttpResponse_private_offset = g_type_add_instance_private (http_response_type_id, sizeof (HttpResponsePrivate));
	return http_response_type_id;
}

GType
http_response_get_type (void)
{
	static volatile gsize http_response_type_id__once = 0;
	if (g_once_init_enter (&http_response_type_id__once)) {
		GType http_response_type_id;
		http_response_type_id = http_response_get_type_once ();
		g_once_init_leave (&http_response_type_id__once, http_response_type_id);
	}
	return http_response_type_id__once;
}

gpointer
http_response_ref (gpointer instance)
{
	HttpResponse * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
http_response_unref (gpointer instance)
{
	HttpResponse * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		HTTP_RESPONSE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

